/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// WorkstationTenderRepositoryStatus.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey :  IEquatable<ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">store ID (required).</param>
        /// <param name="workstationID">workstation ID (required).</param>
        /// <param name="sessionID">designed for POS server functions - the unique id from special pool will be generated&#39;0&#39; for POS (required).</param>
        /// <param name="tenderRepositoryID">assigned till or safe (required).</param>
        public ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey(string businessUnitGroupID = default(string), string workstationID = default(string), string sessionID = default(string), string tenderRepositoryID = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "workstationID" is required (not null)
            if (workstationID == null)
            {
                throw new InvalidDataException("workstationID is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey and cannot be null");
            }
            else
            {
                this.WorkstationID = workstationID;
            }
            // to ensure "sessionID" is required (not null)
            if (sessionID == null)
            {
                throw new InvalidDataException("sessionID is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey and cannot be null");
            }
            else
            {
                this.SessionID = sessionID;
            }
            // to ensure "tenderRepositoryID" is required (not null)
            if (tenderRepositoryID == null)
            {
                throw new InvalidDataException("tenderRepositoryID is a required property for ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey and cannot be null");
            }
            else
            {
                this.TenderRepositoryID = tenderRepositoryID;
            }
        }
        
        /// <summary>
        /// store ID
        /// </summary>
        /// <value>store ID</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// workstation ID
        /// </summary>
        /// <value>workstation ID</value>
        [DataMember(Name="workstationID", EmitDefaultValue=false)]
        public string WorkstationID { get; set; }

        /// <summary>
        /// designed for POS server functions - the unique id from special pool will be generated&#39;0&#39; for POS
        /// </summary>
        /// <value>designed for POS server functions - the unique id from special pool will be generated&#39;0&#39; for POS</value>
        [DataMember(Name="sessionID", EmitDefaultValue=false)]
        public string SessionID { get; set; }

        /// <summary>
        /// assigned till or safe
        /// </summary>
        /// <value>assigned till or safe</value>
        [DataMember(Name="tenderRepositoryID", EmitDefaultValue=false)]
        public string TenderRepositoryID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  WorkstationID: ").Append(WorkstationID).Append("\n");
            sb.Append("  SessionID: ").Append(SessionID).Append("\n");
            sb.Append("  TenderRepositoryID: ").Append(TenderRepositoryID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiLoginManagerDtoWorkstationTenderRepositoryStatusKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.WorkstationID == input.WorkstationID ||
                    (this.WorkstationID != null &&
                    this.WorkstationID.Equals(input.WorkstationID))
                ) && 
                (
                    this.SessionID == input.SessionID ||
                    (this.SessionID != null &&
                    this.SessionID.Equals(input.SessionID))
                ) && 
                (
                    this.TenderRepositoryID == input.TenderRepositoryID ||
                    (this.TenderRepositoryID != null &&
                    this.TenderRepositoryID.Equals(input.TenderRepositoryID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.WorkstationID != null)
                    hashCode = hashCode * 59 + this.WorkstationID.GetHashCode();
                if (this.SessionID != null)
                    hashCode = hashCode * 59 + this.SessionID.GetHashCode();
                if (this.TenderRepositoryID != null)
                    hashCode = hashCode * 59 + this.TenderRepositoryID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
