/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BankAccount &lt;p&gt;Information about bank account.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount :  IEquatable<ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount" /> class.
        /// </summary>
        /// <param name="bankDescription">&lt;p&gt;Bank description.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="bankAccountNumber">&lt;p&gt;Bank account number in a national format, not international.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="nationalBankIdentificationCode">&lt;p&gt;Bank identification code in a national format.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="internationalBankAccountNumber">&lt;p&gt;International bank account number (IBAN). A standard number standardized in accordance with the ECBS (European Commitee for Banking Standards) to represent bank details.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="bankIdentificationCode">&lt;p&gt;Bank identification code in the international format (BIC). Uniquely identifies a bank throughout the world.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="bankAccountTypeCode">&lt;p&gt;This type code is used to differ between multiple bank accounts. Optional - if not provided then filled in the import.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom05">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom04">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount(string bankDescription = default(string), string bankAccountNumber = default(string), string nationalBankIdentificationCode = default(string), string internationalBankAccountNumber = default(string), string bankIdentificationCode = default(string), string bankAccountTypeCode = default(string), string xxcustom05 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom01 = default(string))
        {
            this.BankDescription = bankDescription;
            this.BankAccountNumber = bankAccountNumber;
            this.NationalBankIdentificationCode = nationalBankIdentificationCode;
            this.InternationalBankAccountNumber = internationalBankAccountNumber;
            this.BankIdentificationCode = bankIdentificationCode;
            this.BankAccountTypeCode = bankAccountTypeCode;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Bank description.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Bank description.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="bankDescription", EmitDefaultValue=false)]
        public string BankDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;Bank account number in a national format, not international.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Bank account number in a national format, not international.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="bankAccountNumber", EmitDefaultValue=false)]
        public string BankAccountNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Bank identification code in a national format.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Bank identification code in a national format.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="nationalBankIdentificationCode", EmitDefaultValue=false)]
        public string NationalBankIdentificationCode { get; set; }

        /// <summary>
        /// &lt;p&gt;International bank account number (IBAN). A standard number standardized in accordance with the ECBS (European Commitee for Banking Standards) to represent bank details.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;International bank account number (IBAN). A standard number standardized in accordance with the ECBS (European Commitee for Banking Standards) to represent bank details.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="internationalBankAccountNumber", EmitDefaultValue=false)]
        public string InternationalBankAccountNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Bank identification code in the international format (BIC). Uniquely identifies a bank throughout the world.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Bank identification code in the international format (BIC). Uniquely identifies a bank throughout the world.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="bankIdentificationCode", EmitDefaultValue=false)]
        public string BankIdentificationCode { get; set; }

        /// <summary>
        /// &lt;p&gt;This type code is used to differ between multiple bank accounts. Optional - if not provided then filled in the import.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This type code is used to differ between multiple bank accounts. Optional - if not provided then filled in the import.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="bankAccountTypeCode", EmitDefaultValue=false)]
        public string BankAccountTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount {\n");
            sb.Append("  BankDescription: ").Append(BankDescription).Append("\n");
            sb.Append("  BankAccountNumber: ").Append(BankAccountNumber).Append("\n");
            sb.Append("  NationalBankIdentificationCode: ").Append(NationalBankIdentificationCode).Append("\n");
            sb.Append("  InternationalBankAccountNumber: ").Append(InternationalBankAccountNumber).Append("\n");
            sb.Append("  BankIdentificationCode: ").Append(BankIdentificationCode).Append("\n");
            sb.Append("  BankAccountTypeCode: ").Append(BankAccountTypeCode).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdBusinessUnitDtoDomBankAccount input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BankDescription == input.BankDescription ||
                    (this.BankDescription != null &&
                    this.BankDescription.Equals(input.BankDescription))
                ) && 
                (
                    this.BankAccountNumber == input.BankAccountNumber ||
                    (this.BankAccountNumber != null &&
                    this.BankAccountNumber.Equals(input.BankAccountNumber))
                ) && 
                (
                    this.NationalBankIdentificationCode == input.NationalBankIdentificationCode ||
                    (this.NationalBankIdentificationCode != null &&
                    this.NationalBankIdentificationCode.Equals(input.NationalBankIdentificationCode))
                ) && 
                (
                    this.InternationalBankAccountNumber == input.InternationalBankAccountNumber ||
                    (this.InternationalBankAccountNumber != null &&
                    this.InternationalBankAccountNumber.Equals(input.InternationalBankAccountNumber))
                ) && 
                (
                    this.BankIdentificationCode == input.BankIdentificationCode ||
                    (this.BankIdentificationCode != null &&
                    this.BankIdentificationCode.Equals(input.BankIdentificationCode))
                ) && 
                (
                    this.BankAccountTypeCode == input.BankAccountTypeCode ||
                    (this.BankAccountTypeCode != null &&
                    this.BankAccountTypeCode.Equals(input.BankAccountTypeCode))
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BankDescription != null)
                    hashCode = hashCode * 59 + this.BankDescription.GetHashCode();
                if (this.BankAccountNumber != null)
                    hashCode = hashCode * 59 + this.BankAccountNumber.GetHashCode();
                if (this.NationalBankIdentificationCode != null)
                    hashCode = hashCode * 59 + this.NationalBankIdentificationCode.GetHashCode();
                if (this.InternationalBankAccountNumber != null)
                    hashCode = hashCode * 59 + this.InternationalBankAccountNumber.GetHashCode();
                if (this.BankIdentificationCode != null)
                    hashCode = hashCode * 59 + this.BankIdentificationCode.GetHashCode();
                if (this.BankAccountTypeCode != null)
                    hashCode = hashCode * 59 + this.BankAccountTypeCode.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
