/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BusinessUnitTextDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitID">&lt;p&gt;Ident of the retail store.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="receiptTextKey">&lt;p&gt;Type of the receipt text (e.g. FOOTER)&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="receiptTextSequenceNumber">&lt;p&gt;A sequence number of the receipt text.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey(string businessUnitID = default(string), string receiptTextKey = default(string), int? receiptTextSequenceNumber = default(int?))
        {
            // to ensure "businessUnitID" is required (not null)
            if (businessUnitID == null)
            {
                throw new InvalidDataException("businessUnitID is a required property for ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitID = businessUnitID;
            }
            // to ensure "receiptTextKey" is required (not null)
            if (receiptTextKey == null)
            {
                throw new InvalidDataException("receiptTextKey is a required property for ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey and cannot be null");
            }
            else
            {
                this.ReceiptTextKey = receiptTextKey;
            }
            // to ensure "receiptTextSequenceNumber" is required (not null)
            if (receiptTextSequenceNumber == null)
            {
                throw new InvalidDataException("receiptTextSequenceNumber is a required property for ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey and cannot be null");
            }
            else
            {
                this.ReceiptTextSequenceNumber = receiptTextSequenceNumber;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;Ident of the retail store.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Ident of the retail store.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitID", EmitDefaultValue=false)]
        public string BusinessUnitID { get; set; }

        /// <summary>
        /// &lt;p&gt;Type of the receipt text (e.g. FOOTER)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type of the receipt text (e.g. FOOTER)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="receiptTextKey", EmitDefaultValue=false)]
        public string ReceiptTextKey { get; set; }

        /// <summary>
        /// &lt;p&gt;A sequence number of the receipt text.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A sequence number of the receipt text.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="receiptTextSequenceNumber", EmitDefaultValue=false)]
        public int? ReceiptTextSequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey {\n");
            sb.Append("  BusinessUnitID: ").Append(BusinessUnitID).Append("\n");
            sb.Append("  ReceiptTextKey: ").Append(ReceiptTextKey).Append("\n");
            sb.Append("  ReceiptTextSequenceNumber: ").Append(ReceiptTextSequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdBusinessUnitTextDtoDomBusinessUnitTextDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitID == input.BusinessUnitID ||
                    (this.BusinessUnitID != null &&
                    this.BusinessUnitID.Equals(input.BusinessUnitID))
                ) && 
                (
                    this.ReceiptTextKey == input.ReceiptTextKey ||
                    (this.ReceiptTextKey != null &&
                    this.ReceiptTextKey.Equals(input.ReceiptTextKey))
                ) && 
                (
                    this.ReceiptTextSequenceNumber == input.ReceiptTextSequenceNumber ||
                    (this.ReceiptTextSequenceNumber != null &&
                    this.ReceiptTextSequenceNumber.Equals(input.ReceiptTextSequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitID.GetHashCode();
                if (this.ReceiptTextKey != null)
                    hashCode = hashCode * 59 + this.ReceiptTextKey.GetHashCode();
                if (this.ReceiptTextSequenceNumber != null)
                    hashCode = hashCode * 59 + this.ReceiptTextSequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
