/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ContactTelephone.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey :  IEquatable<ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey" /> class.
        /// </summary>
        /// <param name="contactPurposeTypeCode">&lt;p&gt;Code denoting a reason for contacting a Party.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="contactMethodTypeCode">&lt;p&gt;A retailer assigned code denoting a method of contacting a Party. Suggested values include: WorkPhone, HomePhone, WorkFax, HomeFax, Mobile, Pager.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey(string contactPurposeTypeCode = default(string), string contactMethodTypeCode = default(string))
        {
            // to ensure "contactPurposeTypeCode" is required (not null)
            if (contactPurposeTypeCode == null)
            {
                throw new InvalidDataException("contactPurposeTypeCode is a required property for ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey and cannot be null");
            }
            else
            {
                this.ContactPurposeTypeCode = contactPurposeTypeCode;
            }
            // to ensure "contactMethodTypeCode" is required (not null)
            if (contactMethodTypeCode == null)
            {
                throw new InvalidDataException("contactMethodTypeCode is a required property for ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey and cannot be null");
            }
            else
            {
                this.ContactMethodTypeCode = contactMethodTypeCode;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;Code denoting a reason for contacting a Party.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Code denoting a reason for contacting a Party.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="contactPurposeTypeCode", EmitDefaultValue=false)]
        public string ContactPurposeTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;A retailer assigned code denoting a method of contacting a Party. Suggested values include: WorkPhone, HomePhone, WorkFax, HomeFax, Mobile, Pager.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A retailer assigned code denoting a method of contacting a Party. Suggested values include: WorkPhone, HomePhone, WorkFax, HomeFax, Mobile, Pager.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="contactMethodTypeCode", EmitDefaultValue=false)]
        public string ContactMethodTypeCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey {\n");
            sb.Append("  ContactPurposeTypeCode: ").Append(ContactPurposeTypeCode).Append("\n");
            sb.Append("  ContactMethodTypeCode: ").Append(ContactMethodTypeCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdContactDtoDomContactTelephoneKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ContactPurposeTypeCode == input.ContactPurposeTypeCode ||
                    (this.ContactPurposeTypeCode != null &&
                    this.ContactPurposeTypeCode.Equals(input.ContactPurposeTypeCode))
                ) && 
                (
                    this.ContactMethodTypeCode == input.ContactMethodTypeCode ||
                    (this.ContactMethodTypeCode != null &&
                    this.ContactMethodTypeCode.Equals(input.ContactMethodTypeCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ContactPurposeTypeCode != null)
                    hashCode = hashCode * 59 + this.ContactPurposeTypeCode.GetHashCode();
                if (this.ContactMethodTypeCode != null)
                    hashCode = hashCode * 59 + this.ContactMethodTypeCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
