/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CustomerDO &lt;p&gt;A customer is a person or individual who purchases, may purchase, or did purchase goods or services from a retail store.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO :  IEquatable<ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO" /> class.
        /// </summary>
        /// <param name="key">&lt;p&gt;Getter for inner key class.&lt;/p&gt; (required).</param>
        /// <param name="externalBusinessUnitGroupID">&lt;p&gt;An external unique identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="allowedTermsOfPayment">&lt;p&gt;Denotes the group of allowed tenders.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="creditLimit">&lt;p&gt;Credit limit of the customer.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="personalID">&lt;p&gt;The personal number, unique key for the employee identification. (The number of the Identification that identifies the Party).&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="prohibitedTermsOfPayment">&lt;p&gt;Denotes the group of prohibited tenders.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="remainingCreditLimit">&lt;p&gt;Remaining credit limit of the customer. (Total credit limit - amounts of invoices which haven&#39;t been paid yet).&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="salesTaxLiableFlag">&lt;p&gt;Determines whether the customer is liable to tax on sales&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="statusCode">&lt;p&gt;The current status code of the customer, e.g. active, blocked.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="preferredReceiptPrintoutTypeCode">&lt;p&gt;Default printout mode of the customer.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="taxNumber">&lt;p&gt;The company&#39;s tax number given by the tax office (this is not the sales tax ID).&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="partyID">&lt;p&gt;Party ID&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="creditCardList">&lt;p&gt;List of the customer credit cards.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="customerCardList">&lt;p&gt;List of the customer cards.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="customerGroupIDList">&lt;p&gt;List of CustomerGroupID&#39;s.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="partyIdentification">&lt;p&gt;An official number that may be used to identify a Party. People and businesses have multiple forms of such identification: Drivers License number, Passport number, Credit / Debit Card number, Company Incorporation number, Tax number, etc...&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="organization">&lt;p&gt;Additional data for the organization if the customer is a organization.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="contact">&lt;p&gt;Contacts for the customer, e.g. address, telephone, fax, email-address.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="party">&lt;p&gt;Reference to the party structure&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="person">&lt;p&gt;Additional data for the person if the customer is a person.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="packageID">&lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="declarationAvailable">&lt;p&gt;Denotes if the customer declaration is available.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="dateOfRecord">&lt;p&gt;Date of the customer declaration.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="recordedBy">&lt;p&gt;Identification of person who has recorded the customer declaration (e.g. ID of logged Operator).&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="statisticalUseAllowed">&lt;p&gt;Denotes if the customer data can be used for statistical purposes.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="lastAccessDate">&lt;p&gt;Timestamp of the last access to the data.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="dataProtectCode">&lt;p&gt;The data protection code being used for the evaluation of the data protection requirements.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="parentCustomerID">&lt;p&gt;A unique system assigned identifier for the Customer.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="partnerRoleList">&lt;p&gt;List of the customer partner roles.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="parentCustomerName1">&lt;p&gt;First Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="parentCustomerName2">&lt;p&gt;Second Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom08">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom10">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom09">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom07">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom05">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom06">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom11">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom12">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom13">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom14">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom15">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom04">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom16">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom17">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom18">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom19">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom20">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom21">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom22">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom23">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom24">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom25">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom26">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom27">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom28">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom29">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom30">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO(ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDOKey key = default(ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDOKey), string externalBusinessUnitGroupID = default(string), string allowedTermsOfPayment = default(string), double? creditLimit = default(double?), string personalID = default(string), string prohibitedTermsOfPayment = default(string), double? remainingCreditLimit = default(double?), bool? salesTaxLiableFlag = default(bool?), string statusCode = default(string), string preferredReceiptPrintoutTypeCode = default(string), string taxNumber = default(string), string partyID = default(string), List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCreditCard> creditCardList = default(List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCreditCard>), List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerCard> customerCardList = default(List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerCard>), List<string> customerGroupIDList = default(List<string>), List<ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentification> partyIdentification = default(List<ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentification>), ComGkSoftwareGkrApiServerMdCustomerDtoDomOrganization organization = default(ComGkSoftwareGkrApiServerMdCustomerDtoDomOrganization), ComGkSoftwareGkrApiServerMdContactDtoDomContactDO contact = default(ComGkSoftwareGkrApiServerMdContactDtoDomContactDO), ComGkSoftwareGkrApiServerMdPartyDtoDomPartyDO party = default(ComGkSoftwareGkrApiServerMdPartyDtoDomPartyDO), ComGkSoftwareGkrApiServerMdPersonDtoDomPersonDO person = default(ComGkSoftwareGkrApiServerMdPersonDtoDomPersonDO), string packageID = default(string), bool? declarationAvailable = default(bool?), string dateOfRecord = default(string), string recordedBy = default(string), bool? statisticalUseAllowed = default(bool?), string lastAccessDate = default(string), string dataProtectCode = default(string), string parentCustomerID = default(string), List<ComGkSoftwareGkrApiServerMdCustomerDtoDomPartnerRole> partnerRoleList = default(List<ComGkSoftwareGkrApiServerMdCustomerDtoDomPartnerRole>), string parentCustomerName1 = default(string), string parentCustomerName2 = default(string), string xxcustom08 = default(string), string xxcustom10 = default(string), string xxcustom09 = default(string), string xxcustom07 = default(string), string xxcustom05 = default(string), string xxcustom06 = default(string), string xxcustom11 = default(string), string xxcustom12 = default(string), string xxcustom13 = default(string), string xxcustom14 = default(string), string xxcustom15 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom16 = default(string), string xxcustom17 = default(string), string xxcustom18 = default(string), string xxcustom19 = default(string), string xxcustom20 = default(string), string xxcustom21 = default(string), string xxcustom22 = default(string), string xxcustom23 = default(string), string xxcustom24 = default(string), string xxcustom25 = default(string), string xxcustom26 = default(string), string xxcustom27 = default(string), string xxcustom28 = default(string), string xxcustom29 = default(string), string xxcustom30 = default(string), string xxcustom01 = default(string))
        {
            // to ensure "key" is required (not null)
            if (key == null)
            {
                throw new InvalidDataException("key is a required property for ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO and cannot be null");
            }
            else
            {
                this.Key = key;
            }
            this.ExternalBusinessUnitGroupID = externalBusinessUnitGroupID;
            this.AllowedTermsOfPayment = allowedTermsOfPayment;
            this.CreditLimit = creditLimit;
            this.PersonalID = personalID;
            this.ProhibitedTermsOfPayment = prohibitedTermsOfPayment;
            this.RemainingCreditLimit = remainingCreditLimit;
            this.SalesTaxLiableFlag = salesTaxLiableFlag;
            this.StatusCode = statusCode;
            this.PreferredReceiptPrintoutTypeCode = preferredReceiptPrintoutTypeCode;
            this.TaxNumber = taxNumber;
            this.PartyID = partyID;
            this.CreditCardList = creditCardList;
            this.CustomerCardList = customerCardList;
            this.CustomerGroupIDList = customerGroupIDList;
            this.PartyIdentification = partyIdentification;
            this.Organization = organization;
            this.Contact = contact;
            this.Party = party;
            this.Person = person;
            this.PackageID = packageID;
            this.DeclarationAvailable = declarationAvailable;
            this.DateOfRecord = dateOfRecord;
            this.RecordedBy = recordedBy;
            this.StatisticalUseAllowed = statisticalUseAllowed;
            this.LastAccessDate = lastAccessDate;
            this.DataProtectCode = dataProtectCode;
            this.ParentCustomerID = parentCustomerID;
            this.PartnerRoleList = partnerRoleList;
            this.ParentCustomerName1 = parentCustomerName1;
            this.ParentCustomerName2 = parentCustomerName2;
            this.Xxcustom08 = xxcustom08;
            this.Xxcustom10 = xxcustom10;
            this.Xxcustom09 = xxcustom09;
            this.Xxcustom07 = xxcustom07;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom06 = xxcustom06;
            this.Xxcustom11 = xxcustom11;
            this.Xxcustom12 = xxcustom12;
            this.Xxcustom13 = xxcustom13;
            this.Xxcustom14 = xxcustom14;
            this.Xxcustom15 = xxcustom15;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom16 = xxcustom16;
            this.Xxcustom17 = xxcustom17;
            this.Xxcustom18 = xxcustom18;
            this.Xxcustom19 = xxcustom19;
            this.Xxcustom20 = xxcustom20;
            this.Xxcustom21 = xxcustom21;
            this.Xxcustom22 = xxcustom22;
            this.Xxcustom23 = xxcustom23;
            this.Xxcustom24 = xxcustom24;
            this.Xxcustom25 = xxcustom25;
            this.Xxcustom26 = xxcustom26;
            this.Xxcustom27 = xxcustom27;
            this.Xxcustom28 = xxcustom28;
            this.Xxcustom29 = xxcustom29;
            this.Xxcustom30 = xxcustom30;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        [DataMember(Name="key", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDOKey Key { get; set; }

        /// <summary>
        /// &lt;p&gt;An external unique identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;An external unique identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="externalBusinessUnitGroupID", EmitDefaultValue=false)]
        public string ExternalBusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Denotes the group of allowed tenders.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Denotes the group of allowed tenders.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="allowedTermsOfPayment", EmitDefaultValue=false)]
        public string AllowedTermsOfPayment { get; set; }

        /// <summary>
        /// &lt;p&gt;Credit limit of the customer.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Credit limit of the customer.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="creditLimit", EmitDefaultValue=false)]
        public double? CreditLimit { get; set; }

        /// <summary>
        /// &lt;p&gt;The personal number, unique key for the employee identification. (The number of the Identification that identifies the Party).&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The personal number, unique key for the employee identification. (The number of the Identification that identifies the Party).&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="personalID", EmitDefaultValue=false)]
        public string PersonalID { get; set; }

        /// <summary>
        /// &lt;p&gt;Denotes the group of prohibited tenders.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Denotes the group of prohibited tenders.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="prohibitedTermsOfPayment", EmitDefaultValue=false)]
        public string ProhibitedTermsOfPayment { get; set; }

        /// <summary>
        /// &lt;p&gt;Remaining credit limit of the customer. (Total credit limit - amounts of invoices which haven&#39;t been paid yet).&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Remaining credit limit of the customer. (Total credit limit - amounts of invoices which haven&#39;t been paid yet).&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="remainingCreditLimit", EmitDefaultValue=false)]
        public double? RemainingCreditLimit { get; set; }

        /// <summary>
        /// &lt;p&gt;Determines whether the customer is liable to tax on sales&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Determines whether the customer is liable to tax on sales&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="salesTaxLiableFlag", EmitDefaultValue=false)]
        public bool? SalesTaxLiableFlag { get; set; }

        /// <summary>
        /// &lt;p&gt;The current status code of the customer, e.g. active, blocked.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The current status code of the customer, e.g. active, blocked.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="statusCode", EmitDefaultValue=false)]
        public string StatusCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Default printout mode of the customer.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Default printout mode of the customer.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="preferredReceiptPrintoutTypeCode", EmitDefaultValue=false)]
        public string PreferredReceiptPrintoutTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The company&#39;s tax number given by the tax office (this is not the sales tax ID).&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The company&#39;s tax number given by the tax office (this is not the sales tax ID).&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="taxNumber", EmitDefaultValue=false)]
        public string TaxNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Party ID&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Party ID&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyID", EmitDefaultValue=false)]
        public string PartyID { get; set; }

        /// <summary>
        /// &lt;p&gt;List of the customer credit cards.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of the customer credit cards.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="creditCardList", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCreditCard> CreditCardList { get; set; }

        /// <summary>
        /// &lt;p&gt;List of the customer cards.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of the customer cards.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="customerCardList", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerCard> CustomerCardList { get; set; }

        /// <summary>
        /// &lt;p&gt;List of CustomerGroupID&#39;s.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of CustomerGroupID&#39;s.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="customerGroupIDList", EmitDefaultValue=false)]
        public List<string> CustomerGroupIDList { get; set; }

        /// <summary>
        /// &lt;p&gt;An official number that may be used to identify a Party. People and businesses have multiple forms of such identification: Drivers License number, Passport number, Credit / Debit Card number, Company Incorporation number, Tax number, etc...&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;An official number that may be used to identify a Party. People and businesses have multiple forms of such identification: Drivers License number, Passport number, Credit / Debit Card number, Company Incorporation number, Tax number, etc...&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyIdentification", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentification> PartyIdentification { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional data for the organization if the customer is a organization.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional data for the organization if the customer is a organization.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="organization", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdCustomerDtoDomOrganization Organization { get; set; }

        /// <summary>
        /// &lt;p&gt;Contacts for the customer, e.g. address, telephone, fax, email-address.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Contacts for the customer, e.g. address, telephone, fax, email-address.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="contact", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdContactDtoDomContactDO Contact { get; set; }

        /// <summary>
        /// &lt;p&gt;Reference to the party structure&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the party structure&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="party", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdPartyDtoDomPartyDO Party { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional data for the person if the customer is a person.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional data for the person if the customer is a person.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="person", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdPersonDtoDomPersonDO Person { get; set; }

        /// <summary>
        /// &lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="packageID", EmitDefaultValue=false)]
        public string PackageID { get; set; }

        /// <summary>
        /// &lt;p&gt;Denotes if the customer declaration is available.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Denotes if the customer declaration is available.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="declarationAvailable", EmitDefaultValue=false)]
        public bool? DeclarationAvailable { get; set; }

        /// <summary>
        /// &lt;p&gt;Date of the customer declaration.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Date of the customer declaration.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="dateOfRecord", EmitDefaultValue=false)]
        public string DateOfRecord { get; set; }

        /// <summary>
        /// &lt;p&gt;Identification of person who has recorded the customer declaration (e.g. ID of logged Operator).&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Identification of person who has recorded the customer declaration (e.g. ID of logged Operator).&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="recordedBy", EmitDefaultValue=false)]
        public string RecordedBy { get; set; }

        /// <summary>
        /// &lt;p&gt;Denotes if the customer data can be used for statistical purposes.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Denotes if the customer data can be used for statistical purposes.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="statisticalUseAllowed", EmitDefaultValue=false)]
        public bool? StatisticalUseAllowed { get; set; }

        /// <summary>
        /// &lt;p&gt;Timestamp of the last access to the data.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Timestamp of the last access to the data.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="lastAccessDate", EmitDefaultValue=false)]
        public string LastAccessDate { get; set; }

        /// <summary>
        /// &lt;p&gt;The data protection code being used for the evaluation of the data protection requirements.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The data protection code being used for the evaluation of the data protection requirements.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="dataProtectCode", EmitDefaultValue=false)]
        public string DataProtectCode { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the Customer.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the Customer.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="parentCustomerID", EmitDefaultValue=false)]
        public string ParentCustomerID { get; set; }

        /// <summary>
        /// &lt;p&gt;List of the customer partner roles.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of the customer partner roles.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partnerRoleList", EmitDefaultValue=false)]
        public List<ComGkSoftwareGkrApiServerMdCustomerDtoDomPartnerRole> PartnerRoleList { get; set; }

        /// <summary>
        /// &lt;p&gt;First Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;First Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="parentCustomerName1", EmitDefaultValue=false)]
        public string ParentCustomerName1 { get; set; }

        /// <summary>
        /// &lt;p&gt;Second Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Second Name Line of the customer to which this buyer / contact person belongs.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="parentCustomerName2", EmitDefaultValue=false)]
        public string ParentCustomerName2 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom08", EmitDefaultValue=false)]
        public string Xxcustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom10", EmitDefaultValue=false)]
        public string Xxcustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom09", EmitDefaultValue=false)]
        public string Xxcustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom07", EmitDefaultValue=false)]
        public string Xxcustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom06", EmitDefaultValue=false)]
        public string Xxcustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom11", EmitDefaultValue=false)]
        public string Xxcustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom12", EmitDefaultValue=false)]
        public string Xxcustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom13", EmitDefaultValue=false)]
        public string Xxcustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom14", EmitDefaultValue=false)]
        public string Xxcustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom15", EmitDefaultValue=false)]
        public string Xxcustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom16", EmitDefaultValue=false)]
        public string Xxcustom16 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom17", EmitDefaultValue=false)]
        public string Xxcustom17 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom18", EmitDefaultValue=false)]
        public string Xxcustom18 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom19", EmitDefaultValue=false)]
        public string Xxcustom19 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom20", EmitDefaultValue=false)]
        public string Xxcustom20 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom21", EmitDefaultValue=false)]
        public string Xxcustom21 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom22", EmitDefaultValue=false)]
        public string Xxcustom22 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom23", EmitDefaultValue=false)]
        public string Xxcustom23 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom24", EmitDefaultValue=false)]
        public string Xxcustom24 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom25", EmitDefaultValue=false)]
        public string Xxcustom25 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom26", EmitDefaultValue=false)]
        public string Xxcustom26 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom27", EmitDefaultValue=false)]
        public string Xxcustom27 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom28", EmitDefaultValue=false)]
        public string Xxcustom28 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom29", EmitDefaultValue=false)]
        public string Xxcustom29 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom30", EmitDefaultValue=false)]
        public string Xxcustom30 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO {\n");
            sb.Append("  Key: ").Append(Key).Append("\n");
            sb.Append("  ExternalBusinessUnitGroupID: ").Append(ExternalBusinessUnitGroupID).Append("\n");
            sb.Append("  AllowedTermsOfPayment: ").Append(AllowedTermsOfPayment).Append("\n");
            sb.Append("  CreditLimit: ").Append(CreditLimit).Append("\n");
            sb.Append("  PersonalID: ").Append(PersonalID).Append("\n");
            sb.Append("  ProhibitedTermsOfPayment: ").Append(ProhibitedTermsOfPayment).Append("\n");
            sb.Append("  RemainingCreditLimit: ").Append(RemainingCreditLimit).Append("\n");
            sb.Append("  SalesTaxLiableFlag: ").Append(SalesTaxLiableFlag).Append("\n");
            sb.Append("  StatusCode: ").Append(StatusCode).Append("\n");
            sb.Append("  PreferredReceiptPrintoutTypeCode: ").Append(PreferredReceiptPrintoutTypeCode).Append("\n");
            sb.Append("  TaxNumber: ").Append(TaxNumber).Append("\n");
            sb.Append("  PartyID: ").Append(PartyID).Append("\n");
            sb.Append("  CreditCardList: ").Append(CreditCardList).Append("\n");
            sb.Append("  CustomerCardList: ").Append(CustomerCardList).Append("\n");
            sb.Append("  CustomerGroupIDList: ").Append(CustomerGroupIDList).Append("\n");
            sb.Append("  PartyIdentification: ").Append(PartyIdentification).Append("\n");
            sb.Append("  Organization: ").Append(Organization).Append("\n");
            sb.Append("  Contact: ").Append(Contact).Append("\n");
            sb.Append("  Party: ").Append(Party).Append("\n");
            sb.Append("  Person: ").Append(Person).Append("\n");
            sb.Append("  PackageID: ").Append(PackageID).Append("\n");
            sb.Append("  DeclarationAvailable: ").Append(DeclarationAvailable).Append("\n");
            sb.Append("  DateOfRecord: ").Append(DateOfRecord).Append("\n");
            sb.Append("  RecordedBy: ").Append(RecordedBy).Append("\n");
            sb.Append("  StatisticalUseAllowed: ").Append(StatisticalUseAllowed).Append("\n");
            sb.Append("  LastAccessDate: ").Append(LastAccessDate).Append("\n");
            sb.Append("  DataProtectCode: ").Append(DataProtectCode).Append("\n");
            sb.Append("  ParentCustomerID: ").Append(ParentCustomerID).Append("\n");
            sb.Append("  PartnerRoleList: ").Append(PartnerRoleList).Append("\n");
            sb.Append("  ParentCustomerName1: ").Append(ParentCustomerName1).Append("\n");
            sb.Append("  ParentCustomerName2: ").Append(ParentCustomerName2).Append("\n");
            sb.Append("  Xxcustom08: ").Append(Xxcustom08).Append("\n");
            sb.Append("  Xxcustom10: ").Append(Xxcustom10).Append("\n");
            sb.Append("  Xxcustom09: ").Append(Xxcustom09).Append("\n");
            sb.Append("  Xxcustom07: ").Append(Xxcustom07).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom06: ").Append(Xxcustom06).Append("\n");
            sb.Append("  Xxcustom11: ").Append(Xxcustom11).Append("\n");
            sb.Append("  Xxcustom12: ").Append(Xxcustom12).Append("\n");
            sb.Append("  Xxcustom13: ").Append(Xxcustom13).Append("\n");
            sb.Append("  Xxcustom14: ").Append(Xxcustom14).Append("\n");
            sb.Append("  Xxcustom15: ").Append(Xxcustom15).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom16: ").Append(Xxcustom16).Append("\n");
            sb.Append("  Xxcustom17: ").Append(Xxcustom17).Append("\n");
            sb.Append("  Xxcustom18: ").Append(Xxcustom18).Append("\n");
            sb.Append("  Xxcustom19: ").Append(Xxcustom19).Append("\n");
            sb.Append("  Xxcustom20: ").Append(Xxcustom20).Append("\n");
            sb.Append("  Xxcustom21: ").Append(Xxcustom21).Append("\n");
            sb.Append("  Xxcustom22: ").Append(Xxcustom22).Append("\n");
            sb.Append("  Xxcustom23: ").Append(Xxcustom23).Append("\n");
            sb.Append("  Xxcustom24: ").Append(Xxcustom24).Append("\n");
            sb.Append("  Xxcustom25: ").Append(Xxcustom25).Append("\n");
            sb.Append("  Xxcustom26: ").Append(Xxcustom26).Append("\n");
            sb.Append("  Xxcustom27: ").Append(Xxcustom27).Append("\n");
            sb.Append("  Xxcustom28: ").Append(Xxcustom28).Append("\n");
            sb.Append("  Xxcustom29: ").Append(Xxcustom29).Append("\n");
            sb.Append("  Xxcustom30: ").Append(Xxcustom30).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdCustomerDtoDomCustomerDO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Key == input.Key ||
                    (this.Key != null &&
                    this.Key.Equals(input.Key))
                ) && 
                (
                    this.ExternalBusinessUnitGroupID == input.ExternalBusinessUnitGroupID ||
                    (this.ExternalBusinessUnitGroupID != null &&
                    this.ExternalBusinessUnitGroupID.Equals(input.ExternalBusinessUnitGroupID))
                ) && 
                (
                    this.AllowedTermsOfPayment == input.AllowedTermsOfPayment ||
                    (this.AllowedTermsOfPayment != null &&
                    this.AllowedTermsOfPayment.Equals(input.AllowedTermsOfPayment))
                ) && 
                (
                    this.CreditLimit == input.CreditLimit ||
                    (this.CreditLimit != null &&
                    this.CreditLimit.Equals(input.CreditLimit))
                ) && 
                (
                    this.PersonalID == input.PersonalID ||
                    (this.PersonalID != null &&
                    this.PersonalID.Equals(input.PersonalID))
                ) && 
                (
                    this.ProhibitedTermsOfPayment == input.ProhibitedTermsOfPayment ||
                    (this.ProhibitedTermsOfPayment != null &&
                    this.ProhibitedTermsOfPayment.Equals(input.ProhibitedTermsOfPayment))
                ) && 
                (
                    this.RemainingCreditLimit == input.RemainingCreditLimit ||
                    (this.RemainingCreditLimit != null &&
                    this.RemainingCreditLimit.Equals(input.RemainingCreditLimit))
                ) && 
                (
                    this.SalesTaxLiableFlag == input.SalesTaxLiableFlag ||
                    (this.SalesTaxLiableFlag != null &&
                    this.SalesTaxLiableFlag.Equals(input.SalesTaxLiableFlag))
                ) && 
                (
                    this.StatusCode == input.StatusCode ||
                    (this.StatusCode != null &&
                    this.StatusCode.Equals(input.StatusCode))
                ) && 
                (
                    this.PreferredReceiptPrintoutTypeCode == input.PreferredReceiptPrintoutTypeCode ||
                    (this.PreferredReceiptPrintoutTypeCode != null &&
                    this.PreferredReceiptPrintoutTypeCode.Equals(input.PreferredReceiptPrintoutTypeCode))
                ) && 
                (
                    this.TaxNumber == input.TaxNumber ||
                    (this.TaxNumber != null &&
                    this.TaxNumber.Equals(input.TaxNumber))
                ) && 
                (
                    this.PartyID == input.PartyID ||
                    (this.PartyID != null &&
                    this.PartyID.Equals(input.PartyID))
                ) && 
                (
                    this.CreditCardList == input.CreditCardList ||
                    this.CreditCardList != null &&
                    this.CreditCardList.SequenceEqual(input.CreditCardList)
                ) && 
                (
                    this.CustomerCardList == input.CustomerCardList ||
                    this.CustomerCardList != null &&
                    this.CustomerCardList.SequenceEqual(input.CustomerCardList)
                ) && 
                (
                    this.CustomerGroupIDList == input.CustomerGroupIDList ||
                    this.CustomerGroupIDList != null &&
                    this.CustomerGroupIDList.SequenceEqual(input.CustomerGroupIDList)
                ) && 
                (
                    this.PartyIdentification == input.PartyIdentification ||
                    this.PartyIdentification != null &&
                    this.PartyIdentification.SequenceEqual(input.PartyIdentification)
                ) && 
                (
                    this.Organization == input.Organization ||
                    (this.Organization != null &&
                    this.Organization.Equals(input.Organization))
                ) && 
                (
                    this.Contact == input.Contact ||
                    (this.Contact != null &&
                    this.Contact.Equals(input.Contact))
                ) && 
                (
                    this.Party == input.Party ||
                    (this.Party != null &&
                    this.Party.Equals(input.Party))
                ) && 
                (
                    this.Person == input.Person ||
                    (this.Person != null &&
                    this.Person.Equals(input.Person))
                ) && 
                (
                    this.PackageID == input.PackageID ||
                    (this.PackageID != null &&
                    this.PackageID.Equals(input.PackageID))
                ) && 
                (
                    this.DeclarationAvailable == input.DeclarationAvailable ||
                    (this.DeclarationAvailable != null &&
                    this.DeclarationAvailable.Equals(input.DeclarationAvailable))
                ) && 
                (
                    this.DateOfRecord == input.DateOfRecord ||
                    (this.DateOfRecord != null &&
                    this.DateOfRecord.Equals(input.DateOfRecord))
                ) && 
                (
                    this.RecordedBy == input.RecordedBy ||
                    (this.RecordedBy != null &&
                    this.RecordedBy.Equals(input.RecordedBy))
                ) && 
                (
                    this.StatisticalUseAllowed == input.StatisticalUseAllowed ||
                    (this.StatisticalUseAllowed != null &&
                    this.StatisticalUseAllowed.Equals(input.StatisticalUseAllowed))
                ) && 
                (
                    this.LastAccessDate == input.LastAccessDate ||
                    (this.LastAccessDate != null &&
                    this.LastAccessDate.Equals(input.LastAccessDate))
                ) && 
                (
                    this.DataProtectCode == input.DataProtectCode ||
                    (this.DataProtectCode != null &&
                    this.DataProtectCode.Equals(input.DataProtectCode))
                ) && 
                (
                    this.ParentCustomerID == input.ParentCustomerID ||
                    (this.ParentCustomerID != null &&
                    this.ParentCustomerID.Equals(input.ParentCustomerID))
                ) && 
                (
                    this.PartnerRoleList == input.PartnerRoleList ||
                    this.PartnerRoleList != null &&
                    this.PartnerRoleList.SequenceEqual(input.PartnerRoleList)
                ) && 
                (
                    this.ParentCustomerName1 == input.ParentCustomerName1 ||
                    (this.ParentCustomerName1 != null &&
                    this.ParentCustomerName1.Equals(input.ParentCustomerName1))
                ) && 
                (
                    this.ParentCustomerName2 == input.ParentCustomerName2 ||
                    (this.ParentCustomerName2 != null &&
                    this.ParentCustomerName2.Equals(input.ParentCustomerName2))
                ) && 
                (
                    this.Xxcustom08 == input.Xxcustom08 ||
                    (this.Xxcustom08 != null &&
                    this.Xxcustom08.Equals(input.Xxcustom08))
                ) && 
                (
                    this.Xxcustom10 == input.Xxcustom10 ||
                    (this.Xxcustom10 != null &&
                    this.Xxcustom10.Equals(input.Xxcustom10))
                ) && 
                (
                    this.Xxcustom09 == input.Xxcustom09 ||
                    (this.Xxcustom09 != null &&
                    this.Xxcustom09.Equals(input.Xxcustom09))
                ) && 
                (
                    this.Xxcustom07 == input.Xxcustom07 ||
                    (this.Xxcustom07 != null &&
                    this.Xxcustom07.Equals(input.Xxcustom07))
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom06 == input.Xxcustom06 ||
                    (this.Xxcustom06 != null &&
                    this.Xxcustom06.Equals(input.Xxcustom06))
                ) && 
                (
                    this.Xxcustom11 == input.Xxcustom11 ||
                    (this.Xxcustom11 != null &&
                    this.Xxcustom11.Equals(input.Xxcustom11))
                ) && 
                (
                    this.Xxcustom12 == input.Xxcustom12 ||
                    (this.Xxcustom12 != null &&
                    this.Xxcustom12.Equals(input.Xxcustom12))
                ) && 
                (
                    this.Xxcustom13 == input.Xxcustom13 ||
                    (this.Xxcustom13 != null &&
                    this.Xxcustom13.Equals(input.Xxcustom13))
                ) && 
                (
                    this.Xxcustom14 == input.Xxcustom14 ||
                    (this.Xxcustom14 != null &&
                    this.Xxcustom14.Equals(input.Xxcustom14))
                ) && 
                (
                    this.Xxcustom15 == input.Xxcustom15 ||
                    (this.Xxcustom15 != null &&
                    this.Xxcustom15.Equals(input.Xxcustom15))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom16 == input.Xxcustom16 ||
                    (this.Xxcustom16 != null &&
                    this.Xxcustom16.Equals(input.Xxcustom16))
                ) && 
                (
                    this.Xxcustom17 == input.Xxcustom17 ||
                    (this.Xxcustom17 != null &&
                    this.Xxcustom17.Equals(input.Xxcustom17))
                ) && 
                (
                    this.Xxcustom18 == input.Xxcustom18 ||
                    (this.Xxcustom18 != null &&
                    this.Xxcustom18.Equals(input.Xxcustom18))
                ) && 
                (
                    this.Xxcustom19 == input.Xxcustom19 ||
                    (this.Xxcustom19 != null &&
                    this.Xxcustom19.Equals(input.Xxcustom19))
                ) && 
                (
                    this.Xxcustom20 == input.Xxcustom20 ||
                    (this.Xxcustom20 != null &&
                    this.Xxcustom20.Equals(input.Xxcustom20))
                ) && 
                (
                    this.Xxcustom21 == input.Xxcustom21 ||
                    (this.Xxcustom21 != null &&
                    this.Xxcustom21.Equals(input.Xxcustom21))
                ) && 
                (
                    this.Xxcustom22 == input.Xxcustom22 ||
                    (this.Xxcustom22 != null &&
                    this.Xxcustom22.Equals(input.Xxcustom22))
                ) && 
                (
                    this.Xxcustom23 == input.Xxcustom23 ||
                    (this.Xxcustom23 != null &&
                    this.Xxcustom23.Equals(input.Xxcustom23))
                ) && 
                (
                    this.Xxcustom24 == input.Xxcustom24 ||
                    (this.Xxcustom24 != null &&
                    this.Xxcustom24.Equals(input.Xxcustom24))
                ) && 
                (
                    this.Xxcustom25 == input.Xxcustom25 ||
                    (this.Xxcustom25 != null &&
                    this.Xxcustom25.Equals(input.Xxcustom25))
                ) && 
                (
                    this.Xxcustom26 == input.Xxcustom26 ||
                    (this.Xxcustom26 != null &&
                    this.Xxcustom26.Equals(input.Xxcustom26))
                ) && 
                (
                    this.Xxcustom27 == input.Xxcustom27 ||
                    (this.Xxcustom27 != null &&
                    this.Xxcustom27.Equals(input.Xxcustom27))
                ) && 
                (
                    this.Xxcustom28 == input.Xxcustom28 ||
                    (this.Xxcustom28 != null &&
                    this.Xxcustom28.Equals(input.Xxcustom28))
                ) && 
                (
                    this.Xxcustom29 == input.Xxcustom29 ||
                    (this.Xxcustom29 != null &&
                    this.Xxcustom29.Equals(input.Xxcustom29))
                ) && 
                (
                    this.Xxcustom30 == input.Xxcustom30 ||
                    (this.Xxcustom30 != null &&
                    this.Xxcustom30.Equals(input.Xxcustom30))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Key != null)
                    hashCode = hashCode * 59 + this.Key.GetHashCode();
                if (this.ExternalBusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.ExternalBusinessUnitGroupID.GetHashCode();
                if (this.AllowedTermsOfPayment != null)
                    hashCode = hashCode * 59 + this.AllowedTermsOfPayment.GetHashCode();
                if (this.CreditLimit != null)
                    hashCode = hashCode * 59 + this.CreditLimit.GetHashCode();
                if (this.PersonalID != null)
                    hashCode = hashCode * 59 + this.PersonalID.GetHashCode();
                if (this.ProhibitedTermsOfPayment != null)
                    hashCode = hashCode * 59 + this.ProhibitedTermsOfPayment.GetHashCode();
                if (this.RemainingCreditLimit != null)
                    hashCode = hashCode * 59 + this.RemainingCreditLimit.GetHashCode();
                if (this.SalesTaxLiableFlag != null)
                    hashCode = hashCode * 59 + this.SalesTaxLiableFlag.GetHashCode();
                if (this.StatusCode != null)
                    hashCode = hashCode * 59 + this.StatusCode.GetHashCode();
                if (this.PreferredReceiptPrintoutTypeCode != null)
                    hashCode = hashCode * 59 + this.PreferredReceiptPrintoutTypeCode.GetHashCode();
                if (this.TaxNumber != null)
                    hashCode = hashCode * 59 + this.TaxNumber.GetHashCode();
                if (this.PartyID != null)
                    hashCode = hashCode * 59 + this.PartyID.GetHashCode();
                if (this.CreditCardList != null)
                    hashCode = hashCode * 59 + this.CreditCardList.GetHashCode();
                if (this.CustomerCardList != null)
                    hashCode = hashCode * 59 + this.CustomerCardList.GetHashCode();
                if (this.CustomerGroupIDList != null)
                    hashCode = hashCode * 59 + this.CustomerGroupIDList.GetHashCode();
                if (this.PartyIdentification != null)
                    hashCode = hashCode * 59 + this.PartyIdentification.GetHashCode();
                if (this.Organization != null)
                    hashCode = hashCode * 59 + this.Organization.GetHashCode();
                if (this.Contact != null)
                    hashCode = hashCode * 59 + this.Contact.GetHashCode();
                if (this.Party != null)
                    hashCode = hashCode * 59 + this.Party.GetHashCode();
                if (this.Person != null)
                    hashCode = hashCode * 59 + this.Person.GetHashCode();
                if (this.PackageID != null)
                    hashCode = hashCode * 59 + this.PackageID.GetHashCode();
                if (this.DeclarationAvailable != null)
                    hashCode = hashCode * 59 + this.DeclarationAvailable.GetHashCode();
                if (this.DateOfRecord != null)
                    hashCode = hashCode * 59 + this.DateOfRecord.GetHashCode();
                if (this.RecordedBy != null)
                    hashCode = hashCode * 59 + this.RecordedBy.GetHashCode();
                if (this.StatisticalUseAllowed != null)
                    hashCode = hashCode * 59 + this.StatisticalUseAllowed.GetHashCode();
                if (this.LastAccessDate != null)
                    hashCode = hashCode * 59 + this.LastAccessDate.GetHashCode();
                if (this.DataProtectCode != null)
                    hashCode = hashCode * 59 + this.DataProtectCode.GetHashCode();
                if (this.ParentCustomerID != null)
                    hashCode = hashCode * 59 + this.ParentCustomerID.GetHashCode();
                if (this.PartnerRoleList != null)
                    hashCode = hashCode * 59 + this.PartnerRoleList.GetHashCode();
                if (this.ParentCustomerName1 != null)
                    hashCode = hashCode * 59 + this.ParentCustomerName1.GetHashCode();
                if (this.ParentCustomerName2 != null)
                    hashCode = hashCode * 59 + this.ParentCustomerName2.GetHashCode();
                if (this.Xxcustom08 != null)
                    hashCode = hashCode * 59 + this.Xxcustom08.GetHashCode();
                if (this.Xxcustom10 != null)
                    hashCode = hashCode * 59 + this.Xxcustom10.GetHashCode();
                if (this.Xxcustom09 != null)
                    hashCode = hashCode * 59 + this.Xxcustom09.GetHashCode();
                if (this.Xxcustom07 != null)
                    hashCode = hashCode * 59 + this.Xxcustom07.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom06 != null)
                    hashCode = hashCode * 59 + this.Xxcustom06.GetHashCode();
                if (this.Xxcustom11 != null)
                    hashCode = hashCode * 59 + this.Xxcustom11.GetHashCode();
                if (this.Xxcustom12 != null)
                    hashCode = hashCode * 59 + this.Xxcustom12.GetHashCode();
                if (this.Xxcustom13 != null)
                    hashCode = hashCode * 59 + this.Xxcustom13.GetHashCode();
                if (this.Xxcustom14 != null)
                    hashCode = hashCode * 59 + this.Xxcustom14.GetHashCode();
                if (this.Xxcustom15 != null)
                    hashCode = hashCode * 59 + this.Xxcustom15.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom16 != null)
                    hashCode = hashCode * 59 + this.Xxcustom16.GetHashCode();
                if (this.Xxcustom17 != null)
                    hashCode = hashCode * 59 + this.Xxcustom17.GetHashCode();
                if (this.Xxcustom18 != null)
                    hashCode = hashCode * 59 + this.Xxcustom18.GetHashCode();
                if (this.Xxcustom19 != null)
                    hashCode = hashCode * 59 + this.Xxcustom19.GetHashCode();
                if (this.Xxcustom20 != null)
                    hashCode = hashCode * 59 + this.Xxcustom20.GetHashCode();
                if (this.Xxcustom21 != null)
                    hashCode = hashCode * 59 + this.Xxcustom21.GetHashCode();
                if (this.Xxcustom22 != null)
                    hashCode = hashCode * 59 + this.Xxcustom22.GetHashCode();
                if (this.Xxcustom23 != null)
                    hashCode = hashCode * 59 + this.Xxcustom23.GetHashCode();
                if (this.Xxcustom24 != null)
                    hashCode = hashCode * 59 + this.Xxcustom24.GetHashCode();
                if (this.Xxcustom25 != null)
                    hashCode = hashCode * 59 + this.Xxcustom25.GetHashCode();
                if (this.Xxcustom26 != null)
                    hashCode = hashCode * 59 + this.Xxcustom26.GetHashCode();
                if (this.Xxcustom27 != null)
                    hashCode = hashCode * 59 + this.Xxcustom27.GetHashCode();
                if (this.Xxcustom28 != null)
                    hashCode = hashCode * 59 + this.Xxcustom28.GetHashCode();
                if (this.Xxcustom29 != null)
                    hashCode = hashCode * 59 + this.Xxcustom29.GetHashCode();
                if (this.Xxcustom30 != null)
                    hashCode = hashCode * 59 + this.Xxcustom30.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
