/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PosUOMItemSellingPriceDO.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey :  IEquatable<ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum PriceTypeCodeEnum
        {
            
            /// <summary>
            /// Enum DEFAULTPRICE for value: DEFAULT_PRICE
            /// </summary>
            [EnumMember(Value = "DEFAULT_PRICE")]
            DEFAULTPRICE = 1,
            
            /// <summary>
            /// Enum SPECIALPRICE for value: SPECIAL_PRICE
            /// </summary>
            [EnumMember(Value = "SPECIAL_PRICE")]
            SPECIALPRICE = 2,
            
            /// <summary>
            /// Enum PRICEGROUP for value: PRICE_GROUP
            /// </summary>
            [EnumMember(Value = "PRICE_GROUP")]
            PRICEGROUP = 3
        }

        /// <summary>
        /// &lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="priceTypeCode", EmitDefaultValue=false)]
        public PriceTypeCodeEnum PriceTypeCode { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique retailer assigned identifier for the business unit group&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="itemID">&lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="uomCode">&lt;p&gt;Unit of measure code&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="priceTypeCode">&lt;p&gt;Type code of price (00 &#x3D; default price, 01 &#x3D; special price, PG &#x3D; group price)&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="priceEffectiveDate">&lt;p&gt;Effective (start) time stamp of the price&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone) (required).</param>
        public ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey(string businessUnitGroupID = default(string), string itemID = default(string), string uomCode = default(string), PriceTypeCodeEnum priceTypeCode = default(PriceTypeCodeEnum), string priceEffectiveDate = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "itemID" is required (not null)
            if (itemID == null)
            {
                throw new InvalidDataException("itemID is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey and cannot be null");
            }
            else
            {
                this.ItemID = itemID;
            }
            // to ensure "uomCode" is required (not null)
            if (uomCode == null)
            {
                throw new InvalidDataException("uomCode is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey and cannot be null");
            }
            else
            {
                this.UomCode = uomCode;
            }
            // to ensure "priceTypeCode" is required (not null)
            if (priceTypeCode == null)
            {
                throw new InvalidDataException("priceTypeCode is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey and cannot be null");
            }
            else
            {
                this.PriceTypeCode = priceTypeCode;
            }
            // to ensure "priceEffectiveDate" is required (not null)
            if (priceEffectiveDate == null)
            {
                throw new InvalidDataException("priceEffectiveDate is a required property for ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey and cannot be null");
            }
            else
            {
                this.PriceEffectiveDate = priceEffectiveDate;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique retailer assigned identifier for the business unit group&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique retailer assigned identifier for the business unit group&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="itemID", EmitDefaultValue=false)]
        public string ItemID { get; set; }

        /// <summary>
        /// &lt;p&gt;Unit of measure code&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Unit of measure code&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="uomCode", EmitDefaultValue=false)]
        public string UomCode { get; set; }


        /// <summary>
        /// &lt;p&gt;Effective (start) time stamp of the price&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Effective (start) time stamp of the price&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="priceEffectiveDate", EmitDefaultValue=false)]
        public string PriceEffectiveDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  ItemID: ").Append(ItemID).Append("\n");
            sb.Append("  UomCode: ").Append(UomCode).Append("\n");
            sb.Append("  PriceTypeCode: ").Append(PriceTypeCode).Append("\n");
            sb.Append("  PriceEffectiveDate: ").Append(PriceEffectiveDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSellingPriceDOKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.ItemID == input.ItemID ||
                    (this.ItemID != null &&
                    this.ItemID.Equals(input.ItemID))
                ) && 
                (
                    this.UomCode == input.UomCode ||
                    (this.UomCode != null &&
                    this.UomCode.Equals(input.UomCode))
                ) && 
                (
                    this.PriceTypeCode == input.PriceTypeCode ||
                    (this.PriceTypeCode != null &&
                    this.PriceTypeCode.Equals(input.PriceTypeCode))
                ) && 
                (
                    this.PriceEffectiveDate == input.PriceEffectiveDate ||
                    (this.PriceEffectiveDate != null &&
                    this.PriceEffectiveDate.Equals(input.PriceEffectiveDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.ItemID != null)
                    hashCode = hashCode * 59 + this.ItemID.GetHashCode();
                if (this.UomCode != null)
                    hashCode = hashCode * 59 + this.UomCode.GetHashCode();
                if (this.PriceTypeCode != null)
                    hashCode = hashCode * 59 + this.PriceTypeCode.GetHashCode();
                if (this.PriceEffectiveDate != null)
                    hashCode = hashCode * 59 + this.PriceEffectiveDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
