/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PartyIdentification.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey :  IEquatable<ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey" /> class.
        /// </summary>
        /// <param name="partyID">&lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="partyIdentificationTypeCode">&lt;p&gt;A code denoting a form of identification, e. g. BusinessTypeCode, TaxTypeCode.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey(string partyID = default(string), string businessUnitGroupID = default(string), string partyIdentificationTypeCode = default(string))
        {
            // to ensure "partyID" is required (not null)
            if (partyID == null)
            {
                throw new InvalidDataException("partyID is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey and cannot be null");
            }
            else
            {
                this.PartyID = partyID;
            }
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "partyIdentificationTypeCode" is required (not null)
            if (partyIdentificationTypeCode == null)
            {
                throw new InvalidDataException("partyIdentificationTypeCode is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey and cannot be null");
            }
            else
            {
                this.PartyIdentificationTypeCode = partyIdentificationTypeCode;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyID", EmitDefaultValue=false)]
        public string PartyID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A code denoting a form of identification, e. g. BusinessTypeCode, TaxTypeCode.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code denoting a form of identification, e. g. BusinessTypeCode, TaxTypeCode.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyIdentificationTypeCode", EmitDefaultValue=false)]
        public string PartyIdentificationTypeCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey {\n");
            sb.Append("  PartyID: ").Append(PartyID).Append("\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  PartyIdentificationTypeCode: ").Append(PartyIdentificationTypeCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdPartyDtoDomPartyIdentificationKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PartyID == input.PartyID ||
                    (this.PartyID != null &&
                    this.PartyID.Equals(input.PartyID))
                ) && 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.PartyIdentificationTypeCode == input.PartyIdentificationTypeCode ||
                    (this.PartyIdentificationTypeCode != null &&
                    this.PartyIdentificationTypeCode.Equals(input.PartyIdentificationTypeCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PartyID != null)
                    hashCode = hashCode * 59 + this.PartyID.GetHashCode();
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.PartyIdentificationTypeCode != null)
                    hashCode = hashCode * 59 + this.PartyIdentificationTypeCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
