/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PartyRoleAssignment.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey :  IEquatable<ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey" /> class.
        /// </summary>
        /// <param name="partyID">&lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for the business unit group.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="partyRoleTypeCode">&lt;p&gt;A code that identifies a group of PARTY ROLES. This is used for subtyping the PARTY ROLEs.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="sequenceNumber">&lt;p&gt;A unique system assigned identifier for the particular assignment of Party to the PartyRole.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey(string partyID = default(string), string businessUnitGroupID = default(string), string partyRoleTypeCode = default(string), int? sequenceNumber = default(int?))
        {
            // to ensure "partyID" is required (not null)
            if (partyID == null)
            {
                throw new InvalidDataException("partyID is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey and cannot be null");
            }
            else
            {
                this.PartyID = partyID;
            }
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "partyRoleTypeCode" is required (not null)
            if (partyRoleTypeCode == null)
            {
                throw new InvalidDataException("partyRoleTypeCode is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey and cannot be null");
            }
            else
            {
                this.PartyRoleTypeCode = partyRoleTypeCode;
            }
            // to ensure "sequenceNumber" is required (not null)
            if (sequenceNumber == null)
            {
                throw new InvalidDataException("sequenceNumber is a required property for ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey and cannot be null");
            }
            else
            {
                this.SequenceNumber = sequenceNumber;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique, system assigned identity for the party.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyID", EmitDefaultValue=false)]
        public string PartyID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the business unit group.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the business unit group.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A code that identifies a group of PARTY ROLES. This is used for subtyping the PARTY ROLEs.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code that identifies a group of PARTY ROLES. This is used for subtyping the PARTY ROLEs.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="partyRoleTypeCode", EmitDefaultValue=false)]
        public string PartyRoleTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the particular assignment of Party to the PartyRole.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the particular assignment of Party to the PartyRole.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="sequenceNumber", EmitDefaultValue=false)]
        public int? SequenceNumber { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey {\n");
            sb.Append("  PartyID: ").Append(PartyID).Append("\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  PartyRoleTypeCode: ").Append(PartyRoleTypeCode).Append("\n");
            sb.Append("  SequenceNumber: ").Append(SequenceNumber).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdPartyDtoDomPartyRoleAssignmentKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PartyID == input.PartyID ||
                    (this.PartyID != null &&
                    this.PartyID.Equals(input.PartyID))
                ) && 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.PartyRoleTypeCode == input.PartyRoleTypeCode ||
                    (this.PartyRoleTypeCode != null &&
                    this.PartyRoleTypeCode.Equals(input.PartyRoleTypeCode))
                ) && 
                (
                    this.SequenceNumber == input.SequenceNumber ||
                    (this.SequenceNumber != null &&
                    this.SequenceNumber.Equals(input.SequenceNumber))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PartyID != null)
                    hashCode = hashCode * 59 + this.PartyID.GetHashCode();
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.PartyRoleTypeCode != null)
                    hashCode = hashCode * 59 + this.PartyRoleTypeCode.GetHashCode();
                if (this.SequenceNumber != null)
                    hashCode = hashCode * 59 + this.SequenceNumber.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
