/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TankDO &lt;p&gt;A kind of Location used to store a FuelItem that is measured &amp;amp; dispensed by one or more FuelingPoints&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO :  IEquatable<ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO" /> class.
        /// </summary>
        /// <param name="key">&lt;p&gt;Getter for inner key class.&lt;/p&gt; (required).</param>
        /// <param name="fuelGradeID">&lt;p&gt;Generated ID of a  fuel grade.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="maximumSafeFillCapacity">&lt;p&gt;The largest capacity that the tank safely holds, taking temperature effects into consideration.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="lowCapacity">&lt;p&gt;The volume to which a tank may be emptied  without prumping vapour into the line. The amount of product that just reaches the entrance of the suction pipe.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="tankDiameter">&lt;p&gt;The diameter of the tank&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="highWaterSetPoint">&lt;p&gt;The level at which the TankLevelGuage will set off the &#39;High Water Alarm&#39;&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="itemID">&lt;p&gt;Reference to BusinessUnitGroupItem&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="unitOfMeasureCode">&lt;p&gt;The UOM of the Item&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="fuelProductID">fuelProductID.</param>
        /// <param name="fuelName">fuelName.</param>
        /// <param name="tankGroupID">tankGroupID.</param>
        /// <param name="tankLevelGaugeID">tankLevelGaugeID.</param>
        /// <param name="xxcustom08">xxcustom08.</param>
        /// <param name="xxcustom10">xxcustom10.</param>
        /// <param name="xxcustom09">xxcustom09.</param>
        /// <param name="xxcustom07">xxcustom07.</param>
        /// <param name="xxcustom05">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom06">xxcustom06.</param>
        /// <param name="xxcustom11">xxcustom11.</param>
        /// <param name="xxcustom12">xxcustom12.</param>
        /// <param name="xxcustom13">xxcustom13.</param>
        /// <param name="xxcustom14">xxcustom14.</param>
        /// <param name="xxcustom15">xxcustom15.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom04">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom16">xxcustom16.</param>
        /// <param name="xxcustom17">xxcustom17.</param>
        /// <param name="xxcustom18">xxcustom18.</param>
        /// <param name="xxcustom19">xxcustom19.</param>
        /// <param name="xxcustom20">xxcustom20.</param>
        /// <param name="xxcustom21">xxcustom21.</param>
        /// <param name="xxcustom22">xxcustom22.</param>
        /// <param name="xxcustom23">xxcustom23.</param>
        /// <param name="xxcustom24">xxcustom24.</param>
        /// <param name="xxcustom25">xxcustom25.</param>
        /// <param name="xxcustom26">xxcustom26.</param>
        /// <param name="xxcustom27">xxcustom27.</param>
        /// <param name="xxcustom28">xxcustom28.</param>
        /// <param name="xxcustom29">xxcustom29.</param>
        /// <param name="xxcustom30">xxcustom30.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO(ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDOKey key = default(ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDOKey), string fuelGradeID = default(string), double? maximumSafeFillCapacity = default(double?), double? lowCapacity = default(double?), double? tankDiameter = default(double?), double? highWaterSetPoint = default(double?), string itemID = default(string), string unitOfMeasureCode = default(string), int? fuelProductID = default(int?), string fuelName = default(string), int? tankGroupID = default(int?), int? tankLevelGaugeID = default(int?), string xxcustom08 = default(string), string xxcustom10 = default(string), string xxcustom09 = default(string), string xxcustom07 = default(string), string xxcustom05 = default(string), string xxcustom06 = default(string), string xxcustom11 = default(string), string xxcustom12 = default(string), string xxcustom13 = default(string), string xxcustom14 = default(string), string xxcustom15 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom16 = default(string), string xxcustom17 = default(string), string xxcustom18 = default(string), string xxcustom19 = default(string), string xxcustom20 = default(string), string xxcustom21 = default(string), string xxcustom22 = default(string), string xxcustom23 = default(string), string xxcustom24 = default(string), string xxcustom25 = default(string), string xxcustom26 = default(string), string xxcustom27 = default(string), string xxcustom28 = default(string), string xxcustom29 = default(string), string xxcustom30 = default(string), string xxcustom01 = default(string))
        {
            // to ensure "key" is required (not null)
            if (key == null)
            {
                throw new InvalidDataException("key is a required property for ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO and cannot be null");
            }
            else
            {
                this.Key = key;
            }
            // to ensure "fuelGradeID" is required (not null)
            if (fuelGradeID == null)
            {
                throw new InvalidDataException("fuelGradeID is a required property for ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO and cannot be null");
            }
            else
            {
                this.FuelGradeID = fuelGradeID;
            }
            this.MaximumSafeFillCapacity = maximumSafeFillCapacity;
            this.LowCapacity = lowCapacity;
            this.TankDiameter = tankDiameter;
            this.HighWaterSetPoint = highWaterSetPoint;
            this.ItemID = itemID;
            this.UnitOfMeasureCode = unitOfMeasureCode;
            this.FuelProductID = fuelProductID;
            this.FuelName = fuelName;
            this.TankGroupID = tankGroupID;
            this.TankLevelGaugeID = tankLevelGaugeID;
            this.Xxcustom08 = xxcustom08;
            this.Xxcustom10 = xxcustom10;
            this.Xxcustom09 = xxcustom09;
            this.Xxcustom07 = xxcustom07;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom06 = xxcustom06;
            this.Xxcustom11 = xxcustom11;
            this.Xxcustom12 = xxcustom12;
            this.Xxcustom13 = xxcustom13;
            this.Xxcustom14 = xxcustom14;
            this.Xxcustom15 = xxcustom15;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom16 = xxcustom16;
            this.Xxcustom17 = xxcustom17;
            this.Xxcustom18 = xxcustom18;
            this.Xxcustom19 = xxcustom19;
            this.Xxcustom20 = xxcustom20;
            this.Xxcustom21 = xxcustom21;
            this.Xxcustom22 = xxcustom22;
            this.Xxcustom23 = xxcustom23;
            this.Xxcustom24 = xxcustom24;
            this.Xxcustom25 = xxcustom25;
            this.Xxcustom26 = xxcustom26;
            this.Xxcustom27 = xxcustom27;
            this.Xxcustom28 = xxcustom28;
            this.Xxcustom29 = xxcustom29;
            this.Xxcustom30 = xxcustom30;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        [DataMember(Name="key", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDOKey Key { get; set; }

        /// <summary>
        /// &lt;p&gt;Generated ID of a  fuel grade.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Generated ID of a  fuel grade.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="fuelGradeID", EmitDefaultValue=false)]
        public string FuelGradeID { get; set; }

        /// <summary>
        /// &lt;p&gt;The largest capacity that the tank safely holds, taking temperature effects into consideration.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The largest capacity that the tank safely holds, taking temperature effects into consideration.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="maximumSafeFillCapacity", EmitDefaultValue=false)]
        public double? MaximumSafeFillCapacity { get; set; }

        /// <summary>
        /// &lt;p&gt;The volume to which a tank may be emptied  without prumping vapour into the line. The amount of product that just reaches the entrance of the suction pipe.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The volume to which a tank may be emptied  without prumping vapour into the line. The amount of product that just reaches the entrance of the suction pipe.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="lowCapacity", EmitDefaultValue=false)]
        public double? LowCapacity { get; set; }

        /// <summary>
        /// &lt;p&gt;The diameter of the tank&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The diameter of the tank&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="tankDiameter", EmitDefaultValue=false)]
        public double? TankDiameter { get; set; }

        /// <summary>
        /// &lt;p&gt;The level at which the TankLevelGuage will set off the &#39;High Water Alarm&#39;&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The level at which the TankLevelGuage will set off the &#39;High Water Alarm&#39;&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="highWaterSetPoint", EmitDefaultValue=false)]
        public double? HighWaterSetPoint { get; set; }

        /// <summary>
        /// &lt;p&gt;Reference to BusinessUnitGroupItem&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to BusinessUnitGroupItem&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="itemID", EmitDefaultValue=false)]
        public string ItemID { get; set; }

        /// <summary>
        /// &lt;p&gt;The UOM of the Item&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The UOM of the Item&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="unitOfMeasureCode", EmitDefaultValue=false)]
        public string UnitOfMeasureCode { get; set; }

        /// <summary>
        /// Gets or Sets FuelProductID
        /// </summary>
        [DataMember(Name="fuelProductID", EmitDefaultValue=false)]
        public int? FuelProductID { get; set; }

        /// <summary>
        /// Gets or Sets FuelName
        /// </summary>
        [DataMember(Name="fuelName", EmitDefaultValue=false)]
        public string FuelName { get; set; }

        /// <summary>
        /// Gets or Sets TankGroupID
        /// </summary>
        [DataMember(Name="tankGroupID", EmitDefaultValue=false)]
        public int? TankGroupID { get; set; }

        /// <summary>
        /// Gets or Sets TankLevelGaugeID
        /// </summary>
        [DataMember(Name="tankLevelGaugeID", EmitDefaultValue=false)]
        public int? TankLevelGaugeID { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom08
        /// </summary>
        [DataMember(Name="xxcustom08", EmitDefaultValue=false)]
        public string Xxcustom08 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom10
        /// </summary>
        [DataMember(Name="xxcustom10", EmitDefaultValue=false)]
        public string Xxcustom10 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom09
        /// </summary>
        [DataMember(Name="xxcustom09", EmitDefaultValue=false)]
        public string Xxcustom09 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom07
        /// </summary>
        [DataMember(Name="xxcustom07", EmitDefaultValue=false)]
        public string Xxcustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom06
        /// </summary>
        [DataMember(Name="xxcustom06", EmitDefaultValue=false)]
        public string Xxcustom06 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom11
        /// </summary>
        [DataMember(Name="xxcustom11", EmitDefaultValue=false)]
        public string Xxcustom11 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom12
        /// </summary>
        [DataMember(Name="xxcustom12", EmitDefaultValue=false)]
        public string Xxcustom12 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom13
        /// </summary>
        [DataMember(Name="xxcustom13", EmitDefaultValue=false)]
        public string Xxcustom13 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom14
        /// </summary>
        [DataMember(Name="xxcustom14", EmitDefaultValue=false)]
        public string Xxcustom14 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom15
        /// </summary>
        [DataMember(Name="xxcustom15", EmitDefaultValue=false)]
        public string Xxcustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom16
        /// </summary>
        [DataMember(Name="xxcustom16", EmitDefaultValue=false)]
        public string Xxcustom16 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom17
        /// </summary>
        [DataMember(Name="xxcustom17", EmitDefaultValue=false)]
        public string Xxcustom17 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom18
        /// </summary>
        [DataMember(Name="xxcustom18", EmitDefaultValue=false)]
        public string Xxcustom18 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom19
        /// </summary>
        [DataMember(Name="xxcustom19", EmitDefaultValue=false)]
        public string Xxcustom19 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom20
        /// </summary>
        [DataMember(Name="xxcustom20", EmitDefaultValue=false)]
        public string Xxcustom20 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom21
        /// </summary>
        [DataMember(Name="xxcustom21", EmitDefaultValue=false)]
        public string Xxcustom21 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom22
        /// </summary>
        [DataMember(Name="xxcustom22", EmitDefaultValue=false)]
        public string Xxcustom22 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom23
        /// </summary>
        [DataMember(Name="xxcustom23", EmitDefaultValue=false)]
        public string Xxcustom23 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom24
        /// </summary>
        [DataMember(Name="xxcustom24", EmitDefaultValue=false)]
        public string Xxcustom24 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom25
        /// </summary>
        [DataMember(Name="xxcustom25", EmitDefaultValue=false)]
        public string Xxcustom25 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom26
        /// </summary>
        [DataMember(Name="xxcustom26", EmitDefaultValue=false)]
        public string Xxcustom26 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom27
        /// </summary>
        [DataMember(Name="xxcustom27", EmitDefaultValue=false)]
        public string Xxcustom27 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom28
        /// </summary>
        [DataMember(Name="xxcustom28", EmitDefaultValue=false)]
        public string Xxcustom28 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom29
        /// </summary>
        [DataMember(Name="xxcustom29", EmitDefaultValue=false)]
        public string Xxcustom29 { get; set; }

        /// <summary>
        /// Gets or Sets Xxcustom30
        /// </summary>
        [DataMember(Name="xxcustom30", EmitDefaultValue=false)]
        public string Xxcustom30 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO {\n");
            sb.Append("  Key: ").Append(Key).Append("\n");
            sb.Append("  FuelGradeID: ").Append(FuelGradeID).Append("\n");
            sb.Append("  MaximumSafeFillCapacity: ").Append(MaximumSafeFillCapacity).Append("\n");
            sb.Append("  LowCapacity: ").Append(LowCapacity).Append("\n");
            sb.Append("  TankDiameter: ").Append(TankDiameter).Append("\n");
            sb.Append("  HighWaterSetPoint: ").Append(HighWaterSetPoint).Append("\n");
            sb.Append("  ItemID: ").Append(ItemID).Append("\n");
            sb.Append("  UnitOfMeasureCode: ").Append(UnitOfMeasureCode).Append("\n");
            sb.Append("  FuelProductID: ").Append(FuelProductID).Append("\n");
            sb.Append("  FuelName: ").Append(FuelName).Append("\n");
            sb.Append("  TankGroupID: ").Append(TankGroupID).Append("\n");
            sb.Append("  TankLevelGaugeID: ").Append(TankLevelGaugeID).Append("\n");
            sb.Append("  Xxcustom08: ").Append(Xxcustom08).Append("\n");
            sb.Append("  Xxcustom10: ").Append(Xxcustom10).Append("\n");
            sb.Append("  Xxcustom09: ").Append(Xxcustom09).Append("\n");
            sb.Append("  Xxcustom07: ").Append(Xxcustom07).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom06: ").Append(Xxcustom06).Append("\n");
            sb.Append("  Xxcustom11: ").Append(Xxcustom11).Append("\n");
            sb.Append("  Xxcustom12: ").Append(Xxcustom12).Append("\n");
            sb.Append("  Xxcustom13: ").Append(Xxcustom13).Append("\n");
            sb.Append("  Xxcustom14: ").Append(Xxcustom14).Append("\n");
            sb.Append("  Xxcustom15: ").Append(Xxcustom15).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom16: ").Append(Xxcustom16).Append("\n");
            sb.Append("  Xxcustom17: ").Append(Xxcustom17).Append("\n");
            sb.Append("  Xxcustom18: ").Append(Xxcustom18).Append("\n");
            sb.Append("  Xxcustom19: ").Append(Xxcustom19).Append("\n");
            sb.Append("  Xxcustom20: ").Append(Xxcustom20).Append("\n");
            sb.Append("  Xxcustom21: ").Append(Xxcustom21).Append("\n");
            sb.Append("  Xxcustom22: ").Append(Xxcustom22).Append("\n");
            sb.Append("  Xxcustom23: ").Append(Xxcustom23).Append("\n");
            sb.Append("  Xxcustom24: ").Append(Xxcustom24).Append("\n");
            sb.Append("  Xxcustom25: ").Append(Xxcustom25).Append("\n");
            sb.Append("  Xxcustom26: ").Append(Xxcustom26).Append("\n");
            sb.Append("  Xxcustom27: ").Append(Xxcustom27).Append("\n");
            sb.Append("  Xxcustom28: ").Append(Xxcustom28).Append("\n");
            sb.Append("  Xxcustom29: ").Append(Xxcustom29).Append("\n");
            sb.Append("  Xxcustom30: ").Append(Xxcustom30).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Key == input.Key ||
                    (this.Key != null &&
                    this.Key.Equals(input.Key))
                ) && 
                (
                    this.FuelGradeID == input.FuelGradeID ||
                    (this.FuelGradeID != null &&
                    this.FuelGradeID.Equals(input.FuelGradeID))
                ) && 
                (
                    this.MaximumSafeFillCapacity == input.MaximumSafeFillCapacity ||
                    (this.MaximumSafeFillCapacity != null &&
                    this.MaximumSafeFillCapacity.Equals(input.MaximumSafeFillCapacity))
                ) && 
                (
                    this.LowCapacity == input.LowCapacity ||
                    (this.LowCapacity != null &&
                    this.LowCapacity.Equals(input.LowCapacity))
                ) && 
                (
                    this.TankDiameter == input.TankDiameter ||
                    (this.TankDiameter != null &&
                    this.TankDiameter.Equals(input.TankDiameter))
                ) && 
                (
                    this.HighWaterSetPoint == input.HighWaterSetPoint ||
                    (this.HighWaterSetPoint != null &&
                    this.HighWaterSetPoint.Equals(input.HighWaterSetPoint))
                ) && 
                (
                    this.ItemID == input.ItemID ||
                    (this.ItemID != null &&
                    this.ItemID.Equals(input.ItemID))
                ) && 
                (
                    this.UnitOfMeasureCode == input.UnitOfMeasureCode ||
                    (this.UnitOfMeasureCode != null &&
                    this.UnitOfMeasureCode.Equals(input.UnitOfMeasureCode))
                ) && 
                (
                    this.FuelProductID == input.FuelProductID ||
                    (this.FuelProductID != null &&
                    this.FuelProductID.Equals(input.FuelProductID))
                ) && 
                (
                    this.FuelName == input.FuelName ||
                    (this.FuelName != null &&
                    this.FuelName.Equals(input.FuelName))
                ) && 
                (
                    this.TankGroupID == input.TankGroupID ||
                    (this.TankGroupID != null &&
                    this.TankGroupID.Equals(input.TankGroupID))
                ) && 
                (
                    this.TankLevelGaugeID == input.TankLevelGaugeID ||
                    (this.TankLevelGaugeID != null &&
                    this.TankLevelGaugeID.Equals(input.TankLevelGaugeID))
                ) && 
                (
                    this.Xxcustom08 == input.Xxcustom08 ||
                    (this.Xxcustom08 != null &&
                    this.Xxcustom08.Equals(input.Xxcustom08))
                ) && 
                (
                    this.Xxcustom10 == input.Xxcustom10 ||
                    (this.Xxcustom10 != null &&
                    this.Xxcustom10.Equals(input.Xxcustom10))
                ) && 
                (
                    this.Xxcustom09 == input.Xxcustom09 ||
                    (this.Xxcustom09 != null &&
                    this.Xxcustom09.Equals(input.Xxcustom09))
                ) && 
                (
                    this.Xxcustom07 == input.Xxcustom07 ||
                    (this.Xxcustom07 != null &&
                    this.Xxcustom07.Equals(input.Xxcustom07))
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom06 == input.Xxcustom06 ||
                    (this.Xxcustom06 != null &&
                    this.Xxcustom06.Equals(input.Xxcustom06))
                ) && 
                (
                    this.Xxcustom11 == input.Xxcustom11 ||
                    (this.Xxcustom11 != null &&
                    this.Xxcustom11.Equals(input.Xxcustom11))
                ) && 
                (
                    this.Xxcustom12 == input.Xxcustom12 ||
                    (this.Xxcustom12 != null &&
                    this.Xxcustom12.Equals(input.Xxcustom12))
                ) && 
                (
                    this.Xxcustom13 == input.Xxcustom13 ||
                    (this.Xxcustom13 != null &&
                    this.Xxcustom13.Equals(input.Xxcustom13))
                ) && 
                (
                    this.Xxcustom14 == input.Xxcustom14 ||
                    (this.Xxcustom14 != null &&
                    this.Xxcustom14.Equals(input.Xxcustom14))
                ) && 
                (
                    this.Xxcustom15 == input.Xxcustom15 ||
                    (this.Xxcustom15 != null &&
                    this.Xxcustom15.Equals(input.Xxcustom15))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom16 == input.Xxcustom16 ||
                    (this.Xxcustom16 != null &&
                    this.Xxcustom16.Equals(input.Xxcustom16))
                ) && 
                (
                    this.Xxcustom17 == input.Xxcustom17 ||
                    (this.Xxcustom17 != null &&
                    this.Xxcustom17.Equals(input.Xxcustom17))
                ) && 
                (
                    this.Xxcustom18 == input.Xxcustom18 ||
                    (this.Xxcustom18 != null &&
                    this.Xxcustom18.Equals(input.Xxcustom18))
                ) && 
                (
                    this.Xxcustom19 == input.Xxcustom19 ||
                    (this.Xxcustom19 != null &&
                    this.Xxcustom19.Equals(input.Xxcustom19))
                ) && 
                (
                    this.Xxcustom20 == input.Xxcustom20 ||
                    (this.Xxcustom20 != null &&
                    this.Xxcustom20.Equals(input.Xxcustom20))
                ) && 
                (
                    this.Xxcustom21 == input.Xxcustom21 ||
                    (this.Xxcustom21 != null &&
                    this.Xxcustom21.Equals(input.Xxcustom21))
                ) && 
                (
                    this.Xxcustom22 == input.Xxcustom22 ||
                    (this.Xxcustom22 != null &&
                    this.Xxcustom22.Equals(input.Xxcustom22))
                ) && 
                (
                    this.Xxcustom23 == input.Xxcustom23 ||
                    (this.Xxcustom23 != null &&
                    this.Xxcustom23.Equals(input.Xxcustom23))
                ) && 
                (
                    this.Xxcustom24 == input.Xxcustom24 ||
                    (this.Xxcustom24 != null &&
                    this.Xxcustom24.Equals(input.Xxcustom24))
                ) && 
                (
                    this.Xxcustom25 == input.Xxcustom25 ||
                    (this.Xxcustom25 != null &&
                    this.Xxcustom25.Equals(input.Xxcustom25))
                ) && 
                (
                    this.Xxcustom26 == input.Xxcustom26 ||
                    (this.Xxcustom26 != null &&
                    this.Xxcustom26.Equals(input.Xxcustom26))
                ) && 
                (
                    this.Xxcustom27 == input.Xxcustom27 ||
                    (this.Xxcustom27 != null &&
                    this.Xxcustom27.Equals(input.Xxcustom27))
                ) && 
                (
                    this.Xxcustom28 == input.Xxcustom28 ||
                    (this.Xxcustom28 != null &&
                    this.Xxcustom28.Equals(input.Xxcustom28))
                ) && 
                (
                    this.Xxcustom29 == input.Xxcustom29 ||
                    (this.Xxcustom29 != null &&
                    this.Xxcustom29.Equals(input.Xxcustom29))
                ) && 
                (
                    this.Xxcustom30 == input.Xxcustom30 ||
                    (this.Xxcustom30 != null &&
                    this.Xxcustom30.Equals(input.Xxcustom30))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Key != null)
                    hashCode = hashCode * 59 + this.Key.GetHashCode();
                if (this.FuelGradeID != null)
                    hashCode = hashCode * 59 + this.FuelGradeID.GetHashCode();
                if (this.MaximumSafeFillCapacity != null)
                    hashCode = hashCode * 59 + this.MaximumSafeFillCapacity.GetHashCode();
                if (this.LowCapacity != null)
                    hashCode = hashCode * 59 + this.LowCapacity.GetHashCode();
                if (this.TankDiameter != null)
                    hashCode = hashCode * 59 + this.TankDiameter.GetHashCode();
                if (this.HighWaterSetPoint != null)
                    hashCode = hashCode * 59 + this.HighWaterSetPoint.GetHashCode();
                if (this.ItemID != null)
                    hashCode = hashCode * 59 + this.ItemID.GetHashCode();
                if (this.UnitOfMeasureCode != null)
                    hashCode = hashCode * 59 + this.UnitOfMeasureCode.GetHashCode();
                if (this.FuelProductID != null)
                    hashCode = hashCode * 59 + this.FuelProductID.GetHashCode();
                if (this.FuelName != null)
                    hashCode = hashCode * 59 + this.FuelName.GetHashCode();
                if (this.TankGroupID != null)
                    hashCode = hashCode * 59 + this.TankGroupID.GetHashCode();
                if (this.TankLevelGaugeID != null)
                    hashCode = hashCode * 59 + this.TankLevelGaugeID.GetHashCode();
                if (this.Xxcustom08 != null)
                    hashCode = hashCode * 59 + this.Xxcustom08.GetHashCode();
                if (this.Xxcustom10 != null)
                    hashCode = hashCode * 59 + this.Xxcustom10.GetHashCode();
                if (this.Xxcustom09 != null)
                    hashCode = hashCode * 59 + this.Xxcustom09.GetHashCode();
                if (this.Xxcustom07 != null)
                    hashCode = hashCode * 59 + this.Xxcustom07.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom06 != null)
                    hashCode = hashCode * 59 + this.Xxcustom06.GetHashCode();
                if (this.Xxcustom11 != null)
                    hashCode = hashCode * 59 + this.Xxcustom11.GetHashCode();
                if (this.Xxcustom12 != null)
                    hashCode = hashCode * 59 + this.Xxcustom12.GetHashCode();
                if (this.Xxcustom13 != null)
                    hashCode = hashCode * 59 + this.Xxcustom13.GetHashCode();
                if (this.Xxcustom14 != null)
                    hashCode = hashCode * 59 + this.Xxcustom14.GetHashCode();
                if (this.Xxcustom15 != null)
                    hashCode = hashCode * 59 + this.Xxcustom15.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom16 != null)
                    hashCode = hashCode * 59 + this.Xxcustom16.GetHashCode();
                if (this.Xxcustom17 != null)
                    hashCode = hashCode * 59 + this.Xxcustom17.GetHashCode();
                if (this.Xxcustom18 != null)
                    hashCode = hashCode * 59 + this.Xxcustom18.GetHashCode();
                if (this.Xxcustom19 != null)
                    hashCode = hashCode * 59 + this.Xxcustom19.GetHashCode();
                if (this.Xxcustom20 != null)
                    hashCode = hashCode * 59 + this.Xxcustom20.GetHashCode();
                if (this.Xxcustom21 != null)
                    hashCode = hashCode * 59 + this.Xxcustom21.GetHashCode();
                if (this.Xxcustom22 != null)
                    hashCode = hashCode * 59 + this.Xxcustom22.GetHashCode();
                if (this.Xxcustom23 != null)
                    hashCode = hashCode * 59 + this.Xxcustom23.GetHashCode();
                if (this.Xxcustom24 != null)
                    hashCode = hashCode * 59 + this.Xxcustom24.GetHashCode();
                if (this.Xxcustom25 != null)
                    hashCode = hashCode * 59 + this.Xxcustom25.GetHashCode();
                if (this.Xxcustom26 != null)
                    hashCode = hashCode * 59 + this.Xxcustom26.GetHashCode();
                if (this.Xxcustom27 != null)
                    hashCode = hashCode * 59 + this.Xxcustom27.GetHashCode();
                if (this.Xxcustom28 != null)
                    hashCode = hashCode * 59 + this.Xxcustom28.GetHashCode();
                if (this.Xxcustom29 != null)
                    hashCode = hashCode * 59 + this.Xxcustom29.GetHashCode();
                if (this.Xxcustom30 != null)
                    hashCode = hashCode * 59 + this.Xxcustom30.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
