/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// WorkerDiscountGroupAssignment.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey :  IEquatable<ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="employeeDiscountGroupID">&lt;p&gt;The identifier for a specific employee discount group.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="workerID">&lt;p&gt;A unique system-assigned identifier for the person who is a particular worker.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey(string businessUnitGroupID = default(string), string employeeDiscountGroupID = default(string), string workerID = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "employeeDiscountGroupID" is required (not null)
            if (employeeDiscountGroupID == null)
            {
                throw new InvalidDataException("employeeDiscountGroupID is a required property for ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey and cannot be null");
            }
            else
            {
                this.EmployeeDiscountGroupID = employeeDiscountGroupID;
            }
            // to ensure "workerID" is required (not null)
            if (workerID == null)
            {
                throw new InvalidDataException("workerID is a required property for ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey and cannot be null");
            }
            else
            {
                this.WorkerID = workerID;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;The identifier for a specific employee discount group.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for a specific employee discount group.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="employeeDiscountGroupID", EmitDefaultValue=false)]
        public string EmployeeDiscountGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system-assigned identifier for the person who is a particular worker.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system-assigned identifier for the person who is a particular worker.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="workerID", EmitDefaultValue=false)]
        public string WorkerID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  EmployeeDiscountGroupID: ").Append(EmployeeDiscountGroupID).Append("\n");
            sb.Append("  WorkerID: ").Append(WorkerID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiServerMdWorkerDtoDomWorkerDiscountGroupAssignmentKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.EmployeeDiscountGroupID == input.EmployeeDiscountGroupID ||
                    (this.EmployeeDiscountGroupID != null &&
                    this.EmployeeDiscountGroupID.Equals(input.EmployeeDiscountGroupID))
                ) && 
                (
                    this.WorkerID == input.WorkerID ||
                    (this.WorkerID != null &&
                    this.WorkerID.Equals(input.WorkerID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.EmployeeDiscountGroupID != null)
                    hashCode = hashCode * 59 + this.EmployeeDiscountGroupID.GetHashCode();
                if (this.WorkerID != null)
                    hashCode = hashCode * 59 + this.WorkerID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
