/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RetailTransactionLineItemI18NText.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">A unique system assigned identifier for a group of BusinessUnits. (required).</param>
        /// <param name="transactionID">A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members.  (required).</param>
        /// <param name="retailTransactionLineItemSequenceNumber">The sequence number of line item within the context of this RetailTransaction.  (required).</param>
        /// <param name="textSequenceNumber">Line number (incremental counter) of the text  (required).</param>
        /// <param name="languageID">A combination of ISO-639-1 and ISO-3661-1 to denote a lanuage as spoken in a particular country.  (required).</param>
        /// <param name="category">Category code of the text (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? retailTransactionLineItemSequenceNumber = default(int?), int? textSequenceNumber = default(int?), string languageID = default(string), string category = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "retailTransactionLineItemSequenceNumber" is required (not null)
            if (retailTransactionLineItemSequenceNumber == null)
            {
                throw new InvalidDataException("retailTransactionLineItemSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.RetailTransactionLineItemSequenceNumber = retailTransactionLineItemSequenceNumber;
            }
            // to ensure "textSequenceNumber" is required (not null)
            if (textSequenceNumber == null)
            {
                throw new InvalidDataException("textSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.TextSequenceNumber = textSequenceNumber;
            }
            // to ensure "languageID" is required (not null)
            if (languageID == null)
            {
                throw new InvalidDataException("languageID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.LanguageID = languageID;
            }
            // to ensure "category" is required (not null)
            if (category == null)
            {
                throw new InvalidDataException("category is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey and cannot be null");
            }
            else
            {
                this.Category = category;
            }
        }
        
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        [DataMember(Name="retailTransactionLineItemSequenceNumber", EmitDefaultValue=false)]
        public int? RetailTransactionLineItemSequenceNumber { get; set; }

        /// <summary>
        /// Line number (incremental counter) of the text 
        /// </summary>
        /// <value>Line number (incremental counter) of the text </value>
        [DataMember(Name="textSequenceNumber", EmitDefaultValue=false)]
        public int? TextSequenceNumber { get; set; }

        /// <summary>
        /// A combination of ISO-639-1 and ISO-3661-1 to denote a lanuage as spoken in a particular country. 
        /// </summary>
        /// <value>A combination of ISO-639-1 and ISO-3661-1 to denote a lanuage as spoken in a particular country. </value>
        [DataMember(Name="languageID", EmitDefaultValue=false)]
        public string LanguageID { get; set; }

        /// <summary>
        /// Category code of the text
        /// </summary>
        /// <value>Category code of the text</value>
        [DataMember(Name="category", EmitDefaultValue=false)]
        public string Category { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  RetailTransactionLineItemSequenceNumber: ").Append(RetailTransactionLineItemSequenceNumber).Append("\n");
            sb.Append("  TextSequenceNumber: ").Append(TextSequenceNumber).Append("\n");
            sb.Append("  LanguageID: ").Append(LanguageID).Append("\n");
            sb.Append("  Category: ").Append(Category).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoRetailTransactionLineItemI18NTextKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.RetailTransactionLineItemSequenceNumber == input.RetailTransactionLineItemSequenceNumber ||
                    (this.RetailTransactionLineItemSequenceNumber != null &&
                    this.RetailTransactionLineItemSequenceNumber.Equals(input.RetailTransactionLineItemSequenceNumber))
                ) && 
                (
                    this.TextSequenceNumber == input.TextSequenceNumber ||
                    (this.TextSequenceNumber != null &&
                    this.TextSequenceNumber.Equals(input.TextSequenceNumber))
                ) && 
                (
                    this.LanguageID == input.LanguageID ||
                    (this.LanguageID != null &&
                    this.LanguageID.Equals(input.LanguageID))
                ) && 
                (
                    this.Category == input.Category ||
                    (this.Category != null &&
                    this.Category.Equals(input.Category))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.RetailTransactionLineItemSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemSequenceNumber.GetHashCode();
                if (this.TextSequenceNumber != null)
                    hashCode = hashCode * 59 + this.TextSequenceNumber.GetHashCode();
                if (this.LanguageID != null)
                    hashCode = hashCode * 59 + this.LanguageID.GetHashCode();
                if (this.Category != null)
                    hashCode = hashCode * 59 + this.Category.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
