/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RetailTransactionManufacturerCouponSummary.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">A unique system assigned identifier for a group of BusinessUnits. (required).</param>
        /// <param name="transactionID">A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members.  (required).</param>
        /// <param name="manufacturerCouponScanCode">The barcode on the manufacturer coupon in GS1 interface format. In case that the manufacturer coupon was key entered this information is assembled by the entered information (ManufacturerCompanyCode, ManufacturerOfferCode, TotalAmount) by using the GS1 interface format. (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey(string businessUnitGroupID = default(string), string transactionID = default(string), string manufacturerCouponScanCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "manufacturerCouponScanCode" is required (not null)
            if (manufacturerCouponScanCode == null)
            {
                throw new InvalidDataException("manufacturerCouponScanCode is a required property for ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey and cannot be null");
            }
            else
            {
                this.ManufacturerCouponScanCode = manufacturerCouponScanCode;
            }
        }
        
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The barcode on the manufacturer coupon in GS1 interface format. In case that the manufacturer coupon was key entered this information is assembled by the entered information (ManufacturerCompanyCode, ManufacturerOfferCode, TotalAmount) by using the GS1 interface format.
        /// </summary>
        /// <value>The barcode on the manufacturer coupon in GS1 interface format. In case that the manufacturer coupon was key entered this information is assembled by the entered information (ManufacturerCompanyCode, ManufacturerOfferCode, TotalAmount) by using the GS1 interface format.</value>
        [DataMember(Name="manufacturerCouponScanCode", EmitDefaultValue=false)]
        public string ManufacturerCouponScanCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  ManufacturerCouponScanCode: ").Append(ManufacturerCouponScanCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponSummaryKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.ManufacturerCouponScanCode == input.ManufacturerCouponScanCode ||
                    (this.ManufacturerCouponScanCode != null &&
                    this.ManufacturerCouponScanCode.Equals(input.ManufacturerCouponScanCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.ManufacturerCouponScanCode != null)
                    hashCode = hashCode * 59 + this.ManufacturerCouponScanCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
