/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SaleReturnLineItemCollection.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">A unique system assigned identifier for a group of BusinessUnits. (required).</param>
        /// <param name="transactionID">A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members.  (required).</param>
        /// <param name="retailTransactionLineItemSequenceNumber">The sequence number of line item within the context of this RetailTransaction.  (required).</param>
        /// <param name="itemID">A unique identifier for the item (required).</param>
        /// <param name="itemBaggingUnitOfMeasureCode">The code used to specify the units of the item (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey(string businessUnitGroupID = default(string), string transactionID = default(string), int? retailTransactionLineItemSequenceNumber = default(int?), string itemID = default(string), string itemBaggingUnitOfMeasureCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "retailTransactionLineItemSequenceNumber" is required (not null)
            if (retailTransactionLineItemSequenceNumber == null)
            {
                throw new InvalidDataException("retailTransactionLineItemSequenceNumber is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey and cannot be null");
            }
            else
            {
                this.RetailTransactionLineItemSequenceNumber = retailTransactionLineItemSequenceNumber;
            }
            // to ensure "itemID" is required (not null)
            if (itemID == null)
            {
                throw new InvalidDataException("itemID is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey and cannot be null");
            }
            else
            {
                this.ItemID = itemID;
            }
            // to ensure "itemBaggingUnitOfMeasureCode" is required (not null)
            if (itemBaggingUnitOfMeasureCode == null)
            {
                throw new InvalidDataException("itemBaggingUnitOfMeasureCode is a required property for ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey and cannot be null");
            }
            else
            {
                this.ItemBaggingUnitOfMeasureCode = itemBaggingUnitOfMeasureCode;
            }
        }
        
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// The sequence number of line item within the context of this RetailTransaction. 
        /// </summary>
        /// <value>The sequence number of line item within the context of this RetailTransaction. </value>
        [DataMember(Name="retailTransactionLineItemSequenceNumber", EmitDefaultValue=false)]
        public int? RetailTransactionLineItemSequenceNumber { get; set; }

        /// <summary>
        /// A unique identifier for the item
        /// </summary>
        /// <value>A unique identifier for the item</value>
        [DataMember(Name="itemID", EmitDefaultValue=false)]
        public string ItemID { get; set; }

        /// <summary>
        /// The code used to specify the units of the item
        /// </summary>
        /// <value>The code used to specify the units of the item</value>
        [DataMember(Name="itemBaggingUnitOfMeasureCode", EmitDefaultValue=false)]
        public string ItemBaggingUnitOfMeasureCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  RetailTransactionLineItemSequenceNumber: ").Append(RetailTransactionLineItemSequenceNumber).Append("\n");
            sb.Append("  ItemID: ").Append(ItemID).Append("\n");
            sb.Append("  ItemBaggingUnitOfMeasureCode: ").Append(ItemBaggingUnitOfMeasureCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoSaleReturnLineItemCollectionKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.RetailTransactionLineItemSequenceNumber == input.RetailTransactionLineItemSequenceNumber ||
                    (this.RetailTransactionLineItemSequenceNumber != null &&
                    this.RetailTransactionLineItemSequenceNumber.Equals(input.RetailTransactionLineItemSequenceNumber))
                ) && 
                (
                    this.ItemID == input.ItemID ||
                    (this.ItemID != null &&
                    this.ItemID.Equals(input.ItemID))
                ) && 
                (
                    this.ItemBaggingUnitOfMeasureCode == input.ItemBaggingUnitOfMeasureCode ||
                    (this.ItemBaggingUnitOfMeasureCode != null &&
                    this.ItemBaggingUnitOfMeasureCode.Equals(input.ItemBaggingUnitOfMeasureCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.RetailTransactionLineItemSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemSequenceNumber.GetHashCode();
                if (this.ItemID != null)
                    hashCode = hashCode * 59 + this.ItemID.GetHashCode();
                if (this.ItemBaggingUnitOfMeasureCode != null)
                    hashCode = hashCode * 59 + this.ItemBaggingUnitOfMeasureCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
