/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionAssociation.Key Inner class for composite key attributes
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey :  IEquatable<ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">Business unit group id of the current transaction. (required).</param>
        /// <param name="transactionID">Transaction ID of the current Transaction. (required).</param>
        /// <param name="toTransactionID">Transaction ID of the referenced Transaction. (required).</param>
        /// <param name="toBusinessUnitGroupID">Business unit group id of the referenced transaction. (required).</param>
        /// <param name="transactionAssociationTypeCode">A retailer assigned code denoting the relationship between the two transactions. (required).</param>
        public ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey(string businessUnitGroupID = default(string), string transactionID = default(string), string toTransactionID = default(string), string toBusinessUnitGroupID = default(string), string transactionAssociationTypeCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "toTransactionID" is required (not null)
            if (toTransactionID == null)
            {
                throw new InvalidDataException("toTransactionID is a required property for ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey and cannot be null");
            }
            else
            {
                this.ToTransactionID = toTransactionID;
            }
            // to ensure "toBusinessUnitGroupID" is required (not null)
            if (toBusinessUnitGroupID == null)
            {
                throw new InvalidDataException("toBusinessUnitGroupID is a required property for ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey and cannot be null");
            }
            else
            {
                this.ToBusinessUnitGroupID = toBusinessUnitGroupID;
            }
            // to ensure "transactionAssociationTypeCode" is required (not null)
            if (transactionAssociationTypeCode == null)
            {
                throw new InvalidDataException("transactionAssociationTypeCode is a required property for ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey and cannot be null");
            }
            else
            {
                this.TransactionAssociationTypeCode = transactionAssociationTypeCode;
            }
        }
        
        /// <summary>
        /// Business unit group id of the current transaction.
        /// </summary>
        /// <value>Business unit group id of the current transaction.</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// Transaction ID of the current Transaction.
        /// </summary>
        /// <value>Transaction ID of the current Transaction.</value>
        [DataMember(Name="transactionID", EmitDefaultValue=false)]
        public string TransactionID { get; set; }

        /// <summary>
        /// Transaction ID of the referenced Transaction.
        /// </summary>
        /// <value>Transaction ID of the referenced Transaction.</value>
        [DataMember(Name="toTransactionID", EmitDefaultValue=false)]
        public string ToTransactionID { get; set; }

        /// <summary>
        /// Business unit group id of the referenced transaction.
        /// </summary>
        /// <value>Business unit group id of the referenced transaction.</value>
        [DataMember(Name="toBusinessUnitGroupID", EmitDefaultValue=false)]
        public string ToBusinessUnitGroupID { get; set; }

        /// <summary>
        /// A retailer assigned code denoting the relationship between the two transactions.
        /// </summary>
        /// <value>A retailer assigned code denoting the relationship between the two transactions.</value>
        [DataMember(Name="transactionAssociationTypeCode", EmitDefaultValue=false)]
        public string TransactionAssociationTypeCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  ToTransactionID: ").Append(ToTransactionID).Append("\n");
            sb.Append("  ToBusinessUnitGroupID: ").Append(ToBusinessUnitGroupID).Append("\n");
            sb.Append("  TransactionAssociationTypeCode: ").Append(TransactionAssociationTypeCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareGkrApiTxpoolDtoTransactionAssociationKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.ToTransactionID == input.ToTransactionID ||
                    (this.ToTransactionID != null &&
                    this.ToTransactionID.Equals(input.ToTransactionID))
                ) && 
                (
                    this.ToBusinessUnitGroupID == input.ToBusinessUnitGroupID ||
                    (this.ToBusinessUnitGroupID != null &&
                    this.ToBusinessUnitGroupID.Equals(input.ToBusinessUnitGroupID))
                ) && 
                (
                    this.TransactionAssociationTypeCode == input.TransactionAssociationTypeCode ||
                    (this.TransactionAssociationTypeCode != null &&
                    this.TransactionAssociationTypeCode.Equals(input.TransactionAssociationTypeCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.ToTransactionID != null)
                    hashCode = hashCode * 59 + this.ToTransactionID.GetHashCode();
                if (this.ToBusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.ToBusinessUnitGroupID.GetHashCode();
                if (this.TransactionAssociationTypeCode != null)
                    hashCode = hashCode * 59 + this.TransactionAssociationTypeCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
