/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GoodsReturnConfig &lt;p&gt;This configuration entity defines the goods return process.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig" /> class.
        /// </summary>
        /// <param name="processId">&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt; (required).</param>
        /// <param name="mainProcess">&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;.</param>
        /// <param name="authorizationConfig">&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;.</param>
        /// <param name="withOutOriginalSc">&lt;p&gt;This parameter specifies whether a return is performed without original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="registerCustomer">&lt;p&gt;This parameter specifies whether a customer must be assigned to the return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="onlyOneReturnPosition">&lt;p&gt;This parameter specifies whether the return mode will be finished automatically after one return line item.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="createReturnReceipt">&lt;p&gt;This parameter specifies whether a return receipt is created. This receipt includes only return line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="customerIdentificationConfig">customerIdentificationConfig (required).</param>
        /// <param name="allowedTendersConfig">allowedTendersConfig (required).</param>
        /// <param name="originalBusinessUnitIdRequired">&lt;p&gt;It defines if the original business unit id must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalDateRequired">&lt;p&gt;It defines if the original date must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalWorkstationIdRequired">&lt;p&gt;It defines if the original workstation id must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalSequenceNumberRequired">&lt;p&gt;It defines if the original receipt number must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalFiscalDeviceNumberRequired">&lt;p&gt;It defines if the original fiscal device number must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalFiscalSequenceNumberRequired">&lt;p&gt;It defines if the original fiscal sequence number must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="originalFiscalDayNumberRequired">&lt;p&gt;It defines if the original fiscal day number must be entered in case of return without receipt.&lt;/p&gt; (required).</param>
        /// <param name="requiredOriginalReceiptData">&lt;p&gt;Map of original receipt data to save in sale return line item extensions.&lt;/p&gt;.</param>
        /// <param name="returnWithTransactionConfig">&lt;p&gt;This config defines the return with transaction process.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig(string processId = default(string), bool? mainProcess = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig authorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), bool? withOutOriginalSc = default(bool?), bool? registerCustomer = default(bool?), bool? onlyOneReturnPosition = default(bool?), bool? createReturnReceipt = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsCustomerIdentificationConfig customerIdentificationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsCustomerIdentificationConfig), ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig allowedTendersConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig), bool? originalBusinessUnitIdRequired = default(bool?), bool? originalDateRequired = default(bool?), bool? originalWorkstationIdRequired = default(bool?), bool? originalSequenceNumberRequired = default(bool?), bool? originalFiscalDeviceNumberRequired = default(bool?), bool? originalFiscalSequenceNumberRequired = default(bool?), bool? originalFiscalDayNumberRequired = default(bool?), Dictionary<string, string> requiredOriginalReceiptData = default(Dictionary<string, string>), ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig returnWithTransactionConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "processId" is required (not null)
            if (processId == null)
            {
                throw new InvalidDataException("processId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.ProcessId = processId;
            }
            // to ensure "withOutOriginalSc" is required (not null)
            if (withOutOriginalSc == null)
            {
                throw new InvalidDataException("withOutOriginalSc is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.WithOutOriginalSc = withOutOriginalSc;
            }
            // to ensure "registerCustomer" is required (not null)
            if (registerCustomer == null)
            {
                throw new InvalidDataException("registerCustomer is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.RegisterCustomer = registerCustomer;
            }
            // to ensure "onlyOneReturnPosition" is required (not null)
            if (onlyOneReturnPosition == null)
            {
                throw new InvalidDataException("onlyOneReturnPosition is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OnlyOneReturnPosition = onlyOneReturnPosition;
            }
            // to ensure "createReturnReceipt" is required (not null)
            if (createReturnReceipt == null)
            {
                throw new InvalidDataException("createReturnReceipt is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.CreateReturnReceipt = createReturnReceipt;
            }
            // to ensure "customerIdentificationConfig" is required (not null)
            if (customerIdentificationConfig == null)
            {
                throw new InvalidDataException("customerIdentificationConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.CustomerIdentificationConfig = customerIdentificationConfig;
            }
            // to ensure "allowedTendersConfig" is required (not null)
            if (allowedTendersConfig == null)
            {
                throw new InvalidDataException("allowedTendersConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.AllowedTendersConfig = allowedTendersConfig;
            }
            // to ensure "originalBusinessUnitIdRequired" is required (not null)
            if (originalBusinessUnitIdRequired == null)
            {
                throw new InvalidDataException("originalBusinessUnitIdRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalBusinessUnitIdRequired = originalBusinessUnitIdRequired;
            }
            // to ensure "originalDateRequired" is required (not null)
            if (originalDateRequired == null)
            {
                throw new InvalidDataException("originalDateRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalDateRequired = originalDateRequired;
            }
            // to ensure "originalWorkstationIdRequired" is required (not null)
            if (originalWorkstationIdRequired == null)
            {
                throw new InvalidDataException("originalWorkstationIdRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalWorkstationIdRequired = originalWorkstationIdRequired;
            }
            // to ensure "originalSequenceNumberRequired" is required (not null)
            if (originalSequenceNumberRequired == null)
            {
                throw new InvalidDataException("originalSequenceNumberRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalSequenceNumberRequired = originalSequenceNumberRequired;
            }
            // to ensure "originalFiscalDeviceNumberRequired" is required (not null)
            if (originalFiscalDeviceNumberRequired == null)
            {
                throw new InvalidDataException("originalFiscalDeviceNumberRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalFiscalDeviceNumberRequired = originalFiscalDeviceNumberRequired;
            }
            // to ensure "originalFiscalSequenceNumberRequired" is required (not null)
            if (originalFiscalSequenceNumberRequired == null)
            {
                throw new InvalidDataException("originalFiscalSequenceNumberRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalFiscalSequenceNumberRequired = originalFiscalSequenceNumberRequired;
            }
            // to ensure "originalFiscalDayNumberRequired" is required (not null)
            if (originalFiscalDayNumberRequired == null)
            {
                throw new InvalidDataException("originalFiscalDayNumberRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig and cannot be null");
            }
            else
            {
                this.OriginalFiscalDayNumberRequired = originalFiscalDayNumberRequired;
            }
            this.MainProcess = mainProcess;
            this.AuthorizationConfig = authorizationConfig;
            this.RequiredOriginalReceiptData = requiredOriginalReceiptData;
            this.ReturnWithTransactionConfig = returnWithTransactionConfig;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;</value>
        [DataMember(Name="processId", EmitDefaultValue=false)]
        public string ProcessId { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;</value>
        [DataMember(Name="mainProcess", EmitDefaultValue=false)]
        public bool? MainProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines authorization related processes.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;</value>
        [DataMember(Name="authorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig AuthorizationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a return is performed without original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a return is performed without original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="withOutOriginalSc", EmitDefaultValue=false)]
        public bool? WithOutOriginalSc { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a customer must be assigned to the return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a customer must be assigned to the return.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="registerCustomer", EmitDefaultValue=false)]
        public bool? RegisterCustomer { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the return mode will be finished automatically after one return line item.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the return mode will be finished automatically after one return line item.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="onlyOneReturnPosition", EmitDefaultValue=false)]
        public bool? OnlyOneReturnPosition { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a return receipt is created. This receipt includes only return line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a return receipt is created. This receipt includes only return line items.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="createReturnReceipt", EmitDefaultValue=false)]
        public bool? CreateReturnReceipt { get; set; }

        /// <summary>
        /// Gets or Sets CustomerIdentificationConfig
        /// </summary>
        [DataMember(Name="customerIdentificationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsCustomerIdentificationConfig CustomerIdentificationConfig { get; set; }

        /// <summary>
        /// Gets or Sets AllowedTendersConfig
        /// </summary>
        [DataMember(Name="allowedTendersConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAllowedTendersConfig AllowedTendersConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original business unit id must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original business unit id must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalBusinessUnitIdRequired", EmitDefaultValue=false)]
        public bool? OriginalBusinessUnitIdRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original date must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original date must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalDateRequired", EmitDefaultValue=false)]
        public bool? OriginalDateRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original workstation id must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original workstation id must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalWorkstationIdRequired", EmitDefaultValue=false)]
        public bool? OriginalWorkstationIdRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original receipt number must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original receipt number must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalSequenceNumberRequired", EmitDefaultValue=false)]
        public bool? OriginalSequenceNumberRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original fiscal device number must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original fiscal device number must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalFiscalDeviceNumberRequired", EmitDefaultValue=false)]
        public bool? OriginalFiscalDeviceNumberRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original fiscal sequence number must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original fiscal sequence number must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalFiscalSequenceNumberRequired", EmitDefaultValue=false)]
        public bool? OriginalFiscalSequenceNumberRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the original fiscal day number must be entered in case of return without receipt.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the original fiscal day number must be entered in case of return without receipt.&lt;/p&gt;</value>
        [DataMember(Name="originalFiscalDayNumberRequired", EmitDefaultValue=false)]
        public bool? OriginalFiscalDayNumberRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;Map of original receipt data to save in sale return line item extensions.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Map of original receipt data to save in sale return line item extensions.&lt;/p&gt;</value>
        [DataMember(Name="requiredOriginalReceiptData", EmitDefaultValue=false)]
        public Dictionary<string, string> RequiredOriginalReceiptData { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines the return with transaction process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines the return with transaction process.&lt;/p&gt;</value>
        [DataMember(Name="returnWithTransactionConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig ReturnWithTransactionConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig {\n");
            sb.Append("  ProcessId: ").Append(ProcessId).Append("\n");
            sb.Append("  MainProcess: ").Append(MainProcess).Append("\n");
            sb.Append("  AuthorizationConfig: ").Append(AuthorizationConfig).Append("\n");
            sb.Append("  WithOutOriginalSc: ").Append(WithOutOriginalSc).Append("\n");
            sb.Append("  RegisterCustomer: ").Append(RegisterCustomer).Append("\n");
            sb.Append("  OnlyOneReturnPosition: ").Append(OnlyOneReturnPosition).Append("\n");
            sb.Append("  CreateReturnReceipt: ").Append(CreateReturnReceipt).Append("\n");
            sb.Append("  CustomerIdentificationConfig: ").Append(CustomerIdentificationConfig).Append("\n");
            sb.Append("  AllowedTendersConfig: ").Append(AllowedTendersConfig).Append("\n");
            sb.Append("  OriginalBusinessUnitIdRequired: ").Append(OriginalBusinessUnitIdRequired).Append("\n");
            sb.Append("  OriginalDateRequired: ").Append(OriginalDateRequired).Append("\n");
            sb.Append("  OriginalWorkstationIdRequired: ").Append(OriginalWorkstationIdRequired).Append("\n");
            sb.Append("  OriginalSequenceNumberRequired: ").Append(OriginalSequenceNumberRequired).Append("\n");
            sb.Append("  OriginalFiscalDeviceNumberRequired: ").Append(OriginalFiscalDeviceNumberRequired).Append("\n");
            sb.Append("  OriginalFiscalSequenceNumberRequired: ").Append(OriginalFiscalSequenceNumberRequired).Append("\n");
            sb.Append("  OriginalFiscalDayNumberRequired: ").Append(OriginalFiscalDayNumberRequired).Append("\n");
            sb.Append("  RequiredOriginalReceiptData: ").Append(RequiredOriginalReceiptData).Append("\n");
            sb.Append("  ReturnWithTransactionConfig: ").Append(ReturnWithTransactionConfig).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessFlowsGoodsReturnConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProcessId == input.ProcessId ||
                    (this.ProcessId != null &&
                    this.ProcessId.Equals(input.ProcessId))
                ) && 
                (
                    this.MainProcess == input.MainProcess ||
                    (this.MainProcess != null &&
                    this.MainProcess.Equals(input.MainProcess))
                ) && 
                (
                    this.AuthorizationConfig == input.AuthorizationConfig ||
                    (this.AuthorizationConfig != null &&
                    this.AuthorizationConfig.Equals(input.AuthorizationConfig))
                ) && 
                (
                    this.WithOutOriginalSc == input.WithOutOriginalSc ||
                    (this.WithOutOriginalSc != null &&
                    this.WithOutOriginalSc.Equals(input.WithOutOriginalSc))
                ) && 
                (
                    this.RegisterCustomer == input.RegisterCustomer ||
                    (this.RegisterCustomer != null &&
                    this.RegisterCustomer.Equals(input.RegisterCustomer))
                ) && 
                (
                    this.OnlyOneReturnPosition == input.OnlyOneReturnPosition ||
                    (this.OnlyOneReturnPosition != null &&
                    this.OnlyOneReturnPosition.Equals(input.OnlyOneReturnPosition))
                ) && 
                (
                    this.CreateReturnReceipt == input.CreateReturnReceipt ||
                    (this.CreateReturnReceipt != null &&
                    this.CreateReturnReceipt.Equals(input.CreateReturnReceipt))
                ) && 
                (
                    this.CustomerIdentificationConfig == input.CustomerIdentificationConfig ||
                    (this.CustomerIdentificationConfig != null &&
                    this.CustomerIdentificationConfig.Equals(input.CustomerIdentificationConfig))
                ) && 
                (
                    this.AllowedTendersConfig == input.AllowedTendersConfig ||
                    (this.AllowedTendersConfig != null &&
                    this.AllowedTendersConfig.Equals(input.AllowedTendersConfig))
                ) && 
                (
                    this.OriginalBusinessUnitIdRequired == input.OriginalBusinessUnitIdRequired ||
                    (this.OriginalBusinessUnitIdRequired != null &&
                    this.OriginalBusinessUnitIdRequired.Equals(input.OriginalBusinessUnitIdRequired))
                ) && 
                (
                    this.OriginalDateRequired == input.OriginalDateRequired ||
                    (this.OriginalDateRequired != null &&
                    this.OriginalDateRequired.Equals(input.OriginalDateRequired))
                ) && 
                (
                    this.OriginalWorkstationIdRequired == input.OriginalWorkstationIdRequired ||
                    (this.OriginalWorkstationIdRequired != null &&
                    this.OriginalWorkstationIdRequired.Equals(input.OriginalWorkstationIdRequired))
                ) && 
                (
                    this.OriginalSequenceNumberRequired == input.OriginalSequenceNumberRequired ||
                    (this.OriginalSequenceNumberRequired != null &&
                    this.OriginalSequenceNumberRequired.Equals(input.OriginalSequenceNumberRequired))
                ) && 
                (
                    this.OriginalFiscalDeviceNumberRequired == input.OriginalFiscalDeviceNumberRequired ||
                    (this.OriginalFiscalDeviceNumberRequired != null &&
                    this.OriginalFiscalDeviceNumberRequired.Equals(input.OriginalFiscalDeviceNumberRequired))
                ) && 
                (
                    this.OriginalFiscalSequenceNumberRequired == input.OriginalFiscalSequenceNumberRequired ||
                    (this.OriginalFiscalSequenceNumberRequired != null &&
                    this.OriginalFiscalSequenceNumberRequired.Equals(input.OriginalFiscalSequenceNumberRequired))
                ) && 
                (
                    this.OriginalFiscalDayNumberRequired == input.OriginalFiscalDayNumberRequired ||
                    (this.OriginalFiscalDayNumberRequired != null &&
                    this.OriginalFiscalDayNumberRequired.Equals(input.OriginalFiscalDayNumberRequired))
                ) && 
                (
                    this.RequiredOriginalReceiptData == input.RequiredOriginalReceiptData ||
                    this.RequiredOriginalReceiptData != null &&
                    this.RequiredOriginalReceiptData.SequenceEqual(input.RequiredOriginalReceiptData)
                ) && 
                (
                    this.ReturnWithTransactionConfig == input.ReturnWithTransactionConfig ||
                    (this.ReturnWithTransactionConfig != null &&
                    this.ReturnWithTransactionConfig.Equals(input.ReturnWithTransactionConfig))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProcessId != null)
                    hashCode = hashCode * 59 + this.ProcessId.GetHashCode();
                if (this.MainProcess != null)
                    hashCode = hashCode * 59 + this.MainProcess.GetHashCode();
                if (this.AuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.AuthorizationConfig.GetHashCode();
                if (this.WithOutOriginalSc != null)
                    hashCode = hashCode * 59 + this.WithOutOriginalSc.GetHashCode();
                if (this.RegisterCustomer != null)
                    hashCode = hashCode * 59 + this.RegisterCustomer.GetHashCode();
                if (this.OnlyOneReturnPosition != null)
                    hashCode = hashCode * 59 + this.OnlyOneReturnPosition.GetHashCode();
                if (this.CreateReturnReceipt != null)
                    hashCode = hashCode * 59 + this.CreateReturnReceipt.GetHashCode();
                if (this.CustomerIdentificationConfig != null)
                    hashCode = hashCode * 59 + this.CustomerIdentificationConfig.GetHashCode();
                if (this.AllowedTendersConfig != null)
                    hashCode = hashCode * 59 + this.AllowedTendersConfig.GetHashCode();
                if (this.OriginalBusinessUnitIdRequired != null)
                    hashCode = hashCode * 59 + this.OriginalBusinessUnitIdRequired.GetHashCode();
                if (this.OriginalDateRequired != null)
                    hashCode = hashCode * 59 + this.OriginalDateRequired.GetHashCode();
                if (this.OriginalWorkstationIdRequired != null)
                    hashCode = hashCode * 59 + this.OriginalWorkstationIdRequired.GetHashCode();
                if (this.OriginalSequenceNumberRequired != null)
                    hashCode = hashCode * 59 + this.OriginalSequenceNumberRequired.GetHashCode();
                if (this.OriginalFiscalDeviceNumberRequired != null)
                    hashCode = hashCode * 59 + this.OriginalFiscalDeviceNumberRequired.GetHashCode();
                if (this.OriginalFiscalSequenceNumberRequired != null)
                    hashCode = hashCode * 59 + this.OriginalFiscalSequenceNumberRequired.GetHashCode();
                if (this.OriginalFiscalDayNumberRequired != null)
                    hashCode = hashCode * 59 + this.OriginalFiscalDayNumberRequired.GetHashCode();
                if (this.RequiredOriginalReceiptData != null)
                    hashCode = hashCode * 59 + this.RequiredOriginalReceiptData.GetHashCode();
                if (this.ReturnWithTransactionConfig != null)
                    hashCode = hashCode * 59 + this.ReturnWithTransactionConfig.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
