/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PermanentCustomerInformationConfig &lt;p&gt;This configuration entity defines the permanent customer information panel.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig" /> class.
        /// </summary>
        /// <param name="processId">&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt; (required).</param>
        /// <param name="mainProcess">&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;.</param>
        /// <param name="authorizationConfig">&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;.</param>
        /// <param name="displayCustomerNumber">&lt;p&gt;This parameter specifies whether the customer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="displayCustomerName">&lt;p&gt;This parameter specifies whether the customer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="displayBuyerNumber">&lt;p&gt;This parameter specifies whether the buyer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="displayBuyerName">&lt;p&gt;This parameter specifies whether the buyer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="displayAllowedTenderGroup">&lt;p&gt;This parameter specifies whether the allowed tender group is displayed permanently in the Permanent Customer Information Panel.&lt;br /&gt; The allowed tender group is the CustomerTenderGroup.CustomerTenderGroupDescription of the Customer.AllowedTermsOfPayment.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig(string processId = default(string), bool? mainProcess = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig authorizationConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig), bool? displayCustomerNumber = default(bool?), bool? displayCustomerName = default(bool?), bool? displayBuyerNumber = default(bool?), bool? displayBuyerName = default(bool?), bool? displayAllowedTenderGroup = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "processId" is required (not null)
            if (processId == null)
            {
                throw new InvalidDataException("processId is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.ProcessId = processId;
            }
            // to ensure "displayCustomerNumber" is required (not null)
            if (displayCustomerNumber == null)
            {
                throw new InvalidDataException("displayCustomerNumber is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.DisplayCustomerNumber = displayCustomerNumber;
            }
            // to ensure "displayCustomerName" is required (not null)
            if (displayCustomerName == null)
            {
                throw new InvalidDataException("displayCustomerName is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.DisplayCustomerName = displayCustomerName;
            }
            // to ensure "displayBuyerNumber" is required (not null)
            if (displayBuyerNumber == null)
            {
                throw new InvalidDataException("displayBuyerNumber is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.DisplayBuyerNumber = displayBuyerNumber;
            }
            // to ensure "displayBuyerName" is required (not null)
            if (displayBuyerName == null)
            {
                throw new InvalidDataException("displayBuyerName is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.DisplayBuyerName = displayBuyerName;
            }
            // to ensure "displayAllowedTenderGroup" is required (not null)
            if (displayAllowedTenderGroup == null)
            {
                throw new InvalidDataException("displayAllowedTenderGroup is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig and cannot be null");
            }
            else
            {
                this.DisplayAllowedTenderGroup = displayAllowedTenderGroup;
            }
            this.MainProcess = mainProcess;
            this.AuthorizationConfig = authorizationConfig;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;</value>
        [DataMember(Name="processId", EmitDefaultValue=false)]
        public string ProcessId { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines, whether the process should be treated as a main process or a shared helper process.&lt;br /&gt; This is relevant for context restriction checks, e.g. during barcode processing.&lt;br /&gt; Defaults to true. If false the related process will not be considered as main process.&lt;/p&gt;</value>
        [DataMember(Name="mainProcess", EmitDefaultValue=false)]
        public bool? MainProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines authorization related processes.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines authorization related processes.&lt;/p&gt;</value>
        [DataMember(Name="authorizationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAuthorizationConfig AuthorizationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the customer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the customer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="displayCustomerNumber", EmitDefaultValue=false)]
        public bool? DisplayCustomerNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the customer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the customer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="displayCustomerName", EmitDefaultValue=false)]
        public bool? DisplayCustomerName { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the buyer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the buyer number is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="displayBuyerNumber", EmitDefaultValue=false)]
        public bool? DisplayBuyerNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the buyer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the buyer name is displayed permanently in the Permanent Customer Information Panel.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="displayBuyerName", EmitDefaultValue=false)]
        public bool? DisplayBuyerName { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the allowed tender group is displayed permanently in the Permanent Customer Information Panel.&lt;br /&gt; The allowed tender group is the CustomerTenderGroup.CustomerTenderGroupDescription of the Customer.AllowedTermsOfPayment.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the allowed tender group is displayed permanently in the Permanent Customer Information Panel.&lt;br /&gt; The allowed tender group is the CustomerTenderGroup.CustomerTenderGroupDescription of the Customer.AllowedTermsOfPayment.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="displayAllowedTenderGroup", EmitDefaultValue=false)]
        public bool? DisplayAllowedTenderGroup { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig {\n");
            sb.Append("  ProcessId: ").Append(ProcessId).Append("\n");
            sb.Append("  MainProcess: ").Append(MainProcess).Append("\n");
            sb.Append("  AuthorizationConfig: ").Append(AuthorizationConfig).Append("\n");
            sb.Append("  DisplayCustomerNumber: ").Append(DisplayCustomerNumber).Append("\n");
            sb.Append("  DisplayCustomerName: ").Append(DisplayCustomerName).Append("\n");
            sb.Append("  DisplayBuyerNumber: ").Append(DisplayBuyerNumber).Append("\n");
            sb.Append("  DisplayBuyerName: ").Append(DisplayBuyerName).Append("\n");
            sb.Append("  DisplayAllowedTenderGroup: ").Append(DisplayAllowedTenderGroup).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessFlowsPermanentCustomerInformationConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProcessId == input.ProcessId ||
                    (this.ProcessId != null &&
                    this.ProcessId.Equals(input.ProcessId))
                ) && 
                (
                    this.MainProcess == input.MainProcess ||
                    (this.MainProcess != null &&
                    this.MainProcess.Equals(input.MainProcess))
                ) && 
                (
                    this.AuthorizationConfig == input.AuthorizationConfig ||
                    (this.AuthorizationConfig != null &&
                    this.AuthorizationConfig.Equals(input.AuthorizationConfig))
                ) && 
                (
                    this.DisplayCustomerNumber == input.DisplayCustomerNumber ||
                    (this.DisplayCustomerNumber != null &&
                    this.DisplayCustomerNumber.Equals(input.DisplayCustomerNumber))
                ) && 
                (
                    this.DisplayCustomerName == input.DisplayCustomerName ||
                    (this.DisplayCustomerName != null &&
                    this.DisplayCustomerName.Equals(input.DisplayCustomerName))
                ) && 
                (
                    this.DisplayBuyerNumber == input.DisplayBuyerNumber ||
                    (this.DisplayBuyerNumber != null &&
                    this.DisplayBuyerNumber.Equals(input.DisplayBuyerNumber))
                ) && 
                (
                    this.DisplayBuyerName == input.DisplayBuyerName ||
                    (this.DisplayBuyerName != null &&
                    this.DisplayBuyerName.Equals(input.DisplayBuyerName))
                ) && 
                (
                    this.DisplayAllowedTenderGroup == input.DisplayAllowedTenderGroup ||
                    (this.DisplayAllowedTenderGroup != null &&
                    this.DisplayAllowedTenderGroup.Equals(input.DisplayAllowedTenderGroup))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProcessId != null)
                    hashCode = hashCode * 59 + this.ProcessId.GetHashCode();
                if (this.MainProcess != null)
                    hashCode = hashCode * 59 + this.MainProcess.GetHashCode();
                if (this.AuthorizationConfig != null)
                    hashCode = hashCode * 59 + this.AuthorizationConfig.GetHashCode();
                if (this.DisplayCustomerNumber != null)
                    hashCode = hashCode * 59 + this.DisplayCustomerNumber.GetHashCode();
                if (this.DisplayCustomerName != null)
                    hashCode = hashCode * 59 + this.DisplayCustomerName.GetHashCode();
                if (this.DisplayBuyerNumber != null)
                    hashCode = hashCode * 59 + this.DisplayBuyerNumber.GetHashCode();
                if (this.DisplayBuyerName != null)
                    hashCode = hashCode * 59 + this.DisplayBuyerName.GetHashCode();
                if (this.DisplayAllowedTenderGroup != null)
                    hashCode = hashCode * 59 + this.DisplayAllowedTenderGroup.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
