/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ReturnWithTransactionConfig &lt;p&gt;This configuration entity defines the return process with an available transaction.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig" /> class.
        /// </summary>
        /// <param name="returnTransaction">&lt;p&gt;PositionOperationConfig&lt;/p&gt; (required).</param>
        /// <param name="returnLineItem">&lt;p&gt;PositionOperationConfig&lt;/p&gt; (required).</param>
        /// <param name="promptUserConfig">&lt;p&gt;This config defines the prompt usage.&lt;/p&gt; (required).</param>
        /// <param name="transactionPreview">&lt;p&gt;This parameter defines the configuration for the transaction preview. The config parameters will be passed to the transaction preview component, controller, report and datasource.&lt;/p&gt; (required).</param>
        /// <param name="returnReasonRequired">&lt;p&gt;This parameter specifies whether the reason is requested in case of returns.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="returnPrepaidAllowed">&lt;p&gt;This parameter specifies whether it is allowed to return prepaid line items in case of a return with receipt data.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="differentStoreAllowed">&lt;p&gt;This parameter specifies whether it is allowed to perform a return with a original receipt for receipts from other stores.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="takeOverCustomersFromOriginalSc">&lt;p&gt;This parameter specifies whether the customer data is transferred from the original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="returnReasonCode">&lt;p&gt;This parameter defines the reason for the return.&lt;/p&gt;.</param>
        /// <param name="returnReasonGroupCode">&lt;p&gt;This parameter filters reasons with the following reason group code.&lt;/p&gt; (required).</param>
        /// <param name="findTransactionConfig">&lt;p&gt;FindTransactionConfig&lt;/p&gt; (required).</param>
        /// <param name="checkIfItemsExistInMasterData">&lt;p&gt;It defines if the items must exist in master data for return with transaction.&lt;/p&gt; (required).</param>
        /// <param name="conditionSplitConfig">&lt;p&gt;ConditionSplitConfig&lt;/p&gt; (required).</param>
        /// <param name="manualDiscountTypes">&lt;p&gt;This parameter defines the list of condition types for price reduction.&lt;br /&gt; @deprecated as of 5.6.0. Use instead: conditionSplitConfig.manualDiscountTypes&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig returnTransaction = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig returnLineItem = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig promptUserConfig = default(ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig), ComGkSoftwarePosApiModelConfigProcessUiTransactionPreviewContextConfig transactionPreview = default(ComGkSoftwarePosApiModelConfigProcessUiTransactionPreviewContextConfig), bool? returnReasonRequired = default(bool?), bool? returnPrepaidAllowed = default(bool?), bool? differentStoreAllowed = default(bool?), bool? takeOverCustomersFromOriginalSc = default(bool?), string returnReasonCode = default(string), string returnReasonGroupCode = default(string), ComGkSoftwarePosApiModelConfigProcessFlowsFindTransactionConfig findTransactionConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsFindTransactionConfig), bool? checkIfItemsExistInMasterData = default(bool?), ComGkSoftwarePosApiModelConfigProcessFlowsConditionSplitConfig conditionSplitConfig = default(ComGkSoftwarePosApiModelConfigProcessFlowsConditionSplitConfig), List<string> manualDiscountTypes = default(List<string>), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "returnTransaction" is required (not null)
            if (returnTransaction == null)
            {
                throw new InvalidDataException("returnTransaction is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ReturnTransaction = returnTransaction;
            }
            // to ensure "returnLineItem" is required (not null)
            if (returnLineItem == null)
            {
                throw new InvalidDataException("returnLineItem is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ReturnLineItem = returnLineItem;
            }
            // to ensure "promptUserConfig" is required (not null)
            if (promptUserConfig == null)
            {
                throw new InvalidDataException("promptUserConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.PromptUserConfig = promptUserConfig;
            }
            // to ensure "transactionPreview" is required (not null)
            if (transactionPreview == null)
            {
                throw new InvalidDataException("transactionPreview is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.TransactionPreview = transactionPreview;
            }
            // to ensure "returnReasonRequired" is required (not null)
            if (returnReasonRequired == null)
            {
                throw new InvalidDataException("returnReasonRequired is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ReturnReasonRequired = returnReasonRequired;
            }
            // to ensure "returnPrepaidAllowed" is required (not null)
            if (returnPrepaidAllowed == null)
            {
                throw new InvalidDataException("returnPrepaidAllowed is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ReturnPrepaidAllowed = returnPrepaidAllowed;
            }
            // to ensure "differentStoreAllowed" is required (not null)
            if (differentStoreAllowed == null)
            {
                throw new InvalidDataException("differentStoreAllowed is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.DifferentStoreAllowed = differentStoreAllowed;
            }
            // to ensure "takeOverCustomersFromOriginalSc" is required (not null)
            if (takeOverCustomersFromOriginalSc == null)
            {
                throw new InvalidDataException("takeOverCustomersFromOriginalSc is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.TakeOverCustomersFromOriginalSc = takeOverCustomersFromOriginalSc;
            }
            // to ensure "returnReasonGroupCode" is required (not null)
            if (returnReasonGroupCode == null)
            {
                throw new InvalidDataException("returnReasonGroupCode is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ReturnReasonGroupCode = returnReasonGroupCode;
            }
            // to ensure "findTransactionConfig" is required (not null)
            if (findTransactionConfig == null)
            {
                throw new InvalidDataException("findTransactionConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.FindTransactionConfig = findTransactionConfig;
            }
            // to ensure "checkIfItemsExistInMasterData" is required (not null)
            if (checkIfItemsExistInMasterData == null)
            {
                throw new InvalidDataException("checkIfItemsExistInMasterData is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.CheckIfItemsExistInMasterData = checkIfItemsExistInMasterData;
            }
            // to ensure "conditionSplitConfig" is required (not null)
            if (conditionSplitConfig == null)
            {
                throw new InvalidDataException("conditionSplitConfig is a required property for ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig and cannot be null");
            }
            else
            {
                this.ConditionSplitConfig = conditionSplitConfig;
            }
            this.ReturnReasonCode = returnReasonCode;
            this.ManualDiscountTypes = manualDiscountTypes;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;PositionOperationConfig&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;PositionOperationConfig&lt;/p&gt;</value>
        [DataMember(Name="returnTransaction", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig ReturnTransaction { get; set; }

        /// <summary>
        /// &lt;p&gt;PositionOperationConfig&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;PositionOperationConfig&lt;/p&gt;</value>
        [DataMember(Name="returnLineItem", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig ReturnLineItem { get; set; }

        /// <summary>
        /// &lt;p&gt;This config defines the prompt usage.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This config defines the prompt usage.&lt;/p&gt;</value>
        [DataMember(Name="promptUserConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig PromptUserConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the configuration for the transaction preview. The config parameters will be passed to the transaction preview component, controller, report and datasource.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the configuration for the transaction preview. The config parameters will be passed to the transaction preview component, controller, report and datasource.&lt;/p&gt;</value>
        [DataMember(Name="transactionPreview", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessUiTransactionPreviewContextConfig TransactionPreview { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the reason is requested in case of returns.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the reason is requested in case of returns.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="returnReasonRequired", EmitDefaultValue=false)]
        public bool? ReturnReasonRequired { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether it is allowed to return prepaid line items in case of a return with receipt data.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether it is allowed to return prepaid line items in case of a return with receipt data.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="returnPrepaidAllowed", EmitDefaultValue=false)]
        public bool? ReturnPrepaidAllowed { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether it is allowed to perform a return with a original receipt for receipts from other stores.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether it is allowed to perform a return with a original receipt for receipts from other stores.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="differentStoreAllowed", EmitDefaultValue=false)]
        public bool? DifferentStoreAllowed { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the customer data is transferred from the original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the customer data is transferred from the original receipt.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="takeOverCustomersFromOriginalSc", EmitDefaultValue=false)]
        public bool? TakeOverCustomersFromOriginalSc { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the reason for the return.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the reason for the return.&lt;/p&gt;</value>
        [DataMember(Name="returnReasonCode", EmitDefaultValue=false)]
        public string ReturnReasonCode { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter filters reasons with the following reason group code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter filters reasons with the following reason group code.&lt;/p&gt;</value>
        [DataMember(Name="returnReasonGroupCode", EmitDefaultValue=false)]
        public string ReturnReasonGroupCode { get; set; }

        /// <summary>
        /// &lt;p&gt;FindTransactionConfig&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;FindTransactionConfig&lt;/p&gt;</value>
        [DataMember(Name="findTransactionConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsFindTransactionConfig FindTransactionConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the items must exist in master data for return with transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the items must exist in master data for return with transaction.&lt;/p&gt;</value>
        [DataMember(Name="checkIfItemsExistInMasterData", EmitDefaultValue=false)]
        public bool? CheckIfItemsExistInMasterData { get; set; }

        /// <summary>
        /// &lt;p&gt;ConditionSplitConfig&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ConditionSplitConfig&lt;/p&gt;</value>
        [DataMember(Name="conditionSplitConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsConditionSplitConfig ConditionSplitConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the list of condition types for price reduction.&lt;br /&gt; @deprecated as of 5.6.0. Use instead: conditionSplitConfig.manualDiscountTypes&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the list of condition types for price reduction.&lt;br /&gt; @deprecated as of 5.6.0. Use instead: conditionSplitConfig.manualDiscountTypes&lt;/p&gt;</value>
        [DataMember(Name="manualDiscountTypes", EmitDefaultValue=false)]
        public List<string> ManualDiscountTypes { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig {\n");
            sb.Append("  ReturnTransaction: ").Append(ReturnTransaction).Append("\n");
            sb.Append("  ReturnLineItem: ").Append(ReturnLineItem).Append("\n");
            sb.Append("  PromptUserConfig: ").Append(PromptUserConfig).Append("\n");
            sb.Append("  TransactionPreview: ").Append(TransactionPreview).Append("\n");
            sb.Append("  ReturnReasonRequired: ").Append(ReturnReasonRequired).Append("\n");
            sb.Append("  ReturnPrepaidAllowed: ").Append(ReturnPrepaidAllowed).Append("\n");
            sb.Append("  DifferentStoreAllowed: ").Append(DifferentStoreAllowed).Append("\n");
            sb.Append("  TakeOverCustomersFromOriginalSc: ").Append(TakeOverCustomersFromOriginalSc).Append("\n");
            sb.Append("  ReturnReasonCode: ").Append(ReturnReasonCode).Append("\n");
            sb.Append("  ReturnReasonGroupCode: ").Append(ReturnReasonGroupCode).Append("\n");
            sb.Append("  FindTransactionConfig: ").Append(FindTransactionConfig).Append("\n");
            sb.Append("  CheckIfItemsExistInMasterData: ").Append(CheckIfItemsExistInMasterData).Append("\n");
            sb.Append("  ConditionSplitConfig: ").Append(ConditionSplitConfig).Append("\n");
            sb.Append("  ManualDiscountTypes: ").Append(ManualDiscountTypes).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessFlowsReturnWithTransactionConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ReturnTransaction == input.ReturnTransaction ||
                    (this.ReturnTransaction != null &&
                    this.ReturnTransaction.Equals(input.ReturnTransaction))
                ) && 
                (
                    this.ReturnLineItem == input.ReturnLineItem ||
                    (this.ReturnLineItem != null &&
                    this.ReturnLineItem.Equals(input.ReturnLineItem))
                ) && 
                (
                    this.PromptUserConfig == input.PromptUserConfig ||
                    (this.PromptUserConfig != null &&
                    this.PromptUserConfig.Equals(input.PromptUserConfig))
                ) && 
                (
                    this.TransactionPreview == input.TransactionPreview ||
                    (this.TransactionPreview != null &&
                    this.TransactionPreview.Equals(input.TransactionPreview))
                ) && 
                (
                    this.ReturnReasonRequired == input.ReturnReasonRequired ||
                    (this.ReturnReasonRequired != null &&
                    this.ReturnReasonRequired.Equals(input.ReturnReasonRequired))
                ) && 
                (
                    this.ReturnPrepaidAllowed == input.ReturnPrepaidAllowed ||
                    (this.ReturnPrepaidAllowed != null &&
                    this.ReturnPrepaidAllowed.Equals(input.ReturnPrepaidAllowed))
                ) && 
                (
                    this.DifferentStoreAllowed == input.DifferentStoreAllowed ||
                    (this.DifferentStoreAllowed != null &&
                    this.DifferentStoreAllowed.Equals(input.DifferentStoreAllowed))
                ) && 
                (
                    this.TakeOverCustomersFromOriginalSc == input.TakeOverCustomersFromOriginalSc ||
                    (this.TakeOverCustomersFromOriginalSc != null &&
                    this.TakeOverCustomersFromOriginalSc.Equals(input.TakeOverCustomersFromOriginalSc))
                ) && 
                (
                    this.ReturnReasonCode == input.ReturnReasonCode ||
                    (this.ReturnReasonCode != null &&
                    this.ReturnReasonCode.Equals(input.ReturnReasonCode))
                ) && 
                (
                    this.ReturnReasonGroupCode == input.ReturnReasonGroupCode ||
                    (this.ReturnReasonGroupCode != null &&
                    this.ReturnReasonGroupCode.Equals(input.ReturnReasonGroupCode))
                ) && 
                (
                    this.FindTransactionConfig == input.FindTransactionConfig ||
                    (this.FindTransactionConfig != null &&
                    this.FindTransactionConfig.Equals(input.FindTransactionConfig))
                ) && 
                (
                    this.CheckIfItemsExistInMasterData == input.CheckIfItemsExistInMasterData ||
                    (this.CheckIfItemsExistInMasterData != null &&
                    this.CheckIfItemsExistInMasterData.Equals(input.CheckIfItemsExistInMasterData))
                ) && 
                (
                    this.ConditionSplitConfig == input.ConditionSplitConfig ||
                    (this.ConditionSplitConfig != null &&
                    this.ConditionSplitConfig.Equals(input.ConditionSplitConfig))
                ) && 
                (
                    this.ManualDiscountTypes == input.ManualDiscountTypes ||
                    this.ManualDiscountTypes != null &&
                    this.ManualDiscountTypes.SequenceEqual(input.ManualDiscountTypes)
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ReturnTransaction != null)
                    hashCode = hashCode * 59 + this.ReturnTransaction.GetHashCode();
                if (this.ReturnLineItem != null)
                    hashCode = hashCode * 59 + this.ReturnLineItem.GetHashCode();
                if (this.PromptUserConfig != null)
                    hashCode = hashCode * 59 + this.PromptUserConfig.GetHashCode();
                if (this.TransactionPreview != null)
                    hashCode = hashCode * 59 + this.TransactionPreview.GetHashCode();
                if (this.ReturnReasonRequired != null)
                    hashCode = hashCode * 59 + this.ReturnReasonRequired.GetHashCode();
                if (this.ReturnPrepaidAllowed != null)
                    hashCode = hashCode * 59 + this.ReturnPrepaidAllowed.GetHashCode();
                if (this.DifferentStoreAllowed != null)
                    hashCode = hashCode * 59 + this.DifferentStoreAllowed.GetHashCode();
                if (this.TakeOverCustomersFromOriginalSc != null)
                    hashCode = hashCode * 59 + this.TakeOverCustomersFromOriginalSc.GetHashCode();
                if (this.ReturnReasonCode != null)
                    hashCode = hashCode * 59 + this.ReturnReasonCode.GetHashCode();
                if (this.ReturnReasonGroupCode != null)
                    hashCode = hashCode * 59 + this.ReturnReasonGroupCode.GetHashCode();
                if (this.FindTransactionConfig != null)
                    hashCode = hashCode * 59 + this.FindTransactionConfig.GetHashCode();
                if (this.CheckIfItemsExistInMasterData != null)
                    hashCode = hashCode * 59 + this.CheckIfItemsExistInMasterData.GetHashCode();
                if (this.ConditionSplitConfig != null)
                    hashCode = hashCode * 59 + this.ConditionSplitConfig.GetHashCode();
                if (this.ManualDiscountTypes != null)
                    hashCode = hashCode * 59 + this.ManualDiscountTypes.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
