/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PromptUserDialogConfig &lt;p&gt;This configuration entity defines the process for prompting the user.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig :  IEquatable<ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig" /> class.
        /// </summary>
        /// <param name="titleKey">&lt;p&gt;This parameter defines the translation key for the title.&lt;/p&gt; (required).</param>
        /// <param name="signalConfigId">&lt;p&gt;This parameter defines the configuration identifier for a SignalConfig instance. The resolved configuration will be used for an acoustic signal performed in combination with the message dialog.&lt;/p&gt;.</param>
        /// <param name="inputDomain">&lt;p&gt;This parameter defines the input domain for the input field.&lt;/p&gt; (required).</param>
        /// <param name="inputMandatory">&lt;p&gt;This parameter specifies whether an input is mandatory.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="cancelAllowed">&lt;p&gt;This parameter specifies whether the cancellation of the dialog is allowed.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt; (required).</param>
        /// <param name="labelTextKey">&lt;p&gt;This parameter defines an optional translation key for the label text.&lt;/p&gt;.</param>
        /// <param name="maxLengthOfTitleToSplit">maxLengthOfTitleToSplit.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig(string titleKey = default(string), string signalConfigId = default(string), string inputDomain = default(string), bool? inputMandatory = default(bool?), bool? cancelAllowed = default(bool?), string labelTextKey = default(string), int? maxLengthOfTitleToSplit = default(int?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "titleKey" is required (not null)
            if (titleKey == null)
            {
                throw new InvalidDataException("titleKey is a required property for ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig and cannot be null");
            }
            else
            {
                this.TitleKey = titleKey;
            }
            // to ensure "inputDomain" is required (not null)
            if (inputDomain == null)
            {
                throw new InvalidDataException("inputDomain is a required property for ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig and cannot be null");
            }
            else
            {
                this.InputDomain = inputDomain;
            }
            // to ensure "inputMandatory" is required (not null)
            if (inputMandatory == null)
            {
                throw new InvalidDataException("inputMandatory is a required property for ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig and cannot be null");
            }
            else
            {
                this.InputMandatory = inputMandatory;
            }
            // to ensure "cancelAllowed" is required (not null)
            if (cancelAllowed == null)
            {
                throw new InvalidDataException("cancelAllowed is a required property for ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig and cannot be null");
            }
            else
            {
                this.CancelAllowed = cancelAllowed;
            }
            this.SignalConfigId = signalConfigId;
            this.LabelTextKey = labelTextKey;
            this.MaxLengthOfTitleToSplit = maxLengthOfTitleToSplit;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;This parameter defines the translation key for the title.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the translation key for the title.&lt;/p&gt;</value>
        [DataMember(Name="titleKey", EmitDefaultValue=false)]
        public string TitleKey { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the configuration identifier for a SignalConfig instance. The resolved configuration will be used for an acoustic signal performed in combination with the message dialog.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the configuration identifier for a SignalConfig instance. The resolved configuration will be used for an acoustic signal performed in combination with the message dialog.&lt;/p&gt;</value>
        [DataMember(Name="signalConfigId", EmitDefaultValue=false)]
        public string SignalConfigId { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines the input domain for the input field.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the input domain for the input field.&lt;/p&gt;</value>
        [DataMember(Name="inputDomain", EmitDefaultValue=false)]
        public string InputDomain { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether an input is mandatory.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether an input is mandatory.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="inputMandatory", EmitDefaultValue=false)]
        public bool? InputMandatory { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the cancellation of the dialog is allowed.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the cancellation of the dialog is allowed.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="cancelAllowed", EmitDefaultValue=false)]
        public bool? CancelAllowed { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter defines an optional translation key for the label text.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines an optional translation key for the label text.&lt;/p&gt;</value>
        [DataMember(Name="labelTextKey", EmitDefaultValue=false)]
        public string LabelTextKey { get; set; }

        /// <summary>
        /// Gets or Sets MaxLengthOfTitleToSplit
        /// </summary>
        [DataMember(Name="maxLengthOfTitleToSplit", EmitDefaultValue=false)]
        public int? MaxLengthOfTitleToSplit { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig {\n");
            sb.Append("  TitleKey: ").Append(TitleKey).Append("\n");
            sb.Append("  SignalConfigId: ").Append(SignalConfigId).Append("\n");
            sb.Append("  InputDomain: ").Append(InputDomain).Append("\n");
            sb.Append("  InputMandatory: ").Append(InputMandatory).Append("\n");
            sb.Append("  CancelAllowed: ").Append(CancelAllowed).Append("\n");
            sb.Append("  LabelTextKey: ").Append(LabelTextKey).Append("\n");
            sb.Append("  MaxLengthOfTitleToSplit: ").Append(MaxLengthOfTitleToSplit).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TitleKey == input.TitleKey ||
                    (this.TitleKey != null &&
                    this.TitleKey.Equals(input.TitleKey))
                ) && 
                (
                    this.SignalConfigId == input.SignalConfigId ||
                    (this.SignalConfigId != null &&
                    this.SignalConfigId.Equals(input.SignalConfigId))
                ) && 
                (
                    this.InputDomain == input.InputDomain ||
                    (this.InputDomain != null &&
                    this.InputDomain.Equals(input.InputDomain))
                ) && 
                (
                    this.InputMandatory == input.InputMandatory ||
                    (this.InputMandatory != null &&
                    this.InputMandatory.Equals(input.InputMandatory))
                ) && 
                (
                    this.CancelAllowed == input.CancelAllowed ||
                    (this.CancelAllowed != null &&
                    this.CancelAllowed.Equals(input.CancelAllowed))
                ) && 
                (
                    this.LabelTextKey == input.LabelTextKey ||
                    (this.LabelTextKey != null &&
                    this.LabelTextKey.Equals(input.LabelTextKey))
                ) && 
                (
                    this.MaxLengthOfTitleToSplit == input.MaxLengthOfTitleToSplit ||
                    (this.MaxLengthOfTitleToSplit != null &&
                    this.MaxLengthOfTitleToSplit.Equals(input.MaxLengthOfTitleToSplit))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TitleKey != null)
                    hashCode = hashCode * 59 + this.TitleKey.GetHashCode();
                if (this.SignalConfigId != null)
                    hashCode = hashCode * 59 + this.SignalConfigId.GetHashCode();
                if (this.InputDomain != null)
                    hashCode = hashCode * 59 + this.InputDomain.GetHashCode();
                if (this.InputMandatory != null)
                    hashCode = hashCode * 59 + this.InputMandatory.GetHashCode();
                if (this.CancelAllowed != null)
                    hashCode = hashCode * 59 + this.CancelAllowed.GetHashCode();
                if (this.LabelTextKey != null)
                    hashCode = hashCode * 59 + this.LabelTextKey.GetHashCode();
                if (this.MaxLengthOfTitleToSplit != null)
                    hashCode = hashCode * 59 + this.MaxLengthOfTitleToSplit.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
