/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ItemInformation &lt;p&gt;Object to consolidate item information (e.g. master data, stock details, etc.).&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppItemInformationItemInformation :  IEquatable<ComGkSoftwarePosApiModelDomAppItemInformationItemInformation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppItemInformationItemInformation" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;The business unit group ID&lt;/p&gt;.</param>
        /// <param name="itemID">&lt;p&gt;The item ID&lt;/p&gt;.</param>
        /// <param name="uomCode">&lt;p&gt;The unit of measure code&lt;/p&gt;.</param>
        /// <param name="uomName">&lt;p&gt;The unit of measure name&lt;/p&gt;.</param>
        /// <param name="name">&lt;p&gt;Name of the item&lt;/p&gt;.</param>
        /// <param name="mainPOSItemId">&lt;p&gt;The main pos item id&lt;/p&gt;.</param>
        /// <param name="merchandiseHierarchyGroupName">&lt;p&gt;Name of assigned merchandise hierarchy group.&lt;/p&gt;.</param>
        /// <param name="validPriceAmount">&lt;p&gt;Amount of the actual price.&lt;/p&gt;.</param>
        /// <param name="regularPriceAmount">&lt;p&gt;Amount of the regular price.&lt;/p&gt;.</param>
        /// <param name="validPriceExpiryDate">&lt;p&gt;Expiration (end) time stamp of the actual price.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="deposit">&lt;p&gt;Amount of the deposit&lt;/p&gt;.</param>
        /// <param name="color">&lt;p&gt;Specifies the color of the item.&lt;br /&gt; Item characteristics entry with id COLOR is used to fill this value.&lt;/p&gt;.</param>
        /// <param name="size">&lt;p&gt;Specifies the size, e.g. in case of fashion the dress size.&lt;br /&gt; Item characteristics entry with id SIZE is used to fill this value.&lt;/p&gt;.</param>
        /// <param name="taxGroupID">&lt;p&gt;Code of related tax group.&lt;/p&gt;.</param>
        /// <param name="imageSrcIds">&lt;p&gt;Item image url.&lt;/p&gt;.</param>
        /// <param name="authorisedForSale">&lt;p&gt;A flag to indicate that the retail store is authorized to stock this particular item.&lt;/p&gt;.</param>
        /// <param name="internalStock">&lt;p&gt;Stock details related to local store.&lt;/p&gt;.</param>
        /// <param name="externalStocks">&lt;p&gt;List of stock details from surrounding stores.&lt;/p&gt;.</param>
        /// <param name="itemView">&lt;p&gt;The ItemInformationView instance.&lt;/p&gt;.</param>
        /// <param name="uomItemTextList">&lt;p&gt;It contains extended item information. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;.</param>
        /// <param name="prices">&lt;p&gt;List of aviable price entries.&lt;/p&gt;.</param>
        /// <param name="itemInfoIcons">&lt;p&gt;It contains details about item info icons. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;.</param>
        /// <param name="discountInfoIcons">&lt;p&gt;It contains details about available promotions - e.g. Pay 2 get 3, 10% off...&lt;/p&gt;.</param>
        /// <param name="webshopItemInfoData">&lt;p&gt;It contains item informations requested from web shop system.&lt;/p&gt;.</param>
        /// <param name="variantsAvailable">&lt;p&gt;It contains info about variants available for this item&lt;/p&gt;.</param>
        /// <param name="ePriceTypeCode">&lt;p&gt;Type code of the actual price (00 &#x3D; default price, 01 &#x3D; special price)&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelDomAppItemInformationItemInformation(string businessUnitGroupID = default(string), string itemID = default(string), string uomCode = default(string), string uomName = default(string), string name = default(string), string mainPOSItemId = default(string), string merchandiseHierarchyGroupName = default(string), double? validPriceAmount = default(double?), double? regularPriceAmount = default(double?), string validPriceExpiryDate = default(string), double? deposit = default(double?), string color = default(string), string size = default(string), string taxGroupID = default(string), string imageSrcIds = default(string), bool? authorisedForSale = default(bool?), ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail internalStock = default(ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail), List<ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail> externalStocks = default(List<ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail>), ComGkSoftwarePosApiModelDomAppItemInformationItemInformationView itemView = default(ComGkSoftwarePosApiModelDomAppItemInformationItemInformationView), List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText> uomItemTextList = default(List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText>), List<ComGkSoftwarePosApiModelDomAppItemInformationPrice> prices = default(List<ComGkSoftwarePosApiModelDomAppItemInformationPrice>), List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText> itemInfoIcons = default(List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText>), List<ComGkSoftwarePosFlowLibsTransactionDiscountIconList> discountInfoIcons = default(List<ComGkSoftwarePosFlowLibsTransactionDiscountIconList>), ComGkSoftwarePosApiModelDomAppItemInformationWebshopItemInfoData webshopItemInfoData = default(ComGkSoftwarePosApiModelDomAppItemInformationWebshopItemInfoData), bool? variantsAvailable = default(bool?), string ePriceTypeCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.BusinessUnitGroupID = businessUnitGroupID;
            this.ItemID = itemID;
            this.UomCode = uomCode;
            this.UomName = uomName;
            this.Name = name;
            this.MainPOSItemId = mainPOSItemId;
            this.MerchandiseHierarchyGroupName = merchandiseHierarchyGroupName;
            this.ValidPriceAmount = validPriceAmount;
            this.RegularPriceAmount = regularPriceAmount;
            this.ValidPriceExpiryDate = validPriceExpiryDate;
            this.Deposit = deposit;
            this.Color = color;
            this.Size = size;
            this.TaxGroupID = taxGroupID;
            this.ImageSrcIds = imageSrcIds;
            this.AuthorisedForSale = authorisedForSale;
            this.InternalStock = internalStock;
            this.ExternalStocks = externalStocks;
            this.ItemView = itemView;
            this.UomItemTextList = uomItemTextList;
            this.Prices = prices;
            this.ItemInfoIcons = itemInfoIcons;
            this.DiscountInfoIcons = discountInfoIcons;
            this.WebshopItemInfoData = webshopItemInfoData;
            this.VariantsAvailable = variantsAvailable;
            this.EPriceTypeCode = ePriceTypeCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The business unit group ID&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit group ID&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;The item ID&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item ID&lt;/p&gt;</value>
        [DataMember(Name="itemID", EmitDefaultValue=false)]
        public string ItemID { get; set; }

        /// <summary>
        /// &lt;p&gt;The unit of measure code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unit of measure code&lt;/p&gt;</value>
        [DataMember(Name="uomCode", EmitDefaultValue=false)]
        public string UomCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The unit of measure name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unit of measure name&lt;/p&gt;</value>
        [DataMember(Name="uomName", EmitDefaultValue=false)]
        public string UomName { get; set; }

        /// <summary>
        /// &lt;p&gt;Name of the item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of the item&lt;/p&gt;</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// &lt;p&gt;The main pos item id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The main pos item id&lt;/p&gt;</value>
        [DataMember(Name="mainPOSItemId", EmitDefaultValue=false)]
        public string MainPOSItemId { get; set; }

        /// <summary>
        /// &lt;p&gt;Name of assigned merchandise hierarchy group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of assigned merchandise hierarchy group.&lt;/p&gt;</value>
        [DataMember(Name="merchandiseHierarchyGroupName", EmitDefaultValue=false)]
        public string MerchandiseHierarchyGroupName { get; set; }

        /// <summary>
        /// &lt;p&gt;Amount of the actual price.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the actual price.&lt;/p&gt;</value>
        [DataMember(Name="validPriceAmount", EmitDefaultValue=false)]
        public double? ValidPriceAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;Amount of the regular price.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the regular price.&lt;/p&gt;</value>
        [DataMember(Name="regularPriceAmount", EmitDefaultValue=false)]
        public double? RegularPriceAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;Expiration (end) time stamp of the actual price.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Expiration (end) time stamp of the actual price.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="validPriceExpiryDate", EmitDefaultValue=false)]
        public string ValidPriceExpiryDate { get; set; }

        /// <summary>
        /// &lt;p&gt;Amount of the deposit&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the deposit&lt;/p&gt;</value>
        [DataMember(Name="deposit", EmitDefaultValue=false)]
        public double? Deposit { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies the color of the item.&lt;br /&gt; Item characteristics entry with id COLOR is used to fill this value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies the color of the item.&lt;br /&gt; Item characteristics entry with id COLOR is used to fill this value.&lt;/p&gt;</value>
        [DataMember(Name="color", EmitDefaultValue=false)]
        public string Color { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies the size, e.g. in case of fashion the dress size.&lt;br /&gt; Item characteristics entry with id SIZE is used to fill this value.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies the size, e.g. in case of fashion the dress size.&lt;br /&gt; Item characteristics entry with id SIZE is used to fill this value.&lt;/p&gt;</value>
        [DataMember(Name="size", EmitDefaultValue=false)]
        public string Size { get; set; }

        /// <summary>
        /// &lt;p&gt;Code of related tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Code of related tax group.&lt;/p&gt;</value>
        [DataMember(Name="taxGroupID", EmitDefaultValue=false)]
        public string TaxGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Item image url.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Item image url.&lt;/p&gt;</value>
        [DataMember(Name="imageSrcIds", EmitDefaultValue=false)]
        public string ImageSrcIds { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the retail store is authorized to stock this particular item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the retail store is authorized to stock this particular item.&lt;/p&gt;</value>
        [DataMember(Name="authorisedForSale", EmitDefaultValue=false)]
        public bool? AuthorisedForSale { get; set; }

        /// <summary>
        /// &lt;p&gt;Stock details related to local store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Stock details related to local store.&lt;/p&gt;</value>
        [DataMember(Name="internalStock", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail InternalStock { get; set; }

        /// <summary>
        /// &lt;p&gt;List of stock details from surrounding stores.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of stock details from surrounding stores.&lt;/p&gt;</value>
        [DataMember(Name="externalStocks", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail> ExternalStocks { get; set; }

        /// <summary>
        /// &lt;p&gt;The ItemInformationView instance.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The ItemInformationView instance.&lt;/p&gt;</value>
        [DataMember(Name="itemView", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppItemInformationItemInformationView ItemView { get; set; }

        /// <summary>
        /// &lt;p&gt;It contains extended item information. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains extended item information. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;</value>
        [DataMember(Name="uomItemTextList", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText> UomItemTextList { get; set; }

        /// <summary>
        /// &lt;p&gt;List of aviable price entries.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of aviable price entries.&lt;/p&gt;</value>
        [DataMember(Name="prices", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppItemInformationPrice> Prices { get; set; }

        /// <summary>
        /// &lt;p&gt;It contains details about item info icons. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains details about item info icons. The content is a filtered view on uom item text list. Filtering is done by text class ids defined in configuration.&lt;/p&gt;</value>
        [DataMember(Name="itemInfoIcons", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppItemInformationUomItemText> ItemInfoIcons { get; set; }

        /// <summary>
        /// &lt;p&gt;It contains details about available promotions - e.g. Pay 2 get 3, 10% off...&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains details about available promotions - e.g. Pay 2 get 3, 10% off...&lt;/p&gt;</value>
        [DataMember(Name="discountInfoIcons", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosFlowLibsTransactionDiscountIconList> DiscountInfoIcons { get; set; }

        /// <summary>
        /// &lt;p&gt;It contains item informations requested from web shop system.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains item informations requested from web shop system.&lt;/p&gt;</value>
        [DataMember(Name="webshopItemInfoData", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppItemInformationWebshopItemInfoData WebshopItemInfoData { get; set; }

        /// <summary>
        /// &lt;p&gt;It contains info about variants available for this item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It contains info about variants available for this item&lt;/p&gt;</value>
        [DataMember(Name="variantsAvailable", EmitDefaultValue=false)]
        public bool? VariantsAvailable { get; set; }

        /// <summary>
        /// &lt;p&gt;Type code of the actual price (00 &#x3D; default price, 01 &#x3D; special price)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type code of the actual price (00 &#x3D; default price, 01 &#x3D; special price)&lt;/p&gt;</value>
        [DataMember(Name="ePriceTypeCode", EmitDefaultValue=false)]
        public string EPriceTypeCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppItemInformationItemInformation {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  ItemID: ").Append(ItemID).Append("\n");
            sb.Append("  UomCode: ").Append(UomCode).Append("\n");
            sb.Append("  UomName: ").Append(UomName).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  MainPOSItemId: ").Append(MainPOSItemId).Append("\n");
            sb.Append("  MerchandiseHierarchyGroupName: ").Append(MerchandiseHierarchyGroupName).Append("\n");
            sb.Append("  ValidPriceAmount: ").Append(ValidPriceAmount).Append("\n");
            sb.Append("  RegularPriceAmount: ").Append(RegularPriceAmount).Append("\n");
            sb.Append("  ValidPriceExpiryDate: ").Append(ValidPriceExpiryDate).Append("\n");
            sb.Append("  Deposit: ").Append(Deposit).Append("\n");
            sb.Append("  Color: ").Append(Color).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("  TaxGroupID: ").Append(TaxGroupID).Append("\n");
            sb.Append("  ImageSrcIds: ").Append(ImageSrcIds).Append("\n");
            sb.Append("  AuthorisedForSale: ").Append(AuthorisedForSale).Append("\n");
            sb.Append("  InternalStock: ").Append(InternalStock).Append("\n");
            sb.Append("  ExternalStocks: ").Append(ExternalStocks).Append("\n");
            sb.Append("  ItemView: ").Append(ItemView).Append("\n");
            sb.Append("  UomItemTextList: ").Append(UomItemTextList).Append("\n");
            sb.Append("  Prices: ").Append(Prices).Append("\n");
            sb.Append("  ItemInfoIcons: ").Append(ItemInfoIcons).Append("\n");
            sb.Append("  DiscountInfoIcons: ").Append(DiscountInfoIcons).Append("\n");
            sb.Append("  WebshopItemInfoData: ").Append(WebshopItemInfoData).Append("\n");
            sb.Append("  VariantsAvailable: ").Append(VariantsAvailable).Append("\n");
            sb.Append("  EPriceTypeCode: ").Append(EPriceTypeCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppItemInformationItemInformation);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppItemInformationItemInformation instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppItemInformationItemInformation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppItemInformationItemInformation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.ItemID == input.ItemID ||
                    (this.ItemID != null &&
                    this.ItemID.Equals(input.ItemID))
                ) && 
                (
                    this.UomCode == input.UomCode ||
                    (this.UomCode != null &&
                    this.UomCode.Equals(input.UomCode))
                ) && 
                (
                    this.UomName == input.UomName ||
                    (this.UomName != null &&
                    this.UomName.Equals(input.UomName))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.MainPOSItemId == input.MainPOSItemId ||
                    (this.MainPOSItemId != null &&
                    this.MainPOSItemId.Equals(input.MainPOSItemId))
                ) && 
                (
                    this.MerchandiseHierarchyGroupName == input.MerchandiseHierarchyGroupName ||
                    (this.MerchandiseHierarchyGroupName != null &&
                    this.MerchandiseHierarchyGroupName.Equals(input.MerchandiseHierarchyGroupName))
                ) && 
                (
                    this.ValidPriceAmount == input.ValidPriceAmount ||
                    (this.ValidPriceAmount != null &&
                    this.ValidPriceAmount.Equals(input.ValidPriceAmount))
                ) && 
                (
                    this.RegularPriceAmount == input.RegularPriceAmount ||
                    (this.RegularPriceAmount != null &&
                    this.RegularPriceAmount.Equals(input.RegularPriceAmount))
                ) && 
                (
                    this.ValidPriceExpiryDate == input.ValidPriceExpiryDate ||
                    (this.ValidPriceExpiryDate != null &&
                    this.ValidPriceExpiryDate.Equals(input.ValidPriceExpiryDate))
                ) && 
                (
                    this.Deposit == input.Deposit ||
                    (this.Deposit != null &&
                    this.Deposit.Equals(input.Deposit))
                ) && 
                (
                    this.Color == input.Color ||
                    (this.Color != null &&
                    this.Color.Equals(input.Color))
                ) && 
                (
                    this.Size == input.Size ||
                    (this.Size != null &&
                    this.Size.Equals(input.Size))
                ) && 
                (
                    this.TaxGroupID == input.TaxGroupID ||
                    (this.TaxGroupID != null &&
                    this.TaxGroupID.Equals(input.TaxGroupID))
                ) && 
                (
                    this.ImageSrcIds == input.ImageSrcIds ||
                    (this.ImageSrcIds != null &&
                    this.ImageSrcIds.Equals(input.ImageSrcIds))
                ) && 
                (
                    this.AuthorisedForSale == input.AuthorisedForSale ||
                    (this.AuthorisedForSale != null &&
                    this.AuthorisedForSale.Equals(input.AuthorisedForSale))
                ) && 
                (
                    this.InternalStock == input.InternalStock ||
                    (this.InternalStock != null &&
                    this.InternalStock.Equals(input.InternalStock))
                ) && 
                (
                    this.ExternalStocks == input.ExternalStocks ||
                    this.ExternalStocks != null &&
                    this.ExternalStocks.SequenceEqual(input.ExternalStocks)
                ) && 
                (
                    this.ItemView == input.ItemView ||
                    (this.ItemView != null &&
                    this.ItemView.Equals(input.ItemView))
                ) && 
                (
                    this.UomItemTextList == input.UomItemTextList ||
                    this.UomItemTextList != null &&
                    this.UomItemTextList.SequenceEqual(input.UomItemTextList)
                ) && 
                (
                    this.Prices == input.Prices ||
                    this.Prices != null &&
                    this.Prices.SequenceEqual(input.Prices)
                ) && 
                (
                    this.ItemInfoIcons == input.ItemInfoIcons ||
                    this.ItemInfoIcons != null &&
                    this.ItemInfoIcons.SequenceEqual(input.ItemInfoIcons)
                ) && 
                (
                    this.DiscountInfoIcons == input.DiscountInfoIcons ||
                    this.DiscountInfoIcons != null &&
                    this.DiscountInfoIcons.SequenceEqual(input.DiscountInfoIcons)
                ) && 
                (
                    this.WebshopItemInfoData == input.WebshopItemInfoData ||
                    (this.WebshopItemInfoData != null &&
                    this.WebshopItemInfoData.Equals(input.WebshopItemInfoData))
                ) && 
                (
                    this.VariantsAvailable == input.VariantsAvailable ||
                    (this.VariantsAvailable != null &&
                    this.VariantsAvailable.Equals(input.VariantsAvailable))
                ) && 
                (
                    this.EPriceTypeCode == input.EPriceTypeCode ||
                    (this.EPriceTypeCode != null &&
                    this.EPriceTypeCode.Equals(input.EPriceTypeCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.ItemID != null)
                    hashCode = hashCode * 59 + this.ItemID.GetHashCode();
                if (this.UomCode != null)
                    hashCode = hashCode * 59 + this.UomCode.GetHashCode();
                if (this.UomName != null)
                    hashCode = hashCode * 59 + this.UomName.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.MainPOSItemId != null)
                    hashCode = hashCode * 59 + this.MainPOSItemId.GetHashCode();
                if (this.MerchandiseHierarchyGroupName != null)
                    hashCode = hashCode * 59 + this.MerchandiseHierarchyGroupName.GetHashCode();
                if (this.ValidPriceAmount != null)
                    hashCode = hashCode * 59 + this.ValidPriceAmount.GetHashCode();
                if (this.RegularPriceAmount != null)
                    hashCode = hashCode * 59 + this.RegularPriceAmount.GetHashCode();
                if (this.ValidPriceExpiryDate != null)
                    hashCode = hashCode * 59 + this.ValidPriceExpiryDate.GetHashCode();
                if (this.Deposit != null)
                    hashCode = hashCode * 59 + this.Deposit.GetHashCode();
                if (this.Color != null)
                    hashCode = hashCode * 59 + this.Color.GetHashCode();
                if (this.Size != null)
                    hashCode = hashCode * 59 + this.Size.GetHashCode();
                if (this.TaxGroupID != null)
                    hashCode = hashCode * 59 + this.TaxGroupID.GetHashCode();
                if (this.ImageSrcIds != null)
                    hashCode = hashCode * 59 + this.ImageSrcIds.GetHashCode();
                if (this.AuthorisedForSale != null)
                    hashCode = hashCode * 59 + this.AuthorisedForSale.GetHashCode();
                if (this.InternalStock != null)
                    hashCode = hashCode * 59 + this.InternalStock.GetHashCode();
                if (this.ExternalStocks != null)
                    hashCode = hashCode * 59 + this.ExternalStocks.GetHashCode();
                if (this.ItemView != null)
                    hashCode = hashCode * 59 + this.ItemView.GetHashCode();
                if (this.UomItemTextList != null)
                    hashCode = hashCode * 59 + this.UomItemTextList.GetHashCode();
                if (this.Prices != null)
                    hashCode = hashCode * 59 + this.Prices.GetHashCode();
                if (this.ItemInfoIcons != null)
                    hashCode = hashCode * 59 + this.ItemInfoIcons.GetHashCode();
                if (this.DiscountInfoIcons != null)
                    hashCode = hashCode * 59 + this.DiscountInfoIcons.GetHashCode();
                if (this.WebshopItemInfoData != null)
                    hashCode = hashCode * 59 + this.WebshopItemInfoData.GetHashCode();
                if (this.VariantsAvailable != null)
                    hashCode = hashCode * 59 + this.VariantsAvailable.GetHashCode();
                if (this.EPriceTypeCode != null)
                    hashCode = hashCode * 59 + this.EPriceTypeCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
