/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// StockAmountDetail &lt;p&gt;Entity which contains stock details for one location.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail :  IEquatable<ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail" /> class.
        /// </summary>
        /// <param name="itemID">&lt;p&gt;The item id&lt;/p&gt;.</param>
        /// <param name="uomCode">&lt;p&gt;The unit of mesaure code.&lt;/p&gt;.</param>
        /// <param name="mainPOSItemId">&lt;p&gt;The main pos item ID.&lt;/p&gt;.</param>
        /// <param name="storeId">&lt;p&gt;The business unit id.&lt;/p&gt;.</param>
        /// <param name="storeDescription">&lt;p&gt;Store description&lt;/p&gt;.</param>
        /// <param name="address">&lt;p&gt;Store address&lt;/p&gt;.</param>
        /// <param name="phoneNumber">&lt;p&gt;Store phone number&lt;/p&gt;.</param>
        /// <param name="distance">&lt;p&gt;Distance between that and the local store.&lt;/p&gt;.</param>
        /// <param name="name">&lt;p&gt;Name of the item&lt;/p&gt;.</param>
        /// <param name="stock">&lt;p&gt;Number of item with stock state DEFAULT.&lt;/p&gt;.</param>
        /// <param name="inTransitStock">&lt;p&gt;Number of items with stock state IN-TRANSIT.&lt;/p&gt;.</param>
        /// <param name="reservedStock">&lt;p&gt;Number of reserved items.&lt;/p&gt;.</param>
        /// <param name="transferStock">&lt;p&gt;Number of items with stock state TRANSFER&lt;/p&gt;.</param>
        /// <param name="freeStock">&lt;p&gt;Number of items with stock state FREE&lt;/p&gt;.</param>
        /// <param name="inFlow">&lt;p&gt;Sum of items in TRANSFER and IN-TRANSIT state.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail(string itemID = default(string), string uomCode = default(string), string mainPOSItemId = default(string), string storeId = default(string), string storeDescription = default(string), string address = default(string), string phoneNumber = default(string), double? distance = default(double?), string name = default(string), double? stock = default(double?), double? inTransitStock = default(double?), double? reservedStock = default(double?), double? transferStock = default(double?), double? freeStock = default(double?), double? inFlow = default(double?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.ItemID = itemID;
            this.UomCode = uomCode;
            this.MainPOSItemId = mainPOSItemId;
            this.StoreId = storeId;
            this.StoreDescription = storeDescription;
            this.Address = address;
            this.PhoneNumber = phoneNumber;
            this.Distance = distance;
            this.Name = name;
            this.Stock = stock;
            this.InTransitStock = inTransitStock;
            this.ReservedStock = reservedStock;
            this.TransferStock = transferStock;
            this.FreeStock = freeStock;
            this.InFlow = inFlow;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The item id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item id&lt;/p&gt;</value>
        [DataMember(Name="itemID", EmitDefaultValue=false)]
        public string ItemID { get; set; }

        /// <summary>
        /// &lt;p&gt;The unit of mesaure code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unit of mesaure code.&lt;/p&gt;</value>
        [DataMember(Name="uomCode", EmitDefaultValue=false)]
        public string UomCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The main pos item ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The main pos item ID.&lt;/p&gt;</value>
        [DataMember(Name="mainPOSItemId", EmitDefaultValue=false)]
        public string MainPOSItemId { get; set; }

        /// <summary>
        /// &lt;p&gt;The business unit id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit id.&lt;/p&gt;</value>
        [DataMember(Name="storeId", EmitDefaultValue=false)]
        public string StoreId { get; set; }

        /// <summary>
        /// &lt;p&gt;Store description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store description&lt;/p&gt;</value>
        [DataMember(Name="storeDescription", EmitDefaultValue=false)]
        public string StoreDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;Store address&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store address&lt;/p&gt;</value>
        [DataMember(Name="address", EmitDefaultValue=false)]
        public string Address { get; set; }

        /// <summary>
        /// &lt;p&gt;Store phone number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store phone number&lt;/p&gt;</value>
        [DataMember(Name="phoneNumber", EmitDefaultValue=false)]
        public string PhoneNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Distance between that and the local store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Distance between that and the local store.&lt;/p&gt;</value>
        [DataMember(Name="distance", EmitDefaultValue=false)]
        public double? Distance { get; set; }

        /// <summary>
        /// &lt;p&gt;Name of the item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of the item&lt;/p&gt;</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of item with stock state DEFAULT.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of item with stock state DEFAULT.&lt;/p&gt;</value>
        [DataMember(Name="stock", EmitDefaultValue=false)]
        public double? Stock { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of items with stock state IN-TRANSIT.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state IN-TRANSIT.&lt;/p&gt;</value>
        [DataMember(Name="inTransitStock", EmitDefaultValue=false)]
        public double? InTransitStock { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of reserved items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of reserved items.&lt;/p&gt;</value>
        [DataMember(Name="reservedStock", EmitDefaultValue=false)]
        public double? ReservedStock { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of items with stock state TRANSFER&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state TRANSFER&lt;/p&gt;</value>
        [DataMember(Name="transferStock", EmitDefaultValue=false)]
        public double? TransferStock { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of items with stock state FREE&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state FREE&lt;/p&gt;</value>
        [DataMember(Name="freeStock", EmitDefaultValue=false)]
        public double? FreeStock { get; set; }

        /// <summary>
        /// &lt;p&gt;Sum of items in TRANSFER and IN-TRANSIT state.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Sum of items in TRANSFER and IN-TRANSIT state.&lt;/p&gt;</value>
        [DataMember(Name="inFlow", EmitDefaultValue=false)]
        public double? InFlow { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail {\n");
            sb.Append("  ItemID: ").Append(ItemID).Append("\n");
            sb.Append("  UomCode: ").Append(UomCode).Append("\n");
            sb.Append("  MainPOSItemId: ").Append(MainPOSItemId).Append("\n");
            sb.Append("  StoreId: ").Append(StoreId).Append("\n");
            sb.Append("  StoreDescription: ").Append(StoreDescription).Append("\n");
            sb.Append("  Address: ").Append(Address).Append("\n");
            sb.Append("  PhoneNumber: ").Append(PhoneNumber).Append("\n");
            sb.Append("  Distance: ").Append(Distance).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Stock: ").Append(Stock).Append("\n");
            sb.Append("  InTransitStock: ").Append(InTransitStock).Append("\n");
            sb.Append("  ReservedStock: ").Append(ReservedStock).Append("\n");
            sb.Append("  TransferStock: ").Append(TransferStock).Append("\n");
            sb.Append("  FreeStock: ").Append(FreeStock).Append("\n");
            sb.Append("  InFlow: ").Append(InFlow).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ItemID == input.ItemID ||
                    (this.ItemID != null &&
                    this.ItemID.Equals(input.ItemID))
                ) && 
                (
                    this.UomCode == input.UomCode ||
                    (this.UomCode != null &&
                    this.UomCode.Equals(input.UomCode))
                ) && 
                (
                    this.MainPOSItemId == input.MainPOSItemId ||
                    (this.MainPOSItemId != null &&
                    this.MainPOSItemId.Equals(input.MainPOSItemId))
                ) && 
                (
                    this.StoreId == input.StoreId ||
                    (this.StoreId != null &&
                    this.StoreId.Equals(input.StoreId))
                ) && 
                (
                    this.StoreDescription == input.StoreDescription ||
                    (this.StoreDescription != null &&
                    this.StoreDescription.Equals(input.StoreDescription))
                ) && 
                (
                    this.Address == input.Address ||
                    (this.Address != null &&
                    this.Address.Equals(input.Address))
                ) && 
                (
                    this.PhoneNumber == input.PhoneNumber ||
                    (this.PhoneNumber != null &&
                    this.PhoneNumber.Equals(input.PhoneNumber))
                ) && 
                (
                    this.Distance == input.Distance ||
                    (this.Distance != null &&
                    this.Distance.Equals(input.Distance))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Stock == input.Stock ||
                    (this.Stock != null &&
                    this.Stock.Equals(input.Stock))
                ) && 
                (
                    this.InTransitStock == input.InTransitStock ||
                    (this.InTransitStock != null &&
                    this.InTransitStock.Equals(input.InTransitStock))
                ) && 
                (
                    this.ReservedStock == input.ReservedStock ||
                    (this.ReservedStock != null &&
                    this.ReservedStock.Equals(input.ReservedStock))
                ) && 
                (
                    this.TransferStock == input.TransferStock ||
                    (this.TransferStock != null &&
                    this.TransferStock.Equals(input.TransferStock))
                ) && 
                (
                    this.FreeStock == input.FreeStock ||
                    (this.FreeStock != null &&
                    this.FreeStock.Equals(input.FreeStock))
                ) && 
                (
                    this.InFlow == input.InFlow ||
                    (this.InFlow != null &&
                    this.InFlow.Equals(input.InFlow))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ItemID != null)
                    hashCode = hashCode * 59 + this.ItemID.GetHashCode();
                if (this.UomCode != null)
                    hashCode = hashCode * 59 + this.UomCode.GetHashCode();
                if (this.MainPOSItemId != null)
                    hashCode = hashCode * 59 + this.MainPOSItemId.GetHashCode();
                if (this.StoreId != null)
                    hashCode = hashCode * 59 + this.StoreId.GetHashCode();
                if (this.StoreDescription != null)
                    hashCode = hashCode * 59 + this.StoreDescription.GetHashCode();
                if (this.Address != null)
                    hashCode = hashCode * 59 + this.Address.GetHashCode();
                if (this.PhoneNumber != null)
                    hashCode = hashCode * 59 + this.PhoneNumber.GetHashCode();
                if (this.Distance != null)
                    hashCode = hashCode * 59 + this.Distance.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Stock != null)
                    hashCode = hashCode * 59 + this.Stock.GetHashCode();
                if (this.InTransitStock != null)
                    hashCode = hashCode * 59 + this.InTransitStock.GetHashCode();
                if (this.ReservedStock != null)
                    hashCode = hashCode * 59 + this.ReservedStock.GetHashCode();
                if (this.TransferStock != null)
                    hashCode = hashCode * 59 + this.TransferStock.GetHashCode();
                if (this.FreeStock != null)
                    hashCode = hashCode * 59 + this.FreeStock.GetHashCode();
                if (this.InFlow != null)
                    hashCode = hashCode * 59 + this.InFlow.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
