/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ExternalRetailPriceModifier &lt;p&gt;External retail price modifier object.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier :  IEquatable<ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier" /> class.
        /// </summary>
        /// <param name="retailPriceModifierSequenceNumber">&lt;p&gt;Retail price modifier line item sequence number.&lt;/p&gt;.</param>
        /// <param name="percent">&lt;p&gt;The percentage value in case of percentage price modifiers.&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;The monetary value of the price modification that was given.&lt;/p&gt;.</param>
        /// <param name="extendedAmountBeforeModification">&lt;p&gt;The retail sale total price of the transaction before applying the current price modification line item.&lt;/p&gt;.</param>
        /// <param name="extendedAmountAfterModification">&lt;p&gt;The retail sale total price of the line item after applying the current price modifier.&lt;/p&gt;.</param>
        /// <param name="appliedQuantity">&lt;p&gt;The quantity the price modifier applies to.&lt;/p&gt;.</param>
        /// <param name="triggerSequenceNumber">&lt;p&gt;The identification of the manual trigger (because one line item can have more than one trigger).&lt;/p&gt;.</param>
        /// <param name="extraAmount">&lt;p&gt;A monetary amount which results from applying a price modifier but does not affect the line item total.&lt;/p&gt;.</param>
        /// <param name="roundingAmount">&lt;p&gt;The monetary amount that the price modifier was adjusted by.&lt;/p&gt;.</param>
        /// <param name="calculationBaseAmount">&lt;p&gt;The amount which was used as base for calculation of the price modification.&lt;/p&gt;.</param>
        /// <param name="retailTransactionPriceDerivationRule">&lt;p&gt;Retail transaction price derivation rule.&lt;/p&gt;.</param>
        /// <param name="saleReturnLineItemPromotionTriggerList">&lt;p&gt;List of sale return line item promotion triggers.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier(int? retailPriceModifierSequenceNumber = default(int?), double? percent = default(double?), double? amount = default(double?), double? extendedAmountBeforeModification = default(double?), double? extendedAmountAfterModification = default(double?), double? appliedQuantity = default(double?), int? triggerSequenceNumber = default(int?), double? extraAmount = default(double?), double? roundingAmount = default(double?), double? calculationBaseAmount = default(double?), ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionPriceDerivationRule retailTransactionPriceDerivationRule = default(ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionPriceDerivationRule), List<ComGkSoftwarePosApiModelDomAppServicesTransactionSaleReturnLineItemPromotionTrigger> saleReturnLineItemPromotionTriggerList = default(List<ComGkSoftwarePosApiModelDomAppServicesTransactionSaleReturnLineItemPromotionTrigger>), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.RetailPriceModifierSequenceNumber = retailPriceModifierSequenceNumber;
            this.Percent = percent;
            this.Amount = amount;
            this.ExtendedAmountBeforeModification = extendedAmountBeforeModification;
            this.ExtendedAmountAfterModification = extendedAmountAfterModification;
            this.AppliedQuantity = appliedQuantity;
            this.TriggerSequenceNumber = triggerSequenceNumber;
            this.ExtraAmount = extraAmount;
            this.RoundingAmount = roundingAmount;
            this.CalculationBaseAmount = calculationBaseAmount;
            this.RetailTransactionPriceDerivationRule = retailTransactionPriceDerivationRule;
            this.SaleReturnLineItemPromotionTriggerList = saleReturnLineItemPromotionTriggerList;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Retail price modifier line item sequence number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Retail price modifier line item sequence number.&lt;/p&gt;</value>
        [DataMember(Name="retailPriceModifierSequenceNumber", EmitDefaultValue=false)]
        public int? RetailPriceModifierSequenceNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;The percentage value in case of percentage price modifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The percentage value in case of percentage price modifiers.&lt;/p&gt;</value>
        [DataMember(Name="percent", EmitDefaultValue=false)]
        public double? Percent { get; set; }

        /// <summary>
        /// &lt;p&gt;The monetary value of the price modification that was given.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The monetary value of the price modification that was given.&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail sale total price of the transaction before applying the current price modification line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail sale total price of the transaction before applying the current price modification line item.&lt;/p&gt;</value>
        [DataMember(Name="extendedAmountBeforeModification", EmitDefaultValue=false)]
        public double? ExtendedAmountBeforeModification { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail sale total price of the line item after applying the current price modifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail sale total price of the line item after applying the current price modifier.&lt;/p&gt;</value>
        [DataMember(Name="extendedAmountAfterModification", EmitDefaultValue=false)]
        public double? ExtendedAmountAfterModification { get; set; }

        /// <summary>
        /// &lt;p&gt;The quantity the price modifier applies to.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The quantity the price modifier applies to.&lt;/p&gt;</value>
        [DataMember(Name="appliedQuantity", EmitDefaultValue=false)]
        public double? AppliedQuantity { get; set; }

        /// <summary>
        /// &lt;p&gt;The identification of the manual trigger (because one line item can have more than one trigger).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identification of the manual trigger (because one line item can have more than one trigger).&lt;/p&gt;</value>
        [DataMember(Name="triggerSequenceNumber", EmitDefaultValue=false)]
        public int? TriggerSequenceNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;A monetary amount which results from applying a price modifier but does not affect the line item total.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A monetary amount which results from applying a price modifier but does not affect the line item total.&lt;/p&gt;</value>
        [DataMember(Name="extraAmount", EmitDefaultValue=false)]
        public double? ExtraAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;The monetary amount that the price modifier was adjusted by.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The monetary amount that the price modifier was adjusted by.&lt;/p&gt;</value>
        [DataMember(Name="roundingAmount", EmitDefaultValue=false)]
        public double? RoundingAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;The amount which was used as base for calculation of the price modification.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount which was used as base for calculation of the price modification.&lt;/p&gt;</value>
        [DataMember(Name="calculationBaseAmount", EmitDefaultValue=false)]
        public double? CalculationBaseAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;Retail transaction price derivation rule.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Retail transaction price derivation rule.&lt;/p&gt;</value>
        [DataMember(Name="retailTransactionPriceDerivationRule", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionPriceDerivationRule RetailTransactionPriceDerivationRule { get; set; }

        /// <summary>
        /// &lt;p&gt;List of sale return line item promotion triggers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of sale return line item promotion triggers.&lt;/p&gt;</value>
        [DataMember(Name="saleReturnLineItemPromotionTriggerList", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppServicesTransactionSaleReturnLineItemPromotionTrigger> SaleReturnLineItemPromotionTriggerList { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier {\n");
            sb.Append("  RetailPriceModifierSequenceNumber: ").Append(RetailPriceModifierSequenceNumber).Append("\n");
            sb.Append("  Percent: ").Append(Percent).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  ExtendedAmountBeforeModification: ").Append(ExtendedAmountBeforeModification).Append("\n");
            sb.Append("  ExtendedAmountAfterModification: ").Append(ExtendedAmountAfterModification).Append("\n");
            sb.Append("  AppliedQuantity: ").Append(AppliedQuantity).Append("\n");
            sb.Append("  TriggerSequenceNumber: ").Append(TriggerSequenceNumber).Append("\n");
            sb.Append("  ExtraAmount: ").Append(ExtraAmount).Append("\n");
            sb.Append("  RoundingAmount: ").Append(RoundingAmount).Append("\n");
            sb.Append("  CalculationBaseAmount: ").Append(CalculationBaseAmount).Append("\n");
            sb.Append("  RetailTransactionPriceDerivationRule: ").Append(RetailTransactionPriceDerivationRule).Append("\n");
            sb.Append("  SaleReturnLineItemPromotionTriggerList: ").Append(SaleReturnLineItemPromotionTriggerList).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppServicesTransactionExternalRetailPriceModifier input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.RetailPriceModifierSequenceNumber == input.RetailPriceModifierSequenceNumber ||
                    (this.RetailPriceModifierSequenceNumber != null &&
                    this.RetailPriceModifierSequenceNumber.Equals(input.RetailPriceModifierSequenceNumber))
                ) && 
                (
                    this.Percent == input.Percent ||
                    (this.Percent != null &&
                    this.Percent.Equals(input.Percent))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.ExtendedAmountBeforeModification == input.ExtendedAmountBeforeModification ||
                    (this.ExtendedAmountBeforeModification != null &&
                    this.ExtendedAmountBeforeModification.Equals(input.ExtendedAmountBeforeModification))
                ) && 
                (
                    this.ExtendedAmountAfterModification == input.ExtendedAmountAfterModification ||
                    (this.ExtendedAmountAfterModification != null &&
                    this.ExtendedAmountAfterModification.Equals(input.ExtendedAmountAfterModification))
                ) && 
                (
                    this.AppliedQuantity == input.AppliedQuantity ||
                    (this.AppliedQuantity != null &&
                    this.AppliedQuantity.Equals(input.AppliedQuantity))
                ) && 
                (
                    this.TriggerSequenceNumber == input.TriggerSequenceNumber ||
                    (this.TriggerSequenceNumber != null &&
                    this.TriggerSequenceNumber.Equals(input.TriggerSequenceNumber))
                ) && 
                (
                    this.ExtraAmount == input.ExtraAmount ||
                    (this.ExtraAmount != null &&
                    this.ExtraAmount.Equals(input.ExtraAmount))
                ) && 
                (
                    this.RoundingAmount == input.RoundingAmount ||
                    (this.RoundingAmount != null &&
                    this.RoundingAmount.Equals(input.RoundingAmount))
                ) && 
                (
                    this.CalculationBaseAmount == input.CalculationBaseAmount ||
                    (this.CalculationBaseAmount != null &&
                    this.CalculationBaseAmount.Equals(input.CalculationBaseAmount))
                ) && 
                (
                    this.RetailTransactionPriceDerivationRule == input.RetailTransactionPriceDerivationRule ||
                    (this.RetailTransactionPriceDerivationRule != null &&
                    this.RetailTransactionPriceDerivationRule.Equals(input.RetailTransactionPriceDerivationRule))
                ) && 
                (
                    this.SaleReturnLineItemPromotionTriggerList == input.SaleReturnLineItemPromotionTriggerList ||
                    this.SaleReturnLineItemPromotionTriggerList != null &&
                    this.SaleReturnLineItemPromotionTriggerList.SequenceEqual(input.SaleReturnLineItemPromotionTriggerList)
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RetailPriceModifierSequenceNumber != null)
                    hashCode = hashCode * 59 + this.RetailPriceModifierSequenceNumber.GetHashCode();
                if (this.Percent != null)
                    hashCode = hashCode * 59 + this.Percent.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.ExtendedAmountBeforeModification != null)
                    hashCode = hashCode * 59 + this.ExtendedAmountBeforeModification.GetHashCode();
                if (this.ExtendedAmountAfterModification != null)
                    hashCode = hashCode * 59 + this.ExtendedAmountAfterModification.GetHashCode();
                if (this.AppliedQuantity != null)
                    hashCode = hashCode * 59 + this.AppliedQuantity.GetHashCode();
                if (this.TriggerSequenceNumber != null)
                    hashCode = hashCode * 59 + this.TriggerSequenceNumber.GetHashCode();
                if (this.ExtraAmount != null)
                    hashCode = hashCode * 59 + this.ExtraAmount.GetHashCode();
                if (this.RoundingAmount != null)
                    hashCode = hashCode * 59 + this.RoundingAmount.GetHashCode();
                if (this.CalculationBaseAmount != null)
                    hashCode = hashCode * 59 + this.CalculationBaseAmount.GetHashCode();
                if (this.RetailTransactionPriceDerivationRule != null)
                    hashCode = hashCode * 59 + this.RetailTransactionPriceDerivationRule.GetHashCode();
                if (this.SaleReturnLineItemPromotionTriggerList != null)
                    hashCode = hashCode * 59 + this.SaleReturnLineItemPromotionTriggerList.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
