/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TillDoKey &lt;p&gt;Key identifier for tills.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey :  IEquatable<ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt; (required).</param>
        /// <param name="tillID">&lt;p&gt;The unique identifier of a till.&lt;/p&gt; (required).</param>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey(string businessUnitGroupID = default(string), string tillID = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "tillID" is required (not null)
            if (tillID == null)
            {
                throw new InvalidDataException("tillID is a required property for ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey and cannot be null");
            }
            else
            {
                this.TillID = tillID;
            }
        }
        
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of BusinessUnits.&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;The unique identifier of a till.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of a till.&lt;/p&gt;</value>
        [DataMember(Name="tillID", EmitDefaultValue=false)]
        public string TillID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  TillID: ").Append(TillID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.TillID == input.TillID ||
                    (this.TillID != null &&
                    this.TillID.Equals(input.TillID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.TillID != null)
                    hashCode = hashCode * 59 + this.TillID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
