/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ChangeConfirmationRequestItem &lt;p&gt;Request object of the Change Confirmation Item&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem :  IEquatable<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem" /> class.
        /// </summary>
        /// <param name="id">&lt;p&gt;The item id.&lt;/p&gt;.</param>
        /// <param name="description">&lt;p&gt;The item receipt text description.&lt;/p&gt;.</param>
        /// <param name="productInternalId">&lt;p&gt;The product internal id.&lt;/p&gt;.</param>
        /// <param name="productSalesMeasureUnitCode">&lt;p&gt;The product sales measure unit code.&lt;/p&gt;.</param>
        /// <param name="dateTermsRequestDate">&lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="deliveryTermsDeliveryPlantId">&lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;.</param>
        /// <param name="totalValuesRequestedQuantity">&lt;p&gt;The requested quantity.&lt;/p&gt;.</param>
        /// <param name="salesTermsRejectionReasonCode">&lt;p&gt;Rejection reason (Token 0-2) for reversal of sales orders or order items.&lt;/p&gt;.</param>
        /// <param name="receivingPointPartyInternalId">&lt;p&gt;Pick up destination. This field describes the receiving point party for the items.&lt;br /&gt; For example, it is the current store id if it is an immediate pickup, &lt;br /&gt; or another store&#39;s id if the sales order will be retrieved in a different store.&lt;/p&gt;.</param>
        /// <param name="priceComponents">&lt;p&gt;Price component condition data for the item.&lt;/p&gt;.</param>
        /// <param name="buyerDocumentId">&lt;p&gt;Buyer document id (Token 1-35). &lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="actionCode">&lt;p&gt;Action code for the request (Token 2).&lt;br /&gt; Possible values: &lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;01 – insert record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;02 – update record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;03 – delete record&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem(string id = default(string), string description = default(string), string productInternalId = default(string), string productSalesMeasureUnitCode = default(string), string dateTermsRequestDate = default(string), string deliveryTermsDeliveryPlantId = default(string), double? totalValuesRequestedQuantity = default(double?), string salesTermsRejectionReasonCode = default(string), string receivingPointPartyInternalId = default(string), List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItemPriceComponent> priceComponents = default(List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItemPriceComponent>), string buyerDocumentId = default(string), string actionCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.Id = id;
            this.Description = description;
            this.ProductInternalId = productInternalId;
            this.ProductSalesMeasureUnitCode = productSalesMeasureUnitCode;
            this.DateTermsRequestDate = dateTermsRequestDate;
            this.DeliveryTermsDeliveryPlantId = deliveryTermsDeliveryPlantId;
            this.TotalValuesRequestedQuantity = totalValuesRequestedQuantity;
            this.SalesTermsRejectionReasonCode = salesTermsRejectionReasonCode;
            this.ReceivingPointPartyInternalId = receivingPointPartyInternalId;
            this.PriceComponents = priceComponents;
            this.BuyerDocumentId = buyerDocumentId;
            this.ActionCode = actionCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The item id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item id.&lt;/p&gt;</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// &lt;p&gt;The item receipt text description.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item receipt text description.&lt;/p&gt;</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// &lt;p&gt;The product internal id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product internal id.&lt;/p&gt;</value>
        [DataMember(Name="product_internalId", EmitDefaultValue=false)]
        public string ProductInternalId { get; set; }

        /// <summary>
        /// &lt;p&gt;The product sales measure unit code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product sales measure unit code.&lt;/p&gt;</value>
        [DataMember(Name="product_salesMeasureUnitCode", EmitDefaultValue=false)]
        public string ProductSalesMeasureUnitCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="dateTerms_requestDate", EmitDefaultValue=false)]
        public string DateTermsRequestDate { get; set; }

        /// <summary>
        /// &lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;</value>
        [DataMember(Name="deliveryTerms_deliveryPlantId", EmitDefaultValue=false)]
        public string DeliveryTermsDeliveryPlantId { get; set; }

        /// <summary>
        /// &lt;p&gt;The requested quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The requested quantity.&lt;/p&gt;</value>
        [DataMember(Name="totalValues_requestedQuantity", EmitDefaultValue=false)]
        public double? TotalValuesRequestedQuantity { get; set; }

        /// <summary>
        /// &lt;p&gt;Rejection reason (Token 0-2) for reversal of sales orders or order items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Rejection reason (Token 0-2) for reversal of sales orders or order items.&lt;/p&gt;</value>
        [DataMember(Name="salesTerms_rejectionReasonCode", EmitDefaultValue=false)]
        public string SalesTermsRejectionReasonCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Pick up destination. This field describes the receiving point party for the items.&lt;br /&gt; For example, it is the current store id if it is an immediate pickup, &lt;br /&gt; or another store&#39;s id if the sales order will be retrieved in a different store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Pick up destination. This field describes the receiving point party for the items.&lt;br /&gt; For example, it is the current store id if it is an immediate pickup, &lt;br /&gt; or another store&#39;s id if the sales order will be retrieved in a different store.&lt;/p&gt;</value>
        [DataMember(Name="receivingPointParty_internalId", EmitDefaultValue=false)]
        public string ReceivingPointPartyInternalId { get; set; }

        /// <summary>
        /// &lt;p&gt;Price component condition data for the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Price component condition data for the item.&lt;/p&gt;</value>
        [DataMember(Name="priceComponents", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItemPriceComponent> PriceComponents { get; set; }

        /// <summary>
        /// &lt;p&gt;Buyer document id (Token 1-35). &lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Buyer document id (Token 1-35). &lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="buyerDocument_Id", EmitDefaultValue=false)]
        public string BuyerDocumentId { get; set; }

        /// <summary>
        /// &lt;p&gt;Action code for the request (Token 2).&lt;br /&gt; Possible values: &lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;01 – insert record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;02 – update record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;03 – delete record&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Action code for the request (Token 2).&lt;br /&gt; Possible values: &lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;01 – insert record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;02 – update record&lt;/li&gt;&lt;br /&gt; &lt;li&gt;03 – delete record&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="actionCode", EmitDefaultValue=false)]
        public string ActionCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  ProductInternalId: ").Append(ProductInternalId).Append("\n");
            sb.Append("  ProductSalesMeasureUnitCode: ").Append(ProductSalesMeasureUnitCode).Append("\n");
            sb.Append("  DateTermsRequestDate: ").Append(DateTermsRequestDate).Append("\n");
            sb.Append("  DeliveryTermsDeliveryPlantId: ").Append(DeliveryTermsDeliveryPlantId).Append("\n");
            sb.Append("  TotalValuesRequestedQuantity: ").Append(TotalValuesRequestedQuantity).Append("\n");
            sb.Append("  SalesTermsRejectionReasonCode: ").Append(SalesTermsRejectionReasonCode).Append("\n");
            sb.Append("  ReceivingPointPartyInternalId: ").Append(ReceivingPointPartyInternalId).Append("\n");
            sb.Append("  PriceComponents: ").Append(PriceComponents).Append("\n");
            sb.Append("  BuyerDocumentId: ").Append(BuyerDocumentId).Append("\n");
            sb.Append("  ActionCode: ").Append(ActionCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.ProductInternalId == input.ProductInternalId ||
                    (this.ProductInternalId != null &&
                    this.ProductInternalId.Equals(input.ProductInternalId))
                ) && 
                (
                    this.ProductSalesMeasureUnitCode == input.ProductSalesMeasureUnitCode ||
                    (this.ProductSalesMeasureUnitCode != null &&
                    this.ProductSalesMeasureUnitCode.Equals(input.ProductSalesMeasureUnitCode))
                ) && 
                (
                    this.DateTermsRequestDate == input.DateTermsRequestDate ||
                    (this.DateTermsRequestDate != null &&
                    this.DateTermsRequestDate.Equals(input.DateTermsRequestDate))
                ) && 
                (
                    this.DeliveryTermsDeliveryPlantId == input.DeliveryTermsDeliveryPlantId ||
                    (this.DeliveryTermsDeliveryPlantId != null &&
                    this.DeliveryTermsDeliveryPlantId.Equals(input.DeliveryTermsDeliveryPlantId))
                ) && 
                (
                    this.TotalValuesRequestedQuantity == input.TotalValuesRequestedQuantity ||
                    (this.TotalValuesRequestedQuantity != null &&
                    this.TotalValuesRequestedQuantity.Equals(input.TotalValuesRequestedQuantity))
                ) && 
                (
                    this.SalesTermsRejectionReasonCode == input.SalesTermsRejectionReasonCode ||
                    (this.SalesTermsRejectionReasonCode != null &&
                    this.SalesTermsRejectionReasonCode.Equals(input.SalesTermsRejectionReasonCode))
                ) && 
                (
                    this.ReceivingPointPartyInternalId == input.ReceivingPointPartyInternalId ||
                    (this.ReceivingPointPartyInternalId != null &&
                    this.ReceivingPointPartyInternalId.Equals(input.ReceivingPointPartyInternalId))
                ) && 
                (
                    this.PriceComponents == input.PriceComponents ||
                    this.PriceComponents != null &&
                    this.PriceComponents.SequenceEqual(input.PriceComponents)
                ) && 
                (
                    this.BuyerDocumentId == input.BuyerDocumentId ||
                    (this.BuyerDocumentId != null &&
                    this.BuyerDocumentId.Equals(input.BuyerDocumentId))
                ) && 
                (
                    this.ActionCode == input.ActionCode ||
                    (this.ActionCode != null &&
                    this.ActionCode.Equals(input.ActionCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.ProductInternalId != null)
                    hashCode = hashCode * 59 + this.ProductInternalId.GetHashCode();
                if (this.ProductSalesMeasureUnitCode != null)
                    hashCode = hashCode * 59 + this.ProductSalesMeasureUnitCode.GetHashCode();
                if (this.DateTermsRequestDate != null)
                    hashCode = hashCode * 59 + this.DateTermsRequestDate.GetHashCode();
                if (this.DeliveryTermsDeliveryPlantId != null)
                    hashCode = hashCode * 59 + this.DeliveryTermsDeliveryPlantId.GetHashCode();
                if (this.TotalValuesRequestedQuantity != null)
                    hashCode = hashCode * 59 + this.TotalValuesRequestedQuantity.GetHashCode();
                if (this.SalesTermsRejectionReasonCode != null)
                    hashCode = hashCode * 59 + this.SalesTermsRejectionReasonCode.GetHashCode();
                if (this.ReceivingPointPartyInternalId != null)
                    hashCode = hashCode * 59 + this.ReceivingPointPartyInternalId.GetHashCode();
                if (this.PriceComponents != null)
                    hashCode = hashCode * 59 + this.PriceComponents.GetHashCode();
                if (this.BuyerDocumentId != null)
                    hashCode = hashCode * 59 + this.BuyerDocumentId.GetHashCode();
                if (this.ActionCode != null)
                    hashCode = hashCode * 59 + this.ActionCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
