/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SalesOrderCreateCheckRequest &lt;p&gt;Request object for the SalesOrderCreateCheckWebService.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest :  IEquatable<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest" /> class.
        /// </summary>
        /// <param name="buyerDocumentId">&lt;p&gt;The buyer document id.&lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="processingTypecode">&lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="salesOrganisationID">&lt;p&gt;Store number (Token of length 1-20).&lt;/p&gt;.</param>
        /// <param name="distributionChannelCode">&lt;p&gt;It defines the code of the distribution channel in the SAP ERP system (Token of length 1-2). E.g.: &#39;V1&#39;.&lt;/p&gt;.</param>
        /// <param name="divisionCode">&lt;p&gt;It defines the division/section in the SAP ERP system (Token of length 1-2). E.g.: &#39;R1&#39;.&lt;/p&gt;.</param>
        /// <param name="customerAdrType">&lt;p&gt;The customer address type (e.g.: the customer card type from customer identification configuration is used in the POS client).&lt;/p&gt;.</param>
        /// <param name="customerId">&lt;p&gt;The customer id.&lt;/p&gt;.</param>
        /// <param name="storeId">&lt;p&gt;The store id.&lt;/p&gt;.</param>
        /// <param name="items">&lt;p&gt;The item list.&lt;/p&gt;.</param>
        /// <param name="trainingMode">&lt;p&gt;Indicates whether the service call should be performed in training mode.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest(string buyerDocumentId = default(string), string processingTypecode = default(string), string salesOrganisationID = default(string), string distributionChannelCode = default(string), string divisionCode = default(string), string customerAdrType = default(string), string customerId = default(string), string storeId = default(string), List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderCommonRequestItemData> items = default(List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderCommonRequestItemData>), bool? trainingMode = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.BuyerDocumentId = buyerDocumentId;
            this.ProcessingTypecode = processingTypecode;
            this.SalesOrganisationID = salesOrganisationID;
            this.DistributionChannelCode = distributionChannelCode;
            this.DivisionCode = divisionCode;
            this.CustomerAdrType = customerAdrType;
            this.CustomerId = customerId;
            this.StoreId = storeId;
            this.Items = items;
            this.TrainingMode = trainingMode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The buyer document id.&lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;The buyer document id.&lt;br /&gt; Format: ffffddddddkkkbbbbbb&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;ffff – store id with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;dddddd – date in format ddmmyy (each with leading zeros)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;kkk – pos/workstation number with leading zeros&lt;/li&gt;&lt;br /&gt; &lt;li&gt;bbbbbb – transaction sequence number with leading zeros&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="buyerDocument_Id", EmitDefaultValue=false)]
        public string BuyerDocumentId { get; set; }

        /// <summary>
        /// &lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="processingTypecode", EmitDefaultValue=false)]
        public string ProcessingTypecode { get; set; }

        /// <summary>
        /// &lt;p&gt;Store number (Token of length 1-20).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store number (Token of length 1-20).&lt;/p&gt;</value>
        [DataMember(Name="salesOrganisationID", EmitDefaultValue=false)]
        public string SalesOrganisationID { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the code of the distribution channel in the SAP ERP system (Token of length 1-2). E.g.: &#39;V1&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the code of the distribution channel in the SAP ERP system (Token of length 1-2). E.g.: &#39;V1&#39;.&lt;/p&gt;</value>
        [DataMember(Name="distributionChannelCode", EmitDefaultValue=false)]
        public string DistributionChannelCode { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the division/section in the SAP ERP system (Token of length 1-2). E.g.: &#39;R1&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the division/section in the SAP ERP system (Token of length 1-2). E.g.: &#39;R1&#39;.&lt;/p&gt;</value>
        [DataMember(Name="divisionCode", EmitDefaultValue=false)]
        public string DivisionCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer address type (e.g.: the customer card type from customer identification configuration is used in the POS client).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer address type (e.g.: the customer card type from customer identification configuration is used in the POS client).&lt;/p&gt;</value>
        [DataMember(Name="customerAdrType", EmitDefaultValue=false)]
        public string CustomerAdrType { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer id.&lt;/p&gt;</value>
        [DataMember(Name="customerId", EmitDefaultValue=false)]
        public string CustomerId { get; set; }

        /// <summary>
        /// &lt;p&gt;The store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The store id.&lt;/p&gt;</value>
        [DataMember(Name="storeId", EmitDefaultValue=false)]
        public string StoreId { get; set; }

        /// <summary>
        /// &lt;p&gt;The item list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item list.&lt;/p&gt;</value>
        [DataMember(Name="items", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderCommonRequestItemData> Items { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether the service call should be performed in training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the service call should be performed in training mode.&lt;/p&gt;</value>
        [DataMember(Name="trainingMode", EmitDefaultValue=false)]
        public bool? TrainingMode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest {\n");
            sb.Append("  BuyerDocumentId: ").Append(BuyerDocumentId).Append("\n");
            sb.Append("  ProcessingTypecode: ").Append(ProcessingTypecode).Append("\n");
            sb.Append("  SalesOrganisationID: ").Append(SalesOrganisationID).Append("\n");
            sb.Append("  DistributionChannelCode: ").Append(DistributionChannelCode).Append("\n");
            sb.Append("  DivisionCode: ").Append(DivisionCode).Append("\n");
            sb.Append("  CustomerAdrType: ").Append(CustomerAdrType).Append("\n");
            sb.Append("  CustomerId: ").Append(CustomerId).Append("\n");
            sb.Append("  StoreId: ").Append(StoreId).Append("\n");
            sb.Append("  Items: ").Append(Items).Append("\n");
            sb.Append("  TrainingMode: ").Append(TrainingMode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateCheckSalesOrderCreateCheckRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BuyerDocumentId == input.BuyerDocumentId ||
                    (this.BuyerDocumentId != null &&
                    this.BuyerDocumentId.Equals(input.BuyerDocumentId))
                ) && 
                (
                    this.ProcessingTypecode == input.ProcessingTypecode ||
                    (this.ProcessingTypecode != null &&
                    this.ProcessingTypecode.Equals(input.ProcessingTypecode))
                ) && 
                (
                    this.SalesOrganisationID == input.SalesOrganisationID ||
                    (this.SalesOrganisationID != null &&
                    this.SalesOrganisationID.Equals(input.SalesOrganisationID))
                ) && 
                (
                    this.DistributionChannelCode == input.DistributionChannelCode ||
                    (this.DistributionChannelCode != null &&
                    this.DistributionChannelCode.Equals(input.DistributionChannelCode))
                ) && 
                (
                    this.DivisionCode == input.DivisionCode ||
                    (this.DivisionCode != null &&
                    this.DivisionCode.Equals(input.DivisionCode))
                ) && 
                (
                    this.CustomerAdrType == input.CustomerAdrType ||
                    (this.CustomerAdrType != null &&
                    this.CustomerAdrType.Equals(input.CustomerAdrType))
                ) && 
                (
                    this.CustomerId == input.CustomerId ||
                    (this.CustomerId != null &&
                    this.CustomerId.Equals(input.CustomerId))
                ) && 
                (
                    this.StoreId == input.StoreId ||
                    (this.StoreId != null &&
                    this.StoreId.Equals(input.StoreId))
                ) && 
                (
                    this.Items == input.Items ||
                    this.Items != null &&
                    this.Items.SequenceEqual(input.Items)
                ) && 
                (
                    this.TrainingMode == input.TrainingMode ||
                    (this.TrainingMode != null &&
                    this.TrainingMode.Equals(input.TrainingMode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BuyerDocumentId != null)
                    hashCode = hashCode * 59 + this.BuyerDocumentId.GetHashCode();
                if (this.ProcessingTypecode != null)
                    hashCode = hashCode * 59 + this.ProcessingTypecode.GetHashCode();
                if (this.SalesOrganisationID != null)
                    hashCode = hashCode * 59 + this.SalesOrganisationID.GetHashCode();
                if (this.DistributionChannelCode != null)
                    hashCode = hashCode * 59 + this.DistributionChannelCode.GetHashCode();
                if (this.DivisionCode != null)
                    hashCode = hashCode * 59 + this.DivisionCode.GetHashCode();
                if (this.CustomerAdrType != null)
                    hashCode = hashCode * 59 + this.CustomerAdrType.GetHashCode();
                if (this.CustomerId != null)
                    hashCode = hashCode * 59 + this.CustomerId.GetHashCode();
                if (this.StoreId != null)
                    hashCode = hashCode * 59 + this.StoreId.GetHashCode();
                if (this.Items != null)
                    hashCode = hashCode * 59 + this.Items.GetHashCode();
                if (this.TrainingMode != null)
                    hashCode = hashCode * 59 + this.TrainingMode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
