/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ItemInformationRequest &lt;p&gt;Request object for item information&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest :  IEquatable<ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest" /> class.
        /// </summary>
        /// <param name="posItemId">&lt;p&gt;String: pos item id&lt;/p&gt;.</param>
        /// <param name="additionalTextInfoTextTypeCodes">&lt;p&gt;List String: additional text info text type codes&lt;/p&gt;.</param>
        /// <param name="systemLanguage">&lt;p&gt;String: system language&lt;/p&gt;.</param>
        /// <param name="discountInfoEnabled">&lt;p&gt;It defines if the discount info should be displayed in transaction preview.&lt;/p&gt;.</param>
        /// <param name="itemInfoEnabled">&lt;p&gt;It defines if the item info should be displayed in transaction preview.&lt;/p&gt;.</param>
        /// <param name="iconSalesInfoTextTypeCodes">&lt;p&gt;It defines a list of text type codes that should be displayed as icon sales info.&lt;/p&gt;.</param>
        /// <param name="buId">&lt;p&gt;the clients current buId&lt;/p&gt;.</param>
        /// <param name="displayPromotionPrices">&lt;p&gt;Specifies that promotion prices should be calculated for the item.&lt;br /&gt; It is calculated based on actual basket.&lt;/p&gt; (required).</param>
        /// <param name="displayGroupPrice">&lt;p&gt;It specifies whether the group price is additionally displayed if a single item price is valid.&lt;/p&gt;.</param>
        /// <param name="itemIDCaseSensitive">&lt;p&gt;Specifies treating of posItemID for item look-up. If true then is checked the posItemID in case sensitive mode.&lt;/p&gt; (required).</param>
        /// <param name="requestStock">&lt;p&gt;Specifies if item stock information should be requested from stock information system. Default value is true.&lt;/p&gt; (required).</param>
        /// <param name="price">&lt;p&gt;It defines the unit price which should be used for the price calculation.&lt;/p&gt;.</param>
        /// <param name="priceQuantity">&lt;p&gt;It defines the unit price quantity which should be used for the price calculation (i.e. &#39;3 for $1.00&#39;).&lt;/p&gt;.</param>
        /// <param name="quantity">&lt;p&gt;It defines the quantity of the item.&lt;/p&gt;.</param>
        /// <param name="unit">&lt;p&gt;It defines the units of the item.&lt;/p&gt;.</param>
        /// <param name="itemInformationLoadConfig">itemInformationLoadConfig.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest(string posItemId = default(string), List<string> additionalTextInfoTextTypeCodes = default(List<string>), string systemLanguage = default(string), bool? discountInfoEnabled = default(bool?), bool? itemInfoEnabled = default(bool?), List<string> iconSalesInfoTextTypeCodes = default(List<string>), string buId = default(string), bool? displayPromotionPrices = default(bool?), bool? displayGroupPrice = default(bool?), bool? itemIDCaseSensitive = default(bool?), bool? requestStock = default(bool?), double? price = default(double?), int? priceQuantity = default(int?), int? quantity = default(int?), double? unit = default(double?), ComGkSoftwarePosApiServiceMasterdataItemItemInformationLoadConfig itemInformationLoadConfig = default(ComGkSoftwarePosApiServiceMasterdataItemItemInformationLoadConfig), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "displayPromotionPrices" is required (not null)
            if (displayPromotionPrices == null)
            {
                throw new InvalidDataException("displayPromotionPrices is a required property for ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest and cannot be null");
            }
            else
            {
                this.DisplayPromotionPrices = displayPromotionPrices;
            }
            // to ensure "itemIDCaseSensitive" is required (not null)
            if (itemIDCaseSensitive == null)
            {
                throw new InvalidDataException("itemIDCaseSensitive is a required property for ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest and cannot be null");
            }
            else
            {
                this.ItemIDCaseSensitive = itemIDCaseSensitive;
            }
            // to ensure "requestStock" is required (not null)
            if (requestStock == null)
            {
                throw new InvalidDataException("requestStock is a required property for ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest and cannot be null");
            }
            else
            {
                this.RequestStock = requestStock;
            }
            this.PosItemId = posItemId;
            this.AdditionalTextInfoTextTypeCodes = additionalTextInfoTextTypeCodes;
            this.SystemLanguage = systemLanguage;
            this.DiscountInfoEnabled = discountInfoEnabled;
            this.ItemInfoEnabled = itemInfoEnabled;
            this.IconSalesInfoTextTypeCodes = iconSalesInfoTextTypeCodes;
            this.BuId = buId;
            this.DisplayGroupPrice = displayGroupPrice;
            this.Price = price;
            this.PriceQuantity = priceQuantity;
            this.Quantity = quantity;
            this.Unit = unit;
            this.ItemInformationLoadConfig = itemInformationLoadConfig;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;String: pos item id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: pos item id&lt;/p&gt;</value>
        [DataMember(Name="posItemId", EmitDefaultValue=false)]
        public string PosItemId { get; set; }

        /// <summary>
        /// &lt;p&gt;List String: additional text info text type codes&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List String: additional text info text type codes&lt;/p&gt;</value>
        [DataMember(Name="additionalTextInfoTextTypeCodes", EmitDefaultValue=false)]
        public List<string> AdditionalTextInfoTextTypeCodes { get; set; }

        /// <summary>
        /// &lt;p&gt;String: system language&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: system language&lt;/p&gt;</value>
        [DataMember(Name="systemLanguage", EmitDefaultValue=false)]
        public string SystemLanguage { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the discount info should be displayed in transaction preview.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the discount info should be displayed in transaction preview.&lt;/p&gt;</value>
        [DataMember(Name="discountInfoEnabled", EmitDefaultValue=false)]
        public bool? DiscountInfoEnabled { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines if the item info should be displayed in transaction preview.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines if the item info should be displayed in transaction preview.&lt;/p&gt;</value>
        [DataMember(Name="itemInfoEnabled", EmitDefaultValue=false)]
        public bool? ItemInfoEnabled { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines a list of text type codes that should be displayed as icon sales info.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines a list of text type codes that should be displayed as icon sales info.&lt;/p&gt;</value>
        [DataMember(Name="iconSalesInfoTextTypeCodes", EmitDefaultValue=false)]
        public List<string> IconSalesInfoTextTypeCodes { get; set; }

        /// <summary>
        /// &lt;p&gt;the clients current buId&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;the clients current buId&lt;/p&gt;</value>
        [DataMember(Name="buId", EmitDefaultValue=false)]
        public string BuId { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies that promotion prices should be calculated for the item.&lt;br /&gt; It is calculated based on actual basket.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies that promotion prices should be calculated for the item.&lt;br /&gt; It is calculated based on actual basket.&lt;/p&gt;</value>
        [DataMember(Name="displayPromotionPrices", EmitDefaultValue=false)]
        public bool? DisplayPromotionPrices { get; set; }

        /// <summary>
        /// &lt;p&gt;It specifies whether the group price is additionally displayed if a single item price is valid.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It specifies whether the group price is additionally displayed if a single item price is valid.&lt;/p&gt;</value>
        [DataMember(Name="displayGroupPrice", EmitDefaultValue=false)]
        public bool? DisplayGroupPrice { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies treating of posItemID for item look-up. If true then is checked the posItemID in case sensitive mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies treating of posItemID for item look-up. If true then is checked the posItemID in case sensitive mode.&lt;/p&gt;</value>
        [DataMember(Name="itemIDCaseSensitive", EmitDefaultValue=false)]
        public bool? ItemIDCaseSensitive { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies if item stock information should be requested from stock information system. Default value is true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies if item stock information should be requested from stock information system. Default value is true.&lt;/p&gt;</value>
        [DataMember(Name="requestStock", EmitDefaultValue=false)]
        public bool? RequestStock { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the unit price which should be used for the price calculation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the unit price which should be used for the price calculation.&lt;/p&gt;</value>
        [DataMember(Name="price", EmitDefaultValue=false)]
        public double? Price { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the unit price quantity which should be used for the price calculation (i.e. &#39;3 for $1.00&#39;).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the unit price quantity which should be used for the price calculation (i.e. &#39;3 for $1.00&#39;).&lt;/p&gt;</value>
        [DataMember(Name="priceQuantity", EmitDefaultValue=false)]
        public int? PriceQuantity { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the quantity of the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the quantity of the item.&lt;/p&gt;</value>
        [DataMember(Name="quantity", EmitDefaultValue=false)]
        public int? Quantity { get; set; }

        /// <summary>
        /// &lt;p&gt;It defines the units of the item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;It defines the units of the item.&lt;/p&gt;</value>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public double? Unit { get; set; }

        /// <summary>
        /// Gets or Sets ItemInformationLoadConfig
        /// </summary>
        [DataMember(Name="itemInformationLoadConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceMasterdataItemItemInformationLoadConfig ItemInformationLoadConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest {\n");
            sb.Append("  PosItemId: ").Append(PosItemId).Append("\n");
            sb.Append("  AdditionalTextInfoTextTypeCodes: ").Append(AdditionalTextInfoTextTypeCodes).Append("\n");
            sb.Append("  SystemLanguage: ").Append(SystemLanguage).Append("\n");
            sb.Append("  DiscountInfoEnabled: ").Append(DiscountInfoEnabled).Append("\n");
            sb.Append("  ItemInfoEnabled: ").Append(ItemInfoEnabled).Append("\n");
            sb.Append("  IconSalesInfoTextTypeCodes: ").Append(IconSalesInfoTextTypeCodes).Append("\n");
            sb.Append("  BuId: ").Append(BuId).Append("\n");
            sb.Append("  DisplayPromotionPrices: ").Append(DisplayPromotionPrices).Append("\n");
            sb.Append("  DisplayGroupPrice: ").Append(DisplayGroupPrice).Append("\n");
            sb.Append("  ItemIDCaseSensitive: ").Append(ItemIDCaseSensitive).Append("\n");
            sb.Append("  RequestStock: ").Append(RequestStock).Append("\n");
            sb.Append("  Price: ").Append(Price).Append("\n");
            sb.Append("  PriceQuantity: ").Append(PriceQuantity).Append("\n");
            sb.Append("  Quantity: ").Append(Quantity).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  ItemInformationLoadConfig: ").Append(ItemInformationLoadConfig).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceMasterdataItemItemInformationRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PosItemId == input.PosItemId ||
                    (this.PosItemId != null &&
                    this.PosItemId.Equals(input.PosItemId))
                ) && 
                (
                    this.AdditionalTextInfoTextTypeCodes == input.AdditionalTextInfoTextTypeCodes ||
                    this.AdditionalTextInfoTextTypeCodes != null &&
                    this.AdditionalTextInfoTextTypeCodes.SequenceEqual(input.AdditionalTextInfoTextTypeCodes)
                ) && 
                (
                    this.SystemLanguage == input.SystemLanguage ||
                    (this.SystemLanguage != null &&
                    this.SystemLanguage.Equals(input.SystemLanguage))
                ) && 
                (
                    this.DiscountInfoEnabled == input.DiscountInfoEnabled ||
                    (this.DiscountInfoEnabled != null &&
                    this.DiscountInfoEnabled.Equals(input.DiscountInfoEnabled))
                ) && 
                (
                    this.ItemInfoEnabled == input.ItemInfoEnabled ||
                    (this.ItemInfoEnabled != null &&
                    this.ItemInfoEnabled.Equals(input.ItemInfoEnabled))
                ) && 
                (
                    this.IconSalesInfoTextTypeCodes == input.IconSalesInfoTextTypeCodes ||
                    this.IconSalesInfoTextTypeCodes != null &&
                    this.IconSalesInfoTextTypeCodes.SequenceEqual(input.IconSalesInfoTextTypeCodes)
                ) && 
                (
                    this.BuId == input.BuId ||
                    (this.BuId != null &&
                    this.BuId.Equals(input.BuId))
                ) && 
                (
                    this.DisplayPromotionPrices == input.DisplayPromotionPrices ||
                    (this.DisplayPromotionPrices != null &&
                    this.DisplayPromotionPrices.Equals(input.DisplayPromotionPrices))
                ) && 
                (
                    this.DisplayGroupPrice == input.DisplayGroupPrice ||
                    (this.DisplayGroupPrice != null &&
                    this.DisplayGroupPrice.Equals(input.DisplayGroupPrice))
                ) && 
                (
                    this.ItemIDCaseSensitive == input.ItemIDCaseSensitive ||
                    (this.ItemIDCaseSensitive != null &&
                    this.ItemIDCaseSensitive.Equals(input.ItemIDCaseSensitive))
                ) && 
                (
                    this.RequestStock == input.RequestStock ||
                    (this.RequestStock != null &&
                    this.RequestStock.Equals(input.RequestStock))
                ) && 
                (
                    this.Price == input.Price ||
                    (this.Price != null &&
                    this.Price.Equals(input.Price))
                ) && 
                (
                    this.PriceQuantity == input.PriceQuantity ||
                    (this.PriceQuantity != null &&
                    this.PriceQuantity.Equals(input.PriceQuantity))
                ) && 
                (
                    this.Quantity == input.Quantity ||
                    (this.Quantity != null &&
                    this.Quantity.Equals(input.Quantity))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.ItemInformationLoadConfig == input.ItemInformationLoadConfig ||
                    (this.ItemInformationLoadConfig != null &&
                    this.ItemInformationLoadConfig.Equals(input.ItemInformationLoadConfig))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PosItemId != null)
                    hashCode = hashCode * 59 + this.PosItemId.GetHashCode();
                if (this.AdditionalTextInfoTextTypeCodes != null)
                    hashCode = hashCode * 59 + this.AdditionalTextInfoTextTypeCodes.GetHashCode();
                if (this.SystemLanguage != null)
                    hashCode = hashCode * 59 + this.SystemLanguage.GetHashCode();
                if (this.DiscountInfoEnabled != null)
                    hashCode = hashCode * 59 + this.DiscountInfoEnabled.GetHashCode();
                if (this.ItemInfoEnabled != null)
                    hashCode = hashCode * 59 + this.ItemInfoEnabled.GetHashCode();
                if (this.IconSalesInfoTextTypeCodes != null)
                    hashCode = hashCode * 59 + this.IconSalesInfoTextTypeCodes.GetHashCode();
                if (this.BuId != null)
                    hashCode = hashCode * 59 + this.BuId.GetHashCode();
                if (this.DisplayPromotionPrices != null)
                    hashCode = hashCode * 59 + this.DisplayPromotionPrices.GetHashCode();
                if (this.DisplayGroupPrice != null)
                    hashCode = hashCode * 59 + this.DisplayGroupPrice.GetHashCode();
                if (this.ItemIDCaseSensitive != null)
                    hashCode = hashCode * 59 + this.ItemIDCaseSensitive.GetHashCode();
                if (this.RequestStock != null)
                    hashCode = hashCode * 59 + this.RequestStock.GetHashCode();
                if (this.Price != null)
                    hashCode = hashCode * 59 + this.Price.GetHashCode();
                if (this.PriceQuantity != null)
                    hashCode = hashCode * 59 + this.PriceQuantity.GetHashCode();
                if (this.Quantity != null)
                    hashCode = hashCode * 59 + this.Quantity.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.ItemInformationLoadConfig != null)
                    hashCode = hashCode * 59 + this.ItemInformationLoadConfig.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
