/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CancelGiftCertTransactionRequest &lt;p&gt;Request object for canceling (voiding) a gift certificate.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest :  IEquatable<ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest" /> class.
        /// </summary>
        /// <param name="serviceId">&lt;p&gt;Specific id of gift certificate service to use.&lt;/p&gt;.</param>
        /// <param name="positionOperationConfig">&lt;p&gt;Configuration for dealing with position operations when performing a gift certificate cancel.&lt;/p&gt;.</param>
        /// <param name="callingProcess">&lt;p&gt;Calling process identifier.&lt;/p&gt;.</param>
        /// <param name="storedValuesServiceId">&lt;p&gt;Stored values service identifier.&lt;/p&gt;.</param>
        /// <param name="transactionId">&lt;p&gt;Transaction id for transaction containing the gift certificate to be canceled.&lt;/p&gt;.</param>
        /// <param name="receiptNumber">&lt;p&gt;Number of receipt of transaction canceling the gift certificate (transaction sequence number).&lt;/p&gt;.</param>
        /// <param name="giftCertTransactionId">&lt;p&gt;Transaction ID of the transaction to be canceled at stored value server (eg.: top up transaction id).&lt;/p&gt;.</param>
        /// <param name="giftCertNumber">&lt;p&gt;Gift certificate number.&lt;/p&gt;.</param>
        /// <param name="track2">&lt;p&gt;Gift certificate track2 data.&lt;/p&gt;.</param>
        /// <param name="giftCertAmount">&lt;p&gt;Gift certificate amount.&lt;/p&gt;.</param>
        /// <param name="isoCurrencyCode">&lt;p&gt;ISO currency code.&lt;/p&gt;.</param>
        /// <param name="approvalCode">&lt;p&gt;Approval code from terminal related to gift card transaction.&lt;/p&gt;.</param>
        /// <param name="terminalReferenceNumber">&lt;p&gt;The terminal reference number.&lt;/p&gt;.</param>
        /// <param name="gcsTransactionUUID">&lt;p&gt;The original transaction UUID from registration. &lt;/p&gt;.</param>
        /// <param name="ignoreFailures">&lt;p&gt;Indicates whether failures should be ignored during the cancellation process and tries to cancel all gift certificates.&lt;/p&gt; (required).</param>
        /// <param name="voidTenderLineItems">&lt;p&gt;Indicates whether tender line items should be voided during the cancellation process.&lt;/p&gt; (required).</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest(string serviceId = default(string), ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig positionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), string callingProcess = default(string), string storedValuesServiceId = default(string), string transactionId = default(string), string receiptNumber = default(string), string giftCertTransactionId = default(string), string giftCertNumber = default(string), string track2 = default(string), double? giftCertAmount = default(double?), string isoCurrencyCode = default(string), string approvalCode = default(string), string terminalReferenceNumber = default(string), string gcsTransactionUUID = default(string), bool? ignoreFailures = default(bool?), bool? voidTenderLineItems = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "ignoreFailures" is required (not null)
            if (ignoreFailures == null)
            {
                throw new InvalidDataException("ignoreFailures is a required property for ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest and cannot be null");
            }
            else
            {
                this.IgnoreFailures = ignoreFailures;
            }
            // to ensure "voidTenderLineItems" is required (not null)
            if (voidTenderLineItems == null)
            {
                throw new InvalidDataException("voidTenderLineItems is a required property for ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest and cannot be null");
            }
            else
            {
                this.VoidTenderLineItems = voidTenderLineItems;
            }
            this.ServiceId = serviceId;
            this.PositionOperationConfig = positionOperationConfig;
            this.CallingProcess = callingProcess;
            this.StoredValuesServiceId = storedValuesServiceId;
            this.TransactionId = transactionId;
            this.ReceiptNumber = receiptNumber;
            this.GiftCertTransactionId = giftCertTransactionId;
            this.GiftCertNumber = giftCertNumber;
            this.Track2 = track2;
            this.GiftCertAmount = giftCertAmount;
            this.IsoCurrencyCode = isoCurrencyCode;
            this.ApprovalCode = approvalCode;
            this.TerminalReferenceNumber = terminalReferenceNumber;
            this.GcsTransactionUUID = gcsTransactionUUID;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Specific id of gift certificate service to use.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specific id of gift certificate service to use.&lt;/p&gt;</value>
        [DataMember(Name="serviceId", EmitDefaultValue=false)]
        public string ServiceId { get; set; }

        /// <summary>
        /// &lt;p&gt;Configuration for dealing with position operations when performing a gift certificate cancel.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Configuration for dealing with position operations when performing a gift certificate cancel.&lt;/p&gt;</value>
        [DataMember(Name="positionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig PositionOperationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;Calling process identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Calling process identifier.&lt;/p&gt;</value>
        [DataMember(Name="callingProcess", EmitDefaultValue=false)]
        public string CallingProcess { get; set; }

        /// <summary>
        /// &lt;p&gt;Stored values service identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Stored values service identifier.&lt;/p&gt;</value>
        [DataMember(Name="storedValuesServiceId", EmitDefaultValue=false)]
        public string StoredValuesServiceId { get; set; }

        /// <summary>
        /// &lt;p&gt;Transaction id for transaction containing the gift certificate to be canceled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction id for transaction containing the gift certificate to be canceled.&lt;/p&gt;</value>
        [DataMember(Name="transactionId", EmitDefaultValue=false)]
        public string TransactionId { get; set; }

        /// <summary>
        /// &lt;p&gt;Number of receipt of transaction canceling the gift certificate (transaction sequence number).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of receipt of transaction canceling the gift certificate (transaction sequence number).&lt;/p&gt;</value>
        [DataMember(Name="receiptNumber", EmitDefaultValue=false)]
        public string ReceiptNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Transaction ID of the transaction to be canceled at stored value server (eg.: top up transaction id).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction ID of the transaction to be canceled at stored value server (eg.: top up transaction id).&lt;/p&gt;</value>
        [DataMember(Name="giftCertTransactionId", EmitDefaultValue=false)]
        public string GiftCertTransactionId { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate number.&lt;/p&gt;</value>
        [DataMember(Name="giftCertNumber", EmitDefaultValue=false)]
        public string GiftCertNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate track2 data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate track2 data.&lt;/p&gt;</value>
        [DataMember(Name="Track2", EmitDefaultValue=false)]
        public string Track2 { get; set; }

        /// <summary>
        /// &lt;p&gt;Gift certificate amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Gift certificate amount.&lt;/p&gt;</value>
        [DataMember(Name="giftCertAmount", EmitDefaultValue=false)]
        public double? GiftCertAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;ISO currency code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ISO currency code.&lt;/p&gt;</value>
        [DataMember(Name="isoCurrencyCode", EmitDefaultValue=false)]
        public string IsoCurrencyCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Approval code from terminal related to gift card transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Approval code from terminal related to gift card transaction.&lt;/p&gt;</value>
        [DataMember(Name="approvalCode", EmitDefaultValue=false)]
        public string ApprovalCode { get; set; }

        /// <summary>
        /// &lt;p&gt;The terminal reference number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The terminal reference number.&lt;/p&gt;</value>
        [DataMember(Name="terminalReferenceNumber", EmitDefaultValue=false)]
        public string TerminalReferenceNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;The original transaction UUID from registration. &lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The original transaction UUID from registration. &lt;/p&gt;</value>
        [DataMember(Name="gcsTransactionUUID", EmitDefaultValue=false)]
        public string GcsTransactionUUID { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether failures should be ignored during the cancellation process and tries to cancel all gift certificates.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether failures should be ignored during the cancellation process and tries to cancel all gift certificates.&lt;/p&gt;</value>
        [DataMember(Name="ignoreFailures", EmitDefaultValue=false)]
        public bool? IgnoreFailures { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether tender line items should be voided during the cancellation process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether tender line items should be voided during the cancellation process.&lt;/p&gt;</value>
        [DataMember(Name="voidTenderLineItems", EmitDefaultValue=false)]
        public bool? VoidTenderLineItems { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest {\n");
            sb.Append("  ServiceId: ").Append(ServiceId).Append("\n");
            sb.Append("  PositionOperationConfig: ").Append(PositionOperationConfig).Append("\n");
            sb.Append("  CallingProcess: ").Append(CallingProcess).Append("\n");
            sb.Append("  StoredValuesServiceId: ").Append(StoredValuesServiceId).Append("\n");
            sb.Append("  TransactionId: ").Append(TransactionId).Append("\n");
            sb.Append("  ReceiptNumber: ").Append(ReceiptNumber).Append("\n");
            sb.Append("  GiftCertTransactionId: ").Append(GiftCertTransactionId).Append("\n");
            sb.Append("  GiftCertNumber: ").Append(GiftCertNumber).Append("\n");
            sb.Append("  Track2: ").Append(Track2).Append("\n");
            sb.Append("  GiftCertAmount: ").Append(GiftCertAmount).Append("\n");
            sb.Append("  IsoCurrencyCode: ").Append(IsoCurrencyCode).Append("\n");
            sb.Append("  ApprovalCode: ").Append(ApprovalCode).Append("\n");
            sb.Append("  TerminalReferenceNumber: ").Append(TerminalReferenceNumber).Append("\n");
            sb.Append("  GcsTransactionUUID: ").Append(GcsTransactionUUID).Append("\n");
            sb.Append("  IgnoreFailures: ").Append(IgnoreFailures).Append("\n");
            sb.Append("  VoidTenderLineItems: ").Append(VoidTenderLineItems).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceStoredValueServerCancelGiftCertTransactionRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ServiceId == input.ServiceId ||
                    (this.ServiceId != null &&
                    this.ServiceId.Equals(input.ServiceId))
                ) && 
                (
                    this.PositionOperationConfig == input.PositionOperationConfig ||
                    (this.PositionOperationConfig != null &&
                    this.PositionOperationConfig.Equals(input.PositionOperationConfig))
                ) && 
                (
                    this.CallingProcess == input.CallingProcess ||
                    (this.CallingProcess != null &&
                    this.CallingProcess.Equals(input.CallingProcess))
                ) && 
                (
                    this.StoredValuesServiceId == input.StoredValuesServiceId ||
                    (this.StoredValuesServiceId != null &&
                    this.StoredValuesServiceId.Equals(input.StoredValuesServiceId))
                ) && 
                (
                    this.TransactionId == input.TransactionId ||
                    (this.TransactionId != null &&
                    this.TransactionId.Equals(input.TransactionId))
                ) && 
                (
                    this.ReceiptNumber == input.ReceiptNumber ||
                    (this.ReceiptNumber != null &&
                    this.ReceiptNumber.Equals(input.ReceiptNumber))
                ) && 
                (
                    this.GiftCertTransactionId == input.GiftCertTransactionId ||
                    (this.GiftCertTransactionId != null &&
                    this.GiftCertTransactionId.Equals(input.GiftCertTransactionId))
                ) && 
                (
                    this.GiftCertNumber == input.GiftCertNumber ||
                    (this.GiftCertNumber != null &&
                    this.GiftCertNumber.Equals(input.GiftCertNumber))
                ) && 
                (
                    this.Track2 == input.Track2 ||
                    (this.Track2 != null &&
                    this.Track2.Equals(input.Track2))
                ) && 
                (
                    this.GiftCertAmount == input.GiftCertAmount ||
                    (this.GiftCertAmount != null &&
                    this.GiftCertAmount.Equals(input.GiftCertAmount))
                ) && 
                (
                    this.IsoCurrencyCode == input.IsoCurrencyCode ||
                    (this.IsoCurrencyCode != null &&
                    this.IsoCurrencyCode.Equals(input.IsoCurrencyCode))
                ) && 
                (
                    this.ApprovalCode == input.ApprovalCode ||
                    (this.ApprovalCode != null &&
                    this.ApprovalCode.Equals(input.ApprovalCode))
                ) && 
                (
                    this.TerminalReferenceNumber == input.TerminalReferenceNumber ||
                    (this.TerminalReferenceNumber != null &&
                    this.TerminalReferenceNumber.Equals(input.TerminalReferenceNumber))
                ) && 
                (
                    this.GcsTransactionUUID == input.GcsTransactionUUID ||
                    (this.GcsTransactionUUID != null &&
                    this.GcsTransactionUUID.Equals(input.GcsTransactionUUID))
                ) && 
                (
                    this.IgnoreFailures == input.IgnoreFailures ||
                    (this.IgnoreFailures != null &&
                    this.IgnoreFailures.Equals(input.IgnoreFailures))
                ) && 
                (
                    this.VoidTenderLineItems == input.VoidTenderLineItems ||
                    (this.VoidTenderLineItems != null &&
                    this.VoidTenderLineItems.Equals(input.VoidTenderLineItems))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ServiceId != null)
                    hashCode = hashCode * 59 + this.ServiceId.GetHashCode();
                if (this.PositionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PositionOperationConfig.GetHashCode();
                if (this.CallingProcess != null)
                    hashCode = hashCode * 59 + this.CallingProcess.GetHashCode();
                if (this.StoredValuesServiceId != null)
                    hashCode = hashCode * 59 + this.StoredValuesServiceId.GetHashCode();
                if (this.TransactionId != null)
                    hashCode = hashCode * 59 + this.TransactionId.GetHashCode();
                if (this.ReceiptNumber != null)
                    hashCode = hashCode * 59 + this.ReceiptNumber.GetHashCode();
                if (this.GiftCertTransactionId != null)
                    hashCode = hashCode * 59 + this.GiftCertTransactionId.GetHashCode();
                if (this.GiftCertNumber != null)
                    hashCode = hashCode * 59 + this.GiftCertNumber.GetHashCode();
                if (this.Track2 != null)
                    hashCode = hashCode * 59 + this.Track2.GetHashCode();
                if (this.GiftCertAmount != null)
                    hashCode = hashCode * 59 + this.GiftCertAmount.GetHashCode();
                if (this.IsoCurrencyCode != null)
                    hashCode = hashCode * 59 + this.IsoCurrencyCode.GetHashCode();
                if (this.ApprovalCode != null)
                    hashCode = hashCode * 59 + this.ApprovalCode.GetHashCode();
                if (this.TerminalReferenceNumber != null)
                    hashCode = hashCode * 59 + this.TerminalReferenceNumber.GetHashCode();
                if (this.GcsTransactionUUID != null)
                    hashCode = hashCode * 59 + this.GcsTransactionUUID.GetHashCode();
                if (this.IgnoreFailures != null)
                    hashCode = hashCode * 59 + this.IgnoreFailures.GetHashCode();
                if (this.VoidTenderLineItems != null)
                    hashCode = hashCode * 59 + this.VoidTenderLineItems.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
