/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CustomerRegistrationRequest &lt;p&gt;Request object for the CustomerTransactionService&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest" /> class.
        /// </summary>
        /// <param name="identifier">&lt;p&gt;The customer identifier (customer id / party identification)&lt;/p&gt;.</param>
        /// <param name="customerGroupId">&lt;p&gt;The customer group id&lt;/p&gt;.</param>
        /// <param name="customerCardType">&lt;p&gt;The customer card type&lt;/p&gt;.</param>
        /// <param name="customerCardNumber">&lt;p&gt;The customer card number&lt;/p&gt;.</param>
        /// <param name="customerCardTypeDescriptionKey">&lt;p&gt;The customer card type description key&lt;/p&gt;.</param>
        /// <param name="useWebService">&lt;p&gt;In case that &#39;searchDatabase&#39; setting is set to false the value of&lt;br /&gt; that property is used to determine where the search should be executed.&lt;br /&gt; Possible values are:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;SAP_ERP (default)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;SAP_CRM&lt;/li&gt;&lt;br /&gt; &lt;li&gt;VALUEPHONE&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="searchDatabase">&lt;p&gt;Indicates whether the customer should be searched in local MD database.&lt;/p&gt; (required).</param>
        /// <param name="searchForIdentificationNumber">&lt;p&gt;This parameters works only in combination with searchDatabase&#x3D;true, it&lt;br /&gt; specifies the type of customer identifier:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;false: search by party identification is executed&lt;/li&gt;&lt;br /&gt; &lt;li&gt;true: search by customer id is executed&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt; (required).</param>
        /// <param name="trainingMode">&lt;p&gt;Indicates if the service was started in training mode.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest(string identifier = default(string), string customerGroupId = default(string), string customerCardType = default(string), string customerCardNumber = default(string), string customerCardTypeDescriptionKey = default(string), string useWebService = default(string), bool? searchDatabase = default(bool?), bool? searchForIdentificationNumber = default(bool?), bool? trainingMode = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "searchDatabase" is required (not null)
            if (searchDatabase == null)
            {
                throw new InvalidDataException("searchDatabase is a required property for ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest and cannot be null");
            }
            else
            {
                this.SearchDatabase = searchDatabase;
            }
            // to ensure "searchForIdentificationNumber" is required (not null)
            if (searchForIdentificationNumber == null)
            {
                throw new InvalidDataException("searchForIdentificationNumber is a required property for ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest and cannot be null");
            }
            else
            {
                this.SearchForIdentificationNumber = searchForIdentificationNumber;
            }
            this.Identifier = identifier;
            this.CustomerGroupId = customerGroupId;
            this.CustomerCardType = customerCardType;
            this.CustomerCardNumber = customerCardNumber;
            this.CustomerCardTypeDescriptionKey = customerCardTypeDescriptionKey;
            this.UseWebService = useWebService;
            this.TrainingMode = trainingMode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The customer identifier (customer id / party identification)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer identifier (customer id / party identification)&lt;/p&gt;</value>
        [DataMember(Name="identifier", EmitDefaultValue=false)]
        public string Identifier { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer group id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer group id&lt;/p&gt;</value>
        [DataMember(Name="customerGroupId", EmitDefaultValue=false)]
        public string CustomerGroupId { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer card type&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card type&lt;/p&gt;</value>
        [DataMember(Name="customerCardType", EmitDefaultValue=false)]
        public string CustomerCardType { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer card number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card number&lt;/p&gt;</value>
        [DataMember(Name="customerCardNumber", EmitDefaultValue=false)]
        public string CustomerCardNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;The customer card type description key&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card type description key&lt;/p&gt;</value>
        [DataMember(Name="customerCardTypeDescriptionKey", EmitDefaultValue=false)]
        public string CustomerCardTypeDescriptionKey { get; set; }

        /// <summary>
        /// &lt;p&gt;In case that &#39;searchDatabase&#39; setting is set to false the value of&lt;br /&gt; that property is used to determine where the search should be executed.&lt;br /&gt; Possible values are:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;SAP_ERP (default)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;SAP_CRM&lt;/li&gt;&lt;br /&gt; &lt;li&gt;VALUEPHONE&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;In case that &#39;searchDatabase&#39; setting is set to false the value of&lt;br /&gt; that property is used to determine where the search should be executed.&lt;br /&gt; Possible values are:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;SAP_ERP (default)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;SAP_CRM&lt;/li&gt;&lt;br /&gt; &lt;li&gt;VALUEPHONE&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="useWebService", EmitDefaultValue=false)]
        public string UseWebService { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether the customer should be searched in local MD database.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the customer should be searched in local MD database.&lt;/p&gt;</value>
        [DataMember(Name="searchDatabase", EmitDefaultValue=false)]
        public bool? SearchDatabase { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameters works only in combination with searchDatabase&#x3D;true, it&lt;br /&gt; specifies the type of customer identifier:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;false: search by party identification is executed&lt;/li&gt;&lt;br /&gt; &lt;li&gt;true: search by customer id is executed&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameters works only in combination with searchDatabase&#x3D;true, it&lt;br /&gt; specifies the type of customer identifier:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;false: search by party identification is executed&lt;/li&gt;&lt;br /&gt; &lt;li&gt;true: search by customer id is executed&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="searchForIdentificationNumber", EmitDefaultValue=false)]
        public bool? SearchForIdentificationNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates if the service was started in training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if the service was started in training mode.&lt;/p&gt;</value>
        [DataMember(Name="trainingMode", EmitDefaultValue=false)]
        public bool? TrainingMode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest {\n");
            sb.Append("  Identifier: ").Append(Identifier).Append("\n");
            sb.Append("  CustomerGroupId: ").Append(CustomerGroupId).Append("\n");
            sb.Append("  CustomerCardType: ").Append(CustomerCardType).Append("\n");
            sb.Append("  CustomerCardNumber: ").Append(CustomerCardNumber).Append("\n");
            sb.Append("  CustomerCardTypeDescriptionKey: ").Append(CustomerCardTypeDescriptionKey).Append("\n");
            sb.Append("  UseWebService: ").Append(UseWebService).Append("\n");
            sb.Append("  SearchDatabase: ").Append(SearchDatabase).Append("\n");
            sb.Append("  SearchForIdentificationNumber: ").Append(SearchForIdentificationNumber).Append("\n");
            sb.Append("  TrainingMode: ").Append(TrainingMode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Identifier == input.Identifier ||
                    (this.Identifier != null &&
                    this.Identifier.Equals(input.Identifier))
                ) && 
                (
                    this.CustomerGroupId == input.CustomerGroupId ||
                    (this.CustomerGroupId != null &&
                    this.CustomerGroupId.Equals(input.CustomerGroupId))
                ) && 
                (
                    this.CustomerCardType == input.CustomerCardType ||
                    (this.CustomerCardType != null &&
                    this.CustomerCardType.Equals(input.CustomerCardType))
                ) && 
                (
                    this.CustomerCardNumber == input.CustomerCardNumber ||
                    (this.CustomerCardNumber != null &&
                    this.CustomerCardNumber.Equals(input.CustomerCardNumber))
                ) && 
                (
                    this.CustomerCardTypeDescriptionKey == input.CustomerCardTypeDescriptionKey ||
                    (this.CustomerCardTypeDescriptionKey != null &&
                    this.CustomerCardTypeDescriptionKey.Equals(input.CustomerCardTypeDescriptionKey))
                ) && 
                (
                    this.UseWebService == input.UseWebService ||
                    (this.UseWebService != null &&
                    this.UseWebService.Equals(input.UseWebService))
                ) && 
                (
                    this.SearchDatabase == input.SearchDatabase ||
                    (this.SearchDatabase != null &&
                    this.SearchDatabase.Equals(input.SearchDatabase))
                ) && 
                (
                    this.SearchForIdentificationNumber == input.SearchForIdentificationNumber ||
                    (this.SearchForIdentificationNumber != null &&
                    this.SearchForIdentificationNumber.Equals(input.SearchForIdentificationNumber))
                ) && 
                (
                    this.TrainingMode == input.TrainingMode ||
                    (this.TrainingMode != null &&
                    this.TrainingMode.Equals(input.TrainingMode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Identifier != null)
                    hashCode = hashCode * 59 + this.Identifier.GetHashCode();
                if (this.CustomerGroupId != null)
                    hashCode = hashCode * 59 + this.CustomerGroupId.GetHashCode();
                if (this.CustomerCardType != null)
                    hashCode = hashCode * 59 + this.CustomerCardType.GetHashCode();
                if (this.CustomerCardNumber != null)
                    hashCode = hashCode * 59 + this.CustomerCardNumber.GetHashCode();
                if (this.CustomerCardTypeDescriptionKey != null)
                    hashCode = hashCode * 59 + this.CustomerCardTypeDescriptionKey.GetHashCode();
                if (this.UseWebService != null)
                    hashCode = hashCode * 59 + this.UseWebService.GetHashCode();
                if (this.SearchDatabase != null)
                    hashCode = hashCode * 59 + this.SearchDatabase.GetHashCode();
                if (this.SearchForIdentificationNumber != null)
                    hashCode = hashCode * 59 + this.SearchForIdentificationNumber.GetHashCode();
                if (this.TrainingMode != null)
                    hashCode = hashCode * 59 + this.TrainingMode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
