/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GiftCertificateRegistrationRequest &lt;p&gt;Request object for operations which create a SaleReturnLineItem on active transaction.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest" /> class.
        /// </summary>
        /// <param name="positionOperationConfig">&lt;p&gt;PositionOperationConfig : position operation config&lt;/p&gt;.</param>
        /// <param name="gcNumber">&lt;p&gt;String : gift certificate number&lt;/p&gt;.</param>
        /// <param name="gcItemNumber">&lt;p&gt;String : gift certificate item number&lt;/p&gt;.</param>
        /// <param name="gcAmount">&lt;p&gt;String : gift certificate amount&lt;/p&gt;.</param>
        /// <param name="serviceResult">&lt;p&gt;GiftCertServiceResult : service result&lt;/p&gt;.</param>
        /// <param name="gcDescription">&lt;p&gt;String : gift certificate description&lt;/p&gt;.</param>
        /// <param name="online">&lt;p&gt;boolean : online&lt;/p&gt; (required).</param>
        /// <param name="createReturnReceipt">&lt;p&gt;Specifies if a return receipt should be created.&lt;/p&gt; (required).</param>
        /// <param name="externalSystemAdapterName">&lt;p&gt;String : external system adapter name&lt;/p&gt;.</param>
        /// <param name="gcClass">&lt;p&gt;String : gc class&lt;/p&gt;.</param>
        /// <param name="expiryDate">&lt;p&gt;Date : expiry date&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone).</param>
        /// <param name="quantity">&lt;p&gt;int : quantity&lt;/p&gt;.</param>
        /// <param name="actionCode">&lt;p&gt;String : action code&lt;/p&gt;.</param>
        /// <param name="gcType">&lt;p&gt;String : gift certificate type&lt;/p&gt;.</param>
        /// <param name="gcsUsage">&lt;p&gt;boolean : gcs usage&lt;/p&gt; (required).</param>
        /// <param name="taxGroupID">&lt;p&gt;String : tax group iD&lt;/p&gt;.</param>
        /// <param name="alternativeTaxInfos">&lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;.</param>
        /// <param name="track2">&lt;p&gt;Track2 data.&lt;/p&gt;.</param>
        /// <param name="additionalInfo">&lt;p&gt;Contains additional information.&lt;/p&gt;.</param>
        /// <param name="salesPersonNumberRequest">&lt;p&gt;The sales person number request&lt;/p&gt;.</param>
        /// <param name="takeAwaySaleMode">&lt;p&gt;Indicates whether the take away sale mode is active.&lt;/p&gt; (required).</param>
        /// <param name="entryMethodCode">&lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig positionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), string gcNumber = default(string), string gcItemNumber = default(string), ComGkSoftwarePosApiModelDomAppAmountAmount gcAmount = default(ComGkSoftwarePosApiModelDomAppAmountAmount), ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertServiceResult serviceResult = default(ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertServiceResult), string gcDescription = default(string), bool? online = default(bool?), bool? createReturnReceipt = default(bool?), string externalSystemAdapterName = default(string), string gcClass = default(string), string expiryDate = default(string), int? quantity = default(int?), string actionCode = default(string), string gcType = default(string), bool? gcsUsage = default(bool?), string taxGroupID = default(string), ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos alternativeTaxInfos = default(ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos), string track2 = default(string), List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> additionalInfo = default(List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue>), ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest salesPersonNumberRequest = default(ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest), bool? takeAwaySaleMode = default(bool?), string entryMethodCode = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "online" is required (not null)
            if (online == null)
            {
                throw new InvalidDataException("online is a required property for ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest and cannot be null");
            }
            else
            {
                this.Online = online;
            }
            // to ensure "createReturnReceipt" is required (not null)
            if (createReturnReceipt == null)
            {
                throw new InvalidDataException("createReturnReceipt is a required property for ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest and cannot be null");
            }
            else
            {
                this.CreateReturnReceipt = createReturnReceipt;
            }
            // to ensure "gcsUsage" is required (not null)
            if (gcsUsage == null)
            {
                throw new InvalidDataException("gcsUsage is a required property for ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest and cannot be null");
            }
            else
            {
                this.GcsUsage = gcsUsage;
            }
            // to ensure "takeAwaySaleMode" is required (not null)
            if (takeAwaySaleMode == null)
            {
                throw new InvalidDataException("takeAwaySaleMode is a required property for ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest and cannot be null");
            }
            else
            {
                this.TakeAwaySaleMode = takeAwaySaleMode;
            }
            this.PositionOperationConfig = positionOperationConfig;
            this.GcNumber = gcNumber;
            this.GcItemNumber = gcItemNumber;
            this.GcAmount = gcAmount;
            this.ServiceResult = serviceResult;
            this.GcDescription = gcDescription;
            this.ExternalSystemAdapterName = externalSystemAdapterName;
            this.GcClass = gcClass;
            this.ExpiryDate = expiryDate;
            this.Quantity = quantity;
            this.ActionCode = actionCode;
            this.GcType = gcType;
            this.TaxGroupID = taxGroupID;
            this.AlternativeTaxInfos = alternativeTaxInfos;
            this.Track2 = track2;
            this.AdditionalInfo = additionalInfo;
            this.SalesPersonNumberRequest = salesPersonNumberRequest;
            this.EntryMethodCode = entryMethodCode;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;PositionOperationConfig : position operation config&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;PositionOperationConfig : position operation config&lt;/p&gt;</value>
        [DataMember(Name="positionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig PositionOperationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gift certificate number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gift certificate number&lt;/p&gt;</value>
        [DataMember(Name="gcNumber", EmitDefaultValue=false)]
        public string GcNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gift certificate item number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gift certificate item number&lt;/p&gt;</value>
        [DataMember(Name="gcItemNumber", EmitDefaultValue=false)]
        public string GcItemNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gift certificate amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gift certificate amount&lt;/p&gt;</value>
        [DataMember(Name="gcAmount", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppAmountAmount GcAmount { get; set; }

        /// <summary>
        /// &lt;p&gt;GiftCertServiceResult : service result&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;GiftCertServiceResult : service result&lt;/p&gt;</value>
        [DataMember(Name="serviceResult", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppGiftCertificateServiceGiftCertServiceResult ServiceResult { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gift certificate description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gift certificate description&lt;/p&gt;</value>
        [DataMember(Name="gcDescription", EmitDefaultValue=false)]
        public string GcDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean : online&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : online&lt;/p&gt;</value>
        [DataMember(Name="online", EmitDefaultValue=false)]
        public bool? Online { get; set; }

        /// <summary>
        /// &lt;p&gt;Specifies if a return receipt should be created.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Specifies if a return receipt should be created.&lt;/p&gt;</value>
        [DataMember(Name="createReturnReceipt", EmitDefaultValue=false)]
        public bool? CreateReturnReceipt { get; set; }

        /// <summary>
        /// &lt;p&gt;String : external system adapter name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : external system adapter name&lt;/p&gt;</value>
        [DataMember(Name="externalSystemAdapterName", EmitDefaultValue=false)]
        public string ExternalSystemAdapterName { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gc class&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gc class&lt;/p&gt;</value>
        [DataMember(Name="gcClass", EmitDefaultValue=false)]
        public string GcClass { get; set; }

        /// <summary>
        /// &lt;p&gt;Date : expiry date&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;Date : expiry date&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        [DataMember(Name="expiryDate", EmitDefaultValue=false)]
        public string ExpiryDate { get; set; }

        /// <summary>
        /// &lt;p&gt;int : quantity&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;int : quantity&lt;/p&gt;</value>
        [DataMember(Name="quantity", EmitDefaultValue=false)]
        public int? Quantity { get; set; }

        /// <summary>
        /// &lt;p&gt;String : action code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : action code&lt;/p&gt;</value>
        [DataMember(Name="actionCode", EmitDefaultValue=false)]
        public string ActionCode { get; set; }

        /// <summary>
        /// &lt;p&gt;String : gift certificate type&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : gift certificate type&lt;/p&gt;</value>
        [DataMember(Name="gcType", EmitDefaultValue=false)]
        public string GcType { get; set; }

        /// <summary>
        /// &lt;p&gt;boolean : gcs usage&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : gcs usage&lt;/p&gt;</value>
        [DataMember(Name="gcsUsage", EmitDefaultValue=false)]
        public bool? GcsUsage { get; set; }

        /// <summary>
        /// &lt;p&gt;String : tax group iD&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : tax group iD&lt;/p&gt;</value>
        [DataMember(Name="taxGroupID", EmitDefaultValue=false)]
        public string TaxGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax infos for updating the tax group.&lt;/p&gt;</value>
        [DataMember(Name="alternativeTaxInfos", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos AlternativeTaxInfos { get; set; }

        /// <summary>
        /// &lt;p&gt;Track2 data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Track2 data.&lt;/p&gt;</value>
        [DataMember(Name="track2", EmitDefaultValue=false)]
        public string Track2 { get; set; }

        /// <summary>
        /// &lt;p&gt;Contains additional information.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Contains additional information.&lt;/p&gt;</value>
        [DataMember(Name="additionalInfo", EmitDefaultValue=false)]
        public List<ComGkSoftwarePosApiModelDomAppGiftCertificateServiceAttributeValue> AdditionalInfo { get; set; }

        /// <summary>
        /// &lt;p&gt;The sales person number request&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales person number request&lt;/p&gt;</value>
        [DataMember(Name="salesPersonNumberRequest", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest SalesPersonNumberRequest { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicates whether the take away sale mode is active.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the take away sale mode is active.&lt;/p&gt;</value>
        [DataMember(Name="takeAwaySaleMode", EmitDefaultValue=false)]
        public bool? TakeAwaySaleMode { get; set; }

        /// <summary>
        /// &lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Contains the method with which the item was registered (keyed in, scanned through bar code, etc).&lt;/p&gt;</value>
        [DataMember(Name="entryMethodCode", EmitDefaultValue=false)]
        public string EntryMethodCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest {\n");
            sb.Append("  PositionOperationConfig: ").Append(PositionOperationConfig).Append("\n");
            sb.Append("  GcNumber: ").Append(GcNumber).Append("\n");
            sb.Append("  GcItemNumber: ").Append(GcItemNumber).Append("\n");
            sb.Append("  GcAmount: ").Append(GcAmount).Append("\n");
            sb.Append("  ServiceResult: ").Append(ServiceResult).Append("\n");
            sb.Append("  GcDescription: ").Append(GcDescription).Append("\n");
            sb.Append("  Online: ").Append(Online).Append("\n");
            sb.Append("  CreateReturnReceipt: ").Append(CreateReturnReceipt).Append("\n");
            sb.Append("  ExternalSystemAdapterName: ").Append(ExternalSystemAdapterName).Append("\n");
            sb.Append("  GcClass: ").Append(GcClass).Append("\n");
            sb.Append("  ExpiryDate: ").Append(ExpiryDate).Append("\n");
            sb.Append("  Quantity: ").Append(Quantity).Append("\n");
            sb.Append("  ActionCode: ").Append(ActionCode).Append("\n");
            sb.Append("  GcType: ").Append(GcType).Append("\n");
            sb.Append("  GcsUsage: ").Append(GcsUsage).Append("\n");
            sb.Append("  TaxGroupID: ").Append(TaxGroupID).Append("\n");
            sb.Append("  AlternativeTaxInfos: ").Append(AlternativeTaxInfos).Append("\n");
            sb.Append("  Track2: ").Append(Track2).Append("\n");
            sb.Append("  AdditionalInfo: ").Append(AdditionalInfo).Append("\n");
            sb.Append("  SalesPersonNumberRequest: ").Append(SalesPersonNumberRequest).Append("\n");
            sb.Append("  TakeAwaySaleMode: ").Append(TakeAwaySaleMode).Append("\n");
            sb.Append("  EntryMethodCode: ").Append(EntryMethodCode).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionGiftCertificateGiftCertificateRegistrationRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PositionOperationConfig == input.PositionOperationConfig ||
                    (this.PositionOperationConfig != null &&
                    this.PositionOperationConfig.Equals(input.PositionOperationConfig))
                ) && 
                (
                    this.GcNumber == input.GcNumber ||
                    (this.GcNumber != null &&
                    this.GcNumber.Equals(input.GcNumber))
                ) && 
                (
                    this.GcItemNumber == input.GcItemNumber ||
                    (this.GcItemNumber != null &&
                    this.GcItemNumber.Equals(input.GcItemNumber))
                ) && 
                (
                    this.GcAmount == input.GcAmount ||
                    (this.GcAmount != null &&
                    this.GcAmount.Equals(input.GcAmount))
                ) && 
                (
                    this.ServiceResult == input.ServiceResult ||
                    (this.ServiceResult != null &&
                    this.ServiceResult.Equals(input.ServiceResult))
                ) && 
                (
                    this.GcDescription == input.GcDescription ||
                    (this.GcDescription != null &&
                    this.GcDescription.Equals(input.GcDescription))
                ) && 
                (
                    this.Online == input.Online ||
                    (this.Online != null &&
                    this.Online.Equals(input.Online))
                ) && 
                (
                    this.CreateReturnReceipt == input.CreateReturnReceipt ||
                    (this.CreateReturnReceipt != null &&
                    this.CreateReturnReceipt.Equals(input.CreateReturnReceipt))
                ) && 
                (
                    this.ExternalSystemAdapterName == input.ExternalSystemAdapterName ||
                    (this.ExternalSystemAdapterName != null &&
                    this.ExternalSystemAdapterName.Equals(input.ExternalSystemAdapterName))
                ) && 
                (
                    this.GcClass == input.GcClass ||
                    (this.GcClass != null &&
                    this.GcClass.Equals(input.GcClass))
                ) && 
                (
                    this.ExpiryDate == input.ExpiryDate ||
                    (this.ExpiryDate != null &&
                    this.ExpiryDate.Equals(input.ExpiryDate))
                ) && 
                (
                    this.Quantity == input.Quantity ||
                    (this.Quantity != null &&
                    this.Quantity.Equals(input.Quantity))
                ) && 
                (
                    this.ActionCode == input.ActionCode ||
                    (this.ActionCode != null &&
                    this.ActionCode.Equals(input.ActionCode))
                ) && 
                (
                    this.GcType == input.GcType ||
                    (this.GcType != null &&
                    this.GcType.Equals(input.GcType))
                ) && 
                (
                    this.GcsUsage == input.GcsUsage ||
                    (this.GcsUsage != null &&
                    this.GcsUsage.Equals(input.GcsUsage))
                ) && 
                (
                    this.TaxGroupID == input.TaxGroupID ||
                    (this.TaxGroupID != null &&
                    this.TaxGroupID.Equals(input.TaxGroupID))
                ) && 
                (
                    this.AlternativeTaxInfos == input.AlternativeTaxInfos ||
                    (this.AlternativeTaxInfos != null &&
                    this.AlternativeTaxInfos.Equals(input.AlternativeTaxInfos))
                ) && 
                (
                    this.Track2 == input.Track2 ||
                    (this.Track2 != null &&
                    this.Track2.Equals(input.Track2))
                ) && 
                (
                    this.AdditionalInfo == input.AdditionalInfo ||
                    this.AdditionalInfo != null &&
                    this.AdditionalInfo.SequenceEqual(input.AdditionalInfo)
                ) && 
                (
                    this.SalesPersonNumberRequest == input.SalesPersonNumberRequest ||
                    (this.SalesPersonNumberRequest != null &&
                    this.SalesPersonNumberRequest.Equals(input.SalesPersonNumberRequest))
                ) && 
                (
                    this.TakeAwaySaleMode == input.TakeAwaySaleMode ||
                    (this.TakeAwaySaleMode != null &&
                    this.TakeAwaySaleMode.Equals(input.TakeAwaySaleMode))
                ) && 
                (
                    this.EntryMethodCode == input.EntryMethodCode ||
                    (this.EntryMethodCode != null &&
                    this.EntryMethodCode.Equals(input.EntryMethodCode))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PositionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PositionOperationConfig.GetHashCode();
                if (this.GcNumber != null)
                    hashCode = hashCode * 59 + this.GcNumber.GetHashCode();
                if (this.GcItemNumber != null)
                    hashCode = hashCode * 59 + this.GcItemNumber.GetHashCode();
                if (this.GcAmount != null)
                    hashCode = hashCode * 59 + this.GcAmount.GetHashCode();
                if (this.ServiceResult != null)
                    hashCode = hashCode * 59 + this.ServiceResult.GetHashCode();
                if (this.GcDescription != null)
                    hashCode = hashCode * 59 + this.GcDescription.GetHashCode();
                if (this.Online != null)
                    hashCode = hashCode * 59 + this.Online.GetHashCode();
                if (this.CreateReturnReceipt != null)
                    hashCode = hashCode * 59 + this.CreateReturnReceipt.GetHashCode();
                if (this.ExternalSystemAdapterName != null)
                    hashCode = hashCode * 59 + this.ExternalSystemAdapterName.GetHashCode();
                if (this.GcClass != null)
                    hashCode = hashCode * 59 + this.GcClass.GetHashCode();
                if (this.ExpiryDate != null)
                    hashCode = hashCode * 59 + this.ExpiryDate.GetHashCode();
                if (this.Quantity != null)
                    hashCode = hashCode * 59 + this.Quantity.GetHashCode();
                if (this.ActionCode != null)
                    hashCode = hashCode * 59 + this.ActionCode.GetHashCode();
                if (this.GcType != null)
                    hashCode = hashCode * 59 + this.GcType.GetHashCode();
                if (this.GcsUsage != null)
                    hashCode = hashCode * 59 + this.GcsUsage.GetHashCode();
                if (this.TaxGroupID != null)
                    hashCode = hashCode * 59 + this.TaxGroupID.GetHashCode();
                if (this.AlternativeTaxInfos != null)
                    hashCode = hashCode * 59 + this.AlternativeTaxInfos.GetHashCode();
                if (this.Track2 != null)
                    hashCode = hashCode * 59 + this.Track2.GetHashCode();
                if (this.AdditionalInfo != null)
                    hashCode = hashCode * 59 + this.AdditionalInfo.GetHashCode();
                if (this.SalesPersonNumberRequest != null)
                    hashCode = hashCode * 59 + this.SalesPersonNumberRequest.GetHashCode();
                if (this.TakeAwaySaleMode != null)
                    hashCode = hashCode * 59 + this.TakeAwaySaleMode.GetHashCode();
                if (this.EntryMethodCode != null)
                    hashCode = hashCode * 59 + this.EntryMethodCode.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
