/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// RegisterEmptiesTransactionRequest &lt;p&gt;Request object for the retrieve empties transaction process.&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;The deposit type 1.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The deposit type 1.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum DepositType1Enum
        {
            
            /// <summary>
            /// Enum RETURNABLE for value: RETURNABLE
            /// </summary>
            [EnumMember(Value = "RETURNABLE")]
            RETURNABLE = 1,
            
            /// <summary>
            /// Enum NONRETURNABLE for value: NON_RETURNABLE
            /// </summary>
            [EnumMember(Value = "NON_RETURNABLE")]
            NONRETURNABLE = 2
        }

        /// <summary>
        /// &lt;p&gt;The deposit type 1.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The deposit type 1.&lt;/p&gt;</value>
        [DataMember(Name="depositType1", EmitDefaultValue=false)]
        public DepositType1Enum? DepositType1 { get; set; }
        /// <summary>
        /// &lt;p&gt;The deposit type 2.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The deposit type 2.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum DepositType2Enum
        {
            
            /// <summary>
            /// Enum RETURNABLE for value: RETURNABLE
            /// </summary>
            [EnumMember(Value = "RETURNABLE")]
            RETURNABLE = 1,
            
            /// <summary>
            /// Enum NONRETURNABLE for value: NON_RETURNABLE
            /// </summary>
            [EnumMember(Value = "NON_RETURNABLE")]
            NONRETURNABLE = 2
        }

        /// <summary>
        /// &lt;p&gt;The deposit type 2.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The deposit type 2.&lt;/p&gt;</value>
        [DataMember(Name="depositType2", EmitDefaultValue=false)]
        public DepositType2Enum? DepositType2 { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest" /> class.
        /// </summary>
        /// <param name="positionOperationConfig">&lt;p&gt;The position operation configuration.&lt;/p&gt;.</param>
        /// <param name="returnMode">&lt;p&gt;A flag to indicate that return mode is active.&lt;/p&gt; (required).</param>
        /// <param name="collectiveNumber">&lt;p&gt;The collective number. When add as one line item is wanted or necessary the item with collective number is used for empties return transaction registration.&lt;/p&gt;.</param>
        /// <param name="transactionIdentifier">&lt;p&gt;The transaction identifier for the empties return transaction.&lt;/p&gt;.</param>
        /// <param name="amount">&lt;p&gt;The amount. In case of collective item usage the unit price amount for the line item registration.&lt;/p&gt;.</param>
        /// <param name="amount1">&lt;p&gt;The amount1. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 1 line item registration.&lt;/p&gt;.</param>
        /// <param name="amount2">&lt;p&gt;The amount2. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 2 line item registration.&lt;/p&gt;.</param>
        /// <param name="oneWayItemNumber">&lt;p&gt;The one-way deposit item number.&lt;/p&gt;.</param>
        /// <param name="multiWayItemNumber">&lt;p&gt;The multi-way deposit item number.&lt;/p&gt;.</param>
        /// <param name="depositType1">&lt;p&gt;The deposit type 1.&lt;/p&gt;.</param>
        /// <param name="depositType2">&lt;p&gt;The deposit type 2.&lt;/p&gt;.</param>
        /// <param name="addAsOneLineItem">&lt;p&gt;A flag to indicate that the empties return line items should be registered as one collective line item.&lt;/p&gt; (required).</param>
        /// <param name="statusOfflineConfirmed">&lt;p&gt;A flag to indicate that the status &#39;offline&#39; was confirmed.&lt;/p&gt; (required).</param>
        /// <param name="statusRedeemedConfirmed">&lt;p&gt;A flag to indicate that the status &#39;redeemed&#39; was confirmed.&lt;/p&gt; (required).</param>
        /// <param name="statusNotFoundConfirmed">&lt;p&gt;A flag to indicate that the status &#39;not found&#39; was confirmed.&lt;/p&gt; (required).</param>
        /// <param name="emptiesTransaction">&lt;p&gt;A complete transaction holding the retrieved empties return transaction.&lt;/p&gt;.</param>
        /// <param name="alternativeTaxInfos">&lt;p&gt;The alternative tax information for updating the tax group.&lt;/p&gt;.</param>
        /// <param name="storeId">&lt;p&gt;The retail store identifier.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig positionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), bool? returnMode = default(bool?), string collectiveNumber = default(string), string transactionIdentifier = default(string), double? amount = default(double?), double? amount1 = default(double?), double? amount2 = default(double?), string oneWayItemNumber = default(string), string multiWayItemNumber = default(string), DepositType1Enum? depositType1 = default(DepositType1Enum?), DepositType2Enum? depositType2 = default(DepositType2Enum?), bool? addAsOneLineItem = default(bool?), bool? statusOfflineConfirmed = default(bool?), bool? statusRedeemedConfirmed = default(bool?), bool? statusNotFoundConfirmed = default(bool?), ComGkSoftwareGkrApiTxpoolDtoCompleteTransaction emptiesTransaction = default(ComGkSoftwareGkrApiTxpoolDtoCompleteTransaction), ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos alternativeTaxInfos = default(ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos), string storeId = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "returnMode" is required (not null)
            if (returnMode == null)
            {
                throw new InvalidDataException("returnMode is a required property for ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest and cannot be null");
            }
            else
            {
                this.ReturnMode = returnMode;
            }
            // to ensure "addAsOneLineItem" is required (not null)
            if (addAsOneLineItem == null)
            {
                throw new InvalidDataException("addAsOneLineItem is a required property for ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest and cannot be null");
            }
            else
            {
                this.AddAsOneLineItem = addAsOneLineItem;
            }
            // to ensure "statusOfflineConfirmed" is required (not null)
            if (statusOfflineConfirmed == null)
            {
                throw new InvalidDataException("statusOfflineConfirmed is a required property for ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest and cannot be null");
            }
            else
            {
                this.StatusOfflineConfirmed = statusOfflineConfirmed;
            }
            // to ensure "statusRedeemedConfirmed" is required (not null)
            if (statusRedeemedConfirmed == null)
            {
                throw new InvalidDataException("statusRedeemedConfirmed is a required property for ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest and cannot be null");
            }
            else
            {
                this.StatusRedeemedConfirmed = statusRedeemedConfirmed;
            }
            // to ensure "statusNotFoundConfirmed" is required (not null)
            if (statusNotFoundConfirmed == null)
            {
                throw new InvalidDataException("statusNotFoundConfirmed is a required property for ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest and cannot be null");
            }
            else
            {
                this.StatusNotFoundConfirmed = statusNotFoundConfirmed;
            }
            this.PositionOperationConfig = positionOperationConfig;
            this.CollectiveNumber = collectiveNumber;
            this.TransactionIdentifier = transactionIdentifier;
            this.Amount = amount;
            this.Amount1 = amount1;
            this.Amount2 = amount2;
            this.OneWayItemNumber = oneWayItemNumber;
            this.MultiWayItemNumber = multiWayItemNumber;
            this.DepositType1 = depositType1;
            this.DepositType2 = depositType2;
            this.EmptiesTransaction = emptiesTransaction;
            this.AlternativeTaxInfos = alternativeTaxInfos;
            this.StoreId = storeId;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The position operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration.&lt;/p&gt;</value>
        [DataMember(Name="positionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig PositionOperationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that return mode is active.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that return mode is active.&lt;/p&gt;</value>
        [DataMember(Name="returnMode", EmitDefaultValue=false)]
        public bool? ReturnMode { get; set; }

        /// <summary>
        /// &lt;p&gt;The collective number. When add as one line item is wanted or necessary the item with collective number is used for empties return transaction registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The collective number. When add as one line item is wanted or necessary the item with collective number is used for empties return transaction registration.&lt;/p&gt;</value>
        [DataMember(Name="collectiveNumber", EmitDefaultValue=false)]
        public string CollectiveNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;The transaction identifier for the empties return transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction identifier for the empties return transaction.&lt;/p&gt;</value>
        [DataMember(Name="transactionIdentifier", EmitDefaultValue=false)]
        public string TransactionIdentifier { get; set; }

        /// <summary>
        /// &lt;p&gt;The amount. In case of collective item usage the unit price amount for the line item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount. In case of collective item usage the unit price amount for the line item registration.&lt;/p&gt;</value>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// &lt;p&gt;The amount1. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 1 line item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount1. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 1 line item registration.&lt;/p&gt;</value>
        [DataMember(Name="amount1", EmitDefaultValue=false)]
        public double? Amount1 { get; set; }

        /// <summary>
        /// &lt;p&gt;The amount2. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 2 line item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The amount2. In case of collective item usage and amount is not used the unit price amount for the one-way and multi-way returnable deposit type 2 line item registration.&lt;/p&gt;</value>
        [DataMember(Name="amount2", EmitDefaultValue=false)]
        public double? Amount2 { get; set; }

        /// <summary>
        /// &lt;p&gt;The one-way deposit item number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The one-way deposit item number.&lt;/p&gt;</value>
        [DataMember(Name="oneWayItemNumber", EmitDefaultValue=false)]
        public string OneWayItemNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;The multi-way deposit item number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The multi-way deposit item number.&lt;/p&gt;</value>
        [DataMember(Name="multiWayItemNumber", EmitDefaultValue=false)]
        public string MultiWayItemNumber { get; set; }



        /// <summary>
        /// &lt;p&gt;A flag to indicate that the empties return line items should be registered as one collective line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the empties return line items should be registered as one collective line item.&lt;/p&gt;</value>
        [DataMember(Name="addAsOneLineItem", EmitDefaultValue=false)]
        public bool? AddAsOneLineItem { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;offline&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;offline&#39; was confirmed.&lt;/p&gt;</value>
        [DataMember(Name="statusOfflineConfirmed", EmitDefaultValue=false)]
        public bool? StatusOfflineConfirmed { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;redeemed&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;redeemed&#39; was confirmed.&lt;/p&gt;</value>
        [DataMember(Name="statusRedeemedConfirmed", EmitDefaultValue=false)]
        public bool? StatusRedeemedConfirmed { get; set; }

        /// <summary>
        /// &lt;p&gt;A flag to indicate that the status &#39;not found&#39; was confirmed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the status &#39;not found&#39; was confirmed.&lt;/p&gt;</value>
        [DataMember(Name="statusNotFoundConfirmed", EmitDefaultValue=false)]
        public bool? StatusNotFoundConfirmed { get; set; }

        /// <summary>
        /// &lt;p&gt;A complete transaction holding the retrieved empties return transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A complete transaction holding the retrieved empties return transaction.&lt;/p&gt;</value>
        [DataMember(Name="emptiesTransaction", EmitDefaultValue=false)]
        public ComGkSoftwareGkrApiTxpoolDtoCompleteTransaction EmptiesTransaction { get; set; }

        /// <summary>
        /// &lt;p&gt;The alternative tax information for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax information for updating the tax group.&lt;/p&gt;</value>
        [DataMember(Name="alternativeTaxInfos", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessFlowsAlternativeTaxInfos AlternativeTaxInfos { get; set; }

        /// <summary>
        /// &lt;p&gt;The retail store identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store identifier.&lt;/p&gt;</value>
        [DataMember(Name="storeId", EmitDefaultValue=false)]
        public string StoreId { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest {\n");
            sb.Append("  PositionOperationConfig: ").Append(PositionOperationConfig).Append("\n");
            sb.Append("  ReturnMode: ").Append(ReturnMode).Append("\n");
            sb.Append("  CollectiveNumber: ").Append(CollectiveNumber).Append("\n");
            sb.Append("  TransactionIdentifier: ").Append(TransactionIdentifier).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  Amount1: ").Append(Amount1).Append("\n");
            sb.Append("  Amount2: ").Append(Amount2).Append("\n");
            sb.Append("  OneWayItemNumber: ").Append(OneWayItemNumber).Append("\n");
            sb.Append("  MultiWayItemNumber: ").Append(MultiWayItemNumber).Append("\n");
            sb.Append("  DepositType1: ").Append(DepositType1).Append("\n");
            sb.Append("  DepositType2: ").Append(DepositType2).Append("\n");
            sb.Append("  AddAsOneLineItem: ").Append(AddAsOneLineItem).Append("\n");
            sb.Append("  StatusOfflineConfirmed: ").Append(StatusOfflineConfirmed).Append("\n");
            sb.Append("  StatusRedeemedConfirmed: ").Append(StatusRedeemedConfirmed).Append("\n");
            sb.Append("  StatusNotFoundConfirmed: ").Append(StatusNotFoundConfirmed).Append("\n");
            sb.Append("  EmptiesTransaction: ").Append(EmptiesTransaction).Append("\n");
            sb.Append("  AlternativeTaxInfos: ").Append(AlternativeTaxInfos).Append("\n");
            sb.Append("  StoreId: ").Append(StoreId).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionRegisterEmptiesTransactionRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PositionOperationConfig == input.PositionOperationConfig ||
                    (this.PositionOperationConfig != null &&
                    this.PositionOperationConfig.Equals(input.PositionOperationConfig))
                ) && 
                (
                    this.ReturnMode == input.ReturnMode ||
                    (this.ReturnMode != null &&
                    this.ReturnMode.Equals(input.ReturnMode))
                ) && 
                (
                    this.CollectiveNumber == input.CollectiveNumber ||
                    (this.CollectiveNumber != null &&
                    this.CollectiveNumber.Equals(input.CollectiveNumber))
                ) && 
                (
                    this.TransactionIdentifier == input.TransactionIdentifier ||
                    (this.TransactionIdentifier != null &&
                    this.TransactionIdentifier.Equals(input.TransactionIdentifier))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.Amount1 == input.Amount1 ||
                    (this.Amount1 != null &&
                    this.Amount1.Equals(input.Amount1))
                ) && 
                (
                    this.Amount2 == input.Amount2 ||
                    (this.Amount2 != null &&
                    this.Amount2.Equals(input.Amount2))
                ) && 
                (
                    this.OneWayItemNumber == input.OneWayItemNumber ||
                    (this.OneWayItemNumber != null &&
                    this.OneWayItemNumber.Equals(input.OneWayItemNumber))
                ) && 
                (
                    this.MultiWayItemNumber == input.MultiWayItemNumber ||
                    (this.MultiWayItemNumber != null &&
                    this.MultiWayItemNumber.Equals(input.MultiWayItemNumber))
                ) && 
                (
                    this.DepositType1 == input.DepositType1 ||
                    (this.DepositType1 != null &&
                    this.DepositType1.Equals(input.DepositType1))
                ) && 
                (
                    this.DepositType2 == input.DepositType2 ||
                    (this.DepositType2 != null &&
                    this.DepositType2.Equals(input.DepositType2))
                ) && 
                (
                    this.AddAsOneLineItem == input.AddAsOneLineItem ||
                    (this.AddAsOneLineItem != null &&
                    this.AddAsOneLineItem.Equals(input.AddAsOneLineItem))
                ) && 
                (
                    this.StatusOfflineConfirmed == input.StatusOfflineConfirmed ||
                    (this.StatusOfflineConfirmed != null &&
                    this.StatusOfflineConfirmed.Equals(input.StatusOfflineConfirmed))
                ) && 
                (
                    this.StatusRedeemedConfirmed == input.StatusRedeemedConfirmed ||
                    (this.StatusRedeemedConfirmed != null &&
                    this.StatusRedeemedConfirmed.Equals(input.StatusRedeemedConfirmed))
                ) && 
                (
                    this.StatusNotFoundConfirmed == input.StatusNotFoundConfirmed ||
                    (this.StatusNotFoundConfirmed != null &&
                    this.StatusNotFoundConfirmed.Equals(input.StatusNotFoundConfirmed))
                ) && 
                (
                    this.EmptiesTransaction == input.EmptiesTransaction ||
                    (this.EmptiesTransaction != null &&
                    this.EmptiesTransaction.Equals(input.EmptiesTransaction))
                ) && 
                (
                    this.AlternativeTaxInfos == input.AlternativeTaxInfos ||
                    (this.AlternativeTaxInfos != null &&
                    this.AlternativeTaxInfos.Equals(input.AlternativeTaxInfos))
                ) && 
                (
                    this.StoreId == input.StoreId ||
                    (this.StoreId != null &&
                    this.StoreId.Equals(input.StoreId))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PositionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PositionOperationConfig.GetHashCode();
                if (this.ReturnMode != null)
                    hashCode = hashCode * 59 + this.ReturnMode.GetHashCode();
                if (this.CollectiveNumber != null)
                    hashCode = hashCode * 59 + this.CollectiveNumber.GetHashCode();
                if (this.TransactionIdentifier != null)
                    hashCode = hashCode * 59 + this.TransactionIdentifier.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.Amount1 != null)
                    hashCode = hashCode * 59 + this.Amount1.GetHashCode();
                if (this.Amount2 != null)
                    hashCode = hashCode * 59 + this.Amount2.GetHashCode();
                if (this.OneWayItemNumber != null)
                    hashCode = hashCode * 59 + this.OneWayItemNumber.GetHashCode();
                if (this.MultiWayItemNumber != null)
                    hashCode = hashCode * 59 + this.MultiWayItemNumber.GetHashCode();
                if (this.DepositType1 != null)
                    hashCode = hashCode * 59 + this.DepositType1.GetHashCode();
                if (this.DepositType2 != null)
                    hashCode = hashCode * 59 + this.DepositType2.GetHashCode();
                if (this.AddAsOneLineItem != null)
                    hashCode = hashCode * 59 + this.AddAsOneLineItem.GetHashCode();
                if (this.StatusOfflineConfirmed != null)
                    hashCode = hashCode * 59 + this.StatusOfflineConfirmed.GetHashCode();
                if (this.StatusRedeemedConfirmed != null)
                    hashCode = hashCode * 59 + this.StatusRedeemedConfirmed.GetHashCode();
                if (this.StatusNotFoundConfirmed != null)
                    hashCode = hashCode * 59 + this.StatusNotFoundConfirmed.GetHashCode();
                if (this.EmptiesTransaction != null)
                    hashCode = hashCode * 59 + this.EmptiesTransaction.GetHashCode();
                if (this.AlternativeTaxInfos != null)
                    hashCode = hashCode * 59 + this.AlternativeTaxInfos.GetHashCode();
                if (this.StoreId != null)
                    hashCode = hashCode * 59 + this.StoreId.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
