/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SalesPersonNumberRequest &lt;p&gt;Domain object for SalesPersonNumberRequest&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;The Seller Relation Method.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The Seller Relation Method.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SellerRelationMethodEnum
        {
            
            /// <summary>
            /// Enum CurrentLineItemOnly for value: CurrentLineItemOnly
            /// </summary>
            [EnumMember(Value = "CurrentLineItemOnly")]
            CurrentLineItemOnly = 1,
            
            /// <summary>
            /// Enum CurrentAndFollowingLineItemsOfCurrentTransaction for value: CurrentAndFollowingLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "CurrentAndFollowingLineItemsOfCurrentTransaction")]
            CurrentAndFollowingLineItemsOfCurrentTransaction = 2,
            
            /// <summary>
            /// Enum CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions for value: CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions
            /// </summary>
            [EnumMember(Value = "CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions")]
            CurrentAndFollowingLineItemsOfCurrentAndFollowingTransactions = 3,
            
            /// <summary>
            /// Enum AllLineItemsOfCurrentTransaction for value: AllLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "AllLineItemsOfCurrentTransaction")]
            AllLineItemsOfCurrentTransaction = 4,
            
            /// <summary>
            /// Enum FollowingLineItemsOfCurrentTransaction for value: FollowingLineItemsOfCurrentTransaction
            /// </summary>
            [EnumMember(Value = "FollowingLineItemsOfCurrentTransaction")]
            FollowingLineItemsOfCurrentTransaction = 5,
            
            /// <summary>
            /// Enum FollowingLineItemsOfCurrentAndFollowingTransactions for value: FollowingLineItemsOfCurrentAndFollowingTransactions
            /// </summary>
            [EnumMember(Value = "FollowingLineItemsOfCurrentAndFollowingTransactions")]
            FollowingLineItemsOfCurrentAndFollowingTransactions = 6
        }

        /// <summary>
        /// &lt;p&gt;The Seller Relation Method.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The Seller Relation Method.&lt;/p&gt;</value>
        [DataMember(Name="sellerRelationMethod", EmitDefaultValue=false)]
        public SellerRelationMethodEnum? SellerRelationMethod { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest" /> class.
        /// </summary>
        /// <param name="operationConfiguration">&lt;p&gt;The position operation configuration.&lt;/p&gt;.</param>
        /// <param name="lineItemKey">&lt;p&gt;The line item key the operation refers to.&lt;/p&gt;.</param>
        /// <param name="returnMode">&lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt; (required).</param>
        /// <param name="emptiesReturnMode">&lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt; (required).</param>
        /// <param name="createReturnReceipt">&lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt; (required).</param>
        /// <param name="salesPersonNumber">&lt;p&gt;set sales Person Number (for Entered salesperson number).&lt;/p&gt;.</param>
        /// <param name="sellerRelationMethod">&lt;p&gt;The Seller Relation Method.&lt;/p&gt;.</param>
        /// <param name="sellerAssignmentNeeded">&lt;p&gt;Defines whether the input of a sellerId is needed.&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey lineItemKey = default(ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey), bool? returnMode = default(bool?), bool? emptiesReturnMode = default(bool?), bool? createReturnReceipt = default(bool?), string salesPersonNumber = default(string), SellerRelationMethodEnum? sellerRelationMethod = default(SellerRelationMethodEnum?), bool? sellerAssignmentNeeded = default(bool?), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            // to ensure "returnMode" is required (not null)
            if (returnMode == null)
            {
                throw new InvalidDataException("returnMode is a required property for ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest and cannot be null");
            }
            else
            {
                this.ReturnMode = returnMode;
            }
            // to ensure "emptiesReturnMode" is required (not null)
            if (emptiesReturnMode == null)
            {
                throw new InvalidDataException("emptiesReturnMode is a required property for ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest and cannot be null");
            }
            else
            {
                this.EmptiesReturnMode = emptiesReturnMode;
            }
            // to ensure "createReturnReceipt" is required (not null)
            if (createReturnReceipt == null)
            {
                throw new InvalidDataException("createReturnReceipt is a required property for ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest and cannot be null");
            }
            else
            {
                this.CreateReturnReceipt = createReturnReceipt;
            }
            this.OperationConfiguration = operationConfiguration;
            this.LineItemKey = lineItemKey;
            this.SalesPersonNumber = salesPersonNumber;
            this.SellerRelationMethod = sellerRelationMethod;
            this.SellerAssignmentNeeded = sellerAssignmentNeeded;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The position operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration.&lt;/p&gt;</value>
        [DataMember(Name="operationConfiguration", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig OperationConfiguration { get; set; }

        /// <summary>
        /// &lt;p&gt;The line item key the operation refers to.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item key the operation refers to.&lt;/p&gt;</value>
        [DataMember(Name="lineItemKey", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey LineItemKey { get; set; }

        /// <summary>
        /// &lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;</value>
        [DataMember(Name="returnMode", EmitDefaultValue=false)]
        public bool? ReturnMode { get; set; }

        /// <summary>
        /// &lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;</value>
        [DataMember(Name="emptiesReturnMode", EmitDefaultValue=false)]
        public bool? EmptiesReturnMode { get; set; }

        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;</value>
        [DataMember(Name="createReturnReceipt", EmitDefaultValue=false)]
        public bool? CreateReturnReceipt { get; set; }

        /// <summary>
        /// &lt;p&gt;set sales Person Number (for Entered salesperson number).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;set sales Person Number (for Entered salesperson number).&lt;/p&gt;</value>
        [DataMember(Name="salesPersonNumber", EmitDefaultValue=false)]
        public string SalesPersonNumber { get; set; }


        /// <summary>
        /// &lt;p&gt;Defines whether the input of a sellerId is needed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines whether the input of a sellerId is needed.&lt;/p&gt;</value>
        [DataMember(Name="sellerAssignmentNeeded", EmitDefaultValue=false)]
        public bool? SellerAssignmentNeeded { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest {\n");
            sb.Append("  OperationConfiguration: ").Append(OperationConfiguration).Append("\n");
            sb.Append("  LineItemKey: ").Append(LineItemKey).Append("\n");
            sb.Append("  ReturnMode: ").Append(ReturnMode).Append("\n");
            sb.Append("  EmptiesReturnMode: ").Append(EmptiesReturnMode).Append("\n");
            sb.Append("  CreateReturnReceipt: ").Append(CreateReturnReceipt).Append("\n");
            sb.Append("  SalesPersonNumber: ").Append(SalesPersonNumber).Append("\n");
            sb.Append("  SellerRelationMethod: ").Append(SellerRelationMethod).Append("\n");
            sb.Append("  SellerAssignmentNeeded: ").Append(SellerAssignmentNeeded).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionSalesPersonNumberRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OperationConfiguration == input.OperationConfiguration ||
                    (this.OperationConfiguration != null &&
                    this.OperationConfiguration.Equals(input.OperationConfiguration))
                ) && 
                (
                    this.LineItemKey == input.LineItemKey ||
                    (this.LineItemKey != null &&
                    this.LineItemKey.Equals(input.LineItemKey))
                ) && 
                (
                    this.ReturnMode == input.ReturnMode ||
                    (this.ReturnMode != null &&
                    this.ReturnMode.Equals(input.ReturnMode))
                ) && 
                (
                    this.EmptiesReturnMode == input.EmptiesReturnMode ||
                    (this.EmptiesReturnMode != null &&
                    this.EmptiesReturnMode.Equals(input.EmptiesReturnMode))
                ) && 
                (
                    this.CreateReturnReceipt == input.CreateReturnReceipt ||
                    (this.CreateReturnReceipt != null &&
                    this.CreateReturnReceipt.Equals(input.CreateReturnReceipt))
                ) && 
                (
                    this.SalesPersonNumber == input.SalesPersonNumber ||
                    (this.SalesPersonNumber != null &&
                    this.SalesPersonNumber.Equals(input.SalesPersonNumber))
                ) && 
                (
                    this.SellerRelationMethod == input.SellerRelationMethod ||
                    (this.SellerRelationMethod != null &&
                    this.SellerRelationMethod.Equals(input.SellerRelationMethod))
                ) && 
                (
                    this.SellerAssignmentNeeded == input.SellerAssignmentNeeded ||
                    (this.SellerAssignmentNeeded != null &&
                    this.SellerAssignmentNeeded.Equals(input.SellerAssignmentNeeded))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OperationConfiguration != null)
                    hashCode = hashCode * 59 + this.OperationConfiguration.GetHashCode();
                if (this.LineItemKey != null)
                    hashCode = hashCode * 59 + this.LineItemKey.GetHashCode();
                if (this.ReturnMode != null)
                    hashCode = hashCode * 59 + this.ReturnMode.GetHashCode();
                if (this.EmptiesReturnMode != null)
                    hashCode = hashCode * 59 + this.EmptiesReturnMode.GetHashCode();
                if (this.CreateReturnReceipt != null)
                    hashCode = hashCode * 59 + this.CreateReturnReceipt.GetHashCode();
                if (this.SalesPersonNumber != null)
                    hashCode = hashCode * 59 + this.SalesPersonNumber.GetHashCode();
                if (this.SellerRelationMethod != null)
                    hashCode = hashCode * 59 + this.SellerRelationMethod.GetHashCode();
                if (this.SellerAssignmentNeeded != null)
                    hashCode = hashCode * 59 + this.SellerAssignmentNeeded.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
