/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// VoidTenderLineItemRequest &lt;p&gt;Domain object for VoidTenderLineItem Request&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest :  IEquatable<ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TenderGroupCodeEnum
        {
            
            /// <summary>
            /// Enum CASH for value: CASH
            /// </summary>
            [EnumMember(Value = "CASH")]
            CASH = 1,
            
            /// <summary>
            /// Enum TERMINAL for value: TERMINAL
            /// </summary>
            [EnumMember(Value = "TERMINAL")]
            TERMINAL = 2,
            
            /// <summary>
            /// Enum GIFTCERT for value: GIFT_CERT
            /// </summary>
            [EnumMember(Value = "GIFT_CERT")]
            GIFTCERT = 3,
            
            /// <summary>
            /// Enum COUPON for value: COUPON
            /// </summary>
            [EnumMember(Value = "COUPON")]
            COUPON = 4,
            
            /// <summary>
            /// Enum CHEQUE for value: CHEQUE
            /// </summary>
            [EnumMember(Value = "CHEQUE")]
            CHEQUE = 5,
            
            /// <summary>
            /// Enum CREDIT for value: CREDIT
            /// </summary>
            [EnumMember(Value = "CREDIT")]
            CREDIT = 6,
            
            /// <summary>
            /// Enum PROMOTION for value: PROMOTION
            /// </summary>
            [EnumMember(Value = "PROMOTION")]
            PROMOTION = 7,
            
            /// <summary>
            /// Enum POINTS for value: POINTS
            /// </summary>
            [EnumMember(Value = "POINTS")]
            POINTS = 8,
            
            /// <summary>
            /// Enum CASHENGINE for value: CASHENGINE
            /// </summary>
            [EnumMember(Value = "CASHENGINE")]
            CASHENGINE = 9
        }

        /// <summary>
        /// &lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;</value>
        [DataMember(Name="tenderGroupCode", EmitDefaultValue=false)]
        public TenderGroupCodeEnum? TenderGroupCode { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest" /> class.
        /// </summary>
        /// <param name="positionOperationConfig">&lt;p&gt;The operation configuration.&lt;/p&gt;.</param>
        /// <param name="retailTransactionLineItemKey">&lt;p&gt;The key of the line item to void&lt;/p&gt;.</param>
        /// <param name="voidTypeCode">&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;.</param>
        /// <param name="tenderGroupCode">&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;.</param>
        /// <param name="terminalTenderCancellationAuthorizationKey">&lt;p&gt;Terminal tender authorization key.&lt;/p&gt;.</param>
        /// <param name="pointsCancellationTransactionId">&lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;.</param>
        /// <param name="giftCertCancellationTransactionId">&lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;.</param>
        /// <param name="xXCustom08">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom10">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom09">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom07">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom05">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom06">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom11">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom12">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom13">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom14">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom15">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom03">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom02">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom04">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        /// <param name="xXCustom01">&lt;p&gt;Customizable information&lt;/p&gt;.</param>
        public ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig positionOperationConfig = default(ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig), ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey retailTransactionLineItemKey = default(ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey), string voidTypeCode = default(string), TenderGroupCodeEnum? tenderGroupCode = default(TenderGroupCodeEnum?), ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey terminalTenderCancellationAuthorizationKey = default(ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey), string pointsCancellationTransactionId = default(string), string giftCertCancellationTransactionId = default(string), string xXCustom08 = default(string), string xXCustom10 = default(string), string xXCustom09 = default(string), string xXCustom07 = default(string), string xXCustom05 = default(string), string xXCustom06 = default(string), string xXCustom11 = default(string), string xXCustom12 = default(string), string xXCustom13 = default(string), string xXCustom14 = default(string), string xXCustom15 = default(string), string xXCustom03 = default(string), string xXCustom02 = default(string), string xXCustom04 = default(string), string xXCustom01 = default(string))
        {
            this.PositionOperationConfig = positionOperationConfig;
            this.RetailTransactionLineItemKey = retailTransactionLineItemKey;
            this.VoidTypeCode = voidTypeCode;
            this.TenderGroupCode = tenderGroupCode;
            this.TerminalTenderCancellationAuthorizationKey = terminalTenderCancellationAuthorizationKey;
            this.PointsCancellationTransactionId = pointsCancellationTransactionId;
            this.GiftCertCancellationTransactionId = giftCertCancellationTransactionId;
            this.XXCustom08 = xXCustom08;
            this.XXCustom10 = xXCustom10;
            this.XXCustom09 = xXCustom09;
            this.XXCustom07 = xXCustom07;
            this.XXCustom05 = xXCustom05;
            this.XXCustom06 = xXCustom06;
            this.XXCustom11 = xXCustom11;
            this.XXCustom12 = xXCustom12;
            this.XXCustom13 = xXCustom13;
            this.XXCustom14 = xXCustom14;
            this.XXCustom15 = xXCustom15;
            this.XXCustom03 = xXCustom03;
            this.XXCustom02 = xXCustom02;
            this.XXCustom04 = xXCustom04;
            this.XXCustom01 = xXCustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operation configuration.&lt;/p&gt;</value>
        [DataMember(Name="positionOperationConfig", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig PositionOperationConfig { get; set; }

        /// <summary>
        /// &lt;p&gt;The key of the line item to void&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The key of the line item to void&lt;/p&gt;</value>
        [DataMember(Name="retailTransactionLineItemKey", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey RetailTransactionLineItemKey { get; set; }

        /// <summary>
        /// &lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Describes whether the line item was cancelled immediately after registering it, voided by another line item or internally voided.&lt;/p&gt;</value>
        [DataMember(Name="voidTypeCode", EmitDefaultValue=false)]
        public string VoidTypeCode { get; set; }


        /// <summary>
        /// &lt;p&gt;Terminal tender authorization key.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Terminal tender authorization key.&lt;/p&gt;</value>
        [DataMember(Name="terminalTenderCancellationAuthorizationKey", EmitDefaultValue=false)]
        public ComGkSoftwarePosApiModelDomAppServicesTransactionTenderAuthorizationKey TerminalTenderCancellationAuthorizationKey { get; set; }

        /// <summary>
        /// &lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;</value>
        [DataMember(Name="pointsCancellationTransactionId", EmitDefaultValue=false)]
        public string PointsCancellationTransactionId { get; set; }

        /// <summary>
        /// &lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A gift certificate service result, it is filled only if a gift certificate line item is canceled online&lt;/p&gt;</value>
        [DataMember(Name="giftCertCancellationTransactionId", EmitDefaultValue=false)]
        public string GiftCertCancellationTransactionId { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom08", EmitDefaultValue=false)]
        public string XXCustom08 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom10", EmitDefaultValue=false)]
        public string XXCustom10 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom09", EmitDefaultValue=false)]
        public string XXCustom09 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom07", EmitDefaultValue=false)]
        public string XXCustom07 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom05", EmitDefaultValue=false)]
        public string XXCustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom06", EmitDefaultValue=false)]
        public string XXCustom06 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom11", EmitDefaultValue=false)]
        public string XXCustom11 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom12", EmitDefaultValue=false)]
        public string XXCustom12 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom13", EmitDefaultValue=false)]
        public string XXCustom13 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom14", EmitDefaultValue=false)]
        public string XXCustom14 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom15", EmitDefaultValue=false)]
        public string XXCustom15 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom03", EmitDefaultValue=false)]
        public string XXCustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom02", EmitDefaultValue=false)]
        public string XXCustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom04", EmitDefaultValue=false)]
        public string XXCustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        [DataMember(Name="xXCustom01", EmitDefaultValue=false)]
        public string XXCustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest {\n");
            sb.Append("  PositionOperationConfig: ").Append(PositionOperationConfig).Append("\n");
            sb.Append("  RetailTransactionLineItemKey: ").Append(RetailTransactionLineItemKey).Append("\n");
            sb.Append("  VoidTypeCode: ").Append(VoidTypeCode).Append("\n");
            sb.Append("  TenderGroupCode: ").Append(TenderGroupCode).Append("\n");
            sb.Append("  TerminalTenderCancellationAuthorizationKey: ").Append(TerminalTenderCancellationAuthorizationKey).Append("\n");
            sb.Append("  PointsCancellationTransactionId: ").Append(PointsCancellationTransactionId).Append("\n");
            sb.Append("  GiftCertCancellationTransactionId: ").Append(GiftCertCancellationTransactionId).Append("\n");
            sb.Append("  XXCustom08: ").Append(XXCustom08).Append("\n");
            sb.Append("  XXCustom10: ").Append(XXCustom10).Append("\n");
            sb.Append("  XXCustom09: ").Append(XXCustom09).Append("\n");
            sb.Append("  XXCustom07: ").Append(XXCustom07).Append("\n");
            sb.Append("  XXCustom05: ").Append(XXCustom05).Append("\n");
            sb.Append("  XXCustom06: ").Append(XXCustom06).Append("\n");
            sb.Append("  XXCustom11: ").Append(XXCustom11).Append("\n");
            sb.Append("  XXCustom12: ").Append(XXCustom12).Append("\n");
            sb.Append("  XXCustom13: ").Append(XXCustom13).Append("\n");
            sb.Append("  XXCustom14: ").Append(XXCustom14).Append("\n");
            sb.Append("  XXCustom15: ").Append(XXCustom15).Append("\n");
            sb.Append("  XXCustom03: ").Append(XXCustom03).Append("\n");
            sb.Append("  XXCustom02: ").Append(XXCustom02).Append("\n");
            sb.Append("  XXCustom04: ").Append(XXCustom04).Append("\n");
            sb.Append("  XXCustom01: ").Append(XXCustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest);
        }

        /// <summary>
        /// Returns true if ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwarePosApiServiceTransactionVoidTenderLineItemRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PositionOperationConfig == input.PositionOperationConfig ||
                    (this.PositionOperationConfig != null &&
                    this.PositionOperationConfig.Equals(input.PositionOperationConfig))
                ) && 
                (
                    this.RetailTransactionLineItemKey == input.RetailTransactionLineItemKey ||
                    (this.RetailTransactionLineItemKey != null &&
                    this.RetailTransactionLineItemKey.Equals(input.RetailTransactionLineItemKey))
                ) && 
                (
                    this.VoidTypeCode == input.VoidTypeCode ||
                    (this.VoidTypeCode != null &&
                    this.VoidTypeCode.Equals(input.VoidTypeCode))
                ) && 
                (
                    this.TenderGroupCode == input.TenderGroupCode ||
                    (this.TenderGroupCode != null &&
                    this.TenderGroupCode.Equals(input.TenderGroupCode))
                ) && 
                (
                    this.TerminalTenderCancellationAuthorizationKey == input.TerminalTenderCancellationAuthorizationKey ||
                    (this.TerminalTenderCancellationAuthorizationKey != null &&
                    this.TerminalTenderCancellationAuthorizationKey.Equals(input.TerminalTenderCancellationAuthorizationKey))
                ) && 
                (
                    this.PointsCancellationTransactionId == input.PointsCancellationTransactionId ||
                    (this.PointsCancellationTransactionId != null &&
                    this.PointsCancellationTransactionId.Equals(input.PointsCancellationTransactionId))
                ) && 
                (
                    this.GiftCertCancellationTransactionId == input.GiftCertCancellationTransactionId ||
                    (this.GiftCertCancellationTransactionId != null &&
                    this.GiftCertCancellationTransactionId.Equals(input.GiftCertCancellationTransactionId))
                ) && 
                (
                    this.XXCustom08 == input.XXCustom08 ||
                    (this.XXCustom08 != null &&
                    this.XXCustom08.Equals(input.XXCustom08))
                ) && 
                (
                    this.XXCustom10 == input.XXCustom10 ||
                    (this.XXCustom10 != null &&
                    this.XXCustom10.Equals(input.XXCustom10))
                ) && 
                (
                    this.XXCustom09 == input.XXCustom09 ||
                    (this.XXCustom09 != null &&
                    this.XXCustom09.Equals(input.XXCustom09))
                ) && 
                (
                    this.XXCustom07 == input.XXCustom07 ||
                    (this.XXCustom07 != null &&
                    this.XXCustom07.Equals(input.XXCustom07))
                ) && 
                (
                    this.XXCustom05 == input.XXCustom05 ||
                    (this.XXCustom05 != null &&
                    this.XXCustom05.Equals(input.XXCustom05))
                ) && 
                (
                    this.XXCustom06 == input.XXCustom06 ||
                    (this.XXCustom06 != null &&
                    this.XXCustom06.Equals(input.XXCustom06))
                ) && 
                (
                    this.XXCustom11 == input.XXCustom11 ||
                    (this.XXCustom11 != null &&
                    this.XXCustom11.Equals(input.XXCustom11))
                ) && 
                (
                    this.XXCustom12 == input.XXCustom12 ||
                    (this.XXCustom12 != null &&
                    this.XXCustom12.Equals(input.XXCustom12))
                ) && 
                (
                    this.XXCustom13 == input.XXCustom13 ||
                    (this.XXCustom13 != null &&
                    this.XXCustom13.Equals(input.XXCustom13))
                ) && 
                (
                    this.XXCustom14 == input.XXCustom14 ||
                    (this.XXCustom14 != null &&
                    this.XXCustom14.Equals(input.XXCustom14))
                ) && 
                (
                    this.XXCustom15 == input.XXCustom15 ||
                    (this.XXCustom15 != null &&
                    this.XXCustom15.Equals(input.XXCustom15))
                ) && 
                (
                    this.XXCustom03 == input.XXCustom03 ||
                    (this.XXCustom03 != null &&
                    this.XXCustom03.Equals(input.XXCustom03))
                ) && 
                (
                    this.XXCustom02 == input.XXCustom02 ||
                    (this.XXCustom02 != null &&
                    this.XXCustom02.Equals(input.XXCustom02))
                ) && 
                (
                    this.XXCustom04 == input.XXCustom04 ||
                    (this.XXCustom04 != null &&
                    this.XXCustom04.Equals(input.XXCustom04))
                ) && 
                (
                    this.XXCustom01 == input.XXCustom01 ||
                    (this.XXCustom01 != null &&
                    this.XXCustom01.Equals(input.XXCustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PositionOperationConfig != null)
                    hashCode = hashCode * 59 + this.PositionOperationConfig.GetHashCode();
                if (this.RetailTransactionLineItemKey != null)
                    hashCode = hashCode * 59 + this.RetailTransactionLineItemKey.GetHashCode();
                if (this.VoidTypeCode != null)
                    hashCode = hashCode * 59 + this.VoidTypeCode.GetHashCode();
                if (this.TenderGroupCode != null)
                    hashCode = hashCode * 59 + this.TenderGroupCode.GetHashCode();
                if (this.TerminalTenderCancellationAuthorizationKey != null)
                    hashCode = hashCode * 59 + this.TerminalTenderCancellationAuthorizationKey.GetHashCode();
                if (this.PointsCancellationTransactionId != null)
                    hashCode = hashCode * 59 + this.PointsCancellationTransactionId.GetHashCode();
                if (this.GiftCertCancellationTransactionId != null)
                    hashCode = hashCode * 59 + this.GiftCertCancellationTransactionId.GetHashCode();
                if (this.XXCustom08 != null)
                    hashCode = hashCode * 59 + this.XXCustom08.GetHashCode();
                if (this.XXCustom10 != null)
                    hashCode = hashCode * 59 + this.XXCustom10.GetHashCode();
                if (this.XXCustom09 != null)
                    hashCode = hashCode * 59 + this.XXCustom09.GetHashCode();
                if (this.XXCustom07 != null)
                    hashCode = hashCode * 59 + this.XXCustom07.GetHashCode();
                if (this.XXCustom05 != null)
                    hashCode = hashCode * 59 + this.XXCustom05.GetHashCode();
                if (this.XXCustom06 != null)
                    hashCode = hashCode * 59 + this.XXCustom06.GetHashCode();
                if (this.XXCustom11 != null)
                    hashCode = hashCode * 59 + this.XXCustom11.GetHashCode();
                if (this.XXCustom12 != null)
                    hashCode = hashCode * 59 + this.XXCustom12.GetHashCode();
                if (this.XXCustom13 != null)
                    hashCode = hashCode * 59 + this.XXCustom13.GetHashCode();
                if (this.XXCustom14 != null)
                    hashCode = hashCode * 59 + this.XXCustom14.GetHashCode();
                if (this.XXCustom15 != null)
                    hashCode = hashCode * 59 + this.XXCustom15.GetHashCode();
                if (this.XXCustom03 != null)
                    hashCode = hashCode * 59 + this.XXCustom03.GetHashCode();
                if (this.XXCustom02 != null)
                    hashCode = hashCode * 59 + this.XXCustom02.GetHashCode();
                if (this.XXCustom04 != null)
                    hashCode = hashCode * 59 + this.XXCustom04.GetHashCode();
                if (this.XXCustom01 != null)
                    hashCode = hashCode * 59 + this.XXCustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
