/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// MhgSO &lt;p&gt;Merchandise hierarchy group definition.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterData_MerchandiseHierarchyGroup.xml and masterData_BusinessUnit.xml.&lt;br /&gt; The definition of merchandise hierarchy groups is imported from masterData_MerchandiseHierarchyGroup.xml. The masterData_BusinessUnit.xml allows import additional details. If the MHG from masterData_BusinessUnit.xml does not exist, it is created.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO :  IEquatable<ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO" /> class.
        /// </summary>
        /// <param name="merchandiseHierarchyGroupID">&lt;p&gt;Identifier of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.MerchandiseHierarchyGroupID&lt;br /&gt; masterData_BusinessUnit.xml: BusinessUnit.MerchandiseHierarchyGroupDetail.MerchandiseHierarchyGroupID.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="merchandiseHierarchyGroupIDQualifier">&lt;p&gt;merchandise HierarchyGroup ID Qualifier&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="name">&lt;p&gt;The name of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: first 40 characters from MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="description">&lt;p&gt;The description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="taxGroupID">&lt;p&gt;The tax group assigned to the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TaxGroupID&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="itemSellingRuleID">&lt;p&gt;Reference to the ItemSellingRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemSellingRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="itemMerchandiseManagementRuleID">&lt;p&gt;Reference to the ItemMerchandiseManagementRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from MerchandiseHierarchyGroup.DefaultLayoutClass and MerchandiseHierarchyGroup.DefaultLabelCount.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.NegativePositionFlag.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="packageID">&lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="merchandiseHierarchyLevelID">&lt;p&gt;A unique system assigned identifier for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported. Generated for the levelName.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="levelName">&lt;p&gt;Name for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.LevelName&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="tid">&lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="translationList">&lt;p&gt;List of translations for description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TranslationList&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom05">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_05&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_03&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_02&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom04">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_04&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_01&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO(string merchandiseHierarchyGroupID = default(string), string merchandiseHierarchyGroupIDQualifier = default(string), string name = default(string), string description = default(string), string taxGroupID = default(string), string itemSellingRuleID = default(string), string itemMerchandiseManagementRuleID = default(string), string packageID = default(string), string merchandiseHierarchyLevelID = default(string), string levelName = default(string), string tid = default(string), List<ComGkSoftwareSweeSesApiServerMdMhgDtoSoMHGTranslationSO> translationList = default(List<ComGkSoftwareSweeSesApiServerMdMhgDtoSoMHGTranslationSO>), string xxcustom05 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom01 = default(string))
        {
            // to ensure "merchandiseHierarchyGroupID" is required (not null)
            if (merchandiseHierarchyGroupID == null)
            {
                throw new InvalidDataException("merchandiseHierarchyGroupID is a required property for ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO and cannot be null");
            }
            else
            {
                this.MerchandiseHierarchyGroupID = merchandiseHierarchyGroupID;
            }
            this.MerchandiseHierarchyGroupIDQualifier = merchandiseHierarchyGroupIDQualifier;
            this.Name = name;
            this.Description = description;
            this.TaxGroupID = taxGroupID;
            this.ItemSellingRuleID = itemSellingRuleID;
            this.ItemMerchandiseManagementRuleID = itemMerchandiseManagementRuleID;
            this.PackageID = packageID;
            this.MerchandiseHierarchyLevelID = merchandiseHierarchyLevelID;
            this.LevelName = levelName;
            this.Tid = tid;
            this.TranslationList = translationList;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;Identifier of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.MerchandiseHierarchyGroupID&lt;br /&gt; masterData_BusinessUnit.xml: BusinessUnit.MerchandiseHierarchyGroupDetail.MerchandiseHierarchyGroupID.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Identifier of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.MerchandiseHierarchyGroupID&lt;br /&gt; masterData_BusinessUnit.xml: BusinessUnit.MerchandiseHierarchyGroupDetail.MerchandiseHierarchyGroupID.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="merchandiseHierarchyGroupID", EmitDefaultValue=false)]
        public string MerchandiseHierarchyGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;merchandise HierarchyGroup ID Qualifier&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;merchandise HierarchyGroup ID Qualifier&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="merchandiseHierarchyGroupIDQualifier", EmitDefaultValue=false)]
        public string MerchandiseHierarchyGroupIDQualifier { get; set; }

        /// <summary>
        /// &lt;p&gt;The name of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: first 40 characters from MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The name of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: first 40 characters from MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// &lt;p&gt;The description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// &lt;p&gt;The tax group assigned to the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TaxGroupID&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tax group assigned to the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TaxGroupID&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="taxGroupID", EmitDefaultValue=false)]
        public string TaxGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Reference to the ItemSellingRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemSellingRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the ItemSellingRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemSellingRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="itemSellingRuleID", EmitDefaultValue=false)]
        public string ItemSellingRuleID { get; set; }

        /// <summary>
        /// &lt;p&gt;Reference to the ItemMerchandiseManagementRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from MerchandiseHierarchyGroup.DefaultLayoutClass and MerchandiseHierarchyGroup.DefaultLabelCount.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.NegativePositionFlag.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the ItemMerchandiseManagementRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from MerchandiseHierarchyGroup.DefaultLayoutClass and MerchandiseHierarchyGroup.DefaultLabelCount.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.NegativePositionFlag.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="itemMerchandiseManagementRuleID", EmitDefaultValue=false)]
        public string ItemMerchandiseManagementRuleID { get; set; }

        /// <summary>
        /// &lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="packageID", EmitDefaultValue=false)]
        public string PackageID { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported. Generated for the levelName.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported. Generated for the levelName.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="merchandiseHierarchyLevelID", EmitDefaultValue=false)]
        public string MerchandiseHierarchyLevelID { get; set; }

        /// <summary>
        /// &lt;p&gt;Name for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.LevelName&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.LevelName&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="levelName", EmitDefaultValue=false)]
        public string LevelName { get; set; }

        /// <summary>
        /// &lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="tid", EmitDefaultValue=false)]
        public string Tid { get; set; }

        /// <summary>
        /// &lt;p&gt;List of translations for description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TranslationList&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of translations for description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TranslationList&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="translationList", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerMdMhgDtoSoMHGTranslationSO> TranslationList { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_05&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_05&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_03&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_03&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_02&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_02&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_04&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_04&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_01&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_01&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO {\n");
            sb.Append("  MerchandiseHierarchyGroupID: ").Append(MerchandiseHierarchyGroupID).Append("\n");
            sb.Append("  MerchandiseHierarchyGroupIDQualifier: ").Append(MerchandiseHierarchyGroupIDQualifier).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  TaxGroupID: ").Append(TaxGroupID).Append("\n");
            sb.Append("  ItemSellingRuleID: ").Append(ItemSellingRuleID).Append("\n");
            sb.Append("  ItemMerchandiseManagementRuleID: ").Append(ItemMerchandiseManagementRuleID).Append("\n");
            sb.Append("  PackageID: ").Append(PackageID).Append("\n");
            sb.Append("  MerchandiseHierarchyLevelID: ").Append(MerchandiseHierarchyLevelID).Append("\n");
            sb.Append("  LevelName: ").Append(LevelName).Append("\n");
            sb.Append("  Tid: ").Append(Tid).Append("\n");
            sb.Append("  TranslationList: ").Append(TranslationList).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.MerchandiseHierarchyGroupID == input.MerchandiseHierarchyGroupID ||
                    (this.MerchandiseHierarchyGroupID != null &&
                    this.MerchandiseHierarchyGroupID.Equals(input.MerchandiseHierarchyGroupID))
                ) && 
                (
                    this.MerchandiseHierarchyGroupIDQualifier == input.MerchandiseHierarchyGroupIDQualifier ||
                    (this.MerchandiseHierarchyGroupIDQualifier != null &&
                    this.MerchandiseHierarchyGroupIDQualifier.Equals(input.MerchandiseHierarchyGroupIDQualifier))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.TaxGroupID == input.TaxGroupID ||
                    (this.TaxGroupID != null &&
                    this.TaxGroupID.Equals(input.TaxGroupID))
                ) && 
                (
                    this.ItemSellingRuleID == input.ItemSellingRuleID ||
                    (this.ItemSellingRuleID != null &&
                    this.ItemSellingRuleID.Equals(input.ItemSellingRuleID))
                ) && 
                (
                    this.ItemMerchandiseManagementRuleID == input.ItemMerchandiseManagementRuleID ||
                    (this.ItemMerchandiseManagementRuleID != null &&
                    this.ItemMerchandiseManagementRuleID.Equals(input.ItemMerchandiseManagementRuleID))
                ) && 
                (
                    this.PackageID == input.PackageID ||
                    (this.PackageID != null &&
                    this.PackageID.Equals(input.PackageID))
                ) && 
                (
                    this.MerchandiseHierarchyLevelID == input.MerchandiseHierarchyLevelID ||
                    (this.MerchandiseHierarchyLevelID != null &&
                    this.MerchandiseHierarchyLevelID.Equals(input.MerchandiseHierarchyLevelID))
                ) && 
                (
                    this.LevelName == input.LevelName ||
                    (this.LevelName != null &&
                    this.LevelName.Equals(input.LevelName))
                ) && 
                (
                    this.Tid == input.Tid ||
                    (this.Tid != null &&
                    this.Tid.Equals(input.Tid))
                ) && 
                (
                    this.TranslationList == input.TranslationList ||
                    this.TranslationList != null &&
                    this.TranslationList.SequenceEqual(input.TranslationList)
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.MerchandiseHierarchyGroupID != null)
                    hashCode = hashCode * 59 + this.MerchandiseHierarchyGroupID.GetHashCode();
                if (this.MerchandiseHierarchyGroupIDQualifier != null)
                    hashCode = hashCode * 59 + this.MerchandiseHierarchyGroupIDQualifier.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.TaxGroupID != null)
                    hashCode = hashCode * 59 + this.TaxGroupID.GetHashCode();
                if (this.ItemSellingRuleID != null)
                    hashCode = hashCode * 59 + this.ItemSellingRuleID.GetHashCode();
                if (this.ItemMerchandiseManagementRuleID != null)
                    hashCode = hashCode * 59 + this.ItemMerchandiseManagementRuleID.GetHashCode();
                if (this.PackageID != null)
                    hashCode = hashCode * 59 + this.PackageID.GetHashCode();
                if (this.MerchandiseHierarchyLevelID != null)
                    hashCode = hashCode * 59 + this.MerchandiseHierarchyLevelID.GetHashCode();
                if (this.LevelName != null)
                    hashCode = hashCode * 59 + this.LevelName.GetHashCode();
                if (this.Tid != null)
                    hashCode = hashCode * 59 + this.Tid.GetHashCode();
                if (this.TranslationList != null)
                    hashCode = hashCode * 59 + this.TranslationList.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
