/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ReasonSO &lt;p&gt;Reasons are used for sale and merchandise management processes. They are used to designate different goods movements. Reasons may contain a number of parameters. Each parameter has a defined name with a certain meaning for the respective process.&lt;br /&gt; Reasons are grouped by processes. Each reason is identified based on a combination of code + group.&lt;br /&gt; Each group has a fixed code. The reasons belonging to this group are used in the respective process.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterData_Reason.xml.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO :  IEquatable<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;Type of origin.&lt;br /&gt; OriginCode:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt; PARENT_COPY &#x3D; &#39;00&#39;&lt;br /&gt; IMPORT &#x3D; &#39;01&#39;&lt;br /&gt; MANUAL &#x3D; &#39;02&#39;&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type of origin.&lt;br /&gt; OriginCode:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt; PARENT_COPY &#x3D; &#39;00&#39;&lt;br /&gt; IMPORT &#x3D; &#39;01&#39;&lt;br /&gt; MANUAL &#x3D; &#39;02&#39;&lt;br /&gt;&lt;/pre&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OriginEnum
        {
            
            /// <summary>
            /// Enum PARENTCOPY for value: PARENT_COPY
            /// </summary>
            [EnumMember(Value = "PARENT_COPY")]
            PARENTCOPY = 1,
            
            /// <summary>
            /// Enum IMPORT for value: IMPORT
            /// </summary>
            [EnumMember(Value = "IMPORT")]
            IMPORT = 2,
            
            /// <summary>
            /// Enum MANUAL for value: MANUAL
            /// </summary>
            [EnumMember(Value = "MANUAL")]
            MANUAL = 3
        }

        /// <summary>
        /// &lt;p&gt;Type of origin.&lt;br /&gt; OriginCode:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt; PARENT_COPY &#x3D; &#39;00&#39;&lt;br /&gt; IMPORT &#x3D; &#39;01&#39;&lt;br /&gt; MANUAL &#x3D; &#39;02&#39;&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;Type of origin.&lt;br /&gt; OriginCode:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt; PARENT_COPY &#x3D; &#39;00&#39;&lt;br /&gt; IMPORT &#x3D; &#39;01&#39;&lt;br /&gt; MANUAL &#x3D; &#39;02&#39;&lt;br /&gt;&lt;/pre&gt;</value>
        [DataMember(Name="origin", EmitDefaultValue=false)]
        public OriginEnum? Origin { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO" /> class.
        /// </summary>
        /// <param name="businessUnitGroupID">&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_Reason.xml: BusinessUnitGroupID or the BusinessUnitGroupID for the ExternalBusinessUnitGroupID from Reason.BugHeader or if not filled, then from ReasonMasterData.BugHeader. If not filled, then the reason is globally valid.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="reasonDescription">&lt;p&gt;Long description of the reason&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonShortText">&lt;p&gt;Reason short text&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonCodeGroupCode">&lt;p&gt;Code of the group to which the reason belongs&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="reasonCodeGroupDescription">&lt;p&gt;Description of the assigned reason group; for information purposes&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported, loaded from ReasonCodeGroupSO.reasonCodeGroupDescription&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonOrder">&lt;p&gt;Defines the order within a group for display in the graphical user interface&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonParameterList">&lt;p&gt;List of reason parameters&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="tid">&lt;p&gt;Translation identifier&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="translations">&lt;p&gt;List of translations&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="origin">&lt;p&gt;Type of origin.&lt;br /&gt; OriginCode:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;pre&gt; PARENT_COPY &#x3D; &#39;00&#39;&lt;br /&gt; IMPORT &#x3D; &#39;01&#39;&lt;br /&gt; MANUAL &#x3D; &#39;02&#39;&lt;br /&gt;&lt;/pre&gt;.</param>
        /// <param name="xxcustom05">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom04">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="reasonCode">&lt;p&gt;A unique retailer defined reason code for an action that is taken (or not taken) at a workstation / device.&lt;br /&gt;&lt;/p&gt; (required).</param>
        public ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO(string businessUnitGroupID = default(string), string reasonDescription = default(string), string reasonShortText = default(string), string reasonCodeGroupCode = default(string), string reasonCodeGroupDescription = default(string), int? reasonOrder = default(int?), List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonParameterSO> reasonParameterList = default(List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonParameterSO>), string tid = default(string), List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO> translations = default(List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO>), OriginEnum? origin = default(OriginEnum?), string xxcustom05 = default(string), string xxcustom03 = default(string), string xxcustom02 = default(string), string xxcustom04 = default(string), string xxcustom01 = default(string), string reasonCode = default(string))
        {
            // to ensure "businessUnitGroupID" is required (not null)
            if (businessUnitGroupID == null)
            {
                throw new InvalidDataException("businessUnitGroupID is a required property for ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO and cannot be null");
            }
            else
            {
                this.BusinessUnitGroupID = businessUnitGroupID;
            }
            // to ensure "reasonCodeGroupCode" is required (not null)
            if (reasonCodeGroupCode == null)
            {
                throw new InvalidDataException("reasonCodeGroupCode is a required property for ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO and cannot be null");
            }
            else
            {
                this.ReasonCodeGroupCode = reasonCodeGroupCode;
            }
            // to ensure "reasonCode" is required (not null)
            if (reasonCode == null)
            {
                throw new InvalidDataException("reasonCode is a required property for ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO and cannot be null");
            }
            else
            {
                this.ReasonCode = reasonCode;
            }
            this.ReasonDescription = reasonDescription;
            this.ReasonShortText = reasonShortText;
            this.ReasonCodeGroupDescription = reasonCodeGroupDescription;
            this.ReasonOrder = reasonOrder;
            this.ReasonParameterList = reasonParameterList;
            this.Tid = tid;
            this.Translations = translations;
            this.Origin = origin;
            this.Xxcustom05 = xxcustom05;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.Xxcustom04 = xxcustom04;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_Reason.xml: BusinessUnitGroupID or the BusinessUnitGroupID for the ExternalBusinessUnitGroupID from Reason.BugHeader or if not filled, then from ReasonMasterData.BugHeader. If not filled, then the reason is globally valid.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique identifier of the business unit group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_Reason.xml: BusinessUnitGroupID or the BusinessUnitGroupID for the ExternalBusinessUnitGroupID from Reason.BugHeader or if not filled, then from ReasonMasterData.BugHeader. If not filled, then the reason is globally valid.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="businessUnitGroupID", EmitDefaultValue=false)]
        public string BusinessUnitGroupID { get; set; }

        /// <summary>
        /// &lt;p&gt;Long description of the reason&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Long description of the reason&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonDescription", EmitDefaultValue=false)]
        public string ReasonDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;Reason short text&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reason short text&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonShortText", EmitDefaultValue=false)]
        public string ReasonShortText { get; set; }

        /// <summary>
        /// &lt;p&gt;Code of the group to which the reason belongs&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Code of the group to which the reason belongs&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonCodeGroupCode", EmitDefaultValue=false)]
        public string ReasonCodeGroupCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Description of the assigned reason group; for information purposes&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported, loaded from ReasonCodeGroupSO.reasonCodeGroupDescription&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Description of the assigned reason group; for information purposes&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported, loaded from ReasonCodeGroupSO.reasonCodeGroupDescription&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonCodeGroupDescription", EmitDefaultValue=false)]
        public string ReasonCodeGroupDescription { get; set; }

        /// <summary>
        /// &lt;p&gt;Defines the order within a group for display in the graphical user interface&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines the order within a group for display in the graphical user interface&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonOrder", EmitDefaultValue=false)]
        public int? ReasonOrder { get; set; }

        /// <summary>
        /// &lt;p&gt;List of reason parameters&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of reason parameters&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonParameterList", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonParameterSO> ReasonParameterList { get; set; }

        /// <summary>
        /// &lt;p&gt;Translation identifier&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translation identifier&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="tid", EmitDefaultValue=false)]
        public string Tid { get; set; }

        /// <summary>
        /// &lt;p&gt;List of translations&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of translations&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="translations", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonTranslationSO> Translations { get; set; }


        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom05", EmitDefaultValue=false)]
        public string Xxcustom05 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom04", EmitDefaultValue=false)]
        public string Xxcustom04 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// &lt;p&gt;A unique retailer defined reason code for an action that is taken (or not taken) at a workstation / device.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique retailer defined reason code for an action that is taken (or not taken) at a workstation / device.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="reasonCode", EmitDefaultValue=false)]
        public string ReasonCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO {\n");
            sb.Append("  BusinessUnitGroupID: ").Append(BusinessUnitGroupID).Append("\n");
            sb.Append("  ReasonDescription: ").Append(ReasonDescription).Append("\n");
            sb.Append("  ReasonShortText: ").Append(ReasonShortText).Append("\n");
            sb.Append("  ReasonCodeGroupCode: ").Append(ReasonCodeGroupCode).Append("\n");
            sb.Append("  ReasonCodeGroupDescription: ").Append(ReasonCodeGroupDescription).Append("\n");
            sb.Append("  ReasonOrder: ").Append(ReasonOrder).Append("\n");
            sb.Append("  ReasonParameterList: ").Append(ReasonParameterList).Append("\n");
            sb.Append("  Tid: ").Append(Tid).Append("\n");
            sb.Append("  Translations: ").Append(Translations).Append("\n");
            sb.Append("  Origin: ").Append(Origin).Append("\n");
            sb.Append("  Xxcustom05: ").Append(Xxcustom05).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  Xxcustom04: ").Append(Xxcustom04).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("  ReasonCode: ").Append(ReasonCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareSweeSesApiServerMdReasonDtoSoReasonSO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BusinessUnitGroupID == input.BusinessUnitGroupID ||
                    (this.BusinessUnitGroupID != null &&
                    this.BusinessUnitGroupID.Equals(input.BusinessUnitGroupID))
                ) && 
                (
                    this.ReasonDescription == input.ReasonDescription ||
                    (this.ReasonDescription != null &&
                    this.ReasonDescription.Equals(input.ReasonDescription))
                ) && 
                (
                    this.ReasonShortText == input.ReasonShortText ||
                    (this.ReasonShortText != null &&
                    this.ReasonShortText.Equals(input.ReasonShortText))
                ) && 
                (
                    this.ReasonCodeGroupCode == input.ReasonCodeGroupCode ||
                    (this.ReasonCodeGroupCode != null &&
                    this.ReasonCodeGroupCode.Equals(input.ReasonCodeGroupCode))
                ) && 
                (
                    this.ReasonCodeGroupDescription == input.ReasonCodeGroupDescription ||
                    (this.ReasonCodeGroupDescription != null &&
                    this.ReasonCodeGroupDescription.Equals(input.ReasonCodeGroupDescription))
                ) && 
                (
                    this.ReasonOrder == input.ReasonOrder ||
                    (this.ReasonOrder != null &&
                    this.ReasonOrder.Equals(input.ReasonOrder))
                ) && 
                (
                    this.ReasonParameterList == input.ReasonParameterList ||
                    this.ReasonParameterList != null &&
                    this.ReasonParameterList.SequenceEqual(input.ReasonParameterList)
                ) && 
                (
                    this.Tid == input.Tid ||
                    (this.Tid != null &&
                    this.Tid.Equals(input.Tid))
                ) && 
                (
                    this.Translations == input.Translations ||
                    this.Translations != null &&
                    this.Translations.SequenceEqual(input.Translations)
                ) && 
                (
                    this.Origin == input.Origin ||
                    (this.Origin != null &&
                    this.Origin.Equals(input.Origin))
                ) && 
                (
                    this.Xxcustom05 == input.Xxcustom05 ||
                    (this.Xxcustom05 != null &&
                    this.Xxcustom05.Equals(input.Xxcustom05))
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.Xxcustom04 == input.Xxcustom04 ||
                    (this.Xxcustom04 != null &&
                    this.Xxcustom04.Equals(input.Xxcustom04))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                ) && 
                (
                    this.ReasonCode == input.ReasonCode ||
                    (this.ReasonCode != null &&
                    this.ReasonCode.Equals(input.ReasonCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BusinessUnitGroupID != null)
                    hashCode = hashCode * 59 + this.BusinessUnitGroupID.GetHashCode();
                if (this.ReasonDescription != null)
                    hashCode = hashCode * 59 + this.ReasonDescription.GetHashCode();
                if (this.ReasonShortText != null)
                    hashCode = hashCode * 59 + this.ReasonShortText.GetHashCode();
                if (this.ReasonCodeGroupCode != null)
                    hashCode = hashCode * 59 + this.ReasonCodeGroupCode.GetHashCode();
                if (this.ReasonCodeGroupDescription != null)
                    hashCode = hashCode * 59 + this.ReasonCodeGroupDescription.GetHashCode();
                if (this.ReasonOrder != null)
                    hashCode = hashCode * 59 + this.ReasonOrder.GetHashCode();
                if (this.ReasonParameterList != null)
                    hashCode = hashCode * 59 + this.ReasonParameterList.GetHashCode();
                if (this.Tid != null)
                    hashCode = hashCode * 59 + this.Tid.GetHashCode();
                if (this.Translations != null)
                    hashCode = hashCode * 59 + this.Translations.GetHashCode();
                if (this.Origin != null)
                    hashCode = hashCode * 59 + this.Origin.GetHashCode();
                if (this.Xxcustom05 != null)
                    hashCode = hashCode * 59 + this.Xxcustom05.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.Xxcustom04 != null)
                    hashCode = hashCode * 59 + this.Xxcustom04.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                if (this.ReasonCode != null)
                    hashCode = hashCode * 59 + this.ReasonCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
