/* 
 * GK application - OmniPOS Service API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 5.21.1-b03
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AbstractOperatorSO &lt;p&gt;The data of an operator (person) who can work in many retail stores. The operator can obtain different login data and different roles in different retail stores.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from Operator.xml.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    [DataContract]
    public partial class ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO :  IEquatable<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO>, IValidatableObject
    {
        /// <summary>
        /// &lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OriginEnum
        {
            
            /// <summary>
            /// Enum IMPORT for value: IMPORT
            /// </summary>
            [EnumMember(Value = "IMPORT")]
            IMPORT = 1,
            
            /// <summary>
            /// Enum MANUAL for value: MANUAL
            /// </summary>
            [EnumMember(Value = "MANUAL")]
            MANUAL = 2
        }

        /// <summary>
        /// &lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        [DataMember(Name="origin", EmitDefaultValue=false)]
        public OriginEnum? Origin { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO" /> class.
        /// </summary>
        /// <param name="operatorID">&lt;p&gt;The unique ID of the operator (Note: Not the login name. The login name can be store specific.)&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;dl&gt;&lt;br /&gt; &lt;dt&gt;+&lt;/dt&gt;&lt;br /&gt;&lt;/dl&gt; (required).</param>
        /// <param name="workerID">&lt;p&gt;Worker ID. This attribute can be used as the connection between the operator and the worker object.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="salutation">&lt;p&gt;Salutation&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="firstName">&lt;p&gt;First name&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="lastName">&lt;p&gt;Last name&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="languageID">&lt;p&gt;ISO language ID. The GUI in the portal, on the hand-held and on the POS is displayed in this language after user login&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="leftHandedFlag">&lt;p&gt;Flag for left handed. The flag can control the GUI of the peripheral device.&lt;br /&gt;&lt;/p&gt; (required).</param>
        /// <param name="emailAddress">&lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="birthYearNumber">&lt;p&gt;Birth year&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="birthMonthNumber">&lt;p&gt;Birth month&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="birthDayNumber">&lt;p&gt;Birth day&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="operatorAssignmentSOList">&lt;p&gt;Role assignments in specific retail stores&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="peripheralAccessSOList">&lt;p&gt;Login data for periphery classes in specific retail stores&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="origin">&lt;p&gt;Origin of the import&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;00 - IMPORT&lt;/li&gt;&lt;br /&gt; &lt;li&gt;01 - MANUAL&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;.</param>
        /// <param name="packageID">&lt;p&gt;Internal identifier of the import file&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="opAsgnList">opAsgnList.</param>
        /// <param name="xxcustom03">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom02">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="isocountryCode">&lt;p&gt;ISO country code&lt;br /&gt;&lt;/p&gt;.</param>
        /// <param name="xxcustom01">&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;.</param>
        public ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO(string operatorID = default(string), string workerID = default(string), string salutation = default(string), string firstName = default(string), string lastName = default(string), string languageID = default(string), bool? leftHandedFlag = default(bool?), string emailAddress = default(string), int? birthYearNumber = default(int?), int? birthMonthNumber = default(int?), int? birthDayNumber = default(int?), List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> operatorAssignmentSOList = default(List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO>), List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoPeripheralAccessSO> peripheralAccessSOList = default(List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoPeripheralAccessSO>), OriginEnum? origin = default(OriginEnum?), string packageID = default(string), List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> opAsgnList = default(List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO>), string xxcustom03 = default(string), string xxcustom02 = default(string), string isocountryCode = default(string), string xxcustom01 = default(string))
        {
            // to ensure "operatorID" is required (not null)
            if (operatorID == null)
            {
                throw new InvalidDataException("operatorID is a required property for ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO and cannot be null");
            }
            else
            {
                this.OperatorID = operatorID;
            }
            // to ensure "workerID" is required (not null)
            if (workerID == null)
            {
                throw new InvalidDataException("workerID is a required property for ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO and cannot be null");
            }
            else
            {
                this.WorkerID = workerID;
            }
            // to ensure "languageID" is required (not null)
            if (languageID == null)
            {
                throw new InvalidDataException("languageID is a required property for ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO and cannot be null");
            }
            else
            {
                this.LanguageID = languageID;
            }
            // to ensure "leftHandedFlag" is required (not null)
            if (leftHandedFlag == null)
            {
                throw new InvalidDataException("leftHandedFlag is a required property for ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO and cannot be null");
            }
            else
            {
                this.LeftHandedFlag = leftHandedFlag;
            }
            this.Salutation = salutation;
            this.FirstName = firstName;
            this.LastName = lastName;
            this.EmailAddress = emailAddress;
            this.BirthYearNumber = birthYearNumber;
            this.BirthMonthNumber = birthMonthNumber;
            this.BirthDayNumber = birthDayNumber;
            this.OperatorAssignmentSOList = operatorAssignmentSOList;
            this.PeripheralAccessSOList = peripheralAccessSOList;
            this.Origin = origin;
            this.PackageID = packageID;
            this.OpAsgnList = opAsgnList;
            this.Xxcustom03 = xxcustom03;
            this.Xxcustom02 = xxcustom02;
            this.IsocountryCode = isocountryCode;
            this.Xxcustom01 = xxcustom01;
        }
        
        /// <summary>
        /// &lt;p&gt;The unique ID of the operator (Note: Not the login name. The login name can be store specific.)&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;dl&gt;&lt;br /&gt; &lt;dt&gt;+&lt;/dt&gt;&lt;br /&gt;&lt;/dl&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unique ID of the operator (Note: Not the login name. The login name can be store specific.)&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;dl&gt;&lt;br /&gt; &lt;dt&gt;+&lt;/dt&gt;&lt;br /&gt;&lt;/dl&gt;</value>
        [DataMember(Name="operatorID", EmitDefaultValue=false)]
        public string OperatorID { get; set; }

        /// <summary>
        /// &lt;p&gt;Worker ID. This attribute can be used as the connection between the operator and the worker object.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Worker ID. This attribute can be used as the connection between the operator and the worker object.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="workerID", EmitDefaultValue=false)]
        public string WorkerID { get; set; }

        /// <summary>
        /// &lt;p&gt;Salutation&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Salutation&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="salutation", EmitDefaultValue=false)]
        public string Salutation { get; set; }

        /// <summary>
        /// &lt;p&gt;First name&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;First name&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="firstName", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// &lt;p&gt;Last name&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Last name&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="lastName", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// &lt;p&gt;ISO language ID. The GUI in the portal, on the hand-held and on the POS is displayed in this language after user login&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ISO language ID. The GUI in the portal, on the hand-held and on the POS is displayed in this language after user login&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="languageID", EmitDefaultValue=false)]
        public string LanguageID { get; set; }

        /// <summary>
        /// &lt;p&gt;Flag for left handed. The flag can control the GUI of the peripheral device.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag for left handed. The flag can control the GUI of the peripheral device.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="leftHandedFlag", EmitDefaultValue=false)]
        public bool? LeftHandedFlag { get; set; }

        /// <summary>
        /// &lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Email address&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="emailAddress", EmitDefaultValue=false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// &lt;p&gt;Birth year&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth year&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="birthYearNumber", EmitDefaultValue=false)]
        public int? BirthYearNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Birth month&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth month&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="birthMonthNumber", EmitDefaultValue=false)]
        public int? BirthMonthNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Birth day&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Birth day&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="birthDayNumber", EmitDefaultValue=false)]
        public int? BirthDayNumber { get; set; }

        /// <summary>
        /// &lt;p&gt;Role assignments in specific retail stores&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Role assignments in specific retail stores&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="operatorAssignmentSOList", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> OperatorAssignmentSOList { get; set; }

        /// <summary>
        /// &lt;p&gt;Login data for periphery classes in specific retail stores&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Login data for periphery classes in specific retail stores&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="peripheralAccessSOList", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoPeripheralAccessSO> PeripheralAccessSOList { get; set; }


        /// <summary>
        /// &lt;p&gt;Internal identifier of the import file&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Internal identifier of the import file&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="packageID", EmitDefaultValue=false)]
        public string PackageID { get; set; }

        /// <summary>
        /// Gets or Sets OpAsgnList
        /// </summary>
        [DataMember(Name="opAsgnList", EmitDefaultValue=false)]
        public List<ComGkSoftwareSweeSesApiServerUmOperatorDtoSoOperatorAssignmentSO> OpAsgnList { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom03", EmitDefaultValue=false)]
        public string Xxcustom03 { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom02", EmitDefaultValue=false)]
        public string Xxcustom02 { get; set; }

        /// <summary>
        /// &lt;p&gt;ISO country code&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;ISO country code&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="isocountryCode", EmitDefaultValue=false)]
        public string IsocountryCode { get; set; }

        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        [DataMember(Name="xxcustom01", EmitDefaultValue=false)]
        public string Xxcustom01 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO {\n");
            sb.Append("  OperatorID: ").Append(OperatorID).Append("\n");
            sb.Append("  WorkerID: ").Append(WorkerID).Append("\n");
            sb.Append("  Salutation: ").Append(Salutation).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  LanguageID: ").Append(LanguageID).Append("\n");
            sb.Append("  LeftHandedFlag: ").Append(LeftHandedFlag).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  BirthYearNumber: ").Append(BirthYearNumber).Append("\n");
            sb.Append("  BirthMonthNumber: ").Append(BirthMonthNumber).Append("\n");
            sb.Append("  BirthDayNumber: ").Append(BirthDayNumber).Append("\n");
            sb.Append("  OperatorAssignmentSOList: ").Append(OperatorAssignmentSOList).Append("\n");
            sb.Append("  PeripheralAccessSOList: ").Append(PeripheralAccessSOList).Append("\n");
            sb.Append("  Origin: ").Append(Origin).Append("\n");
            sb.Append("  PackageID: ").Append(PackageID).Append("\n");
            sb.Append("  OpAsgnList: ").Append(OpAsgnList).Append("\n");
            sb.Append("  Xxcustom03: ").Append(Xxcustom03).Append("\n");
            sb.Append("  Xxcustom02: ").Append(Xxcustom02).Append("\n");
            sb.Append("  IsocountryCode: ").Append(IsocountryCode).Append("\n");
            sb.Append("  Xxcustom01: ").Append(Xxcustom01).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO);
        }

        /// <summary>
        /// Returns true if ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO instances are equal
        /// </summary>
        /// <param name="input">Instance of ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ComGkSoftwareSweeSesApiServerUmOperatorDtoSoAbstractOperatorSO input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OperatorID == input.OperatorID ||
                    (this.OperatorID != null &&
                    this.OperatorID.Equals(input.OperatorID))
                ) && 
                (
                    this.WorkerID == input.WorkerID ||
                    (this.WorkerID != null &&
                    this.WorkerID.Equals(input.WorkerID))
                ) && 
                (
                    this.Salutation == input.Salutation ||
                    (this.Salutation != null &&
                    this.Salutation.Equals(input.Salutation))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.LanguageID == input.LanguageID ||
                    (this.LanguageID != null &&
                    this.LanguageID.Equals(input.LanguageID))
                ) && 
                (
                    this.LeftHandedFlag == input.LeftHandedFlag ||
                    (this.LeftHandedFlag != null &&
                    this.LeftHandedFlag.Equals(input.LeftHandedFlag))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.BirthYearNumber == input.BirthYearNumber ||
                    (this.BirthYearNumber != null &&
                    this.BirthYearNumber.Equals(input.BirthYearNumber))
                ) && 
                (
                    this.BirthMonthNumber == input.BirthMonthNumber ||
                    (this.BirthMonthNumber != null &&
                    this.BirthMonthNumber.Equals(input.BirthMonthNumber))
                ) && 
                (
                    this.BirthDayNumber == input.BirthDayNumber ||
                    (this.BirthDayNumber != null &&
                    this.BirthDayNumber.Equals(input.BirthDayNumber))
                ) && 
                (
                    this.OperatorAssignmentSOList == input.OperatorAssignmentSOList ||
                    this.OperatorAssignmentSOList != null &&
                    this.OperatorAssignmentSOList.SequenceEqual(input.OperatorAssignmentSOList)
                ) && 
                (
                    this.PeripheralAccessSOList == input.PeripheralAccessSOList ||
                    this.PeripheralAccessSOList != null &&
                    this.PeripheralAccessSOList.SequenceEqual(input.PeripheralAccessSOList)
                ) && 
                (
                    this.Origin == input.Origin ||
                    (this.Origin != null &&
                    this.Origin.Equals(input.Origin))
                ) && 
                (
                    this.PackageID == input.PackageID ||
                    (this.PackageID != null &&
                    this.PackageID.Equals(input.PackageID))
                ) && 
                (
                    this.OpAsgnList == input.OpAsgnList ||
                    this.OpAsgnList != null &&
                    this.OpAsgnList.SequenceEqual(input.OpAsgnList)
                ) && 
                (
                    this.Xxcustom03 == input.Xxcustom03 ||
                    (this.Xxcustom03 != null &&
                    this.Xxcustom03.Equals(input.Xxcustom03))
                ) && 
                (
                    this.Xxcustom02 == input.Xxcustom02 ||
                    (this.Xxcustom02 != null &&
                    this.Xxcustom02.Equals(input.Xxcustom02))
                ) && 
                (
                    this.IsocountryCode == input.IsocountryCode ||
                    (this.IsocountryCode != null &&
                    this.IsocountryCode.Equals(input.IsocountryCode))
                ) && 
                (
                    this.Xxcustom01 == input.Xxcustom01 ||
                    (this.Xxcustom01 != null &&
                    this.Xxcustom01.Equals(input.Xxcustom01))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OperatorID != null)
                    hashCode = hashCode * 59 + this.OperatorID.GetHashCode();
                if (this.WorkerID != null)
                    hashCode = hashCode * 59 + this.WorkerID.GetHashCode();
                if (this.Salutation != null)
                    hashCode = hashCode * 59 + this.Salutation.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.LanguageID != null)
                    hashCode = hashCode * 59 + this.LanguageID.GetHashCode();
                if (this.LeftHandedFlag != null)
                    hashCode = hashCode * 59 + this.LeftHandedFlag.GetHashCode();
                if (this.EmailAddress != null)
                    hashCode = hashCode * 59 + this.EmailAddress.GetHashCode();
                if (this.BirthYearNumber != null)
                    hashCode = hashCode * 59 + this.BirthYearNumber.GetHashCode();
                if (this.BirthMonthNumber != null)
                    hashCode = hashCode * 59 + this.BirthMonthNumber.GetHashCode();
                if (this.BirthDayNumber != null)
                    hashCode = hashCode * 59 + this.BirthDayNumber.GetHashCode();
                if (this.OperatorAssignmentSOList != null)
                    hashCode = hashCode * 59 + this.OperatorAssignmentSOList.GetHashCode();
                if (this.PeripheralAccessSOList != null)
                    hashCode = hashCode * 59 + this.PeripheralAccessSOList.GetHashCode();
                if (this.Origin != null)
                    hashCode = hashCode * 59 + this.Origin.GetHashCode();
                if (this.PackageID != null)
                    hashCode = hashCode * 59 + this.PackageID.GetHashCode();
                if (this.OpAsgnList != null)
                    hashCode = hashCode * 59 + this.OpAsgnList.GetHashCode();
                if (this.Xxcustom03 != null)
                    hashCode = hashCode * 59 + this.Xxcustom03.GetHashCode();
                if (this.Xxcustom02 != null)
                    hashCode = hashCode * 59 + this.Xxcustom02.GetHashCode();
                if (this.IsocountryCode != null)
                    hashCode = hashCode * 59 + this.IsocountryCode.GetHashCode();
                if (this.Xxcustom01 != null)
                    hashCode = hashCode * 59 + this.Xxcustom01.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
