namespace POSGkSwaggerModel
{
    /// <summary>
    /// PosUOMItemSearchFilter &lt;p&gt;Filter for search view.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSearchFilter	{
        /// <summary>
        /// &lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Item number. Alphanumeric key that identifies the item uniquely.&lt;br /&gt;&lt;/p&gt;</value>
        public string itemID { get; init; }
        /// <summary>
        /// &lt;p&gt;Item name which is searched in GK_BUG_ITEM_I8N_ITEM_TEXT.TEXT if exists, otherwise (if it is allowed by configuration) in AS_BSNGP_ITM.NM_ITM_GK. &lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Item name which is searched in GK_BUG_ITEM_I8N_ITEM_TEXT.TEXT if exists, otherwise (if it is allowed by configuration) in AS_BSNGP_ITM.NM_ITM_GK. &lt;br /&gt;&lt;/p&gt;</value>
        public string name { get; init; }
        /// <summary>
        /// &lt;p&gt;Merchandise Hierarchy Group Name which is searched in GK_I18N_TEXT.LOCALIZED_TEXT if exists, otherwise in CO_MRHRC_GP.NM_MRHRC_GP.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Merchandise Hierarchy Group Name which is searched in GK_I18N_TEXT.LOCALIZED_TEXT if exists, otherwise in CO_MRHRC_GP.NM_MRHRC_GP.&lt;br /&gt;&lt;/p&gt;</value>
        public string merchandiseHierarchyGroupName { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount of the price.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount of the price.&lt;br /&gt;&lt;/p&gt;</value>
        public double? priceAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;If true only items authorized for sale are searched (RU_ITM_SL.FL_AZN_FR_SLS is true). &lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;If true only items authorized for sale are searched (RU_ITM_SL.FL_AZN_FR_SLS is true). &lt;br /&gt;&lt;/p&gt;</value>
        public bool? authorisedForSaleFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;For filtering items with Item Collections. If true only items with Item Collection are searched. &lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;For filtering items with Item Collections. If true only items with Item Collection are searched. &lt;br /&gt;&lt;/p&gt;</value>
        public bool? itemCollectionSet { get; init; }
        /// <summary>
        /// &lt;p&gt;For enabling/disabling case sensitivity for search in ItemID&lt;br /&gt; &lt;br/&gt;&lt;strong&gt;Example&lt;/strong&gt; - in DB are items where AS_BSNGP_ITM.ID_ITM &#x3D; { A001, a001 }&lt;br /&gt;&lt;ul&gt;&lt;li&gt;caseSensitive&#x3D;true: &#x3D;&amp;gt; only one: A001&lt;/li&gt;&lt;li&gt;caseSensitive&#x3D;false: &#x3D;&amp;gt; returns both of them: A001, a001&lt;/li&gt;&lt;/ul&gt;&lt;br /&gt;&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;For enabling/disabling case sensitivity for search in ItemID&lt;br /&gt; &lt;br/&gt;&lt;strong&gt;Example&lt;/strong&gt; - in DB are items where AS_BSNGP_ITM.ID_ITM &#x3D; { A001, a001 }&lt;br /&gt;&lt;ul&gt;&lt;li&gt;caseSensitive&#x3D;true: &#x3D;&amp;gt; only one: A001&lt;/li&gt;&lt;li&gt;caseSensitive&#x3D;false: &#x3D;&amp;gt; returns both of them: A001, a001&lt;/li&gt;&lt;/ul&gt;&lt;br /&gt;&lt;br /&gt;&lt;/p&gt;</value>
        public bool? itemIDCaseSensitive { get; init; }
        /// <summary>
        /// Gets or Sets ScaleDomainID
        /// </summary>
        public string scaleDomainID { get; init; }
        /// <summary>
        /// &lt;p&gt;For filtering according to the code of the POS identity. &lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;For filtering according to the code of the POS identity. &lt;br /&gt;&lt;/p&gt;</value>
        public string posIdentityTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Search option whether the POS item identifier should be loaded and filled to provided view. If this flag is set to false the {@link PosUOMItemSearchView#posItemId} field in the view is always null.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Search option whether the POS item identifier should be loaded and filled to provided view. If this flag is set to false the {@link PosUOMItemSearchView#posItemId} field in the view is always null.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? optionLoadPosIdentity { get; init; }
        /// <summary>
        /// &lt;p&gt;Search option whether the Characteristics should be loaded and filled to provided view. If this flag is set to false the {@link PosUOMItemSearchView#characteristicViewList} field in the view is always null.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Search option whether the Characteristics should be loaded and filled to provided view. If this flag is set to false the {@link PosUOMItemSearchView#characteristicViewList} field in the view is always null.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? optionLoadCharacteristics { get; init; }
        /// <summary>
        /// &lt;p&gt;Filter for Characteristics.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Filter for Characteristics.&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareGkrApiServerMdItemDtoDomPosPosUOMItemSearchCharacteristicFilter> CharacteristicFilterList { get; init; }
        /// <summary>
        /// &lt;p&gt;Search option whether the {@link #itemID} should be used also for searching by Root Item ID in associations. It means that it searches all item with this root, in other words all child items for requested item.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Search option whether the {@link #itemID} should be used also for searching by Root Item ID in associations. It means that it searches all item with this root, in other words all child items for requested item.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? searchItemIdInRootItemId { get; init; }
        /// <summary>
        /// Gets or Sets Offset
        /// </summary>
        public string offset { get; init; }
        /// <summary>
        /// Gets or Sets Limit
        /// </summary>
        public int? limit { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM01 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM16 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM17 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM18 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM19 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM20 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM21 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM22 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM23 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM24 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM25 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM26 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM27 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM28 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM29 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString uomITEMXXCUSTOM30 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM01 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM16 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM17 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM18 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM19 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM20 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM21 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM22 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM23 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM24 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM25 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM26 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM27 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM28 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM29 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public IBasicFilterConditionString itemXXCUSTOM30 { get; init; }
	}
}
