namespace POSGkSwaggerModel
{
    /// <summary>
    /// TankDO &lt;p&gt;A kind of Location used to store a FuelItem that is measured &amp;amp; dispensed by one or more FuelingPoints&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareGkrApiServerMdPetrolDtoDomTankDO	{
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdPetrolDtoDomTankDOkey key { get; init; }
        /// <summary>
        /// &lt;p&gt;Generated ID of a  fuel grade.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Generated ID of a  fuel grade.&lt;br /&gt;&lt;/p&gt;</value>
        public string fuelGradeID { get; init; }
        /// <summary>
        /// &lt;p&gt;The largest capacity that the tank safely holds, taking temperature effects into consideration.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The largest capacity that the tank safely holds, taking temperature effects into consideration.&lt;br /&gt;&lt;/p&gt;</value>
        public double? maximumSafeFillCapacity { get; init; }
        /// <summary>
        /// &lt;p&gt;The volume to which a tank may be emptied  without prumping vapour into the line. The amount of product that just reaches the entrance of the suction pipe.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The volume to which a tank may be emptied  without prumping vapour into the line. The amount of product that just reaches the entrance of the suction pipe.&lt;br /&gt;&lt;/p&gt;</value>
        public double? lowCapacity { get; init; }
        /// <summary>
        /// &lt;p&gt;The diameter of the tank&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The diameter of the tank&lt;br /&gt;&lt;/p&gt;</value>
        public double? tankDiameter { get; init; }
        /// <summary>
        /// &lt;p&gt;The level at which the TankLevelGuage will set off the &#39;High Water Alarm&#39;&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The level at which the TankLevelGuage will set off the &#39;High Water Alarm&#39;&lt;br /&gt;&lt;/p&gt;</value>
        public double? highWaterSetPoint { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to BusinessUnitGroupItem&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to BusinessUnitGroupItem&lt;br /&gt;&lt;/p&gt;</value>
        public string itemID { get; init; }
        /// <summary>
        /// &lt;p&gt;The UOM of the Item&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The UOM of the Item&lt;br /&gt;&lt;/p&gt;</value>
        public string unitOfMeasureCode { get; init; }
        /// <summary>
        /// Gets or Sets FuelProductID
        /// </summary>
        public int? fuelProductID { get; init; }
        /// <summary>
        /// Gets or Sets FuelName
        /// </summary>
        public string fuelName { get; init; }
        /// <summary>
        /// Gets or Sets TankGroupID
        /// </summary>
        public int? tankGroupID { get; init; }
        /// <summary>
        /// Gets or Sets TankLevelGaugeID
        /// </summary>
        public int? tankLevelGaugeID { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom08
        /// </summary>
        public string xxcustom08 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom10
        /// </summary>
        public string xxcustom10 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom09
        /// </summary>
        public string xxcustom09 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom07
        /// </summary>
        public string xxcustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom06
        /// </summary>
        public string xxcustom06 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom11
        /// </summary>
        public string xxcustom11 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom12
        /// </summary>
        public string xxcustom12 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom13
        /// </summary>
        public string xxcustom13 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom14
        /// </summary>
        public string xxcustom14 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom15
        /// </summary>
        public string xxcustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom16
        /// </summary>
        public string xxcustom16 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom17
        /// </summary>
        public string xxcustom17 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom18
        /// </summary>
        public string xxcustom18 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom19
        /// </summary>
        public string xxcustom19 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom20
        /// </summary>
        public string xxcustom20 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom21
        /// </summary>
        public string xxcustom21 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom22
        /// </summary>
        public string xxcustom22 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom23
        /// </summary>
        public string xxcustom23 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom24
        /// </summary>
        public string xxcustom24 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom25
        /// </summary>
        public string xxcustom25 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom26
        /// </summary>
        public string xxcustom26 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom27
        /// </summary>
        public string xxcustom27 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom28
        /// </summary>
        public string xxcustom28 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom29
        /// </summary>
        public string xxcustom29 { get; init; }
        /// <summary>
        /// Gets or Sets Xxcustom30
        /// </summary>
        public string xxcustom30 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
