namespace POSGkSwaggerModel
{
    /// <summary>
    /// TenderRestrictionRule.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiServerMdTenderDtoDomTenderRestrictionRuleKey	{
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for a group of business units.&lt;br /&gt;&lt;/p&gt;</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;A code which uniquely identifies the type of tender, ie cash, check, credit card, etc.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code which uniquely identifies the type of tender, ie cash, check, credit card, etc.&lt;br /&gt;&lt;/p&gt;</value>
        public string tenderTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Transaction type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any transaction type)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Transaction type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any transaction type)&lt;br /&gt;&lt;/p&gt;</value>
        public string forbiddenTransactionTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Position type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any position type)&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Position type;&lt;br /&gt; 0 &#x3D; irrelevant (tender is forbidden for any position type)&lt;br /&gt;&lt;/p&gt;</value>
        public string forbiddenLineItemTypeCode { get; init; }
	}
}
