namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionCustomerIdentification.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionCustomerIdentificationKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// A unique system assigned identifier for the Customer. 
        /// </summary>
        /// <value>A unique system assigned identifier for the Customer. </value>
        public string customerID { get; init; }
        /// <summary>
        /// The customer type code
        /// </summary>
        /// <value>The customer type code</value>
        public string addressTypeCode { get; init; }
        /// <summary>
        /// A code denoting a form of identification that the customer uses to identify themselves. 
        /// </summary>
        /// <value>A code denoting a form of identification that the customer uses to identify themselves. </value>
        public string partyIdentificationTypeCode { get; init; }
	}
}
