namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionManufacturerCouponValidation.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionManufacturerCouponValidationKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// Short description
        /// </summary>
        /// <value>Short description</value>
        public string manufacturerCouponScanCode { get; init; }
        /// <summary>
        /// Reference to the sale line item the manufacturer coupon was applied to
        /// </summary>
        /// <value>Reference to the sale line item the manufacturer coupon was applied to</value>
        public int? saleLineItemSequenceNumber { get; init; }
	}
}
