namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionPromotionExternalActionParameter.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionExternalActionParameterKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The unique identifier of the promotion. 
        /// </summary>
        /// <value>The unique identifier of the promotion. </value>
        public string promotionID { get; init; }
        /// <summary>
        /// The unique identifier of the price derivation rule.  
        /// </summary>
        /// <value>The unique identifier of the price derivation rule.  </value>
        public string priceDerivationRuleID { get; init; }
        /// <summary>
        /// The unique identifier of the root eligibility.
        /// </summary>
        /// <value>The unique identifier of the root eligibility.</value>
        public string priceDerivationRuleEligibilityID { get; init; }
        /// <summary>
        /// The parameter ident
        /// </summary>
        /// <value>The parameter ident</value>
        public string parameterID { get; init; }
	}
}
