namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionPromotionRecommendationBenefit.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionRecommendationBenefitKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The unique identifier for the promotion.
        /// </summary>
        /// <value>The unique identifier for the promotion.</value>
        public string promotionID { get; init; }
        /// <summary>
        /// The unique identifier for the price derivation rule.
        /// </summary>
        /// <value>The unique identifier for the price derivation rule.</value>
        public string priceDerivationRuleID { get; init; }
        /// <summary>
        /// The unique identifier for the root price derivation rule eligibility.
        /// </summary>
        /// <value>The unique identifier for the root price derivation rule eligibility.</value>
        public string rootPriceDerivationRuleEligibilityID { get; init; }
        /// <summary>
        /// The sequence number of the benefit item. This ensures the unique identification in case of mix&amp;amp;match as well as for subsequent discounts.
        /// </summary>
        /// <value>The sequence number of the benefit item. This ensures the unique identification in case of mix&amp;amp;match as well as for subsequent discounts.</value>
        public int? sequenceNumber { get; init; }
	}
}
