namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetailTransactionPromotionTrigger.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoRetailTransactionPromotionTriggerKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The ident of the trigger (because a transaction item can have more than one trigger) 
        /// </summary>
        /// <value>The ident of the trigger (because a transaction item can have more than one trigger) </value>
        public int? triggerSequenceNumber { get; init; }
	}
}
