namespace POSGkSwaggerModel
{
    /// <summary>
    /// TenderLineItem &lt;emph&gt;undocumented&lt;/emph&gt;
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoTenderLineItem	{
        /// <summary>
        /// &lt;p&gt;Getter for inner key class.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Getter for inner key class.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiTxpoolDtoTenderLineItemkey key { get; init; }
        /// <summary>
        /// If true, denotes that the Tender is returned by the retailer to the Customer. 
        /// </summary>
        /// <value>If true, denotes that the Tender is returned by the retailer to the Customer. </value>
        public bool? isChangeFlag { get; init; }
        /// <summary>
        /// A code which uniquely identifies the tenderCorresponds to Tender.TenderTypeCode
        /// </summary>
        /// <value>A code which uniquely identifies the tenderCorresponds to Tender.TenderTypeCode</value>
        public string tenderTypeCode { get; init; }
        /// <summary>
        /// The tender account number
        /// </summary>
        /// <value>The tender account number</value>
        public string tenderAccountNumber { get; init; }
        /// <summary>
        /// The monetary value (in the currency submitted by the Customer) of the tender submitted by the Customer. 
        /// </summary>
        /// <value>The monetary value (in the currency submitted by the Customer) of the tender submitted by the Customer. </value>
        public double? foreignCurrencyAmount { get; init; }
        /// <summary>
        /// The exchange rate used to convert the tendered amount into the default currency of the retail enterprise. &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!
        /// </summary>
        /// <value>The exchange rate used to convert the tendered amount into the default currency of the retail enterprise. &lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!</value>
        public double? exchangeRate { get; init; }
        /// <summary>
        /// The monetary value (in the default currency of the retail enterprise) of the tender submitted by the Customer. 
        /// </summary>
        /// <value>The monetary value (in the default currency of the retail enterprise) of the tender submitted by the Customer. </value>
        public double? tenderAmount { get; init; }
        /// <summary>
        /// The grouping of tenders with similar (technical) handling on POS side. Corresponds to TenderHandlingRule.TenderGroupCode 
        /// </summary>
        /// <value>The grouping of tenders with similar (technical) handling on POS side. Corresponds to TenderHandlingRule.TenderGroupCode </value>
        public string tenderGroupCode { get; init; }
        /// <summary>
        /// The count of the media for the given tender 
        /// </summary>
        /// <value>The count of the media for the given tender </value>
        public int? tenderCount { get; init; }
        /// <summary>
        /// Text to be printed on the receipt.
        /// </summary>
        /// <value>Text to be printed on the receipt.</value>
        public string tenderDescription { get; init; }
        /// <summary>
        /// Boolean identifier for cash back
        /// </summary>
        /// <value>Boolean identifier for cash back</value>
        public bool? cashbackFlag { get; init; }
        /// <summary>
        /// Currency code designated by ISO to identify the currency of the tender
        /// </summary>
        /// <value>Currency code designated by ISO to identify the currency of the tender</value>
        public string foreignISOCurrencyCode { get; init; }
        /// <summary>
        /// Determines whether inside the calculation FromCurrencyID -&gt; ToCurrencyID the amount is to be multiplied with (true) or divided by (false) the factor (ExchangeRate)
        /// </summary>
        /// <value>Determines whether inside the calculation FromCurrencyID -&gt; ToCurrencyID the amount is to be multiplied with (true) or divided by (false) the factor (ExchangeRate)</value>
        public bool? exchangeRateMultiplyFlag { get; init; }
        /// <summary>
        /// Currency symbol of the tender
        /// </summary>
        /// <value>Currency symbol of the tender</value>
        public string currencySymbol { get; init; }
        /// <summary>
        /// The monetary amount (in the default currency of the retail enterprise) being collected as Tip for serving staff&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!
        /// </summary>
        /// <value>The monetary amount (in the default currency of the retail enterprise) being collected as Tip for serving staff&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!</value>
        public double? tipAmount { get; init; }
        /// <summary>
        /// The monetary amount (in the tendered currency) being collected as Tip for serving staff&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!
        /// </summary>
        /// <value>The monetary amount (in the tendered currency) being collected as Tip for serving staff&lt;br&gt;Fixed decimal precision expected, definition of used precision: double(16, 5). Be aware of this and round value!</value>
        public double? tipForeignCurrencyAmount { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom08 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom10 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom09 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom07 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom06 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom11 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom12 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom13 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom14 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom15 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// Check data for check tender line items
        /// </summary>
        /// <value>Check data for check tender line items</value>
        public List<comGkSoftwareGkrApiTxpoolDtoCheckTenderLineItem> CheckTenderLineItemList { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// Customizable information
        /// </summary>
        /// <value>Customizable information</value>
        public string xxcustom01 { get; init; }
	}
}
