namespace POSGkSwaggerModel
{
    /// <summary>
    /// TillSettlementTenderDenomination.Key Inner class for composite key attributes
    /// </summary>
    public record comGkSoftwareGkrApiTxpoolDtoTillSettlementTenderDenominationKey	{
        /// <summary>
        /// A unique system assigned identifier for a group of BusinessUnits.
        /// </summary>
        /// <value>A unique system assigned identifier for a group of BusinessUnits.</value>
        public string businessUnitGroupID { get; init; }
        /// <summary>
        /// A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. 
        /// </summary>
        /// <value>A universally unique identifier (UUID) for the Transaction. This may be assembled from alternate key members. </value>
        public string transactionID { get; init; }
        /// <summary>
        /// The unique identifier for the TENDER REPOSITORY. 
        /// </summary>
        /// <value>The unique identifier for the TENDER REPOSITORY. </value>
        public string tenderRepositoryID { get; init; }
        /// <summary>
        /// A code which uniquely identifies the tender
        /// </summary>
        /// <value>A code which uniquely identifies the tender</value>
        public string tenderTypeCode { get; init; }
        /// <summary>
        /// Line number (incremental counter) of the denomination 
        /// </summary>
        /// <value>Line number (incremental counter) of the denomination </value>
        public int? denominationSequenceNumber { get; init; }
	}
}
