namespace POSGkSwaggerModel
{
    /// <summary>
    /// PromptReceiptDataConfig &lt;p&gt;This configuration entity defines the PromptReceiptData process.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessUiPromptReceiptDataConfig	{
        /// <summary>
        /// &lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the unique process ID.&lt;/p&gt;</value>
        public string processId { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the key value for the prompt receipt data dialog title.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the key value for the prompt receipt data dialog title.&lt;/p&gt;</value>
        public string dialogTitleKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Force manual input. The input dialog will shown even all predefined values are filled&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Force manual input. The input dialog will shown even all predefined values are filled&lt;/p&gt;</value>
        public bool? forceManualInput { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a business unit ID will be returned and whether a business unit ID field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a business unit ID will be returned and whether a business unit ID field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessUnitIdRequired { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a business unit ID field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a business unit ID field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessUnitIdEditable { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies a predefined business unit ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies a predefined business unit ID.&lt;/p&gt;</value>
        public string businessUnitIdPredefined { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a current business unit ID shall be used if no predefined business unit ID is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a current business unit ID shall be used if no predefined business unit ID is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessUnitIdUseCurrent { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a business day date will be returned and whether a business day date field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a business day date will be returned and whether a business day date field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessDayDateRequired { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a business day date field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a business day date field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessDayDateEditable { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a predefined value is used for the business day date. Example value: 2015-01-22&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a predefined value is used for the business day date. Example value: 2015-01-22&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string businessDayDatePredefined { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a current business day date shall be used if no predefined business day date is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a current business day date shall be used if no predefined business day date is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? businessDayDateUseCurrent { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a workstation ID will be returned and whether a workstation ID field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a workstation ID will be returned and whether a workstation ID field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? workstationIdRequired { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a workstation ID field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a workstation ID field is editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? workstationIdEditable { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a predefined value is used for the workstation ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a predefined value is used for the workstation ID.&lt;/p&gt;</value>
        public string workstationIdPredefined { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a current workstation ID shall be used if no predefined workstation ID is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a current workstation ID shall be used if no predefined workstation ID is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? workstationIdUseCurrent { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a transaction sequence number will be returned and whether a transaction sequence number field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a transaction sequence number will be returned and whether a transaction sequence number field will be visible in a dialog.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? receiptNumberRequired { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a transaction sequence number field will be editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a transaction sequence number field will be editable.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? receiptNumberEditable { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a predefined transaction sequence number is used.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a predefined transaction sequence number is used.&lt;/p&gt;</value>
        public string receiptNumberPredefined { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a current transaction sequence number shall be used if no predefined transaction sequence number is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a current transaction sequence number shall be used if no predefined transaction sequence number is given.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? receiptNumberUseCurrent { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies, whether only non voided retail transaction receipts should be considered?&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies, whether only non voided retail transaction receipts should be considered?&lt;/p&gt;</value>
        public bool? useLastNonVoidedReceiptNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
