namespace POSGkSwaggerModel
{
    /// <summary>
    /// PromptUserDialogConfig &lt;p&gt;This configuration entity defines the process for prompting the user.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelConfigProcessUiPromptUserDialogConfig	{
        /// <summary>
        /// &lt;p&gt;This parameter defines the translation key for the title.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the translation key for the title.&lt;/p&gt;</value>
        public string titleKey { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the configuration identifier for a SignalConfig instance. The resolved configuration will be used for an acoustic signal performed in combination with the message dialog.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the configuration identifier for a SignalConfig instance. The resolved configuration will be used for an acoustic signal performed in combination with the message dialog.&lt;/p&gt;</value>
        public string signalConfigId { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines the input domain for the input field.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines the input domain for the input field.&lt;/p&gt;</value>
        public string inputDomain { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether an input is mandatory.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether an input is mandatory.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? inputMandatory { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether the cancellation of the dialog is allowed.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether the cancellation of the dialog is allowed.&lt;/p&gt;&lt;br /&gt;&lt;pre&gt;values: true, false&lt;br /&gt;&lt;/pre&gt;</value>
        public bool? cancelAllowed { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter defines an optional translation key for the label text.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter defines an optional translation key for the label text.&lt;/p&gt;</value>
        public string labelTextKey { get; init; }
        /// <summary>
        /// Gets or Sets MaxLengthOfTitleToSplit
        /// </summary>
        public int? maxLengthOfTitleToSplit { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
