namespace POSGkSwaggerModel
{
    /// <summary>
    /// StockAmountDetail &lt;p&gt;Entity which contains stock details for one location.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppItemInformationStockAmountDetail	{
        /// <summary>
        /// &lt;p&gt;The item id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item id&lt;/p&gt;</value>
        public string itemID { get; init; }
        /// <summary>
        /// &lt;p&gt;The unit of mesaure code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The unit of mesaure code.&lt;/p&gt;</value>
        public string uomCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The main pos item ID.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The main pos item ID.&lt;/p&gt;</value>
        public string mainPOSItemId { get; init; }
        /// <summary>
        /// &lt;p&gt;The business unit id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit id.&lt;/p&gt;</value>
        public string storeId { get; init; }
        /// <summary>
        /// &lt;p&gt;Store description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store description&lt;/p&gt;</value>
        public string storeDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;Store address&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store address&lt;/p&gt;</value>
        public string address { get; init; }
        /// <summary>
        /// &lt;p&gt;Store phone number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Store phone number&lt;/p&gt;</value>
        public string phoneNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Distance between that and the local store.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Distance between that and the local store.&lt;/p&gt;</value>
        public double? distance { get; init; }
        /// <summary>
        /// &lt;p&gt;Name of the item&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name of the item&lt;/p&gt;</value>
        public string name { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of item with stock state DEFAULT.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of item with stock state DEFAULT.&lt;/p&gt;</value>
        public double? stock { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of items with stock state IN-TRANSIT.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state IN-TRANSIT.&lt;/p&gt;</value>
        public double? inTransitStock { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of reserved items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of reserved items.&lt;/p&gt;</value>
        public double? reservedStock { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of items with stock state TRANSFER&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state TRANSFER&lt;/p&gt;</value>
        public double? transferStock { get; init; }
        /// <summary>
        /// &lt;p&gt;Number of items with stock state FREE&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Number of items with stock state FREE&lt;/p&gt;</value>
        public double? freeStock { get; init; }
        /// <summary>
        /// &lt;p&gt;Sum of items in TRANSFER and IN-TRANSIT state.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Sum of items in TRANSFER and IN-TRANSIT state.&lt;/p&gt;</value>
        public double? inFlow { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
