namespace POSGkSwaggerModel
{
    /// <summary>
    /// PrintAdditionalLineItemTextLine &lt;p&gt;Request object for printing additional text lines on receipts. This request object is used for instance in the processing of additional printout documents requested through app enablement feature.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppServicesTransactionPrintAdditionalLineItemTextLine	{
        /// <summary>
        /// &lt;p&gt;Text value to be printed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Text value to be printed.&lt;/p&gt;</value>
        public string text { get; init; }
        /// <summary>
        /// &lt;p&gt;Defines whether the text is printed before or after the line item.&lt;br /&gt; Possible values: &#39;afterLineItem&#39;, &#39;beforeLineItem&#39; and &#39;beforeSubtotalLine&#39;.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines whether the text is printed before or after the line item.&lt;br /&gt; Possible values: &#39;afterLineItem&#39;, &#39;beforeLineItem&#39; and &#39;beforeSubtotalLine&#39;.&lt;/p&gt;</value>
        public string sortOrder { get; init; }
        /// <summary>
        /// &lt;p&gt;Style identifier for a text printout.&lt;br /&gt; Possible values: &#39;NormalPlain&#39; and &#39;NormalBold&#39;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Style identifier for a text printout.&lt;br /&gt; Possible values: &#39;NormalPlain&#39; and &#39;NormalBold&#39;&lt;/p&gt;</value>
        public string styleID { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
