namespace POSGkSwaggerModel
{
    /// <summary>
    /// SaleReturnLineItemPromotionTrigger &lt;p&gt;Promotion trigger for a sale return line item.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiModelDomAppServicesTransactionSaleReturnLineItemPromotionTrigger	{
        /// <summary>
        /// &lt;p&gt;The identification of the manual trigger (because one line item can have more than one trigger).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identification of the manual trigger (because one line item can have more than one trigger).&lt;/p&gt;</value>
        public int? triggerSequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The type of the trigger (referencing to POS configuration).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The type of the trigger (referencing to POS configuration).&lt;/p&gt;</value>
        public string triggerType { get; init; }
        /// <summary>
        /// &lt;p&gt;The value of the trigger (referencing to POS configuration).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The value of the trigger (referencing to POS configuration).&lt;/p&gt;</value>
        public string triggerValue { get; init; }
        /// <summary>
        /// &lt;p&gt;Defines the method for price modification.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines the method for price modification.&lt;/p&gt;</value>
        public string privilegeType { get; init; }
        /// <summary>
        /// &lt;p&gt;Reduction amount, reduction percent or new price amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reduction amount, reduction percent or new price amount.&lt;/p&gt;</value>
        public double? privilegeValue { get; init; }
        /// <summary>
        /// &lt;p&gt;Reason code for the manual discount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reason code for the manual discount.&lt;/p&gt;</value>
        public string reasonCode { get; init; }
        /// <summary>
        /// &lt;p&gt;A narrative description describing the manual discount reason.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A narrative description describing the manual discount reason.&lt;/p&gt;</value>
        public string reasonDescription { get; init; }
        /// <summary>
        /// &lt;p&gt;A value which is to be added to the sequence of the condition (which comes from the master data).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A value which is to be added to the sequence of the condition (which comes from the master data).&lt;/p&gt;</value>
        public string triggerSequenceAddend { get; init; }
	}
}
