namespace POSGkSwaggerModel
{
    /// <summary>
    /// SalesOrderByIdV3Result &lt;p&gt;The sales order details returned froma sales order search by id.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderByIdSalesOrderByIdV3Result	{
        /// <summary>
        /// &lt;p&gt;The sales order id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The sales order id.&lt;/p&gt;</value>
        public string id { get; init; }
        /// <summary>
        /// &lt;p&gt;The sales order date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The sales order date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string date { get; init; }
        /// <summary>
        /// &lt;p&gt;The total gross amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total gross amount.&lt;/p&gt;</value>
        public double? totalValuesGrossAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The total net amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total net amount.&lt;/p&gt;</value>
        public double? totalValuesNetAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The total tax amount.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The total tax amount.&lt;/p&gt;</value>
        public double? totalValuesTaxAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer order life cycle status code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer order life cycle status code.&lt;/p&gt;</value>
        public string statusCustomerOrderLifeCycleStatusCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Processing type code of sales order based on delivery type.&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;Pick up at another store: &#39;ZTA2&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Immediate pickup: &#39;SO&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Delivery from warehouse: &#39;TA&#39;,&lt;/li&gt;&lt;br /&gt; &lt;li&gt;Pickup from store: &#39;TA&#39;&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string processingTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer id.&lt;/p&gt;</value>
        public string customerId { get; init; }
        /// <summary>
        /// &lt;p&gt;The price component list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The price component list.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderWrapperSalesOrderPriceComponentV3> PriceComponents { get; init; }
        /// <summary>
        /// &lt;p&gt;The item list.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item list.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderByIdSalesOrderExtendedItemDataV3> Items { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
