namespace POSGkSwaggerModel
{
    /// <summary>
    /// SalesOrderChangeConfirmationRequest &lt;p&gt;Request object for creating a sales order change confirmation.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesSalesOrderChangeConfirmationRequest	{
        /// <summary>
        /// &lt;p&gt;The store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The store id.&lt;/p&gt;</value>
        public string storeId { get; init; }
        /// <summary>
        /// &lt;p&gt;The date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string date { get; init; }
        /// <summary>
        /// &lt;p&gt;The POS id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The POS id.&lt;/p&gt;</value>
        public string posId { get; init; }
        /// <summary>
        /// &lt;p&gt;Sales order sequence number. This number is used for assembling a header uui for a sales order operation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Sales order sequence number. This number is used for assembling a header uui for a sales order operation.&lt;/p&gt;</value>
        public int? sequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The delivery blocking reason code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The delivery blocking reason code.&lt;/p&gt;</value>
        public string deliveryBlockingReasonCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Sales order number (Token of length 1-10).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Sales order number (Token of length 1-10).&lt;/p&gt;</value>
        public string salesOrderId { get; init; }
        /// <summary>
        /// &lt;p&gt;Price components containing condition data of the sales order.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Price components containing condition data of the sales order.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestPriceComponent> PriceComponents { get; init; }
        /// <summary>
        /// &lt;p&gt;Sales order items.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Sales order items.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderChangeRequestConfirmationEntitiesChangeConfirmationRequestItem> Items { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether service is called on training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether service is called on training mode.&lt;/p&gt;</value>
        public bool? trainingMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
