namespace POSGkSwaggerModel
{
    /// <summary>
    /// CreateConfirmationRequestItem &lt;p&gt;Request object for a sales order item creation.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateRequestConfirmationEntitiesCreateConfirmationRequestItem	{
        /// <summary>
        /// &lt;p&gt;The item id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item id.&lt;/p&gt;</value>
        public string id { get; init; }
        /// <summary>
        /// &lt;p&gt;The item receipt text description.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The item receipt text description.&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;The product internal id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product internal id.&lt;/p&gt;</value>
        public string productInternalId { get; init; }
        /// <summary>
        /// &lt;p&gt;The product sales measure unit code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The product sales measure unit code.&lt;/p&gt;</value>
        public string productSalesMeasureUnitCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The delivery date.&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string dateTermsRequestDate { get; init; }
        /// <summary>
        /// &lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The id of plant where items will be delivered to. E.g.: store id.&lt;/p&gt;</value>
        public string deliveryTermsDeliveryPlantId { get; init; }
        /// <summary>
        /// &lt;p&gt;The requested quantity.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The requested quantity.&lt;/p&gt;</value>
        public double? totalValuesRequestedQuantity { get; init; }
        /// <summary>
        /// &lt;p&gt;Id of receiving point party (Token of length 1-32). E.g.: store id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Id of receiving point party (Token of length 1-32). E.g.: store id.&lt;/p&gt;</value>
        public string receivingPointPartyInternalId { get; init; }
        /// <summary>
        /// &lt;p&gt;Line item condition data.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Line item condition data.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceCommunicationWsSalesOrderCreateRequestConfirmationEntitiesCreateConfirmationRequestItemPriceComponent> PriceComponents { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
