namespace POSGkSwaggerModel
{
    /// <summary>
    /// Address &lt;p&gt;Object for address data&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceCrmTypesAddress	{
        /// <summary>
        /// &lt;p&gt;String: The first line of the address, normally the street number and name.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The first line of the address, normally the street number and name.&lt;/p&gt;</value>
        public string addressLine1 { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The second line of an address, normally the Flat or Building Suite number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The second line of an address, normally the Flat or Building Suite number.&lt;/p&gt;</value>
        public string addressLine2 { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The third line of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The third line of the address.&lt;/p&gt;</value>
        public string addressLine3 { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The fourth line of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The fourth line of the address.&lt;/p&gt;</value>
        public string addressLine4 { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The fifth line of the address.It is normally used for the salutation.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The fifth line of the address.It is normally used for the salutation.&lt;/p&gt;</value>
        public string addressLine5 { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The city, town or village component of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The city, town or village component of the address.&lt;/p&gt;</value>
        public string city { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The County, State, Province, Territory etc component of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The County, State, Province, Territory etc component of the address.&lt;/p&gt;</value>
        public string territory { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The name of the County, State, Province, Territory etc. component of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The name of the County, State, Province, Territory etc. component of the address.&lt;/p&gt;</value>
        public string territoryName { get; init; }
        /// <summary>
        /// &lt;p&gt;String: This field is used to specify the territory or city more concrete, for example for storing the district or suburb of a certain city.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: This field is used to specify the territory or city more concrete, for example for storing the district or suburb of a certain city.&lt;/p&gt;</value>
        public string subTerritoryName { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The postal or zip code of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The postal or zip code of the address.&lt;/p&gt;</value>
        public string postalCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The extension of the postal or zip code that further specifies a particular postal district.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The extension of the postal or zip code that further specifies a particular postal district.&lt;/p&gt;</value>
        public string postalCodeExtension { get; init; }
        /// <summary>
        /// &lt;p&gt;String: The ISO country code of the address.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: The ISO country code of the address.&lt;/p&gt;</value>
        public string isoCountryCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
