namespace POSGkSwaggerModel
{
    /// <summary>
    /// MoveLineItemsRequest &lt;p&gt;Request entity for &#39;MoveLineItems&#39; service.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceHospitalityMoveLineItemsRequest	{
        /// <summary>
        /// &lt;p&gt;The identifier for the source transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for the source transaction.&lt;/p&gt;</value>
        public string sourceTransactionKey { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier for the target transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier for the target transaction.&lt;/p&gt;</value>
        public string targetTransactionKey { get; init; }
        /// <summary>
        /// &lt;p&gt;The position operation configuration (need e.g. for internal void operations).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration (need e.g. for internal void operations).&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag is all line items should be moved.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag is all line items should be moved.&lt;/p&gt;</value>
        public bool? moveAllLineItems { get; init; }
        /// <summary>
        /// &lt;p&gt;List of line items which should be moved.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of line items which should be moved.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceHospitalityMoveLineItem> LineItemList { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
