namespace POSGkSwaggerModel
{
    /// <summary>
    /// PaymentPlanRequest &lt;p&gt;Request of a Calculation of Payment Plan&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceLayawayPaymentPlanRequest	{
        /// <summary>
        /// &lt;p&gt;Count of valid Days.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Count of valid Days.&lt;/p&gt;</value>
        public int? layawayValidDays { get; init; }
        /// <summary>
        /// &lt;p&gt;Count of payment Days.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Count of payment Days.&lt;/p&gt;</value>
        public int? paymentDays { get; init; }
        /// <summary>
        /// &lt;p&gt;Time after expiration layway can shipped.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Time after expiration layway can shipped.&lt;/p&gt;</value>
        public int? toleranceTime { get; init; }
        /// <summary>
        /// &lt;p&gt;Time when Layaway will be deleted if expired.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Time when Layaway will be deleted if expired.&lt;/p&gt;</value>
        public int? deletingTime { get; init; }
        /// <summary>
        /// &lt;p&gt;Fee Percent for cancellation a Layaway.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Fee Percent for cancellation a Layaway.&lt;/p&gt;</value>
        public double? cancellationFeePercent { get; init; }
        /// <summary>
        /// &lt;p&gt;Fee Amount for cancellation a Layaway.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Fee Amount for cancellation a Layaway.&lt;/p&gt;</value>
        public double? cancellationFeeAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;penalty fee percent if layway expired or cancelled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;penalty fee percent if layway expired or cancelled.&lt;/p&gt;</value>
        public double? penaltyFeePercent { get; init; }
        /// <summary>
        /// &lt;p&gt;penalty fee amount if layway expired or cancelled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;penalty fee amount if layway expired or cancelled.&lt;/p&gt;</value>
        public double? penaltyFeeAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
