namespace POSGkSwaggerModel
{
    /// <summary>
    /// AmountValidationRequest &lt;p&gt;A request wrapper for all informations required to validate and check a payment amount&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServicePaymentAmountValidationRequest	{
        /// <summary>
        /// &lt;p&gt;double : amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : amount&lt;/p&gt;</value>
        public double? amount { get; init; }
        /// <summary>
        /// &lt;p&gt;TenderDO : tender&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;TenderDO : tender&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdtenderDtoDomtenderDO tender { get; init; }
        /// <summary>
        /// &lt;p&gt;String : iso currency code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : iso currency code&lt;/p&gt;</value>
        public string isoCurrencyCode { get; init; }
        /// <summary>
        /// &lt;p&gt;double : current tender total payment amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : current tender total payment amount&lt;/p&gt;</value>
        public double? currentTenderTotalPaymentAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;String : payment state&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : payment state&lt;/p&gt;</value>
        public string paymentState { get; init; }
        /// <summary>
        /// &lt;p&gt;String : allowed amount type code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : allowed amount type code&lt;/p&gt;</value>
        public string allowedAmountTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
