namespace POSGkSwaggerModel
{
    /// <summary>
    /// PayableAmountResult &lt;p&gt;Result object of the PaymentService&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServicePaymentPayableAmountResult	{
        /// <summary>
        /// &lt;p&gt;The primary transaction result entry.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The primary transaction result entry.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry primaryEntry { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional result entries.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional result entries.&lt;/p&gt;</value>
        public List<comGkSoftwarePosApiServiceTransactionTransactionOperationResultEntry> AdditionalEntries { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether the transaction result is filtered. A filtered transaction does not contain the details of a retail transaction object in order to optimize service communication.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the transaction result is filtered. A filtered transaction does not contain the details of a retail transaction object in order to optimize service communication.&lt;/p&gt;</value>
        public bool? filtered { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to a failure entity in case a failure occurs during a service execution. This field can be used when a managed exception occurs and we still want to synchronize the resulting transaction instead of throwing an exception containing no information on transaction updates.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to a failure entity in case a failure occurs during a service execution. This field can be used when a managed exception occurs and we still want to synchronize the resulting transaction instead of throwing an exception containing no information on transaction updates.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionTransactionOperationfailureResult failure { get; init; }
        /// <summary>
        /// &lt;p&gt;double : change amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : change amount&lt;/p&gt;</value>
        public double? changeAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : foreign currency change amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : foreign currency change amount&lt;/p&gt;</value>
        public double? foreignCurrencyChangeAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : grand total amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : grand total amount&lt;/p&gt;</value>
        public double? grandTotalAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : foreign currency grand total amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : foreign currency grand total amount&lt;/p&gt;</value>
        public double? foreignCurrencyGrandTotalAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : payed amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : payed amount&lt;/p&gt;</value>
        public double? payedAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : foreign currency payed amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : foreign currency payed amount&lt;/p&gt;</value>
        public double? foreignCurrencyPayedAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount: tip amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount: tip amount&lt;/p&gt;</value>
        public double? tipAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : base currency tender payable amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : base currency tender payable amount&lt;/p&gt;</value>
        public double? baseCurrencyTenderPayableAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;double : foreign currency tender payable amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : foreign currency tender payable amount&lt;/p&gt;</value>
        public double? foreignCurrencyTenderPayableAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean : mgh tender permission rules checked&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : mgh tender permission rules checked&lt;/p&gt;</value>
        public bool? mghTenderPermissionRulesChecked { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
