namespace POSGkSwaggerModel
{
    /// <summary>
    /// PointsPaymentRequest &lt;p&gt;Request object used by points payment operations.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServicePaymentPointsPaymentRequest	{
        /// <summary>
        /// &lt;p&gt;PositionOperationConfig: position operation config&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;PositionOperationConfig: position operation config&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionpositionOperationConfig positionOperationConfig { get; init; }
        /// <summary>
        /// &lt;p&gt;TenderDO: tender&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;TenderDO: tender&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdtenderDtoDomtenderDO tender { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount: amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount: amount&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppamountamount amount { get; init; }
        /// <summary>
        /// &lt;p&gt;Amount: tip amount&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Amount: tip amount&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppAmountAmount tipAmount { get; init; }
        /// <summary>
        /// &lt;p&gt;String: base iso currency code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: base iso currency code&lt;/p&gt;</value>
        public string baseIsoCurrencyCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String: foreign iso currency code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String: foreign iso currency code&lt;/p&gt;</value>
        public string foreignIsoCurrencyCode { get; init; }
        /// <summary>
        /// &lt;p&gt;double: exchange rate&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double: exchange rate&lt;/p&gt;</value>
        public double? exchangeRate { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean: multiply flag&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean: multiply flag&lt;/p&gt;</value>
        public bool? multiplyFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;String : tender class code&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : tender class code&lt;/p&gt;</value>
        public string tenderClassCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String : payment description&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : payment description&lt;/p&gt;</value>
        public string paymentDescription { get; init; }
        /// <summary>
        /// Gets or Sets KeyedOnline
        /// </summary>
        public bool? keyedOnline { get; init; }
        /// <summary>
        /// &lt;p&gt;String : customer account id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : customer account id&lt;/p&gt;</value>
        public string customerAccountId { get; init; }
        /// <summary>
        /// &lt;p&gt;String : redemption transaction id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : redemption transaction id&lt;/p&gt;</value>
        public string redemptionTransactionId { get; init; }
        /// <summary>
        /// &lt;p&gt;double : points redemption conversion factor&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;double : points redemption conversion factor&lt;/p&gt;</value>
        public double? pointsRedemptionConversionFactor { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
