namespace POSGkSwaggerModel
{
    /// <summary>
    /// SpecialReturnAmountLookupKeyRequest &lt;p&gt;Request object to obtain a special return amount lookup key.&lt;br /&gt; Request must contain either the tender or both tenderTypeCode and itemRestrictionTypeCode.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServicePaymentSpecialReturnAmountLookupKeyRequest	{
        /// <summary>
        /// &lt;p&gt;TenderDO : tender to obtain tender type code and item restriction type code from.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;TenderDO : tender to obtain tender type code and item restriction type code from.&lt;/p&gt;</value>
        public ComGkSoftwareGkrApiServerMdtenderDtoDomtenderDO tender { get; init; }
        /// <summary>
        /// &lt;p&gt;String : tender type code to use to generate lookup key. Required if tender is null. If specified when tender is not null, this tender type code and the Tender&#39;s item restriction typecode will be used to generate the lookup key.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : tender type code to use to generate lookup key. Required if tender is null. If specified when tender is not null, this tender type code and the Tender&#39;s item restriction typecode will be used to generate the lookup key.&lt;/p&gt;</value>
        public string tenderTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;String : item restriction type code to use to generate lookup key. Optional; null should be passed in if not relevant. Only used if tender is null.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : item restriction type code to use to generate lookup key. Optional; null should be passed in if not relevant. Only used if tender is null.&lt;/p&gt;</value>
        public string itemRestrictionTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
