namespace POSGkSwaggerModel
{
    /// <summary>
    /// AuthorizationRequest &lt;p&gt;Request object for the AuthorizationService&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSecurityAuthorizationRequest	{
        /// <summary>
        /// &lt;p&gt;String : original operator login name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : original operator login name&lt;/p&gt;</value>
        public string originalOperatorLoginName { get; init; }
        /// <summary>
        /// &lt;p&gt;String : authorizing operator login name&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : authorizing operator login name&lt;/p&gt;</value>
        public string authorizingOperatorLoginName { get; init; }
        /// <summary>
        /// &lt;p&gt;String : authorizing operator password&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : authorizing operator password&lt;/p&gt;</value>
        public string authorizingOperatorPassword { get; init; }
        /// <summary>
        /// &lt;p&gt;String : right id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : right id&lt;/p&gt;</value>
        public string rightId { get; init; }
        /// <summary>
        /// &lt;p&gt;String : entry method code. It specifies how the action was triggered (keyed, scanned, ...)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;String : entry method code. It specifies how the action was triggered (keyed, scanned, ...)&lt;/p&gt;</value>
        public string entryMethodCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to line item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to line item.&lt;/p&gt;</value>
        public bool? lineItemRelevant { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to retail transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to retail transaction.&lt;/p&gt;</value>
        public bool? retailTransactionRelevant { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to control transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to control transaction.&lt;/p&gt;</value>
        public bool? controlTransactionRelevant { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates that operation is related to tender control transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates that operation is related to tender control transaction.&lt;/p&gt;</value>
        public bool? tenderControlTransactionRelevant { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean : authorizing operator must have rights&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : authorizing operator must have rights&lt;/p&gt;</value>
        public bool? authorizingOperatorMustHaveRights { get; init; }
        /// <summary>
        /// &lt;p&gt;boolean : skip password check&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;boolean : skip password check&lt;/p&gt;</value>
        public bool? skipPasswordCheck { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
