namespace POSGkSwaggerModel
{
    /// <summary>
    /// PosGroupOperatorLoginRequest &lt;p&gt;Request object to perform a pos group operator login.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSessionPosgroupPosGroupOperatorLoginRequest	{
        /// <summary>
        /// &lt;p&gt;The retail store identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store identifier.&lt;/p&gt;</value>
        public string retailStoreId { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation identifier.&lt;/p&gt;</value>
        public string workstationId { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation type code.&lt;/p&gt;</value>
        public string workstationTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The client version.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The client version.&lt;/p&gt;</value>
        public string clientVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;The operator login name.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operator login name.&lt;/p&gt;</value>
        public string loginName { get; init; }
        /// <summary>
        /// &lt;p&gt;The operator password.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operator password.&lt;/p&gt;</value>
        public string password { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate whether the password is required or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether the password is required or not.&lt;/p&gt;</value>
        public bool? passwordRequired { get; init; }
        /// <summary>
        /// &lt;p&gt;The till identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The till identifier.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionTillDoKey tillId { get; init; }
        /// <summary>
        /// &lt;p&gt;If set the pos group operator permissions are checked against this right.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;If set the pos group operator permissions are checked against this right.&lt;/p&gt;</value>
        public string requiredRight { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate whether training mode is active or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether training mode is active or not.&lt;/p&gt;</value>
        public bool? trainingMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
