namespace POSGkSwaggerModel
{
    /// <summary>
    /// MDReplicationEndEvent &lt;p&gt;Event object for master data replication end.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSmartposMDReplicationEndEvent	{
        /// <summary>
        /// &lt;p&gt;The store id (business unit id).&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The store id (business unit id).&lt;/p&gt;</value>
        public string storeNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if process ended without failure.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if process ended without failure.&lt;/p&gt;</value>
        public bool? success { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if new pump was downloaded, data transfered to database and databases were switched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if new pump was downloaded, data transfered to database and databases were switched.&lt;/p&gt;</value>
        public bool? newPumpUsed { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether new transport objects were saved during master data replication.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether new transport objects were saved during master data replication.&lt;/p&gt;</value>
        public bool? newTransportObjectsSaved { get; init; }
        /// <summary>
        /// &lt;p&gt;Id of last changed entity during master data replication.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Id of last changed entity during master data replication.&lt;/p&gt;</value>
        public string lastChangedEntityId { get; init; }
        /// <summary>
        /// &lt;p&gt;Message key of failure cause.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Message key of failure cause.&lt;/p&gt;</value>
        public string failKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Localized message of failure cause.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Localized message of failure cause.&lt;/p&gt;</value>
        public string failCause { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
