namespace POSGkSwaggerModel
{
    /// <summary>
    /// ApplicationInfo &lt;p&gt;Data object for service application information.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceSystemApplicationInfo	{
        /// <summary>
        /// &lt;p&gt;Application version.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Application version.&lt;/p&gt;</value>
        public string appVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;Application revision number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Application revision number.&lt;/p&gt;</value>
        public string appRevision { get; init; }
        /// <summary>
        /// &lt;p&gt;Application build number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Application build number.&lt;/p&gt;</value>
        public string appBuildNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Application build date.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Application build date.&lt;/p&gt;</value>
        public string appFormattedDate { get; init; }
        /// <summary>
        /// &lt;p&gt;JDK version used in application build.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;JDK version used in application build.&lt;/p&gt;</value>
        public string appJdkVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;A key-value pair map of strings for fiscalization information. Extension point for projects to load fiscalization specific information into this map.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A key-value pair map of strings for fiscalization information. Extension point for projects to load fiscalization specific information into this map.&lt;/p&gt;</value>
        public Dictionary<string, string> FiscalizationInfo { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
