namespace POSGkSwaggerModel
{
    /// <summary>
    /// ComboMealRegistrationRequest &lt;p&gt;Domain object for ComboMealRegistration&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionComboMealRegistrationRequest	{
        /// <summary>
        /// &lt;p&gt;Flag if line item to register is the main line item of the &#39;Combo Meal&#39;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag if line item to register is the main line item of the &#39;Combo Meal&#39;&lt;/p&gt;</value>
        public bool? mainLineItem { get; init; }
        /// <summary>
        /// &lt;p&gt;The line item key of the &#39;Combo Meal&#39; main line item. This field should only be set for related item registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item key of the &#39;Combo Meal&#39; main line item. This field should only be set for related item registration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionLineItemKey mainLineItemKey { get; init; }
        /// <summary>
        /// &lt;p&gt;The original price of the &#39;Combo Meal&#39; related line item (max(ComponentItem.currentPrice) of all standard items of the component).&lt;br /&gt; This field should only be set for related item registration and if the related item is an alternative item.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The original price of the &#39;Combo Meal&#39; related line item (max(ComponentItem.currentPrice) of all standard items of the component).&lt;br /&gt; This field should only be set for related item registration and if the related item is an alternative item.&lt;/p&gt;</value>
        public double? relatedLineItemOriginalPrice { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag if &#39;discount shares calculation&#39; should be processed during registration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag if &#39;discount shares calculation&#39; should be processed during registration.&lt;/p&gt;</value>
        public bool? calculateDiscountShares { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
