namespace POSGkSwaggerModel
{
    /// <summary>
    /// CreateFailFiscalTransactionRequest &lt;p&gt;Request object to create a fiscal fail transaction.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionCreateFailFiscalTransactionRequest	{
        /// <summary>
        /// &lt;p&gt;The fiscalization data that should be added to the fiscal fail transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The fiscalization data that should be added to the fiscal fail transaction.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionAddfiscalizationDataToTransactionRequest fiscalizationData { get; init; }
        /// <summary>
        /// &lt;p&gt;The identifier of the original transaction for that the fiscal fail transaction should be created.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The identifier of the original transaction for that the fiscal fail transaction should be created.&lt;/p&gt;</value>
        public string originalTransactionID { get; init; }
        /// <summary>
        /// &lt;p&gt;The retail store identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The retail store identifier.&lt;/p&gt;</value>
        public string retailStoreId { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation identifier.&lt;/p&gt;</value>
        public string workstationId { get; init; }
        /// <summary>
        /// &lt;p&gt;The client version.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The client version.&lt;/p&gt;</value>
        public string clientVersion { get; init; }
        /// <summary>
        /// &lt;p&gt;The operator identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The operator identifier.&lt;/p&gt;</value>
        public string operatorId { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
