namespace POSGkSwaggerModel
{
    /// <summary>
    /// CustomerRegistrationRequest &lt;p&gt;Request object for the CustomerTransactionService&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionCustomerCustomerRegistrationRequest	{
        /// <summary>
        /// &lt;p&gt;The customer identifier (customer id / party identification)&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer identifier (customer id / party identification)&lt;/p&gt;</value>
        public string identifier { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer group id&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer group id&lt;/p&gt;</value>
        public string customerGroupId { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer card type&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card type&lt;/p&gt;</value>
        public string customerCardType { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer card number&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card number&lt;/p&gt;</value>
        public string customerCardNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer card type description key&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer card type description key&lt;/p&gt;</value>
        public string customerCardTypeDescriptionKey { get; init; }
        /// <summary>
        /// &lt;p&gt;In case that &#39;searchDatabase&#39; setting is set to false the value of&lt;br /&gt; that property is used to determine where the search should be executed.&lt;br /&gt; Possible values are:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;SAP_ERP (default)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;SAP_CRM&lt;/li&gt;&lt;br /&gt; &lt;li&gt;VALUEPHONE&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;In case that &#39;searchDatabase&#39; setting is set to false the value of&lt;br /&gt; that property is used to determine where the search should be executed.&lt;br /&gt; Possible values are:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;SAP_ERP (default)&lt;/li&gt;&lt;br /&gt; &lt;li&gt;SAP_CRM&lt;/li&gt;&lt;br /&gt; &lt;li&gt;VALUEPHONE&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string useWebService { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether the customer should be searched in local MD database.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether the customer should be searched in local MD database.&lt;/p&gt;</value>
        public bool? searchDatabase { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameters works only in combination with searchDatabase&#x3D;true, it&lt;br /&gt; specifies the type of customer identifier:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;false: search by party identification is executed&lt;/li&gt;&lt;br /&gt; &lt;li&gt;true: search by customer id is executed&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameters works only in combination with searchDatabase&#x3D;true, it&lt;br /&gt; specifies the type of customer identifier:&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;false: search by party identification is executed&lt;/li&gt;&lt;br /&gt; &lt;li&gt;true: search by customer id is executed&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public bool? searchForIdentificationNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates if the service was started in training mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates if the service was started in training mode.&lt;/p&gt;</value>
        public bool? trainingMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
