namespace POSGkSwaggerModel
{
    /// <summary>
    /// RetrieveSuspendedRetailTransactionsByIdsRequest &lt;p&gt;Request object for retrieving suspended retail transactions&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionRetrieveSuspendedRetailTransactionsByIdsRequest	{
        /// <summary>
        /// &lt;p&gt;A list of transaction identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of transaction identifiers.&lt;/p&gt;</value>
        public List<string> TransactionIds { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that only suspended transaction with workstation type code for self scanning are wanted.&lt;/p&gt;</value>
        public bool? onlySSCTransactions { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate that the customer assignment from the suspended transaction should be taken over to the current transaction.&lt;/p&gt;</value>
        public bool? overtakeCustomerFromOriginalReceipt { get; init; }
        /// <summary>
        /// &lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The alternative tax informations for updating the tax group.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessFlowsalternativeTaxInfos alternativeTaxInfos { get; init; }
        /// <summary>
        /// &lt;p&gt;A flag to indicate whether transactions from other stores are allowed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A flag to indicate whether transactions from other stores are allowed.&lt;/p&gt;</value>
        public bool? allowOtherStores { get; init; }
        /// <summary>
        /// &lt;p&gt;The promotion handling. If set to &#39;OLDDISCOUNTS&#39; the retail price modifier for the retrieved item gets the flag externalSystemOriginatorFlag set to true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The promotion handling. If set to &#39;OLDDISCOUNTS&#39; the retail price modifier for the retrieved item gets the flag externalSystemOriginatorFlag set to true.&lt;/p&gt;</value>
        public string promotionHandling { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter defines, if the consolidation of retrieving transactions should be executed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines, if the consolidation of retrieving transactions should be executed.&lt;/p&gt;</value>
        public bool? consolidateLineItemsRetrieve { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter controls, whether items with SaleReturnLineItem.ActionCode &#x3D; RI should be consolidated or not.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter controls, whether items with SaleReturnLineItem.ActionCode &#x3D; RI should be consolidated or not.&lt;/p&gt;</value>
        public bool? consolidateReturnItems { get; init; }
        /// <summary>
        /// &lt;p&gt;The parameter defines, if rescan feature is enabled.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The parameter defines, if rescan feature is enabled.&lt;/p&gt;</value>
        public bool? rescanEnabled { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
