namespace POSGkSwaggerModel
{
    /// <summary>
    /// SearchCustomerTransactionsRequest &lt;p&gt;Request object for the search customer transactions operation.&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionSearchCustomerTransactionsRequest	{
        /// <summary>
        /// &lt;p&gt;A list of customer identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of customer identifiers.&lt;/p&gt;</value>
        public List<string> CustomerIds { get; init; }
        /// <summary>
        /// &lt;p&gt;The begin date timestamp greater or equals (as part of the search criteria).&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The begin date timestamp greater or equals (as part of the search criteria).&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string beginDateTimestampGreaterOrEquals { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation type code.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation type code.&lt;/p&gt;</value>
        public string workstationTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;The maximum count of receipts. The search result will be limited to that number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The maximum count of receipts. The search result will be limited to that number.&lt;/p&gt;</value>
        public int? maxReceiptCount { get; init; }
        /// <summary>
        /// &lt;p&gt;The suspended flag. If set to true only transactions with isSuspended flag true and isRetrieved flag false are searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The suspended flag. If set to true only transactions with isSuspended flag true and isRetrieved flag false are searched.&lt;/p&gt;</value>
        public bool? suspendedFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;The ISO currency code. If set only suspended transactions with matching criteria are searched.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The ISO currency code. If set only suspended transactions with matching criteria are searched.&lt;/p&gt;</value>
        public string iSOCurrencyCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
