namespace POSGkSwaggerModel
{
    /// <summary>
    /// SetQuantityRequest &lt;p&gt;Domain object for SetQuantity Request&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionSetQuantityRequest	{
        /// <summary>
        /// &lt;p&gt;The trigger of the SetQuantityForLineItem process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The trigger of the SetQuantityForLineItem process.&lt;/p&gt;</value>
        public processTriggerEnum? processTrigger { get; init; }
        /// <summary>
        /// &lt;p&gt;The position operation configuration.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The position operation configuration.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelConfigProcessActionPositionOperationConfig operationConfiguration { get; init; }
        /// <summary>
        /// &lt;p&gt;The line item key the operation refers to.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The line item key the operation refers to.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiModelDomAppServicesTransactionRetailTransactionlineItemKey lineItemKey { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicated whether the item should be returned or registered.&lt;/p&gt;</value>
        public bool? returnMode { get; init; }
        /// <summary>
        /// &lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Flag indicating client is in empties return mode.&lt;/p&gt;</value>
        public bool? emptiesReturnMode { get; init; }
        /// <summary>
        /// &lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;This parameter specifies whether a return receipt should be created for returned items.&lt;br /&gt; This has only an impact in case returnMode&#x3D;true.&lt;/p&gt;</value>
        public bool? createReturnReceipt { get; init; }
        /// <summary>
        /// &lt;p&gt;The quantity input.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The quantity input.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceTransactionquantityInput quantityInput { get; init; }
        /// <summary>
        /// &lt;p&gt;The active customer order id.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The active customer order id.&lt;/p&gt;</value>
        public string activeCustomerOrderId { get; init; }
        /// <summary>
        /// &lt;p&gt;The customer sequence number.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The customer sequence number.&lt;/p&gt;</value>
        public int? customerSequenceNumber { get; init; }
        /// <summary>
        /// &lt;p&gt;Set to false if validations should be skip. Default value is true.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Set to false if validations should be skip. Default value is true.&lt;/p&gt;</value>
        public bool? validate { get; init; }
        /// <summary>
        /// &lt;p&gt;Set to true if single quantity limit was exceeded and successfully authorized&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Set to true if single quantity limit was exceeded and successfully authorized&lt;/p&gt;</value>
        public bool? exceededSingleQuantityAuthorized { get; init; }
        /// <summary>
        /// &lt;p&gt;The weight result of a previously executed weighing process.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The weight result of a previously executed weighing process.&lt;/p&gt;</value>
        public ComGkSoftwarePosApiServiceClientHardwareScaleweightResult weightResult { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
