namespace POSGkSwaggerModel
{
    /// <summary>
    /// UnfinishedTransactionsRequest &lt;p&gt;Request object for operations with unfinished transactions (e.g. searching unfinished transactions).&lt;/p&gt;
    /// </summary>
    public record comGkSoftwarePosApiServiceTransactionUnfinishedTransactionsRequest	{
        /// <summary>
        /// &lt;p&gt;The business unit identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The business unit identifier.&lt;/p&gt;</value>
        public string businessUnitId { get; init; }
        /// <summary>
        /// &lt;p&gt;The workstation identifier.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The workstation identifier.&lt;/p&gt;</value>
        public string workStationId { get; init; }
        /// <summary>
        /// &lt;p&gt;A list of transaction type codes. If set only unfinished transactions with a matching transaction type code are processed.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of transaction type codes. If set only unfinished transactions with a matching transaction type code are processed.&lt;/p&gt;</value>
        public List<string> TransactionTypeCodes { get; init; }
        /// <summary>
        /// &lt;p&gt;The transaction category code. Only used for finishing unfinished transactions and if it is set to &#39;AUTO&#39; for an automatic fail control transaction.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The transaction category code. Only used for finishing unfinished transactions and if it is set to &#39;AUTO&#39; for an automatic fail control transaction.&lt;/p&gt;</value>
        public string transactionCategoryCode { get; init; }
        /// <summary>
        /// &lt;p&gt;A list of transaction identifiers.&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A list of transaction identifiers.&lt;/p&gt;</value>
        public List<string> TransactionIds { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Customizable information&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Customizable information&lt;/p&gt;</value>
        public string xXCustom01 { get; init; }
	}
}
