namespace POSGkSwaggerModel
{
    /// <summary>
    /// MhgSO &lt;p&gt;Merchandise hierarchy group definition.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterData_MerchandiseHierarchyGroup.xml and masterData_BusinessUnit.xml.&lt;br /&gt; The definition of merchandise hierarchy groups is imported from masterData_MerchandiseHierarchyGroup.xml. The masterData_BusinessUnit.xml allows import additional details. If the MHG from masterData_BusinessUnit.xml does not exist, it is created.&lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareSweeSesApiServerMdMhgDtoSoMhgSO	{
        /// <summary>
        /// &lt;p&gt;Identifier of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.MerchandiseHierarchyGroupID&lt;br /&gt; masterData_BusinessUnit.xml: BusinessUnit.MerchandiseHierarchyGroupDetail.MerchandiseHierarchyGroupID.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Identifier of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.MerchandiseHierarchyGroupID&lt;br /&gt; masterData_BusinessUnit.xml: BusinessUnit.MerchandiseHierarchyGroupDetail.MerchandiseHierarchyGroupID.&lt;br /&gt;&lt;/p&gt;</value>
        public string merchandiseHierarchyGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;merchandise HierarchyGroup ID Qualifier&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;merchandise HierarchyGroup ID Qualifier&lt;br /&gt;&lt;/p&gt;</value>
        public string merchandiseHierarchyGroupIDQualifier { get; init; }
        /// <summary>
        /// &lt;p&gt;The name of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: first 40 characters from MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The name of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: first 40 characters from MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;</value>
        public string name { get; init; }
        /// <summary>
        /// &lt;p&gt;The description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.Description&lt;br /&gt;&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;The tax group assigned to the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TaxGroupID&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The tax group assigned to the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TaxGroupID&lt;br /&gt;&lt;/p&gt;</value>
        public string taxGroupID { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to the ItemSellingRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemSellingRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the ItemSellingRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemSellingRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string itemSellingRuleID { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to the ItemMerchandiseManagementRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from MerchandiseHierarchyGroup.DefaultLayoutClass and MerchandiseHierarchyGroup.DefaultLabelCount.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.NegativePositionFlag.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the ItemMerchandiseManagementRule object.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from MerchandiseHierarchyGroup.DefaultLayoutClass and MerchandiseHierarchyGroup.DefaultLabelCount.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;masterData_BusinessUnit.xml:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;The referred ItemMerchandiseManagementRule object is created / loaded from BusinessUnit.MerchandiseHierarchyGroupDetail.NegativePositionFlag.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string itemMerchandiseManagementRuleID { get; init; }
        /// <summary>
        /// &lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Internal identification of the import package (e.g. IDoc file). The identification is used for monitoring purposes.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string packageID { get; init; }
        /// <summary>
        /// &lt;p&gt;A unique system assigned identifier for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported. Generated for the levelName.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique system assigned identifier for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported. Generated for the levelName.&lt;br /&gt;&lt;/p&gt;</value>
        public string merchandiseHierarchyLevelID { get; init; }
        /// <summary>
        /// &lt;p&gt;Name for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.LevelName&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name for the level within the merchandise hierarchy tree.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.LevelName&lt;br /&gt;&lt;/p&gt;</value>
        public string levelName { get; init; }
        /// <summary>
        /// &lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string tid { get; init; }
        /// <summary>
        /// &lt;p&gt;List of translations for description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TranslationList&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of translations for description of the merchandise hierarchy group.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.TranslationList&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerMdMhgDtoSoMHGTranslationSO> TranslationList { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_05&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_05&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_03&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_03&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_02&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_02&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_04&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_04&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_01&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; masterData_MerchandiseHierarchyGroup.xml: MerchandiseHierarchyGroup.xx_custom_01&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
