namespace POSGkSwaggerModel
{
    /// <summary>
    /// PromotionConditionEligibilitySO &lt;p&gt;Promotion eligibility&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;masterdata_Promotion_SE.xml: Promotion.Condition.Eligibility&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PromotionCPD.xml: Promotion.Condition.Eligibility&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
    /// </summary>
    public record comGkSoftwareSweeSesApiServerMdPromotionDtoSoPromotionConditionEligibilitySO	{
        /// <summary>
        /// &lt;p&gt;A code that indicates the type of Price Derivation Rule Eligibility.&lt;br /&gt; Possible types:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;&#39;COMB&#39; &#x3D; combination&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;EGRP&#39; &#x3D; employee discount group&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;CGRP&#39; &#x3D; customer group&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;CUST&#39; &#x3D; customer&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;MSTR&#39; &#x3D; merchandise category&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;ITEM&#39; &#x3D; item&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;TOTL&#39; &#x3D; total purchase market basket&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;COUP&#39; &#x3D; coupon&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;MANU&#39; &#x3D; manual trigger&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;POST&#39; &#x3D; line item type&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;EXTV&#39; &#x3D; external trigger value&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;APRT&#39; &#x3D; additional price type eligibility&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;SITH&#39; &#x3D; simple threshold eligibility&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;masterdata_Promotion_SE.xml: filled according to filled eligibility in Promotion.Condition.Eligibility. Supported &#39;COMB&#39;, &#39;ITEM&#39;, &#39;MSRT&#39;, &#39;TOTL&#39; only.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PromotionCPD.xml: filled according to filled eligibility in Promotion.Condition.Eligibility&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;A code that indicates the type of Price Derivation Rule Eligibility.&lt;br /&gt; Possible types:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;&#39;COMB&#39; &#x3D; combination&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;EGRP&#39; &#x3D; employee discount group&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;CGRP&#39; &#x3D; customer group&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;CUST&#39; &#x3D; customer&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;MSTR&#39; &#x3D; merchandise category&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;ITEM&#39; &#x3D; item&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;TOTL&#39; &#x3D; total purchase market basket&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;COUP&#39; &#x3D; coupon&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;MANU&#39; &#x3D; manual trigger&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;POST&#39; &#x3D; line item type&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;EXTV&#39; &#x3D; external trigger value&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;APRT&#39; &#x3D; additional price type eligibility&lt;/li&gt;&lt;br /&gt; &lt;li&gt;&#39;SITH&#39; &#x3D; simple threshold eligibility&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;masterdata_Promotion_SE.xml: filled according to filled eligibility in Promotion.Condition.Eligibility. Supported &#39;COMB&#39;, &#39;ITEM&#39;, &#39;MSRT&#39;, &#39;TOTL&#39; only.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PromotionCPD.xml: filled according to filled eligibility in Promotion.Condition.Eligibility&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public typeCodeEnum typeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;A unique identifier for the rule eligibility&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;A unique identifier for the rule eligibility&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string internalEligibilityID { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to the root eligibility of the condition eligibility tree&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the root eligibility of the condition eligibility tree&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string rootEligibilityID { get; init; }
        /// <summary>
        /// &lt;p&gt;Reference to the parent eligibility in the condition eligibility tree&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Reference to the parent eligibility in the condition eligibility tree&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string parentEligibilityID { get; init; }
        /// <summary>
        /// &lt;p&gt;Level in the eligibility tree the eligibility belongs to&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Level in the eligibility tree the eligibility belongs to&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public int? levelID { get; init; }
        /// <summary>
        /// &lt;p&gt;The timestamp this eligibility becomes active&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The timestamp this eligibility becomes active&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string effectiveDateTime { get; init; }
        /// <summary>
        /// &lt;p&gt;The last date and time that this eligibility is effective&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)
        /// </summary>
        /// <value>&lt;p&gt;The last date and time that this eligibility is effective&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt; Date format &#39;yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSS&#39; (no timezone)</value>
        public string expirationDateTime { get; init; }
        /// <summary>
        /// &lt;p&gt;Defines the current status for the eligibility. Examples of valid codes include: AC/null &#x3D; Active, IA &#x3D; Inactive&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;masterdata_Promotion_SE.xml: Not imported.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PromotionCPD.xml: Not imported, fix value &#39;AC&#39; used.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;
        /// </summary>
        /// <value>&lt;p&gt;Defines the current status for the eligibility. Examples of valid codes include: AC/null &#x3D; Active, IA &#x3D; Inactive&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;ul&gt;&lt;br /&gt; &lt;li&gt;masterdata_Promotion_SE.xml: Not imported.&lt;/li&gt;&lt;br /&gt; &lt;li&gt;PromotionCPD.xml: Not imported, fix value &#39;AC&#39; used.&lt;/li&gt;&lt;br /&gt;&lt;/ul&gt;</value>
        public string statusCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Determines whether the eligibility must be fulfilled (false) or not (true) in order that the price derivation rule can be applied&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Determines whether the eligibility must be fulfilled (false) or not (true) in order that the price derivation rule can be applied&lt;br /&gt;&lt;/p&gt;</value>
        public bool? negationFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;Read only flag which is returned only in case it&#39;s required by the caller from API method.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Read only flag which is returned only in case it&#39;s required by the caller from API method.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? recommendationFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom08 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom10 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom09 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom07 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom06 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom11 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom12 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom13 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom14 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom15 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom16 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom17 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom18 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom19 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom20 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom21 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom22 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom23 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom24 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom25 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom26 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom27 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom28 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom29 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom30 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from masterdata_Promotion_SE.xml only.&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
