namespace POSGkSwaggerModel
{
    /// <summary>
    /// UomSO &lt;p&gt;Units in which a value is being expressed, or manner in which a measurement has been taken.&lt;br /&gt; Unit of measure codes are referred from the item. The codes have to be initialized before they are used on the item.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import from dc_import_UnitOfMeasure. &lt;br /&gt;&lt;/p&gt;
    /// </summary>
    public record comGkSoftwareSweeSesApiServerMdUomDtoSoUomSO	{
        /// <summary>
        /// &lt;p&gt;Identification of the unit of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UOMCode&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Identification of the unit of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UOMCode&lt;br /&gt;&lt;/p&gt;</value>
        public string unitOfMeasureCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Localized code of the unit of measure. This code is displayed in the GUI and can be used also in exports. Example: The unit of measure with the code &#39;PCE&#39; has the localized code &#39;ST&#39;.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Localized code of the unit of measure. This code is displayed in the GUI and can be used also in exports. Example: The unit of measure with the code &#39;PCE&#39; has the localized code &#39;ST&#39;.&lt;br /&gt;&lt;/p&gt;</value>
        public string translatedUOMCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates what this unit of measure entity type instance measures. Examples include weight or mass, length, cube (length x width x depth), volume, discrete items (each), etc.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UOMTypeCode&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates what this unit of measure entity type instance measures. Examples include weight or mass, length, cube (length x width x depth), volume, discrete items (each), etc.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UOMTypeCode&lt;br /&gt;&lt;/p&gt;</value>
        public string unitOfMeasureTypeCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Indicates whether this unit of measure is part of the English or metric system of measurements.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Indicates whether this unit of measure is part of the English or metric system of measurements.&lt;br /&gt;&lt;/p&gt;</value>
        public bool? englishMetricFlag { get; init; }
        /// <summary>
        /// &lt;p&gt;Name assigned to this unit of measure.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Name assigned to this unit of measure.&lt;br /&gt;&lt;/p&gt;</value>
        public string name { get; init; }
        /// <summary>
        /// &lt;p&gt;Description assigned to this unit of measure.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Description assigned to this unit of measure.&lt;br /&gt;&lt;/p&gt;</value>
        public string description { get; init; }
        /// <summary>
        /// &lt;p&gt;List of conversions from this unit of measure into other units of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not used. Not filled in the data maintenance.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of conversions from this unit of measure into other units of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not used. Not filled in the data maintenance.&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerMdUomDtoSoUomConversionSO> UomConversionList { get; init; }
        /// <summary>
        /// &lt;p&gt;Allowed count of decimal places. The quantities are displayed with this decimal places count in the GUI and reports. When registering an item in this unit, there can be registered maximally this count of decimal places.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Allowed count of decimal places. The quantities are displayed with this decimal places count in the GUI and reports. When registering an item in this unit, there can be registered maximally this count of decimal places.&lt;br /&gt;&lt;/p&gt;</value>
        public int? decimalPlacesCount { get; init; }
        /// <summary>
        /// &lt;p&gt;The corresponding ISO code for this unit of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;The corresponding ISO code for this unit of measure&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string isoUnitOfMeasureCode { get; init; }
        /// <summary>
        /// &lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Translation identifier - used for the unique identification of translations in the common translation table.&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Generated, not imported.&lt;br /&gt;&lt;/p&gt;</value>
        public string tid { get; init; }
        /// <summary>
        /// &lt;p&gt;List of translations of unit of measure texts&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UomTranslationList&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;List of translations of unit of measure texts&lt;br /&gt;&lt;/p&gt;&lt;br /&gt;&lt;p&gt;Import:&lt;br /&gt; dc_import_UnitOfMeasure: UnitOfMeasure.UomTranslationList&lt;br /&gt;&lt;/p&gt;</value>
        public List<comGkSoftwareSweeSesApiServerMdUomDtoSoUomTranslationSO> Translations { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom05 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom03 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom02 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom04 { get; init; }
        /// <summary>
        /// &lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;
        /// </summary>
        /// <value>&lt;p&gt;Additional field for custom development&lt;br /&gt;&lt;/p&gt;</value>
        public string xxcustom01 { get; init; }
	}
}
